-- phpMyAdmin SQL Dump
-- version 4.8.3
-- https://www.phpmyadmin.net/
--
-- Host: 127.0.0.1
-- Generation Time: Jan 17, 2019 at 01:39 AM
-- Server version: 10.1.35-MariaDB
-- PHP Version: 7.2.9

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `sabrehaven`
--

-- --------------------------------------------------------

--
-- Table structure for table `accounts`
--

CREATE TABLE `accounts` (
  `id` int(11) NOT NULL,
  `password` char(40) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '1',
  `premdays` int(11) NOT NULL DEFAULT '0',
  `lastday` int(10) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `accounts`
--

INSERT INTO `accounts` (`id`, `password`, `type`, `premdays`, `lastday`) VALUES
(1234567, '41da8bef22aaef9d7c5821fa0f0de7cccc4dda4d', 5, 497, 1547320555);

-- --------------------------------------------------------

--
-- Table structure for table `account_bans`
--

CREATE TABLE `account_bans` (
  `account_id` int(11) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `banned_at` bigint(20) NOT NULL,
  `expires_at` bigint(20) NOT NULL,
  `banned_by` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `account_ban_history`
--

CREATE TABLE `account_ban_history` (
  `id` int(10) UNSIGNED NOT NULL,
  `account_id` int(11) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `banned_at` bigint(20) NOT NULL,
  `expired_at` bigint(20) NOT NULL,
  `banned_by` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `account_viplist`
--

CREATE TABLE `account_viplist` (
  `account_id` int(11) NOT NULL COMMENT 'id of account whose viplist entry it is',
  `player_id` int(11) NOT NULL COMMENT 'id of target player of viplist entry',
  `description` varchar(128) NOT NULL DEFAULT '',
  `icon` tinyint(2) UNSIGNED NOT NULL DEFAULT '0',
  `notify` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `account_viplist`
--

INSERT INTO `account_viplist` (`account_id`, `player_id`, `description`, `icon`, `notify`) VALUES
(1234567, 3, '', 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `guilds`
--

CREATE TABLE `guilds` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `ownerid` int(11) NOT NULL,
  `creationdata` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Triggers `guilds`
--
DELIMITER $$
CREATE TRIGGER `oncreate_guilds` AFTER INSERT ON `guilds` FOR EACH ROW BEGIN
    INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('the Leader', 3, NEW.`id`);
    INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('a Vice-Leader', 2, NEW.`id`);
    INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('a Member', 1, NEW.`id`);
END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `guildwar_kills`
--

CREATE TABLE `guildwar_kills` (
  `id` int(11) NOT NULL,
  `killer` varchar(50) NOT NULL,
  `target` varchar(50) NOT NULL,
  `killerguild` int(11) NOT NULL DEFAULT '0',
  `targetguild` int(11) NOT NULL DEFAULT '0',
  `warid` int(11) NOT NULL DEFAULT '0',
  `time` bigint(15) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `guild_invites`
--

CREATE TABLE `guild_invites` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `guild_id` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `guild_membership`
--

CREATE TABLE `guild_membership` (
  `player_id` int(11) NOT NULL,
  `guild_id` int(11) NOT NULL,
  `rank_id` int(11) NOT NULL,
  `nick` varchar(15) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `guild_ranks`
--

CREATE TABLE `guild_ranks` (
  `id` int(11) NOT NULL,
  `guild_id` int(11) NOT NULL COMMENT 'guild',
  `name` varchar(255) NOT NULL COMMENT 'rank name',
  `level` int(11) NOT NULL COMMENT 'rank level - leader, vice, member, maybe something else'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `guild_wars`
--

CREATE TABLE `guild_wars` (
  `id` int(11) NOT NULL,
  `guild1` int(11) NOT NULL DEFAULT '0',
  `guild2` int(11) NOT NULL DEFAULT '0',
  `name1` varchar(255) NOT NULL,
  `name2` varchar(255) NOT NULL,
  `status` tinyint(2) NOT NULL DEFAULT '0',
  `started` bigint(15) NOT NULL DEFAULT '0',
  `ended` bigint(15) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `houses`
--

CREATE TABLE `houses` (
  `id` int(11) NOT NULL,
  `owner` int(11) NOT NULL,
  `paid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `warnings` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `rent` int(11) NOT NULL DEFAULT '0',
  `town_id` int(11) NOT NULL DEFAULT '0',
  `bid` int(11) NOT NULL DEFAULT '0',
  `bid_end` int(11) NOT NULL DEFAULT '0',
  `last_bid` int(11) NOT NULL DEFAULT '0',
  `highest_bidder` int(11) NOT NULL DEFAULT '0',
  `size` int(11) NOT NULL DEFAULT '0',
  `beds` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `houses`
--

INSERT INTO `houses` (`id`, `owner`, `paid`, `warnings`, `name`, `rent`, `town_id`, `bid`, `bid_end`, `last_bid`, `highest_bidder`, `size`, `beds`) VALUES
(1, 0, 0, 0, 'Spiritkeep', 36220, 1, 0, 0, 0, 0, 378, 23),
(2, 0, 0, 0, 'Snake Tower', 57440, 1, 0, 0, 0, 0, 616, 21),
(3, 0, 0, 0, 'Halls of the Adventurers', 29060, 1, 0, 0, 0, 0, 304, 18),
(4, 0, 0, 0, 'Dark Mansion', 34090, 1, 0, 0, 0, 0, 361, 17),
(5, 0, 0, 0, 'Bloodhall', 29040, 1, 0, 0, 0, 0, 306, 16),
(6, 0, 0, 0, 'Sunset Homes, Flat 01', 1040, 1, 0, 0, 0, 0, 13, 1),
(7, 0, 0, 0, 'Sunset Homes, Flat 02', 1040, 1, 0, 0, 0, 0, 13, 1),
(8, 0, 0, 0, 'Sunset Homes, Flat 03', 1040, 1, 0, 0, 0, 0, 13, 1),
(9, 0, 0, 0, 'Sunset Homes, Flat 11', 1040, 1, 0, 0, 0, 0, 13, 1),
(10, 0, 0, 0, 'Sunset Homes, Flat 12', 1040, 1, 0, 0, 0, 0, 13, 1),
(11, 0, 0, 0, 'Sunset Homes, Flat 13', 1620, 1, 0, 0, 0, 0, 19, 2),
(12, 0, 0, 0, 'Sunset Homes, Flat 14', 1040, 1, 0, 0, 0, 0, 13, 1),
(13, 0, 0, 0, 'Sunset Homes, Flat 21', 1040, 1, 0, 0, 0, 0, 13, 1),
(14, 0, 0, 0, 'Sunset Homes, Flat 22', 1040, 1, 0, 0, 0, 0, 13, 1),
(15, 0, 0, 0, 'Sunset Homes, Flat 23', 1620, 1, 0, 0, 0, 0, 19, 2),
(16, 0, 0, 0, 'Sunset Homes, Flat 24', 1040, 1, 0, 0, 0, 0, 13, 1),
(17, 0, 0, 0, 'Beach Home Apartments, Flat 01', 1430, 1, 0, 0, 0, 0, 13, 1),
(18, 0, 0, 0, 'Beach Home Apartments, Flat 02', 1430, 1, 0, 0, 0, 0, 13, 1),
(19, 0, 0, 0, 'Beach Home Apartments, Flat 03', 1430, 1, 0, 0, 0, 0, 13, 1),
(20, 0, 0, 0, 'Beach Home Apartments, Flat 04', 1430, 1, 0, 0, 0, 0, 13, 1),
(21, 0, 0, 0, 'Beach Home Apartments, Flat 05', 1430, 1, 0, 0, 0, 0, 13, 1),
(22, 0, 0, 0, 'Beach Home Apartments, Flat 06', 2190, 1, 0, 0, 0, 0, 19, 2),
(23, 0, 0, 0, 'Beach Home Apartments, Flat 11', 1430, 1, 0, 0, 0, 0, 13, 1),
(24, 0, 0, 0, 'Beach Home Apartments, Flat 12', 1760, 1, 0, 0, 0, 0, 16, 1),
(25, 0, 0, 0, 'Beach Home Apartments, Flat 13', 1760, 1, 0, 0, 0, 0, 16, 1),
(26, 0, 0, 0, 'Beach Home Apartments, Flat 14', 770, 1, 0, 0, 0, 0, 7, 1),
(27, 0, 0, 0, 'Beach Home Apartments, Flat 15', 770, 1, 0, 0, 0, 0, 7, 1),
(28, 0, 0, 0, 'Beach Home Apartments, Flat 16', 2190, 1, 0, 0, 0, 0, 19, 2),
(29, 0, 0, 0, 'Alai Flats, Flat 01', 1530, 1, 0, 0, 0, 0, 17, 1),
(30, 0, 0, 0, 'Alai Flats, Flat 02', 1530, 1, 0, 0, 0, 0, 17, 1),
(31, 0, 0, 0, 'Alai Flats, Flat 03', 1530, 1, 0, 0, 0, 0, 17, 1),
(32, 0, 0, 0, 'Alai Flats, Flat 04', 1530, 1, 0, 0, 0, 0, 17, 1),
(33, 0, 0, 0, 'Alai Flats, Flat 05', 2350, 1, 0, 0, 0, 0, 25, 2),
(34, 0, 0, 0, 'Alai Flats, Flat 06', 2350, 1, 0, 0, 0, 0, 25, 2),
(35, 0, 0, 0, 'Alai Flats, Flat 07', 1530, 1, 0, 0, 0, 0, 17, 1),
(36, 0, 0, 0, 'Alai Flats, Flat 08', 1530, 1, 0, 0, 0, 0, 17, 1),
(37, 0, 0, 0, 'Alai Flats, Flat 11', 1530, 1, 0, 0, 0, 0, 17, 1),
(38, 0, 0, 0, 'Alai Flats, Flat 12', 1530, 1, 0, 0, 0, 0, 17, 1),
(39, 0, 0, 0, 'Alai Flats, Flat 13', 1530, 1, 0, 0, 0, 0, 17, 1),
(40, 0, 0, 0, 'Alai Flats, Flat 14', 1800, 1, 0, 0, 0, 0, 20, 1),
(41, 0, 0, 0, 'Alai Flats, Flat 15', 2800, 1, 0, 0, 0, 0, 30, 2),
(42, 0, 0, 0, 'Alai Flats, Flat 16', 2800, 1, 0, 0, 0, 0, 30, 2),
(43, 0, 0, 0, 'Alai Flats, Flat 17', 1800, 1, 0, 0, 0, 0, 20, 1),
(44, 0, 0, 0, 'Alai Flats, Flat 18', 1800, 1, 0, 0, 0, 0, 20, 1),
(45, 0, 0, 0, 'Alai Flats, Flat 22', 1530, 1, 0, 0, 0, 0, 17, 1),
(46, 0, 0, 0, 'Alai Flats, Flat 21', 1530, 1, 0, 0, 0, 0, 17, 1),
(47, 0, 0, 0, 'Alai Flats, Flat 23', 1530, 1, 0, 0, 0, 0, 17, 1),
(48, 0, 0, 0, 'Alai Flats, Flat 24', 1800, 1, 0, 0, 0, 0, 20, 1),
(49, 0, 0, 0, 'Alai Flats, Flat 25', 2800, 1, 0, 0, 0, 0, 30, 2),
(50, 0, 0, 0, 'Alai Flats, Flat 26', 2800, 1, 0, 0, 0, 0, 30, 2),
(51, 0, 0, 0, 'Alai Flats, Flat 27', 1800, 1, 0, 0, 0, 0, 20, 1),
(52, 0, 0, 0, 'Alai Flats, Flat 28', 1800, 1, 0, 0, 0, 0, 20, 1),
(53, 0, 0, 0, 'Upper Swamp Lane 2', 9180, 1, 0, 0, 0, 0, 74, 4),
(54, 0, 0, 0, 'Upper Swamp Lane 4', 9180, 1, 0, 0, 0, 0, 74, 4),
(55, 0, 0, 0, 'Lower Swamp Lane 1', 9180, 1, 0, 0, 0, 0, 74, 4),
(56, 0, 0, 0, 'Lower Swamp Lane 3', 9180, 1, 0, 0, 0, 0, 74, 4),
(57, 0, 0, 0, 'Upper Swamp Lane 8', 16040, 1, 0, 0, 0, 0, 132, 3),
(58, 0, 0, 0, 'Southern Thais Guildhall', 43020, 1, 0, 0, 0, 0, 346, 16),
(59, 0, 0, 0, 'Upper Swamp Lane 10', 3920, 1, 0, 0, 0, 0, 31, 3),
(60, 0, 0, 0, 'Upper Swamp Lane 12', 7400, 1, 0, 0, 0, 0, 60, 3),
(61, 0, 0, 0, 'Sorcerer\'s Avenue 1a', 2410, 1, 0, 0, 0, 0, 21, 2),
(62, 0, 0, 0, 'Sorcerer\'s Avenue 1b', 1970, 1, 0, 0, 0, 0, 17, 2),
(63, 0, 0, 0, 'Sorcerer\'s Avenue 1c', 2410, 1, 0, 0, 0, 0, 21, 2),
(64, 0, 0, 0, 'Sorcerer\'s Avenue 5', 5390, 1, 0, 0, 0, 0, 49, 1),
(65, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2a', 1430, 1, 0, 0, 0, 0, 13, 1),
(66, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2b', 1430, 1, 0, 0, 0, 0, 13, 1),
(67, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2c', 1430, 1, 0, 0, 0, 0, 13, 1),
(68, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2d', 1430, 1, 0, 0, 0, 0, 13, 1),
(69, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2e', 1430, 1, 0, 0, 0, 0, 13, 1),
(70, 0, 0, 0, 'Sorcerer\'s Avenue Labs 2f', 1430, 1, 0, 0, 0, 0, 13, 1),
(71, 0, 0, 0, 'Thais Clanhall', 15940, 1, 0, 0, 0, 0, 188, 10),
(72, 0, 0, 0, 'Harbour Street 4', 1870, 1, 0, 0, 0, 0, 17, 1),
(73, 0, 0, 0, 'Thais Hostel', 11660, 1, 0, 0, 0, 0, 117, 24),
(74, 0, 0, 0, 'Farm Lane, Basement (Shop)', 1890, 1, 0, 0, 0, 0, 21, 0),
(75, 0, 0, 0, 'Farm Lane, 1st floor (Shop)', 1890, 1, 0, 0, 0, 0, 21, 0),
(76, 0, 0, 0, 'Farm Lane, 2nd Floor (Shop)', 1890, 1, 0, 0, 0, 0, 21, 0),
(77, 0, 0, 0, 'Warriors Guildhall', 28450, 1, 0, 0, 0, 0, 305, 11),
(78, 0, 0, 0, 'Main Street 9, 1st floor (Shop)', 2880, 1, 0, 0, 0, 0, 32, 0),
(79, 0, 0, 0, 'Main Street 9a, 2nd floor (Shop)', 1530, 1, 0, 0, 0, 0, 17, 0),
(80, 0, 0, 0, 'Main Street 9b, 2nd floor (Shop)', 2520, 1, 0, 0, 0, 0, 28, 0),
(81, 0, 0, 0, 'Mill Avenue 1 (Shop)', 2600, 1, 0, 0, 0, 0, 26, 1),
(82, 0, 0, 0, 'Mill Avenue 2 (Shop)', 4600, 1, 0, 0, 0, 0, 45, 2),
(83, 0, 0, 0, 'Mill Avenue 3', 2700, 1, 0, 0, 0, 0, 26, 2),
(84, 0, 0, 0, 'Mill Avenue 4', 2700, 1, 0, 0, 0, 0, 26, 2),
(85, 0, 0, 0, 'Mill Avenue 5', 6200, 1, 0, 0, 0, 0, 59, 4),
(86, 0, 0, 0, 'The City Wall 5a', 1170, 1, 0, 0, 0, 0, 13, 1),
(87, 0, 0, 0, 'The City Wall 5b', 1170, 1, 0, 0, 0, 0, 13, 1),
(88, 0, 0, 0, 'The City Wall 5c', 1170, 1, 0, 0, 0, 0, 13, 1),
(89, 0, 0, 0, 'The City Wall 5d', 1170, 1, 0, 0, 0, 0, 13, 1),
(90, 0, 0, 0, 'The City Wall 5e', 1170, 1, 0, 0, 0, 0, 13, 1),
(91, 0, 0, 0, 'The City Wall 5f', 1170, 1, 0, 0, 0, 0, 13, 1),
(92, 0, 0, 0, 'The City Wall 7a', 1170, 1, 0, 0, 0, 0, 13, 1),
(93, 0, 0, 0, 'The City Wall 7b', 1170, 1, 0, 0, 0, 0, 13, 1),
(94, 0, 0, 0, 'The City Wall 7c', 1630, 1, 0, 0, 0, 0, 17, 2),
(95, 0, 0, 0, 'The City Wall 7d', 1630, 1, 0, 0, 0, 0, 17, 2),
(96, 0, 0, 0, 'The City Wall 7e', 1630, 1, 0, 0, 0, 0, 17, 2),
(97, 0, 0, 0, 'The City Wall 7f', 1630, 1, 0, 0, 0, 0, 17, 2),
(98, 0, 0, 0, 'The City Wall 7g', 1170, 1, 0, 0, 0, 0, 13, 1),
(99, 0, 0, 0, 'The City Wall 7h', 1170, 1, 0, 0, 0, 0, 13, 1),
(100, 0, 0, 0, 'The City Wall 9', 1810, 1, 0, 0, 0, 0, 19, 2),
(101, 0, 0, 0, 'The City Wall 3a', 1990, 1, 0, 0, 0, 0, 21, 2),
(102, 0, 0, 0, 'The City Wall 3b', 1990, 1, 0, 0, 0, 0, 21, 2),
(103, 0, 0, 0, 'The City Wall 3c', 1990, 1, 0, 0, 0, 0, 21, 2),
(104, 0, 0, 0, 'The City Wall 3d', 1990, 1, 0, 0, 0, 0, 21, 2),
(105, 0, 0, 0, 'The City Wall 3e', 1990, 1, 0, 0, 0, 0, 21, 2),
(106, 0, 0, 0, 'The City Wall 3f', 1990, 1, 0, 0, 0, 0, 21, 2),
(107, 0, 0, 0, 'The City Wall 1a', 2440, 1, 0, 0, 0, 0, 26, 2),
(108, 0, 0, 0, 'The City Wall 1b', 2440, 1, 0, 0, 0, 0, 26, 2),
(109, 0, 0, 0, 'Harbour Place 2 (Shop)', 2600, 1, 0, 0, 0, 0, 26, 1),
(110, 0, 0, 0, 'Harbour Place 1 (Shop)', 2200, 1, 0, 0, 0, 0, 22, 0),
(111, 0, 0, 0, 'Mercenary Tower', 81410, 1, 0, 0, 0, 0, 607, 26),
(112, 0, 0, 0, 'Guildhall of the Red Rose', 54050, 1, 0, 0, 0, 0, 405, 15),
(113, 0, 0, 0, 'Fibula Village 1', 1690, 1, 0, 0, 0, 0, 13, 1),
(114, 0, 0, 0, 'Fibula Village 2', 1690, 1, 0, 0, 0, 0, 13, 1),
(115, 0, 0, 0, 'Fibula Village 3', 7320, 1, 0, 0, 0, 0, 54, 4),
(116, 0, 0, 0, 'Fibula Village 4', 3480, 1, 0, 0, 0, 0, 26, 2),
(117, 0, 0, 0, 'Fibula Village 5', 3480, 1, 0, 0, 0, 0, 26, 2),
(118, 0, 0, 0, 'Fibula Village, Tower Flat', 10110, 1, 0, 0, 0, 0, 77, 2),
(119, 0, 0, 0, 'Fibula Village, Bar', 10370, 1, 0, 0, 0, 0, 79, 2),
(120, 0, 0, 0, 'Fibula Clanhall', 21960, 1, 0, 0, 0, 0, 162, 10),
(121, 0, 0, 0, 'Fibula Village, Villa', 22380, 1, 0, 0, 0, 0, 242, 7),
(122, 0, 0, 0, 'The Tibianic', 66900, 1, 0, 0, 0, 0, 540, 22),
(123, 0, 0, 0, 'Castle of Greenshore', 36380, 1, 0, 0, 0, 0, 294, 12),
(124, 0, 0, 0, 'Greenshore Village, Villa', 20580, 1, 0, 0, 0, 0, 169, 4),
(125, 0, 0, 0, 'Greenshore Village, Shop', 3600, 1, 0, 0, 0, 0, 30, 1),
(126, 0, 0, 0, 'Greenshore Village 1', 4640, 1, 0, 0, 0, 0, 37, 3),
(127, 0, 0, 0, 'Greenshore Village 2', 1560, 1, 0, 0, 0, 0, 13, 1),
(128, 0, 0, 0, 'Greenshore Village 3', 1560, 1, 0, 0, 0, 0, 13, 1),
(129, 0, 0, 0, 'Greenshore Village 4', 1560, 1, 0, 0, 0, 0, 13, 1),
(130, 0, 0, 0, 'Greenshore Village 5', 1560, 1, 0, 0, 0, 0, 13, 1),
(131, 0, 0, 0, 'Greenshore Village 6', 8620, 1, 0, 0, 0, 0, 71, 2),
(132, 0, 0, 0, 'Greenshore Village 7', 2520, 1, 0, 0, 0, 0, 21, 1),
(133, 0, 0, 0, 'Greenshore Clanhall', 20700, 1, 0, 0, 0, 0, 165, 10),
(134, 0, 0, 0, 'Moonkeep', 24540, 2, 0, 0, 0, 0, 288, 16),
(135, 0, 0, 0, 'House of Recreation', 39460, 2, 0, 0, 0, 0, 412, 16),
(136, 0, 0, 0, 'Nordic Stronghold', 34700, 2, 0, 0, 0, 0, 410, 21),
(137, 0, 0, 0, 'Druids Retreat A', 2580, 2, 0, 0, 0, 0, 31, 2),
(138, 0, 0, 0, 'Druids Retreat B', 2420, 2, 0, 0, 0, 0, 29, 2),
(139, 0, 0, 0, 'Druids Retreat C', 1860, 2, 0, 0, 0, 0, 22, 2),
(140, 0, 0, 0, 'Druids Retreat D', 2260, 2, 0, 0, 0, 0, 27, 2),
(141, 0, 0, 0, 'Central Plaza 3', 1200, 2, 0, 0, 0, 0, 12, 0),
(142, 0, 0, 0, 'Central Plaza 2', 1200, 2, 0, 0, 0, 0, 12, 0),
(143, 0, 0, 0, 'Central Plaza 1', 1200, 2, 0, 0, 0, 0, 12, 0),
(144, 0, 0, 0, 'Park Lane 1a', 2340, 2, 0, 0, 0, 0, 28, 2),
(145, 0, 0, 0, 'Park Lane 1b', 2660, 2, 0, 0, 0, 0, 32, 2),
(146, 0, 0, 0, 'Park Lane 3b', 2100, 2, 0, 0, 0, 0, 25, 2),
(147, 0, 0, 0, 'Park Lane 3a', 2340, 2, 0, 0, 0, 0, 28, 2),
(148, 0, 0, 0, 'Park Lane 4', 1860, 2, 0, 0, 0, 0, 22, 2),
(149, 0, 0, 0, 'Park Lane 2', 1860, 2, 0, 0, 0, 0, 22, 2),
(150, 0, 0, 0, 'Theater Avenue 6a', 1540, 2, 0, 0, 0, 0, 16, 2),
(151, 0, 0, 0, 'Theater Avenue 6b', 1540, 2, 0, 0, 0, 0, 16, 2),
(152, 0, 0, 0, 'Theater Avenue 6c', 450, 2, 0, 0, 0, 0, 5, 1),
(153, 0, 0, 0, 'Theater Avenue 6d', 450, 2, 0, 0, 0, 0, 5, 1),
(154, 0, 0, 0, 'Theater Avenue 6e', 1540, 2, 0, 0, 0, 0, 16, 2),
(155, 0, 0, 0, 'Theater Avenue 6f', 1540, 2, 0, 0, 0, 0, 16, 2),
(156, 0, 0, 0, 'Theater Avenue 5a', 900, 2, 0, 0, 0, 0, 10, 1),
(157, 0, 0, 0, 'Theater Avenue 5b', 900, 2, 0, 0, 0, 0, 10, 1),
(158, 0, 0, 0, 'Theater Avenue 5c', 900, 2, 0, 0, 0, 0, 10, 1),
(159, 0, 0, 0, 'Theater Avenue 5d', 900, 2, 0, 0, 0, 0, 10, 1),
(160, 0, 0, 0, 'Theater Avenue 8a', 2440, 2, 0, 0, 0, 0, 26, 2),
(161, 0, 0, 0, 'Theater Avenue 8b', 2540, 2, 0, 0, 0, 0, 26, 3),
(162, 0, 0, 0, 'Theater Avenue 7, Flat 01', 630, 2, 0, 0, 0, 0, 7, 1),
(163, 0, 0, 0, 'Theater Avenue 7, Flat 02', 810, 2, 0, 0, 0, 0, 9, 1),
(164, 0, 0, 0, 'Theater Avenue 7, Flat 03', 810, 2, 0, 0, 0, 0, 9, 1),
(165, 0, 0, 0, 'Theater Avenue 7, Flat 04', 990, 2, 0, 0, 0, 0, 11, 1),
(166, 0, 0, 0, 'Theater Avenue 7, Flat 05', 810, 2, 0, 0, 0, 0, 9, 1),
(167, 0, 0, 0, 'Theater Avenue 7, Flat 06', 630, 2, 0, 0, 0, 0, 7, 1),
(168, 0, 0, 0, 'Theater Avenue 7, Flat 11', 990, 2, 0, 0, 0, 0, 11, 1),
(169, 0, 0, 0, 'Theater Avenue 7, Flat 12', 810, 2, 0, 0, 0, 0, 9, 1),
(170, 0, 0, 0, 'Theater Avenue 7, Flat 13', 810, 2, 0, 0, 0, 0, 9, 1),
(171, 0, 0, 0, 'Theater Avenue 7, Flat 14', 990, 2, 0, 0, 0, 0, 11, 1),
(172, 0, 0, 0, 'Theater Avenue 7, Flat 15', 810, 2, 0, 0, 0, 0, 9, 1),
(173, 0, 0, 0, 'Theater Avenue 7, Flat 16', 810, 2, 0, 0, 0, 0, 9, 1),
(174, 0, 0, 0, 'Theater Avenue 10', 2080, 2, 0, 0, 0, 0, 22, 2),
(175, 0, 0, 0, 'Theater Avenue 12', 1810, 2, 0, 0, 0, 0, 19, 2),
(176, 0, 0, 0, 'Theater Avenue 14 (Shop)', 4230, 2, 0, 0, 0, 0, 47, 1),
(177, 0, 0, 0, 'Theater Avenue 11a', 2710, 2, 0, 0, 0, 0, 29, 2),
(178, 0, 0, 0, 'Theater Avenue 11b', 1170, 2, 0, 0, 0, 0, 13, 1),
(179, 0, 0, 0, 'Theater Avenue 11c', 1170, 2, 0, 0, 0, 0, 13, 1),
(180, 0, 0, 0, 'Magician\'s Alley 1', 2000, 2, 0, 0, 0, 0, 19, 2),
(181, 0, 0, 0, 'Magician\'s Alley 1a', 1300, 2, 0, 0, 0, 0, 12, 2),
(182, 0, 0, 0, 'Magician\'s Alley 1b', 1400, 2, 0, 0, 0, 0, 13, 2),
(183, 0, 0, 0, 'Magician\'s Alley 1c', 1000, 2, 0, 0, 0, 0, 10, 1),
(184, 0, 0, 0, 'Magician\'s Alley 1d', 900, 2, 0, 0, 0, 0, 9, 1),
(185, 0, 0, 0, 'Magician\'s Alley 5a', 700, 2, 0, 0, 0, 0, 7, 1),
(186, 0, 0, 0, 'Magician\'s Alley 5b', 1000, 2, 0, 0, 0, 0, 10, 1),
(187, 0, 0, 0, 'Magician\'s Alley 5c', 2200, 2, 0, 0, 0, 0, 21, 2),
(188, 0, 0, 0, 'Magician\'s Alley 5d', 1000, 2, 0, 0, 0, 0, 10, 1),
(189, 0, 0, 0, 'Magician\'s Alley 5e', 1000, 2, 0, 0, 0, 0, 10, 1),
(190, 0, 0, 0, 'Magician\'s Alley 5f', 2200, 2, 0, 0, 0, 0, 21, 2),
(191, 0, 0, 0, 'Magician\'s Alley 4', 5200, 2, 0, 0, 0, 0, 49, 4),
(192, 0, 0, 0, 'Magician\'s Alley 8', 2700, 2, 0, 0, 0, 0, 26, 2),
(193, 0, 0, 0, 'Carlin Clanhall', 22700, 2, 0, 0, 0, 0, 218, 10),
(194, 0, 0, 0, 'Northern Street 1a', 1780, 2, 0, 0, 0, 0, 21, 2),
(195, 0, 0, 0, 'Northern Street 1b', 1780, 2, 0, 0, 0, 0, 21, 2),
(196, 0, 0, 0, 'Northern Street 1c', 1380, 2, 0, 0, 0, 0, 16, 2),
(197, 0, 0, 0, 'Northern Street 3a', 1380, 2, 0, 0, 0, 0, 16, 2),
(198, 0, 0, 0, 'Northern Street 3b', 1460, 2, 0, 0, 0, 0, 17, 2),
(199, 0, 0, 0, 'Northern Street 5', 3860, 2, 0, 0, 0, 0, 47, 2),
(200, 0, 0, 0, 'Northern Street 7', 3300, 2, 0, 0, 0, 0, 40, 2),
(201, 0, 0, 0, 'Harbour Lane 1 (Shop)', 2080, 2, 0, 0, 0, 0, 26, 0),
(202, 0, 0, 0, 'Harbour Lane 3', 6920, 2, 0, 0, 0, 0, 84, 3),
(203, 0, 0, 0, 'Harbour Lane 2a (Shop)', 1360, 2, 0, 0, 0, 0, 17, 0),
(204, 0, 0, 0, 'Harbour Lane 2b (Shop)', 1360, 2, 0, 0, 0, 0, 17, 0),
(205, 0, 0, 0, 'Harbour Flats, Flat 11', 1040, 2, 0, 0, 0, 0, 13, 1),
(206, 0, 0, 0, 'Harbour Flats, Flat 12', 800, 2, 0, 0, 0, 0, 10, 1),
(207, 0, 0, 0, 'Harbour Flats, Flat 13', 1040, 2, 0, 0, 0, 0, 13, 1),
(208, 0, 0, 0, 'Harbour Flats, Flat 14', 800, 2, 0, 0, 0, 0, 10, 1),
(209, 0, 0, 0, 'Harbour Flats, Flat 15', 720, 2, 0, 0, 0, 0, 9, 1),
(210, 0, 0, 0, 'Harbour Flats, Flat 16', 800, 2, 0, 0, 0, 0, 10, 1),
(211, 0, 0, 0, 'Harbour Flats, Flat 17', 720, 2, 0, 0, 0, 0, 9, 1),
(212, 0, 0, 0, 'Harbour Flats, Flat 18', 800, 2, 0, 0, 0, 0, 10, 1),
(213, 0, 0, 0, 'Harbour Flats, Flat 21', 1620, 2, 0, 0, 0, 0, 19, 2),
(214, 0, 0, 0, 'Harbour Flats, Flat 22', 1860, 2, 0, 0, 0, 0, 22, 2),
(215, 0, 0, 0, 'Harbour Flats, Flat 23', 800, 2, 0, 0, 0, 0, 10, 1),
(216, 0, 0, 0, 'East Lane 1a', 4420, 2, 0, 0, 0, 0, 54, 2),
(217, 0, 0, 0, 'East Lane 1b', 3300, 2, 0, 0, 0, 0, 40, 2),
(218, 0, 0, 0, 'East Lane 2', 9060, 2, 0, 0, 0, 0, 112, 2),
(219, 0, 0, 0, 'Suntower', 19360, 2, 0, 0, 0, 0, 232, 9),
(220, 0, 0, 0, 'Lonely Sea Side Hostel', 23660, 2, 0, 0, 0, 0, 287, 8),
(221, 0, 0, 0, 'Northport Village 1', 2850, 2, 0, 0, 0, 0, 25, 2),
(222, 0, 0, 0, 'Northport Village 2', 2850, 2, 0, 0, 0, 0, 25, 2),
(223, 0, 0, 0, 'Northport Village 3', 10770, 2, 0, 0, 0, 0, 97, 2),
(224, 0, 0, 0, 'Northport Village 4', 5160, 2, 0, 0, 0, 0, 46, 2),
(225, 0, 0, 0, 'Seawatch', 48220, 2, 0, 0, 0, 0, 422, 19),
(226, 0, 0, 0, 'Northport Village 5', 3510, 2, 0, 0, 0, 0, 31, 2),
(227, 0, 0, 0, 'Northport Village 6', 4170, 2, 0, 0, 0, 0, 37, 2),
(228, 0, 0, 0, 'Northport Clanhall', 18720, 2, 0, 0, 0, 0, 162, 10),
(229, 0, 0, 0, 'Senja Village 1a', 1530, 2, 0, 0, 0, 0, 17, 1),
(230, 0, 0, 0, 'Senja Village 1b', 3160, 2, 0, 0, 0, 0, 34, 2),
(231, 0, 0, 0, 'Senja Village 2', 1530, 2, 0, 0, 0, 0, 17, 1),
(232, 0, 0, 0, 'Senja Village 3', 3430, 2, 0, 0, 0, 0, 37, 2),
(233, 0, 0, 0, 'Senja Village 4', 1530, 2, 0, 0, 0, 0, 17, 1),
(234, 0, 0, 0, 'Senja Village 5', 2350, 2, 0, 0, 0, 0, 25, 2),
(235, 0, 0, 0, 'Senja Village 6a', 1530, 2, 0, 0, 0, 0, 17, 1),
(236, 0, 0, 0, 'Senja Village 6b', 1530, 2, 0, 0, 0, 0, 17, 1),
(237, 0, 0, 0, 'Senja Village 7', 1630, 2, 0, 0, 0, 0, 17, 2),
(238, 0, 0, 0, 'Senja Village 8', 3250, 2, 0, 0, 0, 0, 35, 2),
(239, 0, 0, 0, 'Senja Village 9', 5050, 2, 0, 0, 0, 0, 55, 2),
(240, 0, 0, 0, 'Senja Village 10', 2970, 2, 0, 0, 0, 0, 33, 1),
(241, 0, 0, 0, 'Senja Village 11', 5140, 2, 0, 0, 0, 0, 56, 2),
(242, 0, 0, 0, 'Senja Clanhall', 20250, 2, 0, 0, 0, 0, 215, 10),
(243, 0, 0, 0, 'Wolftower', 40900, 3, 0, 0, 0, 0, 387, 23),
(244, 0, 0, 0, 'Hill Hideout', 26500, 3, 0, 0, 0, 0, 251, 15),
(245, 0, 0, 0, 'Riverspring', 37100, 3, 0, 0, 0, 0, 353, 19),
(246, 0, 0, 0, 'The Farms 1', 4820, 3, 0, 0, 0, 0, 42, 3),
(247, 0, 0, 0, 'The Farms 2', 2960, 3, 0, 0, 0, 0, 26, 2),
(248, 0, 0, 0, 'The Farms 3', 2960, 3, 0, 0, 0, 0, 26, 2),
(249, 0, 0, 0, 'The Farms 4', 2960, 3, 0, 0, 0, 0, 26, 2),
(250, 0, 0, 0, 'The Farms 5', 2960, 3, 0, 0, 0, 0, 26, 2),
(251, 0, 0, 0, 'The Farms 6, Fishing Hut', 2410, 3, 0, 0, 0, 0, 21, 2),
(252, 0, 0, 0, 'Nobility Quarter 1', 3530, 3, 0, 0, 0, 0, 37, 3),
(253, 0, 0, 0, 'Nobility Quarter 2', 3530, 3, 0, 0, 0, 0, 37, 3),
(254, 0, 0, 0, 'Nobility Quarter 3', 3530, 3, 0, 0, 0, 0, 37, 3),
(255, 0, 0, 0, 'Nobility Quarter 4', 1530, 3, 0, 0, 0, 0, 17, 1),
(256, 0, 0, 0, 'Nobility Quarter 5', 1530, 3, 0, 0, 0, 0, 17, 1),
(257, 0, 0, 0, 'Nobility Quarter 6', 1530, 3, 0, 0, 0, 0, 17, 1),
(258, 0, 0, 0, 'Nobility Quarter 7', 1530, 3, 0, 0, 0, 0, 17, 1),
(259, 0, 0, 0, 'Nobility Quarter 8', 1530, 3, 0, 0, 0, 0, 17, 1),
(260, 0, 0, 0, 'Nobility Quarter 9', 1530, 3, 0, 0, 0, 0, 17, 1),
(261, 0, 0, 0, 'Upper Barracks 1', 420, 3, 0, 0, 0, 0, 7, 1),
(262, 0, 0, 0, 'Upper Barracks 2', 420, 3, 0, 0, 0, 0, 7, 1),
(263, 0, 0, 0, 'Upper Barracks 3', 420, 3, 0, 0, 0, 0, 7, 1),
(264, 0, 0, 0, 'Upper Barracks 4', 420, 3, 0, 0, 0, 0, 7, 1),
(265, 0, 0, 0, 'Upper Barracks 5', 420, 3, 0, 0, 0, 0, 7, 1),
(266, 0, 0, 0, 'Upper Barracks 6', 420, 3, 0, 0, 0, 0, 7, 1),
(267, 0, 0, 0, 'Upper Barracks 7', 420, 3, 0, 0, 0, 0, 7, 1),
(268, 0, 0, 0, 'Upper Barracks 8', 420, 3, 0, 0, 0, 0, 7, 1),
(269, 0, 0, 0, 'Upper Barracks 9', 420, 3, 0, 0, 0, 0, 7, 1),
(270, 0, 0, 0, 'Upper Barracks 10', 420, 3, 0, 0, 0, 0, 7, 1),
(271, 0, 0, 0, 'Upper Barracks 11', 420, 3, 0, 0, 0, 0, 7, 1),
(272, 0, 0, 0, 'Upper Barracks 12', 420, 3, 0, 0, 0, 0, 7, 1),
(273, 0, 0, 0, 'Upper Barracks 13', 1060, 3, 0, 0, 0, 0, 16, 2),
(274, 0, 0, 0, 'The Market 1 (Shop)', 1300, 3, 0, 0, 0, 0, 13, 0),
(275, 0, 0, 0, 'The Market 2 (Shop)', 2200, 3, 0, 0, 0, 0, 22, 0),
(276, 0, 0, 0, 'The Market 3 (Shop)', 2900, 3, 0, 0, 0, 0, 29, 0),
(277, 0, 0, 0, 'The Market 4 (Shop)', 3600, 3, 0, 0, 0, 0, 36, 0),
(278, 0, 0, 0, 'Lower Barracks 1', 600, 3, 0, 0, 0, 0, 10, 1),
(279, 0, 0, 0, 'Lower Barracks 2', 600, 3, 0, 0, 0, 0, 10, 1),
(280, 0, 0, 0, 'Lower Barracks 3', 600, 3, 0, 0, 0, 0, 10, 1),
(281, 0, 0, 0, 'Lower Barracks 4', 600, 3, 0, 0, 0, 0, 10, 1),
(282, 0, 0, 0, 'Lower Barracks 5', 600, 3, 0, 0, 0, 0, 10, 1),
(283, 0, 0, 0, 'Lower Barracks 6', 600, 3, 0, 0, 0, 0, 10, 1),
(284, 0, 0, 0, 'Lower Barracks 7', 600, 3, 0, 0, 0, 0, 10, 1),
(285, 0, 0, 0, 'Lower Barracks 8', 600, 3, 0, 0, 0, 0, 10, 1),
(286, 0, 0, 0, 'Lower Barracks 9', 600, 3, 0, 0, 0, 0, 10, 1),
(287, 0, 0, 0, 'Lower Barracks 10', 600, 3, 0, 0, 0, 0, 10, 1),
(288, 0, 0, 0, 'Lower Barracks 11', 600, 3, 0, 0, 0, 0, 10, 1),
(289, 0, 0, 0, 'Lower Barracks 12', 600, 3, 0, 0, 0, 0, 10, 1),
(290, 0, 0, 0, 'Lower Barracks 13', 600, 3, 0, 0, 0, 0, 10, 1),
(291, 0, 0, 0, 'Lower Barracks 14', 600, 3, 0, 0, 0, 0, 10, 1),
(292, 0, 0, 0, 'Lower Barracks 15', 600, 3, 0, 0, 0, 0, 10, 1),
(293, 0, 0, 0, 'Lower Barracks 16', 600, 3, 0, 0, 0, 0, 10, 1),
(294, 0, 0, 0, 'Lower Barracks 17', 600, 3, 0, 0, 0, 0, 10, 1),
(295, 0, 0, 0, 'Lower Barracks 18', 600, 3, 0, 0, 0, 0, 10, 1),
(296, 0, 0, 0, 'Lower Barracks 19', 600, 3, 0, 0, 0, 0, 10, 1),
(297, 0, 0, 0, 'Lower Barracks 20', 600, 3, 0, 0, 0, 0, 10, 1),
(298, 0, 0, 0, 'Lower Barracks 21', 600, 3, 0, 0, 0, 0, 10, 1),
(299, 0, 0, 0, 'Lower Barracks 22', 600, 3, 0, 0, 0, 0, 10, 1),
(300, 0, 0, 0, 'Lower Barracks 23', 600, 3, 0, 0, 0, 0, 10, 1),
(301, 0, 0, 0, 'Lower Barracks 24', 600, 3, 0, 0, 0, 0, 10, 1),
(302, 0, 0, 0, 'Tunnel Gardens 1', 3440, 3, 0, 0, 0, 0, 27, 3),
(303, 0, 0, 0, 'Tunnel Gardens 2 ', 3440, 3, 0, 0, 0, 0, 27, 3),
(304, 0, 0, 0, 'Tunnel Gardens 3', 3800, 3, 0, 0, 0, 0, 30, 3),
(305, 0, 0, 0, 'Tunnel Gardens 4', 3800, 3, 0, 0, 0, 0, 30, 3),
(306, 0, 0, 0, 'Tunnel Gardens 5', 2620, 3, 0, 0, 0, 0, 21, 2),
(307, 0, 0, 0, 'Tunnel Gardens 6', 2620, 3, 0, 0, 0, 0, 21, 2),
(308, 0, 0, 0, 'Tunnel Gardens 7', 2620, 3, 0, 0, 0, 0, 21, 2),
(309, 0, 0, 0, 'Tunnel Gardens 8', 2620, 3, 0, 0, 0, 0, 21, 2),
(310, 0, 0, 0, 'Tunnel Gardens 9', 1900, 3, 0, 0, 0, 0, 15, 2),
(311, 0, 0, 0, 'Tunnel Gardens 10', 1900, 3, 0, 0, 0, 0, 15, 2),
(312, 0, 0, 0, 'Tunnel Gardens 11', 2020, 3, 0, 0, 0, 0, 16, 2),
(313, 0, 0, 0, 'Tunnel Gardens 12', 2020, 3, 0, 0, 0, 0, 16, 2),
(314, 0, 0, 0, 'Marble Guildhall', 32020, 3, 0, 0, 0, 0, 338, 17),
(315, 0, 0, 0, 'Iron Guildhall', 29420, 3, 0, 0, 0, 0, 308, 18),
(316, 0, 0, 0, 'Granite Guildhall', 34090, 3, 0, 0, 0, 0, 361, 17),
(317, 0, 0, 0, 'Outlaw Camp 1', 3220, 3, 0, 0, 0, 0, 39, 2),
(318, 0, 0, 0, 'Outlaw Camp 2', 560, 3, 0, 0, 0, 0, 7, 1),
(319, 0, 0, 0, 'Outlaw Camp 3', 1380, 3, 0, 0, 0, 0, 16, 2),
(320, 0, 0, 0, 'Outlaw Camp 4', 400, 3, 0, 0, 0, 0, 5, 1),
(321, 0, 0, 0, 'Outlaw Camp 5', 400, 3, 0, 0, 0, 0, 5, 1),
(322, 0, 0, 0, 'Outlaw Camp 6', 400, 3, 0, 0, 0, 0, 5, 1),
(323, 0, 0, 0, 'Outlaw Camp 7', 1460, 3, 0, 0, 0, 0, 17, 2),
(324, 0, 0, 0, 'Outlaw Camp 8', 560, 3, 0, 0, 0, 0, 7, 1),
(325, 0, 0, 0, 'Outlaw Camp 9', 400, 3, 0, 0, 0, 0, 5, 1),
(326, 0, 0, 0, 'Outlaw Camp 10', 400, 3, 0, 0, 0, 0, 5, 1),
(327, 0, 0, 0, 'Outlaw Camp 11', 400, 3, 0, 0, 0, 0, 5, 1),
(328, 0, 0, 0, 'Outlaw Camp 12 (Shop)', 560, 3, 0, 0, 0, 0, 7, 0),
(329, 0, 0, 0, 'Outlaw Camp 13 (Shop)', 560, 3, 0, 0, 0, 0, 7, 0),
(330, 0, 0, 0, 'Outlaw Camp 14 (Shop)', 1280, 3, 0, 0, 0, 0, 16, 0),
(331, 0, 0, 0, 'Outlaw Castle', 15200, 3, 0, 0, 0, 0, 180, 9),
(332, 0, 0, 0, 'Blessed Shield Guildhall', 15380, 7, 0, 0, 0, 0, 162, 9),
(333, 0, 0, 0, 'Steel Home', 26490, 7, 0, 0, 0, 0, 281, 13),
(334, 0, 0, 0, 'Swamp Watch', 21080, 7, 0, 0, 0, 0, 222, 12),
(335, 0, 0, 0, 'Golden Axe Guildhall', 20070, 7, 0, 0, 0, 0, 213, 10),
(336, 0, 0, 0, 'Valorous Venore', 28070, 7, 0, 0, 0, 0, 303, 9),
(337, 0, 0, 0, 'Dagger Alley 1', 5230, 7, 0, 0, 0, 0, 57, 2),
(338, 0, 0, 0, 'Iron Alley 1', 6600, 7, 0, 0, 0, 0, 70, 4),
(339, 0, 0, 0, 'Iron Alley 2', 6600, 7, 0, 0, 0, 0, 70, 4),
(340, 0, 0, 0, 'Dream Street 1 (Shop)', 8560, 7, 0, 0, 0, 0, 94, 2),
(341, 0, 0, 0, 'Dream Street 2', 6580, 7, 0, 0, 0, 0, 72, 2),
(342, 0, 0, 0, 'Dream Street 3', 5320, 7, 0, 0, 0, 0, 58, 2),
(343, 0, 0, 0, 'Dream Street 4', 7230, 7, 0, 0, 0, 0, 77, 4),
(344, 0, 0, 0, 'Elm Street 1', 5320, 7, 0, 0, 0, 0, 58, 2),
(345, 0, 0, 0, 'Elm Street 2', 5230, 7, 0, 0, 0, 0, 57, 2),
(346, 0, 0, 0, 'Elm Street 3', 5510, 7, 0, 0, 0, 0, 59, 3),
(347, 0, 0, 0, 'Elm Street 4', 5140, 7, 0, 0, 0, 0, 56, 2),
(348, 0, 0, 0, 'Seagull Walk 1', 10090, 7, 0, 0, 0, 0, 111, 2),
(349, 0, 0, 0, 'Seagull Walk 2', 5330, 7, 0, 0, 0, 0, 57, 3),
(350, 0, 0, 0, 'Lucky Lane 1 (Shop)', 13620, 7, 0, 0, 0, 0, 148, 4),
(351, 0, 0, 0, 'Paupers Palace, Flat 01', 810, 7, 0, 0, 0, 0, 9, 1),
(352, 0, 0, 0, 'Paupers Palace, Flat 02', 900, 7, 0, 0, 0, 0, 10, 1),
(353, 0, 0, 0, 'Paupers Palace, Flat 03', 810, 7, 0, 0, 0, 0, 9, 1),
(354, 0, 0, 0, 'Paupers Palace, Flat 04', 900, 7, 0, 0, 0, 0, 10, 1),
(355, 0, 0, 0, 'Paupers Palace, Flat 05', 630, 7, 0, 0, 0, 0, 7, 1),
(356, 0, 0, 0, 'Paupers Palace, Flat 06', 900, 7, 0, 0, 0, 0, 10, 1),
(357, 0, 0, 0, 'Paupers Palace, Flat 07', 1270, 7, 0, 0, 0, 0, 13, 2),
(358, 0, 0, 0, 'Paupers Palace, Flat 11', 630, 7, 0, 0, 0, 0, 7, 1),
(359, 0, 0, 0, 'Paupers Palace, Flat 12', 1270, 7, 0, 0, 0, 0, 13, 2),
(360, 0, 0, 0, 'Paupers Palace, Flat 13', 900, 7, 0, 0, 0, 0, 10, 1),
(361, 0, 0, 0, 'Paupers Palace, Flat 14', 1170, 7, 0, 0, 0, 0, 13, 1),
(362, 0, 0, 0, 'Paupers Palace, Flat 15', 900, 7, 0, 0, 0, 0, 10, 1),
(363, 0, 0, 0, 'Paupers Palace, Flat 16', 1170, 7, 0, 0, 0, 0, 13, 1),
(364, 0, 0, 0, 'Paupers Palace, Flat 17', 900, 7, 0, 0, 0, 0, 10, 1),
(365, 0, 0, 0, 'Paupers Palace, Flat 18', 630, 7, 0, 0, 0, 0, 7, 1),
(366, 0, 0, 0, 'Paupers Palace, Flat 21', 630, 7, 0, 0, 0, 0, 7, 1),
(367, 0, 0, 0, 'Paupers Palace, Flat 22', 900, 7, 0, 0, 0, 0, 10, 1),
(368, 0, 0, 0, 'Paupers Palace, Flat 23', 1170, 7, 0, 0, 0, 0, 13, 1),
(369, 0, 0, 0, 'Paupers Palace, Flat 24', 900, 7, 0, 0, 0, 0, 10, 1),
(370, 0, 0, 0, 'Paupers Palace, Flat 25', 1170, 7, 0, 0, 0, 0, 13, 1),
(371, 0, 0, 0, 'Paupers Palace, Flat 26', 900, 7, 0, 0, 0, 0, 10, 1),
(372, 0, 0, 0, 'Paupers Palace, Flat 27', 1270, 7, 0, 0, 0, 0, 13, 2),
(373, 0, 0, 0, 'Paupers Palace, Flat 28', 630, 7, 0, 0, 0, 0, 7, 1),
(374, 0, 0, 0, 'Paupers Palace, Flat 31', 1710, 7, 0, 0, 0, 0, 19, 1),
(375, 0, 0, 0, 'Paupers Palace, Flat 32', 2170, 7, 0, 0, 0, 0, 23, 2),
(376, 0, 0, 0, 'Paupers Palace, Flat 33', 1530, 7, 0, 0, 0, 0, 17, 1),
(377, 0, 0, 0, 'Paupers Palace, Flat 34', 3250, 7, 0, 0, 0, 0, 35, 2),
(378, 0, 0, 0, 'Salvation Street 1 (Shop)', 12180, 7, 0, 0, 0, 0, 132, 4),
(379, 0, 0, 0, 'Salvation Street 2', 7480, 7, 0, 0, 0, 0, 82, 2),
(380, 0, 0, 0, 'Salvation Street 3', 7480, 7, 0, 0, 0, 0, 82, 2),
(381, 0, 0, 0, 'Mystic Lane 1', 5690, 7, 0, 0, 0, 0, 61, 3),
(382, 0, 0, 0, 'Mystic Lane 2', 5860, 7, 0, 0, 0, 0, 64, 2),
(383, 0, 0, 0, 'Silver Street 1', 5130, 7, 0, 0, 0, 0, 57, 1),
(384, 0, 0, 0, 'Silver Street 2', 3960, 7, 0, 0, 0, 0, 44, 1),
(385, 0, 0, 0, 'Silver Street 3', 3960, 7, 0, 0, 0, 0, 44, 1),
(386, 0, 0, 0, 'Silver Street 4', 6490, 7, 0, 0, 0, 0, 71, 2),
(387, 0, 0, 0, 'Loot Lane 1 (Shop)', 8930, 7, 0, 0, 0, 0, 97, 3),
(388, 0, 0, 0, 'Old Lighthouse', 7120, 7, 0, 0, 0, 0, 78, 2),
(389, 0, 0, 0, 'Market Street 1', 13160, 7, 0, 0, 0, 0, 144, 3),
(390, 0, 0, 0, 'Market Street 2', 9650, 7, 0, 0, 0, 0, 105, 3),
(391, 0, 0, 0, 'Market Street 3', 6850, 7, 0, 0, 0, 0, 75, 2),
(392, 0, 0, 0, 'Market Street 4 (Shop)', 10010, 7, 0, 0, 0, 0, 109, 3),
(393, 0, 0, 0, 'Market Street 5 (Shop)', 12450, 7, 0, 0, 0, 0, 135, 4),
(394, 0, 0, 0, 'Market Street 6', 10570, 7, 0, 0, 0, 0, 113, 5),
(395, 0, 0, 0, 'Market Street 7', 4510, 7, 0, 0, 0, 0, 49, 2),
(396, 0, 0, 0, 'Shadow Towers', 41900, 4, 0, 0, 0, 0, 402, 18),
(397, 0, 0, 0, 'The Hideout', 39700, 4, 0, 0, 0, 0, 378, 20),
(398, 0, 0, 0, 'Underwood 1', 2890, 4, 0, 0, 0, 0, 31, 2),
(399, 0, 0, 0, 'Underwood 2', 2890, 4, 0, 0, 0, 0, 31, 2),
(400, 0, 0, 0, 'Underwood 3', 3170, 4, 0, 0, 0, 0, 33, 3),
(401, 0, 0, 0, 'Underwood 4', 4170, 4, 0, 0, 0, 0, 43, 4),
(402, 0, 0, 0, 'Underwood 5', 2540, 4, 0, 0, 0, 0, 26, 3),
(403, 0, 0, 0, 'Underwood 6', 2990, 4, 0, 0, 0, 0, 31, 3),
(404, 0, 0, 0, 'Underwood 7', 2720, 4, 0, 0, 0, 0, 28, 3),
(405, 0, 0, 0, 'Underwood 8', 1630, 4, 0, 0, 0, 0, 17, 2),
(406, 0, 0, 0, 'Underwood 9', 1170, 4, 0, 0, 0, 0, 13, 1),
(407, 0, 0, 0, 'Underwood 10', 1170, 4, 0, 0, 0, 0, 13, 1),
(408, 0, 0, 0, 'Ab\'Dendriel Clanhall', 28800, 4, 0, 0, 0, 0, 310, 10),
(409, 0, 0, 0, 'Castle of the Winds', 46070, 4, 0, 0, 0, 0, 493, 18),
(410, 0, 0, 0, 'Great Willow 1a', 1000, 4, 0, 0, 0, 0, 10, 1),
(411, 0, 0, 0, 'Great Willow 1b', 1300, 4, 0, 0, 0, 0, 13, 1),
(412, 0, 0, 0, 'Great Willow 1c', 1300, 4, 0, 0, 0, 0, 13, 1),
(413, 0, 0, 0, 'Great Willow 2a', 1300, 4, 0, 0, 0, 0, 13, 1),
(414, 0, 0, 0, 'Great Willow 2b', 900, 4, 0, 0, 0, 0, 9, 1),
(415, 0, 0, 0, 'Great Willow 2c', 1300, 4, 0, 0, 0, 0, 13, 1),
(416, 0, 0, 0, 'Great Willow 2d', 900, 4, 0, 0, 0, 0, 9, 1),
(417, 0, 0, 0, 'Great Willow 3a', 1300, 4, 0, 0, 0, 0, 13, 1),
(418, 0, 0, 0, 'Great Willow 3b', 900, 4, 0, 0, 0, 0, 9, 1),
(419, 0, 0, 0, 'Great Willow 3c', 1300, 4, 0, 0, 0, 0, 13, 1),
(420, 0, 0, 0, 'Great Willow 3d', 900, 4, 0, 0, 0, 0, 9, 1),
(421, 0, 0, 0, 'Great Willow 4a', 1800, 4, 0, 0, 0, 0, 17, 2),
(422, 0, 0, 0, 'Great Willow 4b', 1800, 4, 0, 0, 0, 0, 17, 2),
(423, 0, 0, 0, 'Great Willow 4c', 1800, 4, 0, 0, 0, 0, 17, 2),
(424, 0, 0, 0, 'Great Willow 4d', 1500, 4, 0, 0, 0, 0, 15, 1),
(425, 0, 0, 0, 'Mangrove 1', 3300, 4, 0, 0, 0, 0, 31, 3),
(426, 0, 0, 0, 'Mangrove 2', 2600, 4, 0, 0, 0, 0, 25, 2),
(427, 0, 0, 0, 'Mangrove 3', 2200, 4, 0, 0, 0, 0, 21, 2),
(428, 0, 0, 0, 'Mangrove 4', 1800, 4, 0, 0, 0, 0, 17, 2),
(429, 0, 0, 0, 'Treetop 1', 1300, 4, 0, 0, 0, 0, 13, 1),
(430, 0, 0, 0, 'Treetop 2', 1300, 4, 0, 0, 0, 0, 13, 1),
(431, 0, 0, 0, 'Treetop 3 (Shop)', 2500, 4, 0, 0, 0, 0, 25, 1),
(432, 0, 0, 0, 'Treetop 4 (Shop)', 2500, 4, 0, 0, 0, 0, 25, 1),
(433, 0, 0, 0, 'Treetop 5 (Shop)', 2700, 4, 0, 0, 0, 0, 27, 1),
(434, 0, 0, 0, 'Treetop 6', 900, 4, 0, 0, 0, 0, 9, 1),
(435, 0, 0, 0, 'Treetop 7', 1600, 4, 0, 0, 0, 0, 16, 1),
(436, 0, 0, 0, 'Treetop 8', 1600, 4, 0, 0, 0, 0, 16, 1),
(437, 0, 0, 0, 'Treetop 9', 2200, 4, 0, 0, 0, 0, 21, 2),
(438, 0, 0, 0, 'Treetop 10', 2200, 4, 0, 0, 0, 0, 21, 2),
(439, 0, 0, 0, 'Treetop 11', 1700, 4, 0, 0, 0, 0, 16, 2),
(440, 0, 0, 0, 'Treetop 12 (Shop)', 2700, 4, 0, 0, 0, 0, 27, 1),
(441, 0, 0, 0, 'Treetop 13', 2700, 4, 0, 0, 0, 0, 26, 2),
(442, 0, 0, 0, 'Coastwood 1', 1860, 4, 0, 0, 0, 0, 16, 2),
(443, 0, 0, 0, 'Coastwood 2', 1860, 4, 0, 0, 0, 0, 16, 2),
(444, 0, 0, 0, 'Coastwood 3', 2520, 4, 0, 0, 0, 0, 22, 2),
(445, 0, 0, 0, 'Coastwood 4', 2190, 4, 0, 0, 0, 0, 19, 2),
(446, 0, 0, 0, 'Coastwood 5', 2960, 4, 0, 0, 0, 0, 26, 2),
(447, 0, 0, 0, 'Coastwood 6 (Shop)', 3190, 4, 0, 0, 0, 0, 29, 1),
(448, 0, 0, 0, 'Coastwood 7', 1320, 4, 0, 0, 0, 0, 12, 1),
(449, 0, 0, 0, 'Coastwood 8', 2410, 4, 0, 0, 0, 0, 21, 2),
(450, 0, 0, 0, 'Coastwood 9', 1870, 4, 0, 0, 0, 0, 17, 1),
(451, 0, 0, 0, 'Coastwood 10', 3060, 4, 0, 0, 0, 0, 26, 3),
(452, 0, 0, 0, 'Shadow Caves 1', 600, 4, 0, 0, 0, 0, 10, 1),
(453, 0, 0, 0, 'Shadow Caves 2', 600, 4, 0, 0, 0, 0, 10, 1),
(454, 0, 0, 0, 'Shadow Caves 3', 600, 4, 0, 0, 0, 0, 10, 1),
(455, 0, 0, 0, 'Shadow Caves 4', 600, 4, 0, 0, 0, 0, 10, 1),
(456, 0, 0, 0, 'Shadow Caves 11', 600, 4, 0, 0, 0, 0, 10, 1),
(457, 0, 0, 0, 'Shadow Caves 12', 600, 4, 0, 0, 0, 0, 10, 1),
(458, 0, 0, 0, 'Shadow Caves 13', 600, 4, 0, 0, 0, 0, 10, 1),
(459, 0, 0, 0, 'Shadow Caves 14', 600, 4, 0, 0, 0, 0, 10, 1),
(460, 0, 0, 0, 'Shadow Caves 15', 600, 4, 0, 0, 0, 0, 10, 1),
(461, 0, 0, 0, 'Shadow Caves 16', 600, 4, 0, 0, 0, 0, 10, 1),
(462, 0, 0, 0, 'Shadow Caves 17', 600, 4, 0, 0, 0, 0, 10, 1),
(463, 0, 0, 0, 'Shadow Caves 18', 600, 4, 0, 0, 0, 0, 10, 1),
(464, 0, 0, 0, 'Shadow Caves 21', 600, 4, 0, 0, 0, 0, 10, 1),
(465, 0, 0, 0, 'Shadow Caves 22', 600, 4, 0, 0, 0, 0, 10, 1),
(466, 0, 0, 0, 'Shadow Caves 23', 600, 4, 0, 0, 0, 0, 10, 1),
(467, 0, 0, 0, 'Shadow Caves 24', 600, 4, 0, 0, 0, 0, 10, 1),
(468, 0, 0, 0, 'Shadow Caves 25', 600, 4, 0, 0, 0, 0, 10, 1),
(469, 0, 0, 0, 'Shadow Caves 26', 600, 4, 0, 0, 0, 0, 10, 1),
(470, 0, 0, 0, 'Shadow Caves 27', 600, 4, 0, 0, 0, 0, 10, 1),
(471, 0, 0, 0, 'Shadow Caves 28', 600, 4, 0, 0, 0, 0, 10, 1),
(472, 0, 0, 0, 'Haggler\'s Hangout 1', 2700, 9, 0, 0, 0, 0, 26, 2),
(473, 0, 0, 0, 'Haggler\'s Hangout 2', 2600, 9, 0, 0, 0, 0, 26, 1),
(474, 0, 0, 0, 'Haggler\'s Hangout 3', 14800, 9, 0, 0, 0, 0, 145, 4),
(475, 0, 0, 0, 'Haggler\'s Hangout 4a', 3700, 9, 0, 0, 0, 0, 37, 1),
(476, 0, 0, 0, 'Haggler\'s Hangout 4b', 3100, 9, 0, 0, 0, 0, 31, 1),
(477, 0, 0, 0, 'Haggler\'s Hangout 5', 3100, 9, 0, 0, 0, 0, 31, 1),
(478, 0, 0, 0, 'Haggler\'s Hangout 6', 12600, 9, 0, 0, 0, 0, 123, 4),
(479, 0, 0, 0, 'Banana Bay 1', 900, 9, 0, 0, 0, 0, 10, 1),
(480, 0, 0, 0, 'Banana Bay 2', 1530, 9, 0, 0, 0, 0, 17, 1),
(481, 0, 0, 0, 'Banana Bay 3', 900, 9, 0, 0, 0, 0, 10, 1),
(482, 0, 0, 0, 'Banana Bay 4', 900, 9, 0, 0, 0, 0, 10, 1),
(483, 0, 0, 0, 'Crocodile Bridge 1', 1990, 9, 0, 0, 0, 0, 21, 2),
(484, 0, 0, 0, 'Crocodile Bridge 2', 1630, 9, 0, 0, 0, 0, 17, 2),
(485, 0, 0, 0, 'Crocodile Bridge 3', 2440, 9, 0, 0, 0, 0, 26, 2),
(486, 0, 0, 0, 'Crocodile Bridge 4', 9210, 9, 0, 0, 0, 0, 99, 4),
(487, 0, 0, 0, 'Crocodile Bridge 5', 7840, 9, 0, 0, 0, 0, 86, 2),
(488, 0, 0, 0, 'Woodway 1', 1530, 9, 0, 0, 0, 0, 17, 1),
(489, 0, 0, 0, 'Woodway 2', 1170, 9, 0, 0, 0, 0, 13, 1),
(490, 0, 0, 0, 'Woodway 3', 2980, 9, 0, 0, 0, 0, 32, 2),
(491, 0, 0, 0, 'Woodway 4', 810, 9, 0, 0, 0, 0, 9, 1),
(492, 0, 0, 0, 'Flamingo Flats 1', 1270, 9, 0, 0, 0, 0, 13, 2),
(493, 0, 0, 0, 'Flamingo Flats 2', 1990, 9, 0, 0, 0, 0, 21, 2),
(494, 0, 0, 0, 'Flamingo Flats 3', 1270, 9, 0, 0, 0, 0, 13, 2),
(495, 0, 0, 0, 'Flamingo Flats 4', 1630, 9, 0, 0, 0, 0, 17, 2),
(496, 0, 0, 0, 'Flamingo Flats 5', 3690, 9, 0, 0, 0, 0, 41, 1),
(497, 0, 0, 0, 'Bamboo Garden 1', 3080, 9, 0, 0, 0, 0, 32, 3),
(498, 0, 0, 0, 'Bamboo Garden 2', 1990, 9, 0, 0, 0, 0, 21, 2),
(499, 0, 0, 0, 'Bamboo Garden 3', 2980, 9, 0, 0, 0, 0, 32, 2),
(500, 0, 0, 0, 'Coconut Quay 1', 3430, 9, 0, 0, 0, 0, 37, 2),
(501, 0, 0, 0, 'Coconut Quay 2', 1990, 9, 0, 0, 0, 0, 21, 2),
(502, 0, 0, 0, 'Coconut Quay 3', 3990, 9, 0, 0, 0, 0, 41, 4),
(503, 0, 0, 0, 'Coconut Quay 4', 4070, 9, 0, 0, 0, 0, 43, 3),
(504, 0, 0, 0, 'River Homes 1', 6770, 9, 0, 0, 0, 0, 73, 3),
(505, 0, 0, 0, 'River Homes 2a', 2440, 9, 0, 0, 0, 0, 26, 2),
(506, 0, 0, 0, 'River Homes 2b', 2990, 9, 0, 0, 0, 0, 31, 3),
(507, 0, 0, 0, 'River Homes 3', 9510, 9, 0, 0, 0, 0, 99, 7),
(508, 0, 0, 0, 'Jungle Edge 1', 4790, 9, 0, 0, 0, 0, 51, 3),
(509, 0, 0, 0, 'Jungle Edge 2', 6140, 9, 0, 0, 0, 0, 66, 3),
(510, 0, 0, 0, 'Jungle Edge 3', 1630, 9, 0, 0, 0, 0, 17, 2),
(511, 0, 0, 0, 'Jungle Edge 4', 1630, 9, 0, 0, 0, 0, 17, 2),
(512, 0, 0, 0, 'Jungle Edge 5', 1630, 9, 0, 0, 0, 0, 17, 2),
(513, 0, 0, 0, 'Jungle Edge 6', 900, 9, 0, 0, 0, 0, 10, 1),
(514, 0, 0, 0, 'Shark Manor', 16160, 9, 0, 0, 0, 0, 164, 15),
(515, 0, 0, 0, 'Bamboo Fortress', 42040, 9, 0, 0, 0, 0, 446, 20),
(516, 0, 0, 0, 'The Treehouse', 46040, 9, 0, 0, 0, 0, 548, 23),
(517, 0, 0, 0, 'Castle Shop 1', 3780, 5, 0, 0, 0, 0, 42, 1),
(518, 0, 0, 0, 'Castle Shop 2', 3780, 5, 0, 0, 0, 0, 42, 1),
(519, 0, 0, 0, 'Castle Shop 3', 3780, 5, 0, 0, 0, 0, 42, 1),
(520, 0, 0, 0, 'Castle, 3rd Floor, Flat 01', 1170, 5, 0, 0, 0, 0, 13, 1),
(521, 0, 0, 0, 'Castle, 3rd Floor, Flat 02', 1530, 5, 0, 0, 0, 0, 17, 1),
(522, 0, 0, 0, 'Castle, 3rd Floor, Flat 03', 1170, 5, 0, 0, 0, 0, 13, 1),
(523, 0, 0, 0, 'Castle, 3rd Floor, Flat 04', 1170, 5, 0, 0, 0, 0, 13, 1),
(524, 0, 0, 0, 'Castle, 3rd Floor, Flat 05', 1530, 5, 0, 0, 0, 0, 17, 1),
(525, 0, 0, 0, 'Castle, 3rd Floor, Flat 06', 1990, 5, 0, 0, 0, 0, 21, 2),
(526, 0, 0, 0, 'Castle, 3rd Floor, Flat 07', 1440, 5, 0, 0, 0, 0, 16, 1),
(527, 0, 0, 0, 'Castle, 4th Floor, Flat 01', 1170, 5, 0, 0, 0, 0, 13, 1),
(528, 0, 0, 0, 'Castle, 4th Floor, Flat 02', 1530, 5, 0, 0, 0, 0, 17, 1),
(529, 0, 0, 0, 'Castle, 4th Floor, Flat 03', 1170, 5, 0, 0, 0, 0, 13, 1),
(530, 0, 0, 0, 'Castle, 4th Floor, Flat 04', 1170, 5, 0, 0, 0, 0, 13, 1),
(531, 0, 0, 0, 'Castle, 4th Floor, Flat 05', 1530, 5, 0, 0, 0, 0, 17, 1),
(532, 0, 0, 0, 'Castle, 4th Floor, Flat 06', 1890, 5, 0, 0, 0, 0, 21, 1),
(533, 0, 0, 0, 'Castle, 4th Floor, Flat 07', 1440, 5, 0, 0, 0, 0, 16, 1),
(534, 0, 0, 0, 'Castle, 4th Floor, Flat 08', 1890, 5, 0, 0, 0, 0, 21, 1),
(535, 0, 0, 0, 'Castle, 4th Floor, Flat 09', 1440, 5, 0, 0, 0, 0, 16, 1),
(536, 0, 0, 0, 'Castle, Basement, Flat 01', 1170, 5, 0, 0, 0, 0, 13, 1),
(537, 0, 0, 0, 'Castle, Basement, Flat 02', 1170, 5, 0, 0, 0, 0, 13, 1),
(538, 0, 0, 0, 'Castle, Basement, Flat 03', 1170, 5, 0, 0, 0, 0, 13, 1),
(539, 0, 0, 0, 'Castle, Basement, Flat 04', 1170, 5, 0, 0, 0, 0, 13, 1),
(540, 0, 0, 0, 'Castle, Basement, Flat 05', 1170, 5, 0, 0, 0, 0, 13, 1),
(541, 0, 0, 0, 'Castle, Basement, Flat 06', 1170, 5, 0, 0, 0, 0, 13, 1),
(542, 0, 0, 0, 'Castle, Basement, Flat 07', 1170, 5, 0, 0, 0, 0, 13, 1),
(543, 0, 0, 0, 'Castle, Basement, Flat 08', 1170, 5, 0, 0, 0, 0, 13, 1),
(544, 0, 0, 0, 'Castle, Basement, Flat 09', 1170, 5, 0, 0, 0, 0, 13, 1),
(545, 0, 0, 0, 'Castle Street 1', 5600, 5, 0, 0, 0, 0, 60, 3),
(546, 0, 0, 0, 'Castle Street 2', 2890, 5, 0, 0, 0, 0, 31, 2),
(547, 0, 0, 0, 'Castle Street 3', 3430, 5, 0, 0, 0, 0, 37, 2),
(548, 0, 0, 0, 'Castle Street 4', 3430, 5, 0, 0, 0, 0, 37, 2),
(549, 0, 0, 0, 'Castle Street 5', 3430, 5, 0, 0, 0, 0, 37, 2),
(550, 0, 0, 0, 'Edron Flats, Flat 01', 800, 5, 0, 0, 0, 0, 10, 1),
(551, 0, 0, 0, 'Edron Flats, Flat 02', 1620, 5, 0, 0, 0, 0, 19, 2),
(552, 0, 0, 0, 'Edron Flats, Flat 03', 800, 5, 0, 0, 0, 0, 10, 1),
(553, 0, 0, 0, 'Edron Flats, Flat 04', 800, 5, 0, 0, 0, 0, 10, 1),
(554, 0, 0, 0, 'Edron Flats, Flat 05', 800, 5, 0, 0, 0, 0, 10, 1),
(555, 0, 0, 0, 'Edron Flats, Flat 06', 800, 5, 0, 0, 0, 0, 10, 1),
(556, 0, 0, 0, 'Edron Flats, Flat 07', 800, 5, 0, 0, 0, 0, 10, 1),
(557, 0, 0, 0, 'Edron Flats, Flat 08', 800, 5, 0, 0, 0, 0, 10, 1),
(558, 0, 0, 0, 'Edron Flats, Flat 11', 800, 5, 0, 0, 0, 0, 10, 1),
(559, 0, 0, 0, 'Edron Flats, Flat 12', 800, 5, 0, 0, 0, 0, 10, 1),
(560, 0, 0, 0, 'Edron Flats, Flat 13', 800, 5, 0, 0, 0, 0, 10, 1),
(561, 0, 0, 0, 'Edron Flats, Flat 14', 800, 5, 0, 0, 0, 0, 10, 1),
(562, 0, 0, 0, 'Edron Flats, Flat 15', 800, 5, 0, 0, 0, 0, 10, 1),
(563, 0, 0, 0, 'Edron Flats, Flat 16', 800, 5, 0, 0, 0, 0, 10, 1),
(564, 0, 0, 0, 'Edron Flats, Flat 17', 800, 5, 0, 0, 0, 0, 10, 1),
(565, 0, 0, 0, 'Edron Flats, Flat 18', 800, 5, 0, 0, 0, 0, 10, 1),
(566, 0, 0, 0, 'Edron Flats, Flat 21', 1620, 5, 0, 0, 0, 0, 19, 2),
(567, 0, 0, 0, 'Edron Flats, Flat 22', 800, 5, 0, 0, 0, 0, 10, 1),
(568, 0, 0, 0, 'Edron Flats, Flat 23', 800, 5, 0, 0, 0, 0, 10, 1),
(569, 0, 0, 0, 'Edron Flats, Flat 24', 800, 5, 0, 0, 0, 0, 10, 1),
(570, 0, 0, 0, 'Edron Flats, Flat 25', 800, 5, 0, 0, 0, 0, 10, 1),
(571, 0, 0, 0, 'Edron Flats, Flat 26', 800, 5, 0, 0, 0, 0, 10, 1),
(572, 0, 0, 0, 'Edron Flats, Flat 27', 800, 5, 0, 0, 0, 0, 10, 1),
(573, 0, 0, 0, 'Edron Flats, Flat 28', 800, 5, 0, 0, 0, 0, 10, 1),
(574, 0, 0, 0, 'Edron Flats, Basement Flat 1', 2980, 5, 0, 0, 0, 0, 36, 2),
(575, 0, 0, 0, 'Edron Flats, Basement Flat 2', 2980, 5, 0, 0, 0, 0, 36, 2),
(576, 0, 0, 0, 'Central Circle 1', 5940, 5, 0, 0, 0, 0, 73, 2),
(577, 0, 0, 0, 'Central Circle 2', 6500, 5, 0, 0, 0, 0, 80, 2),
(578, 0, 0, 0, 'Central Circle 3', 7920, 5, 0, 0, 0, 0, 94, 5),
(579, 0, 0, 0, 'Central Circle 4', 7920, 5, 0, 0, 0, 0, 94, 5),
(580, 0, 0, 0, 'Central Circle 5', 7920, 5, 0, 0, 0, 0, 94, 5),
(581, 0, 0, 0, 'Central Circle 6 (Shop)', 7860, 5, 0, 0, 0, 0, 97, 2),
(582, 0, 0, 0, 'Central Circle 7 (Shop)', 7860, 5, 0, 0, 0, 0, 97, 2),
(583, 0, 0, 0, 'Central Circle 8 (Shop)', 7860, 5, 0, 0, 0, 0, 97, 2),
(584, 0, 0, 0, 'Central Circle 9a', 1780, 5, 0, 0, 0, 0, 21, 2),
(585, 0, 0, 0, 'Central Circle 9b', 1780, 5, 0, 0, 0, 0, 21, 2),
(586, 0, 0, 0, 'Wood Avenue 1', 3430, 5, 0, 0, 0, 0, 37, 2),
(587, 0, 0, 0, 'Wood Avenue 2', 3430, 5, 0, 0, 0, 0, 37, 2),
(588, 0, 0, 0, 'Wood Avenue 3', 3430, 5, 0, 0, 0, 0, 37, 2),
(589, 0, 0, 0, 'Wood Avenue 4', 3430, 5, 0, 0, 0, 0, 37, 2),
(590, 0, 0, 0, 'Wood Avenue 5', 3430, 5, 0, 0, 0, 0, 37, 2),
(591, 0, 0, 0, 'Wood Avenue 6a', 2800, 5, 0, 0, 0, 0, 30, 2),
(592, 0, 0, 0, 'Wood Avenue 6b', 2800, 5, 0, 0, 0, 0, 30, 2),
(593, 0, 0, 0, 'Wood Avenue 7', 11720, 5, 0, 0, 0, 0, 128, 3),
(594, 0, 0, 0, 'Wood Avenue 8', 11720, 5, 0, 0, 0, 0, 128, 3),
(595, 0, 0, 0, 'Wood Avenue 9a', 2980, 5, 0, 0, 0, 0, 32, 2),
(596, 0, 0, 0, 'Wood Avenue 9b', 2890, 5, 0, 0, 0, 0, 31, 2),
(597, 0, 0, 0, 'Wood Avenue 10a', 2980, 5, 0, 0, 0, 0, 32, 2),
(598, 0, 0, 0, 'Wood Avenue 10b', 2990, 5, 0, 0, 0, 0, 31, 3),
(599, 0, 0, 0, 'Wood Avenue 11', 13910, 5, 0, 0, 0, 0, 149, 6),
(600, 0, 0, 0, 'Wood Avenue 4a', 2890, 5, 0, 0, 0, 0, 31, 2),
(601, 0, 0, 0, 'Wood Avenue 4b', 2890, 5, 0, 0, 0, 0, 31, 2),
(602, 0, 0, 0, 'Wood Avenue 4c', 3430, 5, 0, 0, 0, 0, 37, 2),
(603, 0, 0, 0, 'Sky Lane, Guild 1', 40090, 5, 0, 0, 0, 0, 421, 23),
(604, 0, 0, 0, 'Sky Lane, Guild 2', 37300, 5, 0, 0, 0, 0, 400, 14),
(605, 0, 0, 0, 'Sky Lane, Guild 3', 32930, 5, 0, 0, 0, 0, 347, 18),
(606, 0, 0, 0, 'Sky Lane, Sea Tower', 9050, 5, 0, 0, 0, 0, 95, 6),
(607, 0, 0, 0, 'Magic Academy, Guild', 22750, 5, 0, 0, 0, 0, 195, 14),
(608, 0, 0, 0, 'Magic Academy, Shop', 3190, 5, 0, 0, 0, 0, 29, 1),
(609, 0, 0, 0, 'Magic Academy, Flat 1', 2730, 5, 0, 0, 0, 0, 23, 3),
(610, 0, 0, 0, 'Magic Academy, Flat 2', 2960, 5, 0, 0, 0, 0, 26, 2),
(611, 0, 0, 0, 'Magic Academy, Flat 3', 2860, 5, 0, 0, 0, 0, 26, 1),
(612, 0, 0, 0, 'Magic Academy, Flat 4', 2960, 5, 0, 0, 0, 0, 26, 2),
(613, 0, 0, 0, 'Magic Academy, Flat 5', 2860, 5, 0, 0, 0, 0, 26, 1),
(614, 0, 0, 0, 'Stonehome Village 1', 3460, 5, 0, 0, 0, 0, 42, 2),
(615, 0, 0, 0, 'Stonehome Village 2', 1280, 5, 0, 0, 0, 0, 16, 1),
(616, 0, 0, 0, 'Stonehome Village 3', 1360, 5, 0, 0, 0, 0, 17, 1),
(617, 0, 0, 0, 'Stonehome Village 4', 1780, 5, 0, 0, 0, 0, 21, 2),
(618, 0, 0, 0, 'Stonehome Village 5', 2180, 5, 0, 0, 0, 0, 26, 2),
(619, 0, 0, 0, 'Stonehome Village 6', 2500, 5, 0, 0, 0, 0, 30, 2),
(620, 0, 0, 0, 'Stonehome Village 7', 2180, 5, 0, 0, 0, 0, 26, 2),
(621, 0, 0, 0, 'Stonehome Village 8', 1360, 5, 0, 0, 0, 0, 17, 1),
(622, 0, 0, 0, 'Stonehome Village 9', 1360, 5, 0, 0, 0, 0, 17, 1),
(623, 0, 0, 0, 'Stonehome Flats, Flat 01', 800, 5, 0, 0, 0, 0, 10, 1),
(624, 0, 0, 0, 'Stonehome Flats, Flat 02', 1380, 5, 0, 0, 0, 0, 16, 2),
(625, 0, 0, 0, 'Stonehome Flats, Flat 03', 800, 5, 0, 0, 0, 0, 10, 1),
(626, 0, 0, 0, 'Stonehome Flats, Flat 04', 800, 5, 0, 0, 0, 0, 10, 1),
(627, 0, 0, 0, 'Stonehome Flats, Flat 05', 800, 5, 0, 0, 0, 0, 10, 1),
(628, 0, 0, 0, 'Stonehome Flats, Flat 06', 800, 5, 0, 0, 0, 0, 10, 1),
(629, 0, 0, 0, 'Stonehome Flats, Flat 11', 1380, 5, 0, 0, 0, 0, 16, 2),
(630, 0, 0, 0, 'Stonehome Flats, Flat 12', 1380, 5, 0, 0, 0, 0, 16, 2),
(631, 0, 0, 0, 'Stonehome Flats, Flat 13', 800, 5, 0, 0, 0, 0, 10, 1),
(632, 0, 0, 0, 'Stonehome Flats, Flat 14', 800, 5, 0, 0, 0, 0, 10, 1),
(633, 0, 0, 0, 'Stonehome Flats, Flat 15', 800, 5, 0, 0, 0, 0, 10, 1),
(634, 0, 0, 0, 'Stonehome Flats, Flat 16', 800, 5, 0, 0, 0, 0, 10, 1),
(635, 0, 0, 0, 'Stonehome Clanhall', 16260, 5, 0, 0, 0, 0, 192, 10),
(636, 0, 0, 0, 'Cormaya Flats, Flat 01', 900, 5, 0, 0, 0, 0, 10, 1),
(637, 0, 0, 0, 'Cormaya Flats, Flat 02', 900, 5, 0, 0, 0, 0, 10, 1),
(638, 0, 0, 0, 'Cormaya Flats, Flat 03', 1540, 5, 0, 0, 0, 0, 16, 2),
(639, 0, 0, 0, 'Cormaya Flats, Flat 04', 1540, 5, 0, 0, 0, 0, 16, 2),
(640, 0, 0, 0, 'Cormaya Flats, Flat 05', 900, 5, 0, 0, 0, 0, 10, 1),
(641, 0, 0, 0, 'Cormaya Flats, Flat 06', 900, 5, 0, 0, 0, 0, 10, 1),
(642, 0, 0, 0, 'Cormaya Flats, Flat 11', 900, 5, 0, 0, 0, 0, 10, 1),
(643, 0, 0, 0, 'Cormaya Flats, Flat 12', 900, 5, 0, 0, 0, 0, 10, 1),
(644, 0, 0, 0, 'Cormaya Flats, Flat 13', 1540, 5, 0, 0, 0, 0, 16, 2),
(645, 0, 0, 0, 'Cormaya Flats, Flat 14', 1540, 5, 0, 0, 0, 0, 16, 2),
(646, 0, 0, 0, 'Cormaya Flats, Flat 15', 900, 5, 0, 0, 0, 0, 10, 1),
(647, 0, 0, 0, 'Cormaya Flats, Flat 16', 900, 5, 0, 0, 0, 0, 10, 1),
(648, 0, 0, 0, 'Cormaya 1', 2440, 5, 0, 0, 0, 0, 26, 2),
(649, 0, 0, 0, 'Cormaya 2', 7220, 5, 0, 0, 0, 0, 78, 3),
(650, 0, 0, 0, 'Cormaya 3', 3970, 5, 0, 0, 0, 0, 43, 2),
(651, 0, 0, 0, 'Cormaya 4', 3340, 5, 0, 0, 0, 0, 36, 2),
(652, 0, 0, 0, 'Cormaya 5', 11000, 5, 0, 0, 0, 0, 120, 3),
(653, 0, 0, 0, 'Cormaya 6', 4690, 5, 0, 0, 0, 0, 51, 2),
(654, 0, 0, 0, 'Cormaya 7', 4690, 5, 0, 0, 0, 0, 51, 2),
(655, 0, 0, 0, 'Cormaya 8', 5320, 5, 0, 0, 0, 0, 58, 2),
(656, 0, 0, 0, 'Cormaya 9a', 2350, 5, 0, 0, 0, 0, 25, 2),
(657, 0, 0, 0, 'Cormaya 9b', 5140, 5, 0, 0, 0, 0, 56, 2),
(658, 0, 0, 0, 'Cormaya 9c', 2350, 5, 0, 0, 0, 0, 25, 2),
(659, 0, 0, 0, 'Cormaya 9d', 5140, 5, 0, 0, 0, 0, 56, 2),
(660, 0, 0, 0, 'Cormaya 10', 7400, 5, 0, 0, 0, 0, 80, 3),
(661, 0, 0, 0, 'Cormaya 11', 3970, 5, 0, 0, 0, 0, 43, 2),
(662, 0, 0, 0, 'Castle of the White Dragon', 48150, 5, 0, 0, 0, 0, 515, 19),
(663, 0, 0, 0, 'Chameken I', 1700, 8, 0, 0, 0, 0, 17, 1),
(664, 0, 0, 0, 'Chameken II', 1700, 8, 0, 0, 0, 0, 17, 1),
(665, 0, 0, 0, 'Thanah I a', 1700, 8, 0, 0, 0, 0, 17, 1),
(666, 0, 0, 0, 'Thanah I b', 5800, 8, 0, 0, 0, 0, 56, 3),
(667, 0, 0, 0, 'Thanah I c', 6300, 8, 0, 0, 0, 0, 61, 3),
(668, 0, 0, 0, 'Thanah I d', 5500, 8, 0, 0, 0, 0, 52, 4),
(669, 0, 0, 0, 'Thanah II a', 1700, 8, 0, 0, 0, 0, 17, 1),
(670, 0, 0, 0, 'Thanah II b', 900, 8, 0, 0, 0, 0, 9, 1),
(671, 0, 0, 0, 'Thanah II c', 900, 8, 0, 0, 0, 0, 9, 1),
(672, 0, 0, 0, 'Thanah II d', 700, 8, 0, 0, 0, 0, 7, 1),
(673, 0, 0, 0, 'Thanah II e', 700, 8, 0, 0, 0, 0, 7, 1),
(674, 0, 0, 0, 'Thanah II f', 5500, 8, 0, 0, 0, 0, 53, 3),
(675, 0, 0, 0, 'Thanah II g', 3200, 8, 0, 0, 0, 0, 31, 2),
(676, 0, 0, 0, 'Thanah II h', 2700, 8, 0, 0, 0, 0, 26, 2),
(677, 0, 0, 0, 'Thrarhor I a (Shop)', 2100, 8, 0, 0, 0, 0, 21, 1),
(678, 0, 0, 0, 'Thrarhor I b (Shop)', 2100, 8, 0, 0, 0, 0, 21, 1),
(679, 0, 0, 0, 'Thrarhor I c (Shop)', 2100, 8, 0, 0, 0, 0, 21, 1),
(680, 0, 0, 0, 'Thrarhor I d (Shop)', 2100, 8, 0, 0, 0, 0, 21, 1),
(681, 0, 0, 0, 'Botham I a', 1900, 8, 0, 0, 0, 0, 19, 1),
(682, 0, 0, 0, 'Botham I b', 5800, 8, 0, 0, 0, 0, 56, 3),
(683, 0, 0, 0, 'Botham I c', 3300, 8, 0, 0, 0, 0, 32, 2),
(684, 0, 0, 0, 'Botham I d', 5900, 8, 0, 0, 0, 0, 57, 3),
(685, 0, 0, 0, 'Botham I e', 3200, 8, 0, 0, 0, 0, 31, 2),
(686, 0, 0, 0, 'Botham II a', 1700, 8, 0, 0, 0, 0, 17, 1),
(687, 0, 0, 0, 'Botham II b', 3100, 8, 0, 0, 0, 0, 30, 2),
(688, 0, 0, 0, 'Botham II c', 2400, 8, 0, 0, 0, 0, 23, 2),
(689, 0, 0, 0, 'Botham II d', 3800, 8, 0, 0, 0, 0, 37, 2),
(690, 0, 0, 0, 'Botham II e', 3200, 8, 0, 0, 0, 0, 31, 2),
(691, 0, 0, 0, 'Botham II f', 3200, 8, 0, 0, 0, 0, 31, 2),
(692, 0, 0, 0, 'Botham II g', 2700, 8, 0, 0, 0, 0, 26, 2),
(693, 0, 0, 0, 'Botham III a', 2700, 8, 0, 0, 0, 0, 26, 2),
(694, 0, 0, 0, 'Botham III b', 1800, 8, 0, 0, 0, 0, 17, 2),
(695, 0, 0, 0, 'Botham III c', 1700, 8, 0, 0, 0, 0, 17, 1),
(696, 0, 0, 0, 'Botham III d', 1700, 8, 0, 0, 0, 0, 17, 1),
(697, 0, 0, 0, 'Botham III e', 1700, 8, 0, 0, 0, 0, 17, 1),
(698, 0, 0, 0, 'Botham III f', 4500, 8, 0, 0, 0, 0, 43, 3),
(699, 0, 0, 0, 'Botham III g', 3200, 8, 0, 0, 0, 0, 31, 2),
(700, 0, 0, 0, 'Botham III h', 7300, 8, 0, 0, 0, 0, 71, 3),
(701, 0, 0, 0, 'Botham IV a', 2700, 8, 0, 0, 0, 0, 26, 2),
(702, 0, 0, 0, 'Botham IV b', 1700, 8, 0, 0, 0, 0, 17, 1),
(703, 0, 0, 0, 'Botham IV c', 1700, 8, 0, 0, 0, 0, 17, 1),
(704, 0, 0, 0, 'Botham IV d', 1700, 8, 0, 0, 0, 0, 17, 1),
(705, 0, 0, 0, 'Botham IV e', 1700, 8, 0, 0, 0, 0, 17, 1),
(706, 0, 0, 0, 'Botham IV f', 3300, 8, 0, 0, 0, 0, 32, 2),
(707, 0, 0, 0, 'Botham IV g', 3200, 8, 0, 0, 0, 0, 31, 2),
(708, 0, 0, 0, 'Botham IV h', 3700, 8, 0, 0, 0, 0, 37, 1),
(709, 0, 0, 0, 'Botham IV i', 3400, 8, 0, 0, 0, 0, 32, 3),
(710, 0, 0, 0, 'Ramen Tah', 13800, 8, 0, 0, 0, 0, 123, 16),
(711, 0, 0, 0, 'Charsirakh I a', 560, 8, 0, 0, 0, 0, 7, 1),
(712, 0, 0, 0, 'Charsirakh I b', 3060, 8, 0, 0, 0, 0, 37, 2),
(713, 0, 0, 0, 'Charsirakh II', 2180, 8, 0, 0, 0, 0, 26, 2),
(714, 0, 0, 0, 'Charsirakh III', 1360, 8, 0, 0, 0, 0, 17, 1),
(715, 0, 0, 0, 'Othehothep I a', 560, 8, 0, 0, 0, 0, 7, 1),
(716, 0, 0, 0, 'Othehothep I b', 2660, 8, 0, 0, 0, 0, 32, 2),
(717, 0, 0, 0, 'Othehothep I c', 3240, 8, 0, 0, 0, 0, 38, 3),
(718, 0, 0, 0, 'Othehothep I d', 3740, 8, 0, 0, 0, 0, 43, 4),
(719, 0, 0, 0, 'Othehothep II a', 800, 8, 0, 0, 0, 0, 10, 1),
(720, 0, 0, 0, 'Othehothep II b', 3640, 8, 0, 0, 0, 0, 43, 3),
(721, 0, 0, 0, 'Othehothep II c', 1680, 8, 0, 0, 0, 0, 21, 1),
(722, 0, 0, 0, 'Othehothep II d', 1680, 8, 0, 0, 0, 0, 21, 1),
(723, 0, 0, 0, 'Othehothep II e', 2580, 8, 0, 0, 0, 0, 31, 2),
(724, 0, 0, 0, 'Othehothep II f', 2580, 8, 0, 0, 0, 0, 31, 2),
(725, 0, 0, 0, 'Othehothep III a', 560, 8, 0, 0, 0, 0, 7, 1),
(726, 0, 0, 0, 'Othehothep III b', 2580, 8, 0, 0, 0, 0, 31, 2),
(727, 0, 0, 0, 'Othehothep III c', 1780, 8, 0, 0, 0, 0, 21, 2),
(728, 0, 0, 0, 'Othehothep III d', 2080, 8, 0, 0, 0, 0, 26, 1),
(729, 0, 0, 0, 'Othehothep III e', 1680, 8, 0, 0, 0, 0, 21, 1),
(730, 0, 0, 0, 'Othehothep III f', 1360, 8, 0, 0, 0, 0, 17, 1),
(731, 0, 0, 0, 'Harrah I', 10580, 8, 0, 0, 0, 0, 121, 10),
(732, 0, 0, 0, 'Murkhol I a', 880, 8, 0, 0, 0, 0, 11, 1),
(733, 0, 0, 0, 'Murkhol I b', 880, 8, 0, 0, 0, 0, 11, 1),
(734, 0, 0, 0, 'Murkhol I c', 880, 8, 0, 0, 0, 0, 11, 1),
(735, 0, 0, 0, 'Murkhol I d', 880, 8, 0, 0, 0, 0, 11, 1),
(736, 0, 0, 0, 'Oskahl I a', 3060, 8, 0, 0, 0, 0, 37, 2),
(737, 0, 0, 0, 'Oskahl I b', 1680, 8, 0, 0, 0, 0, 21, 1),
(738, 0, 0, 0, 'Oskahl I c', 1360, 8, 0, 0, 0, 0, 17, 1),
(739, 0, 0, 0, 'Oskahl I d', 2180, 8, 0, 0, 0, 0, 26, 2),
(740, 0, 0, 0, 'Oskahl I e', 1680, 8, 0, 0, 0, 0, 21, 1),
(741, 0, 0, 0, 'Oskahl I f', 1680, 8, 0, 0, 0, 0, 21, 1),
(742, 0, 0, 0, 'Oskahl I g', 2180, 8, 0, 0, 0, 0, 26, 2),
(743, 0, 0, 0, 'Oskahl I h', 3320, 8, 0, 0, 0, 0, 39, 3),
(744, 0, 0, 0, 'Oskahl I i', 1680, 8, 0, 0, 0, 0, 21, 1),
(745, 0, 0, 0, 'Oskahl I j', 1360, 8, 0, 0, 0, 0, 17, 1),
(746, 0, 0, 0, 'Mothrem I', 2180, 8, 0, 0, 0, 0, 26, 2),
(747, 0, 0, 0, 'Arakmehn I', 2440, 8, 0, 0, 0, 0, 28, 3),
(748, 0, 0, 0, 'Arakmehn II', 2080, 8, 0, 0, 0, 0, 26, 1),
(749, 0, 0, 0, 'Arakmehn III', 2180, 8, 0, 0, 0, 0, 26, 2),
(750, 0, 0, 0, 'Arakmehn IV', 2340, 8, 0, 0, 0, 0, 28, 2),
(751, 0, 0, 0, 'Unklath I a', 2180, 8, 0, 0, 0, 0, 26, 2),
(752, 0, 0, 0, 'Unklath I b', 2820, 8, 0, 0, 0, 0, 34, 2),
(753, 0, 0, 0, 'Unklath I c', 2820, 8, 0, 0, 0, 0, 34, 2),
(754, 0, 0, 0, 'Unklath I d', 3160, 8, 0, 0, 0, 0, 37, 3),
(755, 0, 0, 0, 'Unklath I e', 3060, 8, 0, 0, 0, 0, 37, 2),
(756, 0, 0, 0, 'Unklath I f', 3060, 8, 0, 0, 0, 0, 37, 2),
(757, 0, 0, 0, 'Unklath I g', 2960, 8, 0, 0, 0, 0, 37, 1),
(758, 0, 0, 0, 'Unklath II a', 2080, 8, 0, 0, 0, 0, 26, 1),
(759, 0, 0, 0, 'Unklath II b', 1360, 8, 0, 0, 0, 0, 17, 1),
(760, 0, 0, 0, 'Unklath II c', 1360, 8, 0, 0, 0, 0, 17, 1),
(761, 0, 0, 0, 'Unklath II d', 3060, 8, 0, 0, 0, 0, 37, 2),
(762, 0, 0, 0, 'Rathal I a', 2180, 8, 0, 0, 0, 0, 26, 2),
(763, 0, 0, 0, 'Rathal I b', 1360, 8, 0, 0, 0, 0, 17, 1),
(764, 0, 0, 0, 'Rathal I c', 1360, 8, 0, 0, 0, 0, 17, 1),
(765, 0, 0, 0, 'Rathal I d', 1460, 8, 0, 0, 0, 0, 17, 2),
(766, 0, 0, 0, 'Rathal I e', 1460, 8, 0, 0, 0, 0, 17, 2),
(767, 0, 0, 0, 'Rathal II a', 2080, 8, 0, 0, 0, 0, 26, 1),
(768, 0, 0, 0, 'Rathal II b', 1360, 8, 0, 0, 0, 0, 17, 1),
(769, 0, 0, 0, 'Rathal II c', 1360, 8, 0, 0, 0, 0, 17, 1),
(770, 0, 0, 0, 'Rathal II d', 2820, 8, 0, 0, 0, 0, 34, 2),
(771, 0, 0, 0, 'Uthemath I a', 800, 8, 0, 0, 0, 0, 10, 1),
(772, 0, 0, 0, 'Uthemath I b', 1600, 8, 0, 0, 0, 0, 20, 1),
(773, 0, 0, 0, 'Uthemath I c', 1700, 8, 0, 0, 0, 0, 20, 2),
(774, 0, 0, 0, 'Uthemath I d', 1680, 8, 0, 0, 0, 0, 21, 1),
(775, 0, 0, 0, 'Uthemath I e', 1780, 8, 0, 0, 0, 0, 21, 2),
(776, 0, 0, 0, 'Uthemath I f', 4680, 8, 0, 0, 0, 0, 56, 3),
(777, 0, 0, 0, 'Uthemath II', 8220, 8, 0, 0, 0, 0, 94, 8),
(778, 0, 0, 0, 'Esuph I', 1360, 8, 0, 0, 0, 0, 17, 1),
(779, 0, 0, 0, 'Esuph II a', 560, 8, 0, 0, 0, 0, 7, 1),
(780, 0, 0, 0, 'Esuph II b', 2660, 8, 0, 0, 0, 0, 32, 2),
(781, 0, 0, 0, 'Esuph III a', 560, 8, 0, 0, 0, 0, 7, 1),
(782, 0, 0, 0, 'Esuph III b', 2580, 8, 0, 0, 0, 0, 31, 2),
(783, 0, 0, 0, 'Esuph IV a', 800, 8, 0, 0, 0, 0, 10, 1),
(784, 0, 0, 0, 'Esuph IV b', 800, 8, 0, 0, 0, 0, 10, 1),
(785, 0, 0, 0, 'Esuph IV c', 800, 8, 0, 0, 0, 0, 10, 1),
(786, 0, 0, 0, 'Esuph IV d', 1600, 8, 0, 0, 0, 0, 20, 1),
(787, 0, 0, 0, 'Horakhal', 17540, 8, 0, 0, 0, 0, 203, 14),
(788, 0, 0, 0, 'Darashia 1, Flat 01', 2100, 6, 0, 0, 0, 0, 25, 2),
(789, 0, 0, 0, 'Darashia 1, Flat 02', 2000, 6, 0, 0, 0, 0, 25, 1),
(790, 0, 0, 0, 'Darashia 1, Flat 03', 5020, 6, 0, 0, 0, 0, 59, 4),
(791, 0, 0, 0, 'Darashia 1, Flat 04', 2000, 6, 0, 0, 0, 0, 25, 1),
(792, 0, 0, 0, 'Darashia 1, Flat 05', 2100, 6, 0, 0, 0, 0, 25, 2),
(793, 0, 0, 0, 'Darashia 1, Flat 11', 2100, 6, 0, 0, 0, 0, 25, 2),
(794, 0, 0, 0, 'Darashia 1, Flat 12', 3460, 6, 0, 0, 0, 0, 42, 2),
(795, 0, 0, 0, 'Darashia 1, Flat 13', 3460, 6, 0, 0, 0, 0, 42, 2),
(796, 0, 0, 0, 'Darashia 1, Flat 14', 5120, 6, 0, 0, 0, 0, 59, 5);
INSERT INTO `houses` (`id`, `owner`, `paid`, `warnings`, `name`, `rent`, `town_id`, `bid`, `bid_end`, `last_bid`, `highest_bidder`, `size`, `beds`) VALUES
(797, 0, 0, 0, 'Darashia 2, Flat 01', 2000, 6, 0, 0, 0, 0, 25, 1),
(798, 0, 0, 0, 'Darashia 2, Flat 02', 2000, 6, 0, 0, 0, 0, 25, 1),
(799, 0, 0, 0, 'Darashia 2, Flat 03', 2320, 6, 0, 0, 0, 0, 29, 1),
(800, 0, 0, 0, 'Darashia 2, Flat 04', 1040, 6, 0, 0, 0, 0, 13, 1),
(801, 0, 0, 0, 'Darashia 2, Flat 05', 2420, 6, 0, 0, 0, 0, 29, 2),
(802, 0, 0, 0, 'Darashia 2, Flat 06', 1040, 6, 0, 0, 0, 0, 13, 1),
(803, 0, 0, 0, 'Darashia 2, Flat 07', 2000, 6, 0, 0, 0, 0, 25, 1),
(804, 0, 0, 0, 'Darashia 2, Flat 11', 2000, 6, 0, 0, 0, 0, 25, 1),
(805, 0, 0, 0, 'Darashia 2, Flat 12', 1040, 6, 0, 0, 0, 0, 13, 1),
(806, 0, 0, 0, 'Darashia 2, Flat 13', 2320, 6, 0, 0, 0, 0, 29, 1),
(807, 0, 0, 0, 'Darashia 2, Flat 14', 1040, 6, 0, 0, 0, 0, 13, 1),
(808, 0, 0, 0, 'Darashia 2, Flat 15', 2420, 6, 0, 0, 0, 0, 29, 2),
(809, 0, 0, 0, 'Darashia 2, Flat 16', 1360, 6, 0, 0, 0, 0, 17, 1),
(810, 0, 0, 0, 'Darashia 2, Flat 17', 2000, 6, 0, 0, 0, 0, 25, 1),
(811, 0, 0, 0, 'Darashia 2, Flat 18', 1360, 6, 0, 0, 0, 0, 17, 1),
(812, 0, 0, 0, 'Darashia 3, Flat 01', 2100, 6, 0, 0, 0, 0, 25, 2),
(813, 0, 0, 0, 'Darashia 3, Flat 02', 3140, 6, 0, 0, 0, 0, 38, 2),
(814, 0, 0, 0, 'Darashia 3, Flat 03', 2100, 6, 0, 0, 0, 0, 25, 2),
(815, 0, 0, 0, 'Darashia 3, Flat 04', 3140, 6, 0, 0, 0, 0, 38, 2),
(816, 0, 0, 0, 'Darashia 3, Flat 05', 2000, 6, 0, 0, 0, 0, 25, 1),
(817, 0, 0, 0, 'Darashia 3, Flat 11', 2000, 6, 0, 0, 0, 0, 25, 1),
(818, 0, 0, 0, 'Darashia 3, Flat 12', 4800, 6, 0, 0, 0, 0, 55, 5),
(819, 0, 0, 0, 'Darashia 3, Flat 13', 2100, 6, 0, 0, 0, 0, 25, 2),
(820, 0, 0, 0, 'Darashia 3, Flat 14', 4600, 6, 0, 0, 0, 0, 55, 3),
(821, 0, 0, 0, 'Darashia 4, Flat 01', 2000, 6, 0, 0, 0, 0, 25, 1),
(822, 0, 0, 0, 'Darashia 4, Flat 02', 3460, 6, 0, 0, 0, 0, 42, 2),
(823, 0, 0, 0, 'Darashia 4, Flat 03', 2000, 6, 0, 0, 0, 0, 25, 1),
(824, 0, 0, 0, 'Darashia 4, Flat 04', 3460, 6, 0, 0, 0, 0, 42, 2),
(825, 0, 0, 0, 'Darashia 4, Flat 05', 2100, 6, 0, 0, 0, 0, 25, 2),
(826, 0, 0, 0, 'Darashia 4, Flat 11', 2000, 6, 0, 0, 0, 0, 25, 1),
(827, 0, 0, 0, 'Darashia 4, Flat 12', 4920, 6, 0, 0, 0, 0, 59, 3),
(828, 0, 0, 0, 'Darashia 4, Flat 13', 3460, 6, 0, 0, 0, 0, 42, 2),
(829, 0, 0, 0, 'Darashia 4, Flat 14', 3460, 6, 0, 0, 0, 0, 42, 2),
(830, 0, 0, 0, 'Darashia 5, Flat 01', 2000, 6, 0, 0, 0, 0, 25, 1),
(831, 0, 0, 0, 'Darashia 5, Flat 02', 3140, 6, 0, 0, 0, 0, 38, 2),
(832, 0, 0, 0, 'Darashia 5, Flat 03', 2000, 6, 0, 0, 0, 0, 25, 1),
(833, 0, 0, 0, 'Darashia 5, Flat 04', 3140, 6, 0, 0, 0, 0, 38, 2),
(834, 0, 0, 0, 'Darashia 5, Flat 05', 2000, 6, 0, 0, 0, 0, 25, 1),
(835, 0, 0, 0, 'Darashia 5, Flat 11', 3460, 6, 0, 0, 0, 0, 42, 2),
(836, 0, 0, 0, 'Darashia 5, Flat 12', 3140, 6, 0, 0, 0, 0, 38, 2),
(837, 0, 0, 0, 'Darashia 5, Flat 13', 3460, 6, 0, 0, 0, 0, 42, 2),
(838, 0, 0, 0, 'Darashia 5, Flat 14', 3140, 6, 0, 0, 0, 0, 38, 2),
(839, 0, 0, 0, 'Darashia 6a', 6130, 6, 0, 0, 0, 0, 67, 2),
(840, 0, 0, 0, 'Darashia 6b', 6760, 6, 0, 0, 0, 0, 74, 2),
(841, 0, 0, 0, 'Darashia 7, Flat 01', 2250, 6, 0, 0, 0, 0, 25, 1),
(842, 0, 0, 0, 'Darashia 7, Flat 02', 2250, 6, 0, 0, 0, 0, 25, 1),
(843, 0, 0, 0, 'Darashia 7, Flat 03', 5610, 6, 0, 0, 0, 0, 59, 4),
(844, 0, 0, 0, 'Darashia 7, Flat 04', 2250, 6, 0, 0, 0, 0, 25, 1),
(845, 0, 0, 0, 'Darashia 7, Flat 05', 2350, 6, 0, 0, 0, 0, 25, 2),
(846, 0, 0, 0, 'Darashia 7, Flat 11', 2250, 6, 0, 0, 0, 0, 25, 1),
(847, 0, 0, 0, 'Darashia 7, Flat 12', 5610, 6, 0, 0, 0, 0, 59, 4),
(848, 0, 0, 0, 'Darashia 7, Flat 13', 2250, 6, 0, 0, 0, 0, 25, 1),
(849, 0, 0, 0, 'Darashia 7, Flat 14', 5610, 6, 0, 0, 0, 0, 59, 4),
(850, 0, 0, 0, 'Darashia 8, Flat 01', 4870, 6, 0, 0, 0, 0, 53, 2),
(851, 0, 0, 0, 'Darashia 8, Flat 02', 6670, 6, 0, 0, 0, 0, 73, 2),
(852, 0, 0, 0, 'Darashia 8, Flat 03', 9200, 6, 0, 0, 0, 0, 100, 3),
(853, 0, 0, 0, 'Darashia 8, Flat 04', 5590, 6, 0, 0, 0, 0, 61, 2),
(854, 0, 0, 0, 'Darashia 8, Flat 05', 5230, 6, 0, 0, 0, 0, 57, 2),
(855, 0, 0, 0, 'Darashia, Villa', 10470, 6, 0, 0, 0, 0, 113, 4),
(856, 0, 0, 0, 'Darashia, Western Guildhall', 19570, 6, 0, 0, 0, 0, 203, 14),
(857, 0, 0, 0, 'Darashia, Eastern Guildhall', 23820, 6, 0, 0, 0, 0, 248, 16),
(858, 0, 0, 0, 'Darashia 8, Flat 11', 3880, 6, 0, 0, 0, 0, 42, 2),
(859, 0, 0, 0, 'Darashia 8, Flat 12', 3520, 6, 0, 0, 0, 0, 38, 2),
(860, 0, 0, 0, 'Darashia 8, Flat 13', 3880, 6, 0, 0, 0, 0, 42, 2),
(861, 0, 0, 0, 'Darashia 8, Flat 14', 3520, 6, 0, 0, 0, 0, 38, 2);

-- --------------------------------------------------------

--
-- Table structure for table `house_lists`
--

CREATE TABLE `house_lists` (
  `house_id` int(11) NOT NULL,
  `listid` int(11) NOT NULL,
  `list` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `ip_bans`
--

CREATE TABLE `ip_bans` (
  `ip` int(10) UNSIGNED NOT NULL,
  `reason` varchar(255) NOT NULL,
  `banned_at` bigint(20) NOT NULL,
  `expires_at` bigint(20) NOT NULL,
  `banned_by` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `players`
--

CREATE TABLE `players` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `group_id` int(11) NOT NULL DEFAULT '1',
  `account_id` int(11) NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '1',
  `vocation` int(11) NOT NULL DEFAULT '0',
  `health` int(11) NOT NULL DEFAULT '150',
  `healthmax` int(11) NOT NULL DEFAULT '150',
  `experience` bigint(20) NOT NULL DEFAULT '0',
  `lookbody` int(11) NOT NULL DEFAULT '0',
  `lookfeet` int(11) NOT NULL DEFAULT '0',
  `lookhead` int(11) NOT NULL DEFAULT '0',
  `looklegs` int(11) NOT NULL DEFAULT '0',
  `looktype` int(11) NOT NULL DEFAULT '136',
  `lookaddons` int(11) NOT NULL DEFAULT '0',
  `maglevel` int(11) NOT NULL DEFAULT '0',
  `mana` int(11) NOT NULL DEFAULT '0',
  `manamax` int(11) NOT NULL DEFAULT '0',
  `manaspent` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `soul` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `town_id` int(11) NOT NULL DEFAULT '0',
  `posx` int(11) NOT NULL DEFAULT '0',
  `posy` int(11) NOT NULL DEFAULT '0',
  `posz` int(11) NOT NULL DEFAULT '0',
  `conditions` blob NOT NULL,
  `cap` int(11) NOT NULL DEFAULT '0',
  `sex` int(11) NOT NULL DEFAULT '0',
  `lastlogin` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `lastip` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `save` tinyint(1) NOT NULL DEFAULT '1',
  `skull` tinyint(1) NOT NULL DEFAULT '0',
  `skulltime` int(11) NOT NULL DEFAULT '0',
  `lastlogout` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `blessings` tinyint(2) NOT NULL DEFAULT '0',
  `onlinetime` int(11) NOT NULL DEFAULT '0',
  `deletion` bigint(15) NOT NULL DEFAULT '0',
  `balance` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `stamina` smallint(5) NOT NULL DEFAULT '3360',
  `skill_fist` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_fist_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_club` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_club_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_sword` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_sword_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_axe` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_axe_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_dist` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_dist_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_shielding` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_shielding_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `skill_fishing` int(10) UNSIGNED NOT NULL DEFAULT '10',
  `skill_fishing_tries` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `deleted` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `players`
--

INSERT INTO `players` (`id`, `name`, `group_id`, `account_id`, `level`, `vocation`, `health`, `healthmax`, `experience`, `lookbody`, `lookfeet`, `lookhead`, `looklegs`, `looktype`, `maglevel`, `mana`, `manamax`, `manaspent`, `soul`, `town_id`, `posx`, `posy`, `posz`, `conditions`, `cap`, `sex`, `lastlogin`, `lastip`, `save`, `skull`, `skulltime`, `lastlogout`, `blessings`, `onlinetime`, `deletion`, `balance`, `skill_fist`, `skill_fist_tries`, `skill_club`, `skill_club_tries`, `skill_sword`, `skill_sword_tries`, `skill_axe`, `skill_axe_tries`, `skill_dist`, `skill_dist_tries`, `skill_shielding`, `skill_shielding_tries`, `skill_fishing`, `skill_fishing_tries`, `deleted`) VALUES
(1, 'GM Sabrehaven', 3, 1234567, 2, 0, 155, 155, 105, 106, 95, 78, 58, 75, 100, 5, 5, 0, 100, 1, 32370, 32231, 7, '', 405, 0, 1547336581, 75260863, 1, 0, 0, 1547336668, 0, 7631, 0, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 0),
(2, 'GM Sabrehaven 2', 3, 1234567, 2, 0, 155, 155, 105, 106, 95, 78, 58, 75, 0, 5, 5, 0, 100, 10, 33211, 31646, 13, 0x018000000002000000000360361e001c0000000013d70000001408000000151027000016aecb0300fe, 405, 0, 1547183307, 75260863, 1, 0, 0, 1547183320, 0, 781, 0, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 10, 0, 0),
(3, 'Mage', 1, 1234567, 89, 2, 1171, 2045, 10982400, 106, 95, 78, 58, 128, 62, 10, 4770, 7200, 2, 1, 32367, 32230, 7, '', 1490, 232, 1547334403, 75260863, 1, 0, 0, 1547335694, 0, 7330, 0, 0, 10, 0, 10, 19, 10, 0, 10, 0, 10, 0, 39, 10439596, 10, 0, 0);

--
-- Triggers `players`
--
DELIMITER $$
CREATE TRIGGER `ondelete_players` BEFORE DELETE ON `players` FOR EACH ROW BEGIN
    UPDATE `houses` SET `owner` = 0 WHERE `owner` = OLD.`id`;
END
$$
DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `players_online`
--

CREATE TABLE `players_online` (
  `player_id` int(11) NOT NULL
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `player_deaths`
--

CREATE TABLE `player_deaths` (
  `player_id` int(11) NOT NULL,
  `time` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '1',
  `killed_by` varchar(255) NOT NULL,
  `is_player` tinyint(1) NOT NULL DEFAULT '1',
  `mostdamage_by` varchar(100) NOT NULL,
  `mostdamage_is_player` tinyint(1) NOT NULL DEFAULT '0',
  `unjustified` tinyint(1) NOT NULL DEFAULT '0',
  `mostdamage_unjustified` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `player_deaths`
--

INSERT INTO `player_deaths` (`player_id`, `time`, `level`, `killed_by`, `is_player`, `mostdamage_by`, `mostdamage_is_player`, `unjustified`, `mostdamage_unjustified`) VALUES
(3, 1542493004, 50, 'Thalas', 0, 'Thalas', 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `player_depotitems`
--

CREATE TABLE `player_depotitems` (
  `player_id` int(11) NOT NULL,
  `sid` int(11) NOT NULL COMMENT 'any given range eg 0-100 will be reserved for depot lockers and all > 100 will be then normal items inside depots',
  `pid` int(11) NOT NULL DEFAULT '0',
  `itemtype` smallint(6) NOT NULL,
  `count` smallint(5) NOT NULL DEFAULT '0',
  `attributes` blob NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `player_items`
--

CREATE TABLE `player_items` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `pid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `itemtype` smallint(6) NOT NULL DEFAULT '0',
  `count` smallint(5) NOT NULL DEFAULT '0',
  `attributes` blob NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `player_items`
--

INSERT INTO `player_items` (`player_id`, `pid`, `sid`, `itemtype`, `count`, `attributes`) VALUES
(2, 4, 101, 3388, 1, ''),
(3, 4, 101, 3561, 1, ''),
(3, 6, 102, 3270, 1, ''),
(3, 10, 103, 3198, 77, 0x164d00),
(1, 3, 101, 2853, 1, ''),
(1, 4, 102, 3562, 1, ''),
(1, 5, 103, 2920, 1, ''),
(1, 6, 104, 3043, 1, 0x0f01),
(1, 10, 105, 3031, 94, 0x0f5e),
(1, 101, 106, 2874, 0, 0x0f00),
(1, 101, 107, 2874, 0, 0x0f00),
(1, 101, 108, 2874, 0, 0x0f00),
(1, 101, 109, 2854, 1, ''),
(1, 101, 110, 3198, 5, 0x160500),
(1, 101, 111, 3270, 1, ''),
(1, 101, 112, 3035, 9, 0x0f09),
(1, 101, 113, 3379, 1, '');

-- --------------------------------------------------------

--
-- Table structure for table `player_murders`
--

CREATE TABLE `player_murders` (
  `id` bigint(20) NOT NULL,
  `player_id` int(11) NOT NULL,
  `date` bigint(20) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `player_namelocks`
--

CREATE TABLE `player_namelocks` (
  `player_id` int(11) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `namelocked_at` bigint(20) NOT NULL,
  `namelocked_by` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `player_spells`
--

CREATE TABLE `player_spells` (
  `player_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `player_storage`
--

CREATE TABLE `player_storage` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `key` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `value` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `player_storage`
--

INSERT INTO `player_storage` (`player_id`, `key`, `value`) VALUES
(1, 203, 1),
(1, 224, 1),
(1, 227, 1),
(1, 43434, 1),
(2, 203, 1),
(2, 43434, 1),
(3, 101, 0),
(3, 102, 0),
(3, 103, 0),
(3, 104, 0),
(3, 105, 0),
(3, 270, 0),
(3, 43434, 1);

-- --------------------------------------------------------

--
-- Table structure for table `server_config`
--

CREATE TABLE `server_config` (
  `config` varchar(50) NOT NULL,
  `value` varchar(256) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `server_config`
--

INSERT INTO `server_config` (`config`, `value`) VALUES
('motd_hash', '591d7fcbec26bc2982bdf5b0f13fd6bcbbd3aa0c'),
('motd_num', '1'),
('players_record', '2');

-- --------------------------------------------------------

--
-- Table structure for table `tile_store`
--

CREATE TABLE `tile_store` (
  `house_id` int(11) NOT NULL,
  `data` longblob NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `tile_store`
--

INSERT INTO `tile_store` (`house_id`, `data`) VALUES
(1, 0x027e347e0901000000bd0900),
(1, 0x027e367e0901000000bd0900),
(1, 0x037e347e0901000000be0900),
(1, 0x037e367e0901000000be0900),
(1, 0x077e367e0801000000660600),
(1, 0x067e357e0901000000660600),
(1, 0x0a7e357e0901000000660600),
(1, 0x0c7e377e0701000000680600),
(1, 0x0d7e367e0801000000680600),
(1, 0x0e7e377e0801000000bd0900),
(1, 0x0f7e377e0801000000be0900),
(1, 0x0c7e357e0901000000b70900),
(1, 0x0c7e367e0901000000b80900),
(1, 0x0d7e357e0901000000b70900),
(1, 0x0d7e367e0901000000b80900),
(1, 0x0e7e357e0901000000b70900),
(1, 0x0e7e367e0901000000b80900),
(1, 0x0f7e357e0901000000b70900),
(1, 0x0f7e367e0901000000b80900),
(1, 0x037e3b7e0601000000680600),
(1, 0x037e3b7e0701000000680600),
(1, 0x027e387e0901000000bd0900),
(1, 0x027e3a7e0901000000bd0900),
(1, 0x037e387e0901000000be0900),
(1, 0x037e3a7e0901000000be0900),
(1, 0x047e397e0601000000b70900),
(1, 0x047e3a7e0601000000b80900),
(1, 0x057e397e0601000000b70900),
(1, 0x057e3a7e0601000000b80900),
(1, 0x067e397e0701000000660600),
(1, 0x077e3b7e0801000000660600),
(1, 0x067e397e0901000000660600),
(1, 0x097e3b7e0701000000680600),
(1, 0x0b7e397e0701000000660600),
(1, 0x0b7e3a7e0801000000b70900),
(1, 0x0b7e3b7e0801000000b80900),
(1, 0x0a7e3a7e0901000000660600),
(1, 0x0c7e397e0601000000b70900),
(1, 0x0c7e3a7e0601000000b80900),
(1, 0x0e7e3b7e0601000000680600),
(1, 0x0d7e397e0701000000220900),
(1, 0x0e7e3b7e0701000000680600),
(1, 0x0c7e3a7e0801000000b70900),
(1, 0x0c7e3b7e0801000000b80900),
(1, 0x0e7e387e0801000000bd0900),
(1, 0x0e7e3a7e0801000000b70900),
(1, 0x0e7e3b7e0801000000b80900),
(1, 0x0f7e387e0801000000be0900),
(1, 0x0f7e3a7e0801000000b70900),
(1, 0x0f7e3b7e0801000000b80900),
(1, 0x027e3c7e0901000000b70900),
(1, 0x027e3d7e0901000000b80900),
(1, 0x067e3d7e0901000000660600),
(1, 0x0b7e3d7e0801000000b70900),
(1, 0x0b7e3e7e0801000000b80900),
(1, 0x0c7e3d7e0801000000b70900),
(1, 0x0c7e3e7e0801000000b80900),
(1, 0x0e7e3d7e0801000000b70900),
(1, 0x0e7e3e7e0801000000b80900),
(1, 0x0f7e3d7e0801000000b70900),
(1, 0x0f7e3e7e0801000000b80900),
(1, 0x107e357e0901000000b70900),
(1, 0x107e367e0901000000b80900),
(1, 0x047e407e0601000000660600),
(1, 0x0d7e407e0601000000660600),
(2, 0xa97e677e0901000000b70900),
(2, 0xab7e677e0901000000b70900),
(2, 0xac7e677e0901000000b70900),
(2, 0xae7e677e0901000000b70900),
(2, 0xa97e687e0901000000b80900),
(2, 0xab7e687e0901000000b80900),
(2, 0xac7e687e0901000000b80900),
(2, 0xae7e687e0901000000b80900),
(2, 0xae7e6a7e0901000000680600),
(2, 0xa97e6d7e0901000000bd0900),
(2, 0xaa7e6d7e0901000000be0900),
(2, 0xac7e6d7e0901000000660600),
(2, 0xb67e677e0901000000b70900),
(2, 0xb77e677e0901000000b70900),
(2, 0xb17e6a7e0401000000bd0900),
(2, 0xb27e6a7e0401000000be0900),
(2, 0xb37e687e0701000000680600),
(2, 0xb37e6b7e0701000000680600),
(2, 0xb17e697e0801000000b70900),
(2, 0xb17e6a7e0801000000b80900),
(2, 0xb17e6a7e0901000000680600),
(2, 0xb37e687e0901000000b70900),
(2, 0xb37e697e0901000000b80900),
(2, 0xb47e6a7e0401000000660600),
(2, 0xb77e6b7e0401000000660600),
(2, 0xb47e6b7e0501000000660600),
(2, 0xb47e6b7e0601000000660600),
(2, 0xb47e687e0701000000680600),
(2, 0xb47e6b7e0701000000680600),
(2, 0xb47e697e0801000000b70900),
(2, 0xb47e6a7e0801000000b80900),
(2, 0xb77e697e0801000000b70900),
(2, 0xb77e6a7e0801000000b80900),
(2, 0xb47e687e0901000000b70900),
(2, 0xb47e697e0901000000b80900),
(2, 0xb67e687e0901000000b80900),
(2, 0xb77e687e0901000000b80900),
(2, 0xb77e6a7e0901000000680600),
(2, 0xba7e697e0401000000b70900),
(2, 0xba7e6a7e0401000000b80900),
(2, 0xb97e6b7e0701000000240900),
(2, 0xba7e697e0801000000b70900),
(2, 0xba7e6a7e0801000000b80900),
(2, 0xb97e687e0901000000b70900),
(2, 0xb97e697e0901000000b80900),
(2, 0xba7e687e0901000000b70900),
(2, 0xba7e697e0901000000b80900),
(2, 0xb17e6d7e0401000000bd0900),
(2, 0xb27e6d7e0401000000be0900),
(2, 0xb27e6e7e0501000000680600),
(2, 0xb27e6e7e0701000000680600),
(2, 0xb27e6c7e0801000000680600),
(2, 0xb27e6d7e0901000000660600),
(2, 0xb47e6d7e0401000000660600),
(2, 0xb47e6c7e0601000000660600),
(2, 0xb57e6e7e0701000000680600),
(2, 0xb67e6d7e0701000000660600),
(2, 0xb57e6c7e0801000000680600),
(2, 0xb67e6e7e0801000000680600),
(2, 0xba7e6e7e0401000000b70900),
(2, 0xba7e6f7e0401000000b80900),
(2, 0xb87e6c7e0801000000680600),
(2, 0xba7e6e7e0801000000680600),
(2, 0xbb7e6c7e0801000000680600),
(2, 0xac7e707e0901000000660600),
(2, 0xb47e707e0401000000660600),
(2, 0xb77e707e0401000000660600),
(2, 0xb57e717e0801000000bd0900),
(2, 0xb67e717e0801000000be0900),
(2, 0xb97e717e0801000000bd0900),
(2, 0xba7e717e0801000000be0900),
(3, 0x877e217d0601000000bd0900),
(3, 0x887e217d0601000000be0900),
(3, 0x8a7e217d0601000000660600),
(3, 0x8d7e237d0801000000660600),
(3, 0x8f7e227d0801000000b70900),
(3, 0x8f7e237d0801000000b80900),
(3, 0x877e257d0601000000bd0900),
(3, 0x887e257d0601000000be0900),
(3, 0x8a7e277d0601000000660600),
(3, 0x8d7e247d0601000000660600),
(3, 0x8e7e267d0601000000b70900),
(3, 0x8e7e277d0601000000b80900),
(3, 0x8f7e267d0601000000b70900),
(3, 0x8f7e277d0601000000b80900),
(3, 0x8d7e277d0801000000660600),
(3, 0x8f7e267d0801000000b70900),
(3, 0x8f7e277d0801000000b80900),
(3, 0x877e297d0601000000bd0900),
(3, 0x887e297d0601000000be0900),
(3, 0x8a7e297d0601000000660600),
(3, 0x897e297d0701000000680600),
(3, 0x897e297d0801000000680600),
(3, 0x8b7e2a7d0801000000660600),
(3, 0x8c7e287d0601000000680600),
(3, 0x8c7e297d0701000000680600),
(3, 0x8d7e297d0701000000680600),
(3, 0x917e217d0601000000bd0900),
(3, 0x917e227d0601000000bd0900),
(3, 0x917e237d0601000000bd0900),
(3, 0x927e217d0601000000be0900),
(3, 0x927e227d0601000000be0900),
(3, 0x927e237d0601000000be0900),
(3, 0x907e227d0801000000b70900),
(3, 0x907e237d0801000000b80900),
(3, 0x927e227d0801000000b70900),
(3, 0x927e237d0801000000b80900),
(3, 0x917e247d0601000000bd0900),
(3, 0x917e257d0601000000bd0900),
(3, 0x917e267d0601000000bd0900),
(3, 0x917e277d0601000000bd0900),
(3, 0x927e247d0601000000be0900),
(3, 0x927e257d0601000000be0900),
(3, 0x927e267d0601000000be0900),
(3, 0x927e277d0601000000be0900),
(3, 0x907e267d0801000000b70900),
(3, 0x907e277d0801000000b80900),
(3, 0x927e267d0801000000b70900),
(3, 0x927e277d0801000000b80900),
(3, 0x907e297d0701000000680600),
(3, 0x917e297d0801000000680600),
(4, 0x877e927d0601000000b70900),
(4, 0x877e937d0601000000b80900),
(4, 0x897e927d0601000000bd0900),
(4, 0x897e937d0601000000bd0900),
(4, 0x8a7e927d0601000000be0900),
(4, 0x8a7e937d0601000000be0900),
(4, 0x8e7e927d0601000000b70900),
(4, 0x8e7e937d0601000000b80900),
(4, 0x897e977d0601000000680600),
(4, 0x8d7e977d0601000000680600),
(4, 0x8e7e947d0801000000660600),
(4, 0x877e9a7d0601000000b70900),
(4, 0x877e9b7d0601000000b80900),
(4, 0x887e997d0601000000680600),
(4, 0x8b7e9b7d0601000000bd0900),
(4, 0x897e9a7d0701000000680600),
(4, 0x8a7e9a7d0801000000680600),
(4, 0x887e997d0901000000680600),
(4, 0x8c7e9b7d0601000000be0900),
(4, 0x8e7e9b7d0601000000bd0900),
(4, 0x8f7e9b7d0601000000be0900),
(4, 0x8d7e9a7d0701000000680600),
(4, 0x8e7e9b7d0801000000660600),
(4, 0x8b7e9d7d0601000000bd0900),
(4, 0x8c7e9d7d0601000000be0900),
(4, 0x8e7e9c7d0601000000bd0900),
(4, 0x8e7e9d7d0601000000bd0900),
(4, 0x8f7e9c7d0601000000be0900),
(4, 0x8f7e9d7d0601000000be0900),
(4, 0x907e927d0601000000b70900),
(4, 0x907e937d0601000000b80900),
(4, 0x927e927d0601000000bd0900),
(4, 0x927e937d0601000000bd0900),
(4, 0x937e927d0601000000be0900),
(4, 0x937e937d0601000000be0900),
(4, 0x927e977d0601000000680600),
(4, 0x907e947d0801000000b70900),
(4, 0x907e957d0801000000b80900),
(4, 0x917e947d0801000000b70900),
(4, 0x917e957d0801000000b80900),
(4, 0x927e947d0801000000b70900),
(4, 0x927e957d0801000000b80900),
(4, 0x937e947d0801000000b70900),
(4, 0x937e957d0801000000b80900),
(4, 0x907e9a7d0601000000660600),
(4, 0x927e997d0601000000680600),
(4, 0x917e9a7d0701000000680600),
(5, 0xd57eab7d0701000000680600),
(5, 0xd27eac7d0501000000b70900),
(5, 0xd27ead7d0501000000b80900),
(5, 0xd37eac7d0501000000b70900),
(5, 0xd37ead7d0501000000b80900),
(5, 0xd37eaf7d0501000000680600),
(5, 0xd37eae7d0601000000680600),
(5, 0xd17eae7d0701000000bd0900),
(5, 0xd27eae7d0701000000be0900),
(5, 0xd37ead7d0701000000660600),
(5, 0xd17eac7d0801000000bd0900),
(5, 0xd17eae7d0801000000bd0900),
(5, 0xd17eaf7d0801000000b70900),
(5, 0xd27eac7d0801000000be0900),
(5, 0xd27eae7d0801000000be0900),
(5, 0xd57eae7d0401000000680600),
(5, 0xd57ead7d0601000000660600),
(5, 0xd77eae7d0601000000680600),
(5, 0xd67ead7d0701000000660600),
(5, 0xd57eaf7d0801000000b70900),
(5, 0xd67ead7d0801000000660600),
(5, 0xd87eae7d0701000000680600),
(5, 0xd87eae7d0801000000680600),
(5, 0xd17eb37d0501000000b70900),
(5, 0xd27eb17d0501000000680600),
(5, 0xd17eb07d0701000000bd0900),
(5, 0xd27eb07d0701000000be0900),
(5, 0xd37eb27d0701000000660600),
(5, 0xd17eb07d0801000000b80900),
(5, 0xd17eb17d0801000000bd0900),
(5, 0xd17eb37d0801000000bd0900),
(5, 0xd27eb17d0801000000be0900),
(5, 0xd27eb37d0801000000be0900),
(5, 0xd47eb37d0501000000b70900),
(5, 0xd57eb17d0501000000680600),
(5, 0xd77eb37d0501000000b70900),
(5, 0xd47eb17d0801000000bd0900),
(5, 0xd47eb37d0801000000bd0900),
(5, 0xd57eb07d0801000000b80900),
(5, 0xd57eb17d0801000000be0900),
(5, 0xd57eb37d0801000000be0900),
(5, 0xd87eb17d0501000000680600),
(5, 0xd17eb47d0501000000b80900),
(5, 0xd17eb47d0701000000bd0900),
(5, 0xd27eb47d0701000000be0900),
(5, 0xd47eb47d0501000000b80900),
(5, 0xd77eb47d0501000000b80900),
(6, 0x497ee67d0701000000b70900),
(6, 0x497ee77d0701000000b80900),
(6, 0x4c7ee87d0701000000660600),
(7, 0x497eeb7d0701000000b70900),
(7, 0x497eec7d0701000000b80900),
(7, 0x4c7eed7d0701000000660600),
(8, 0x4a7ef27d0701000000b70900),
(8, 0x4a7ef37d0701000000b80900),
(8, 0x4d7ef47d0701000000660600),
(9, 0x497ee67d0601000000b70900),
(9, 0x497ee77d0601000000b80900),
(9, 0x4c7ee87d0601000000660600),
(10, 0x497eeb7d0601000000b70900),
(10, 0x497eec7d0601000000b80900),
(10, 0x4c7eed7d0601000000660600),
(11, 0x4a7ef07d0601000000b70900),
(11, 0x4a7ef17d0601000000b80900),
(11, 0x4c7ef07d0601000000b70900),
(11, 0x4c7ef17d0601000000b80900),
(11, 0x4d7ef47d0601000000660600),
(12, 0x4a7ef77d0601000000b70900),
(12, 0x4a7ef87d0601000000b80900),
(12, 0x4d7ef97d0601000000660600),
(13, 0x497ee67d0501000000b70900),
(13, 0x497ee77d0501000000b80900),
(13, 0x4c7ee87d0501000000660600),
(14, 0x497eeb7d0501000000b70900),
(14, 0x497eec7d0501000000b80900),
(14, 0x4c7eed7d0501000000660600),
(15, 0x4a7ef07d0501000000b70900),
(15, 0x4a7ef17d0501000000b80900),
(15, 0x4c7ef07d0501000000b70900),
(15, 0x4c7ef17d0501000000b80900),
(15, 0x4d7ef47d0501000000660600),
(16, 0x4a7ef77d0501000000b70900),
(16, 0x4a7ef87d0501000000b80900),
(16, 0x4d7ef97d0501000000660600),
(17, 0x3e7ef27d0701000000b70900),
(17, 0x3e7ef37d0701000000b80900),
(17, 0x3b7ef57d0701000000660600),
(18, 0x3e7eed7d0701000000b70900),
(18, 0x3e7eee7d0701000000b80900),
(18, 0x3b7ef07d0701000000660600),
(19, 0x3e7ee67d0701000000b70900),
(19, 0x3e7ee77d0701000000b80900),
(19, 0x3d7eea7d0701000000680600),
(20, 0x3a7ee67d0701000000b70900),
(20, 0x3a7ee77d0701000000b80900),
(20, 0x397eea7d0701000000680600),
(21, 0x367ee67d0701000000b70900),
(21, 0x367ee77d0701000000b80900),
(21, 0x357eea7d0701000000680600),
(22, 0x317ef07d0701000000b70900),
(22, 0x317ef17d0701000000b80900),
(22, 0x337ef07d0701000000b70900),
(22, 0x337ef17d0701000000b80900),
(22, 0x347ef37d0701000000660600),
(23, 0x3b7ef37d0601000000660600),
(23, 0x3e7ef07d0601000000b70900),
(23, 0x3e7ef17d0601000000b80900),
(24, 0x3e7eea7d0601000000b70900),
(24, 0x3e7eeb7d0601000000b80900),
(24, 0x3b7eee7d0601000000660600),
(25, 0x3e7ee67d0601000000b70900),
(25, 0x3e7ee77d0601000000b80900),
(25, 0x3a7ee97d0601000000680600),
(26, 0x387ee67d0601000000b70900),
(26, 0x387ee77d0601000000b80900),
(26, 0x387ee97d0601000000680600),
(27, 0x357ee67d0601000000b70900),
(27, 0x357ee77d0601000000b80900),
(27, 0x357ee97d0601000000680600),
(28, 0x317ef07d0601000000b70900),
(28, 0x317ef17d0601000000b80900),
(28, 0x337ef07d0601000000b70900),
(28, 0x337ef17d0601000000b80900),
(28, 0x307ef47d0601000000660600),
(29, 0x787e027e0701000000b70900),
(29, 0x787e037e0701000000b80900),
(29, 0x797e017e0701000000680600),
(30, 0x7d7e027e0701000000b70900),
(30, 0x7d7e037e0701000000b80900),
(30, 0x7e7e017e0701000000680600),
(31, 0x7b7e077e0701000000b70900),
(31, 0x777e087e0701000000660600),
(31, 0x7b7e087e0701000000b80900),
(32, 0x847e027e0701000000b70900),
(32, 0x847e037e0701000000b80900),
(32, 0x837e057e0701000000660600),
(33, 0x867e0b7e0701000000b70900),
(33, 0x877e0b7e0701000000b70900),
(33, 0x837e0c7e0701000000660600),
(33, 0x867e0c7e0701000000b80900),
(33, 0x877e0c7e0701000000b80900),
(34, 0x827e0d7e0701000000680600),
(34, 0x867e0e7e0701000000bd0900),
(34, 0x867e0f7e0701000000bd0900),
(34, 0x877e0e7e0701000000be0900),
(34, 0x877e0f7e0701000000be0900),
(35, 0x7d7e0e7e0701000000b70900),
(35, 0x7d7e0f7e0701000000b80900),
(35, 0x7e7e0d7e0701000000680600),
(36, 0x787e0e7e0701000000b70900),
(36, 0x787e0f7e0701000000b80900),
(36, 0x797e0d7e0701000000680600),
(37, 0x7d7e027e0601000000b70900),
(37, 0x7d7e037e0601000000b80900),
(37, 0x7e7e017e0601000000680600),
(38, 0x787e027e0601000000b70900),
(38, 0x787e037e0601000000b80900),
(38, 0x797e017e0601000000680600),
(39, 0x787e077e0601000000b70900),
(39, 0x787e087e0601000000b80900),
(39, 0x797e0b7e0601000000680600),
(40, 0x847e027e0601000000b70900),
(40, 0x847e037e0601000000b80900),
(40, 0x837e057e0601000000660600),
(40, 0x887e047e0601000000660600),
(41, 0x867e077e0601000000bd0900),
(41, 0x877e077e0601000000be0900),
(41, 0x867e087e0601000000bd0900),
(41, 0x877e087e0601000000be0900),
(41, 0x887e097e0601000000660600),
(41, 0x837e0c7e0601000000660600),
(42, 0x827e0d7e0601000000680600),
(42, 0x867e0e7e0601000000bd0900),
(42, 0x867e0f7e0601000000bd0900),
(42, 0x877e0e7e0601000000be0900),
(42, 0x877e0f7e0601000000be0900),
(42, 0x857e127e0601000000680600),
(43, 0x7d7e0e7e0601000000b70900),
(43, 0x7d7e0f7e0601000000b80900),
(43, 0x7e7e0d7e0601000000680600),
(43, 0x7f7e127e0601000000680600),
(44, 0x787e0e7e0601000000b70900),
(44, 0x787e0f7e0601000000b80900),
(44, 0x797e0d7e0601000000680600),
(44, 0x7a7e127e0601000000680600),
(45, 0x787e027e0501000000b70900),
(45, 0x787e037e0501000000b80900),
(45, 0x797e017e0501000000680600),
(46, 0x7d7e027e0501000000b70900),
(46, 0x7d7e037e0501000000b80900),
(46, 0x7e7e017e0501000000680600),
(47, 0x787e077e0501000000b70900),
(47, 0x787e087e0501000000b80900),
(47, 0x797e0b7e0501000000680600),
(48, 0x847e027e0501000000b70900),
(48, 0x847e037e0501000000b80900),
(48, 0x837e057e0501000000660600),
(48, 0x887e047e0501000000660600),
(49, 0x867e077e0501000000bd0900),
(49, 0x877e077e0501000000be0900),
(49, 0x867e087e0501000000bd0900),
(49, 0x877e087e0501000000be0900),
(49, 0x887e097e0501000000660600),
(49, 0x837e0c7e0501000000660600),
(50, 0x827e0d7e0501000000680600),
(50, 0x867e0e7e0501000000bd0900),
(50, 0x867e0f7e0501000000bd0900),
(50, 0x877e0e7e0501000000be0900),
(50, 0x877e0f7e0501000000be0900),
(50, 0x857e127e0501000000680600),
(51, 0x7d7e0e7e0501000000b70900),
(51, 0x7d7e0f7e0501000000b80900),
(51, 0x7e7e0d7e0501000000680600),
(51, 0x7f7e127e0501000000680600),
(52, 0x787e0e7e0501000000b70900),
(52, 0x787e0f7e0501000000b80900),
(52, 0x797e0d7e0501000000680600),
(52, 0x7a7e127e0501000000680600),
(53, 0x567eff7d0701000000b70900),
(53, 0x577eff7d0701000000b70900),
(53, 0x5a7eff7d0601000000660600),
(53, 0x5a7eff7d0701000000660600),
(53, 0x5d7efe7d0601000000bd0900),
(53, 0x5d7eff7d0601000000bd0900),
(53, 0x5e7efe7d0601000000be0900),
(53, 0x5e7eff7d0601000000be0900),
(53, 0x5c7efd7d0701000000680600),
(53, 0x5d7eff7d0701000000660600),
(53, 0x577e017e0601000000680600),
(53, 0x567e007e0701000000b80900),
(53, 0x577e007e0701000000b80900),
(53, 0x587e037e0601000000660600),
(53, 0x5a7e027e0701000000660600),
(54, 0x627eff7d0701000000b70900),
(54, 0x637eff7d0701000000b70900),
(54, 0x667eff7d0601000000660600),
(54, 0x667eff7d0701000000660600),
(54, 0x697efe7d0601000000bd0900),
(54, 0x697eff7d0601000000bd0900),
(54, 0x6a7efe7d0601000000be0900),
(54, 0x6a7eff7d0601000000be0900),
(54, 0x687efd7d0701000000680600),
(54, 0x697eff7d0701000000660600),
(54, 0x637e017e0601000000680600),
(54, 0x627e007e0701000000b80900),
(54, 0x637e007e0701000000b80900),
(54, 0x647e037e0601000000660600),
(54, 0x667e027e0701000000660600),
(55, 0x5f7e0b7e0601000000680600),
(55, 0x5e7e097e0701000000b70900),
(55, 0x5e7e0a7e0701000000b80900),
(55, 0x5f7e097e0701000000b70900),
(55, 0x5f7e0a7e0701000000b80900),
(55, 0x647e077e0701000000680600),
(55, 0x627e097e0601000000660600),
(55, 0x627e097e0701000000660600),
(55, 0x657e087e0601000000bd0900),
(55, 0x657e097e0601000000bd0900),
(55, 0x667e087e0601000000be0900),
(55, 0x667e097e0601000000be0900),
(55, 0x657e097e0701000000660600),
(55, 0x607e0d7e0601000000660600),
(55, 0x627e0c7e0701000000660600),
(56, 0x6b7e0b7e0601000000680600),
(56, 0x6a7e097e0701000000b70900),
(56, 0x6a7e0a7e0701000000b80900),
(56, 0x6b7e097e0701000000b70900),
(56, 0x6b7e0a7e0701000000b80900),
(56, 0x6e7e097e0601000000660600),
(56, 0x6e7e097e0701000000660600),
(56, 0x6c7e0d7e0601000000660600),
(56, 0x6e7e0c7e0701000000660600),
(56, 0x707e077e0701000000680600),
(56, 0x717e087e0601000000bd0900),
(56, 0x717e097e0601000000bd0900),
(56, 0x727e087e0601000000be0900),
(56, 0x727e097e0601000000be0900),
(56, 0x717e097e0701000000660600),
(57, 0x8e7e017e0701000000680600),
(57, 0x8c7e047e0701000000660600),
(57, 0x907e037e0601000000660600),
(57, 0x947e027e0701000000b70900),
(57, 0x947e037e0701000000b80900),
(57, 0x907e047e0701000000660600),
(57, 0x937e067e0701000000b70900),
(57, 0x937e077e0701000000b80900),
(57, 0x947e067e0701000000b70900),
(57, 0x947e077e0701000000b80900),
(58, 0x8a7ef57d0601000000b70900),
(58, 0x8a7ef67d0601000000b80900),
(58, 0x887ef67d0901000000b70900),
(58, 0x887ef77d0901000000b80900),
(58, 0x8d7ef57d0601000000b70900),
(58, 0x8d7ef67d0601000000b80900),
(58, 0x8c7ef67d0901000000b70900),
(58, 0x8c7ef77d0901000000b80900),
(58, 0x8b7ef87d0601000000680600),
(58, 0x8b7efa7d0601000000680600),
(58, 0x897ef97d0901000000680600),
(58, 0x897efb7d0901000000680600),
(58, 0x8e7ef87d0601000000680600),
(58, 0x8f7efa7d0601000000680600),
(58, 0x8f7efb7d0701000000660600),
(58, 0x8d7ef97d0901000000680600),
(58, 0x8a7efc7d0601000000bd0900),
(58, 0x8b7efc7d0601000000be0900),
(58, 0x8a7efc7d0901000000b70900),
(58, 0x8a7efd7d0901000000b80900),
(58, 0x8e7efc7d0601000000bd0900),
(58, 0x8f7efc7d0601000000be0900),
(58, 0x937ef57d0601000000b70900),
(58, 0x937ef67d0601000000b80900),
(58, 0x947ef57d0701000000b70900),
(58, 0x947ef67d0701000000b80900),
(58, 0x967ef57d0701000000b70900),
(58, 0x967ef67d0701000000b80900),
(58, 0x977ef57d0701000000b70900),
(58, 0x977ef67d0701000000b80900),
(58, 0x987ef57d0601000000bd0900),
(58, 0x987ef67d0601000000bd0900),
(58, 0x997ef57d0601000000be0900),
(58, 0x997ef67d0601000000be0900),
(58, 0x997ef57d0701000000b70900),
(58, 0x997ef67d0701000000b80900),
(58, 0x937efa7d0601000000680600),
(58, 0x917ef87d0701000000680600),
(58, 0x937efb7d0701000000660600),
(58, 0x917ef87d0801000000660600),
(58, 0x937ef87d0801000000660600),
(58, 0x927ef97d0901000000660600),
(58, 0x947ef87d0601000000680600),
(58, 0x957ef97d0601000000660600),
(58, 0x957ef87d0701000000680600),
(58, 0x967efb7d0701000000660600),
(58, 0x997ef97d0701000000b70900),
(58, 0x997efa7d0701000000b80900),
(58, 0x927efc7d0601000000bd0900),
(58, 0x937efc7d0601000000be0900),
(58, 0x917efd7d0701000000680600),
(58, 0x927efd7d0901000000660600),
(59, 0x9b7e037e0601000000b70900),
(59, 0x9c7e037e0601000000b70900),
(59, 0x9c7e017e0701000000680600),
(59, 0x9b7e047e0601000000b80900),
(59, 0x987e047e0701000000bd0900),
(59, 0x997e047e0701000000be0900),
(59, 0x9c7e047e0601000000b80900),
(60, 0xa37e017e0701000000680600),
(60, 0xa07e057e0601000000b70900),
(60, 0xa07e067e0601000000b80900),
(60, 0xa17e047e0601000000680600),
(60, 0xa37e047e0601000000680600),
(60, 0xa07e057e0701000000b70900),
(60, 0xa07e067e0701000000b80900),
(60, 0xa27e067e0701000000660600),
(60, 0xa37e077e0701000000680600),
(60, 0xa47e057e0601000000b70900),
(60, 0xa47e067e0601000000b80900),
(61, 0x297efa7d0701000000bd0900),
(61, 0x297efb7d0701000000bd0900),
(61, 0x2a7efa7d0701000000be0900),
(61, 0x2a7efb7d0701000000be0900),
(61, 0x2b7efe7d0701000000660600),
(62, 0x277efb7d0601000000b70900),
(62, 0x2b7efb7d0601000000660600),
(62, 0x277efc7d0601000000b80900),
(62, 0x277efd7d0601000000b70900),
(62, 0x277efe7d0601000000b80900),
(63, 0x297ef57d0601000000bd0900),
(63, 0x297ef67d0601000000bd0900),
(63, 0x2a7ef57d0601000000be0900),
(63, 0x2a7ef67d0601000000be0900),
(63, 0x2b7ef97d0601000000660600),
(64, 0x1b7efc7d0701000000660600),
(64, 0x177e007e0601000000bd0900),
(64, 0x187e007e0601000000be0900),
(64, 0x1b7e007e0701000000660600),
(65, 0x297e0c7e0801000000b70900),
(65, 0x297e0d7e0801000000b80900),
(65, 0x297e107e0801000000680600),
(66, 0x257e0c7e0801000000b70900),
(66, 0x257e0d7e0801000000b80900),
(66, 0x257e107e0801000000680600),
(67, 0x317e137e0801000000680600),
(67, 0x317e167e0801000000b70900),
(67, 0x317e177e0801000000b80900),
(68, 0x2d7e137e0801000000680600),
(68, 0x2d7e167e0801000000b70900),
(68, 0x2d7e177e0801000000b80900),
(69, 0x297e137e0801000000680600),
(69, 0x297e167e0801000000b70900),
(69, 0x297e177e0801000000b80900),
(70, 0x257e137e0801000000680600),
(70, 0x257e167e0801000000b70900),
(70, 0x257e177e0801000000b80900),
(71, 0x3c7e0b7e0601000000b70900),
(71, 0x3c7e0f7e0401000000b70900),
(71, 0x3e7e0d7e0401000000680600),
(71, 0x3f7e0f7e0401000000b70900),
(71, 0x3c7e0c7e0601000000b80900),
(71, 0x3c7e0f7e0601000000b70900),
(71, 0x3d7e0f7e0601000000b70900),
(71, 0x3f7e0c7e0601000000660600),
(71, 0x3d7e0d7e0701000000680600),
(71, 0x3c7e107e0401000000b80900),
(71, 0x3f7e107e0401000000b80900),
(71, 0x3c7e107e0601000000b80900),
(71, 0x3d7e107e0601000000b80900),
(71, 0x407e0c7e0401000000660600),
(71, 0x427e0d7e0401000000680600),
(71, 0x437e0e7e0401000000bd0900),
(71, 0x417e0c7e0501000000660600),
(71, 0x427e0f7e0501000000b70900),
(71, 0x437e0d7e0501000000680600),
(71, 0x407e0d7e0601000000680600),
(71, 0x437e0d7e0601000000680600),
(71, 0x427e0e7e0701000000660600),
(71, 0x447e0e7e0401000000be0900),
(71, 0x447e0f7e0501000000b70900),
(71, 0x447e0f7e0601000000b70900),
(71, 0x457e0c7e0801000000660600),
(71, 0x437e107e0401000000bd0900),
(71, 0x427e107e0501000000b80900),
(71, 0x447e107e0401000000be0900),
(71, 0x447e107e0501000000b80900),
(71, 0x447e107e0601000000b80900),
(71, 0x457e107e0701000000660600),
(72, 0x477efe7d0701000000b70900),
(72, 0x477eff7d0701000000b80900),
(72, 0x4b7e017e0701000000660600),
(73, 0x4c7eff7d0601000000660600),
(73, 0x477e037e0601000000b70900),
(73, 0x487e007e0601000000680600),
(73, 0x487e037e0601000000b70900),
(73, 0x4a7e037e0601000000b70900),
(73, 0x4b7e007e0601000000680600),
(73, 0x4b7e037e0601000000b70900),
(73, 0x4d7e037e0601000000b70900),
(73, 0x4e7e037e0601000000b70900),
(73, 0x477e047e0601000000b80900),
(73, 0x477e067e0601000000b70900),
(73, 0x477e077e0601000000b80900),
(73, 0x487e047e0601000000b80900),
(73, 0x487e067e0601000000b70900),
(73, 0x487e077e0601000000b80900),
(73, 0x4a7e047e0601000000b80900),
(73, 0x4a7e067e0601000000b70900),
(73, 0x4a7e077e0601000000b80900),
(73, 0x4b7e047e0601000000b80900),
(73, 0x4b7e067e0601000000b70900),
(73, 0x4b7e077e0601000000b80900),
(73, 0x4d7e047e0601000000b80900),
(73, 0x4d7e067e0601000000b70900),
(73, 0x4d7e077e0601000000b80900),
(73, 0x4e7e047e0601000000b80900),
(73, 0x4e7e067e0601000000b70900),
(73, 0x4e7e077e0601000000b80900),
(73, 0x477e097e0601000000b70900),
(73, 0x477e0a7e0601000000b80900),
(73, 0x487e097e0601000000b70900),
(73, 0x487e0a7e0601000000b80900),
(73, 0x4a7e097e0601000000b70900),
(73, 0x4a7e0a7e0601000000b80900),
(73, 0x4b7e097e0601000000b70900),
(73, 0x4b7e0a7e0601000000b80900),
(73, 0x4d7e097e0601000000b70900),
(73, 0x4d7e0a7e0601000000b80900),
(73, 0x4e7e097e0601000000b70900),
(73, 0x4e7e0a7e0601000000b80900),
(73, 0x477e0c7e0601000000b70900),
(73, 0x477e0d7e0601000000b80900),
(73, 0x487e0c7e0601000000b70900),
(73, 0x487e0d7e0601000000b80900),
(73, 0x4a7e0c7e0601000000b70900),
(73, 0x4a7e0d7e0601000000b80900),
(73, 0x4b7e0c7e0601000000b70900),
(73, 0x4b7e0d7e0601000000b80900),
(73, 0x4d7e0c7e0601000000b70900),
(73, 0x4d7e0d7e0601000000b80900),
(73, 0x4e7e0c7e0601000000b70900),
(73, 0x4e7e0d7e0601000000b80900),
(74, 0x7d7ee77d0801000000660600),
(74, 0x7b7ee87d0801000000220900),
(75, 0x7b7ee87d0701000000220900),
(75, 0x7d7ee87d0701000000660600),
(76, 0x7b7ee87d0601000000220900),
(76, 0x7d7ee97d0601000000660600),
(77, 0x587ec37d0801000000b70900),
(77, 0x597ec37d0801000000b70900),
(77, 0x587ec67d0601000000b70900),
(77, 0x587ec77d0601000000b80900),
(77, 0x5b7ec57d0601000000680600),
(77, 0x5b7ec57d0701000000680600),
(77, 0x587ec47d0801000000b80900),
(77, 0x587ec67d0801000000bd0900),
(77, 0x597ec47d0801000000b80900),
(77, 0x597ec67d0801000000be0900),
(77, 0x5b7ec47d0801000000660600),
(77, 0x5b7ec77d0801000000660600),
(77, 0x5d7ec67d0601000000b70900),
(77, 0x5d7ec77d0601000000b80900),
(77, 0x5e7ec47d0801000000660600),
(77, 0x5e7ec77d0801000000660600),
(77, 0x587ec87d0601000000b70900),
(77, 0x587ec97d0601000000b80900),
(77, 0x5a7ec97d0601000000660600),
(77, 0x597ecb7d0701000000680600),
(77, 0x5e7ec97d0601000000680600),
(77, 0x5c7ecb7d0701000000680600),
(77, 0x5d7ec97d0801000000680600),
(77, 0x577ecc7d0601000000bd0900),
(77, 0x587ecc7d0601000000be0900),
(77, 0x5a7ece7d0701000000220900),
(77, 0x5b7ecf7d0801000000660600),
(77, 0x5d7ecd7d0601000000660600),
(77, 0x607ec37d0801000000b70900),
(77, 0x617ec37d0801000000b70900),
(77, 0x607ec47d0801000000b80900),
(77, 0x607ec67d0801000000bd0900),
(77, 0x617ec47d0801000000b80900),
(77, 0x617ec67d0801000000be0900),
(77, 0x597ed07d0601000000b70900),
(77, 0x597ed17d0601000000b80900),
(77, 0x5d7ed07d0601000000660600),
(77, 0x5e7ed27d0601000000680600),
(77, 0x5c7ed47d0701000000680600),
(77, 0x5d7ed47d0701000000680600),
(78, 0x7a7ee07d0701000000660600),
(78, 0x7d7ee17d0701000000240900),
(78, 0x7a7ee47d0701000000660600),
(79, 0x7a7ede7d0601000000660600),
(79, 0x7d7edd7d0601000000240900),
(80, 0x7a7ee07d0601000000660600),
(80, 0x7d7ee17d0601000000240900),
(80, 0x7a7ee47d0601000000660600),
(81, 0x897eb07d0701000000bd0900),
(81, 0x8a7eb07d0701000000be0900),
(81, 0x8b7eb17d0701000000660600),
(81, 0x8e7eb27d0701000000240900),
(81, 0x8e7eb47d0701000000680600),
(82, 0x947eaf7d0601000000680600),
(82, 0x947eaf7d0701000000680600),
(82, 0x937eb27d0601000000b70900),
(82, 0x937eb37d0601000000b80900),
(82, 0x957eb27d0601000000b70900),
(82, 0x957eb37d0601000000b80900),
(82, 0x947eb27d0701000000240900),
(82, 0x947eb47d0701000000680600),
(83, 0x9a7eb97d0701000000680600),
(83, 0x977ebd7d0701000000b70900),
(83, 0x977ebe7d0701000000b80900),
(83, 0x987ebd7d0701000000b70900),
(83, 0x987ebe7d0701000000b80900),
(84, 0x977ebd7d0601000000b70900),
(84, 0x977ebe7d0601000000b80900),
(84, 0x987ebd7d0601000000b70900),
(84, 0x987ebe7d0601000000b80900),
(84, 0x9c7ebd7d0601000000660600),
(85, 0xa47eab7d0601000000b70900),
(85, 0xa77eab7d0601000000b70900),
(85, 0xa47eab7d0701000000b70900),
(85, 0xa77eab7d0701000000b70900),
(85, 0xa37eaf7d0701000000660600),
(85, 0xa47eac7d0601000000b80900),
(85, 0xa67ead7d0601000000680600),
(85, 0xa77eac7d0601000000b80900),
(85, 0xa47eac7d0701000000b80900),
(85, 0xa67ead7d0701000000680600),
(85, 0xa77eac7d0701000000b80900),
(85, 0xa67eb17d0701000000680600),
(86, 0x9b7eda7d0701000000b70900),
(86, 0x9b7edb7d0701000000b80900),
(86, 0x9f7edc7d0701000000660600),
(87, 0x9b7eda7d0601000000b70900),
(87, 0x9b7edb7d0601000000b80900),
(87, 0x9f7edc7d0601000000660600),
(88, 0x9b7ede7d0701000000b70900),
(88, 0x9b7edf7d0701000000b80900),
(88, 0x9f7edf7d0701000000660600),
(89, 0x9b7ede7d0601000000b70900),
(89, 0x9b7edf7d0601000000b80900),
(89, 0x9f7edf7d0601000000660600),
(90, 0x9b7ee27d0701000000b70900),
(90, 0x9b7ee37d0701000000b80900),
(90, 0x9f7ee27d0701000000660600),
(91, 0x9b7ee27d0601000000b70900),
(91, 0x9b7ee37d0601000000b80900),
(91, 0x9f7ee27d0601000000660600),
(92, 0xa47ee87d0701000000b70900),
(92, 0xa47ee97d0701000000b80900),
(92, 0xa37eec7d0701000000680600),
(93, 0xa47ee87d0601000000b70900),
(93, 0xa47ee97d0601000000b80900),
(93, 0xa37eec7d0601000000680600),
(94, 0x9e7ee87d0701000000bd0900),
(94, 0x9e7ee97d0701000000bd0900),
(94, 0x9f7ee87d0701000000be0900),
(94, 0x9f7ee97d0701000000be0900),
(94, 0x9d7eec7d0701000000680600),
(95, 0x9e7ee87d0601000000bd0900),
(95, 0x9e7ee97d0601000000bd0900),
(95, 0x9f7ee87d0601000000be0900),
(95, 0x9f7ee97d0601000000be0900),
(95, 0x9d7eec7d0601000000680600),
(96, 0x9d7eef7d0701000000680600),
(96, 0x9e7ef07d0701000000bd0900),
(96, 0x9e7ef17d0701000000bd0900),
(96, 0x9f7ef07d0701000000be0900),
(96, 0x9f7ef17d0701000000be0900),
(97, 0x9d7eef7d0601000000680600),
(97, 0x9e7ef07d0601000000bd0900),
(97, 0x9e7ef17d0601000000bd0900),
(97, 0x9f7ef07d0601000000be0900),
(97, 0x9f7ef17d0601000000be0900),
(98, 0xa37eef7d0701000000680600),
(98, 0xa47ef07d0701000000b70900),
(98, 0xa47ef17d0701000000b80900),
(99, 0xa37eef7d0601000000680600),
(99, 0xa47ef07d0601000000b70900),
(99, 0xa47ef17d0601000000b80900),
(100, 0xa27ef97d0601000000b70900),
(100, 0xa27efa7d0601000000b80900),
(100, 0xa37ef87d0701000000680600),
(100, 0xa37efb7d0701000000bd0900),
(100, 0xa47efb7d0701000000be0900),
(101, 0xa17ed07d0701000000b70900),
(101, 0xa17ed17d0701000000b80900),
(101, 0xa27ed07d0701000000b70900),
(101, 0xa27ed17d0701000000b80900),
(101, 0xa67ed07d0701000000660600),
(102, 0xa17ecb7d0701000000b70900),
(102, 0xa27ecb7d0701000000b70900),
(102, 0xa67ecb7d0701000000660600),
(102, 0xa17ecc7d0701000000b80900),
(102, 0xa27ecc7d0701000000b80900),
(103, 0xa17ec67d0701000000b70900),
(103, 0xa17ec77d0701000000b80900),
(103, 0xa27ec67d0701000000b70900),
(103, 0xa27ec77d0701000000b80900),
(103, 0xa67ec67d0701000000660600),
(104, 0xa17ed07d0601000000b70900),
(104, 0xa17ed17d0601000000b80900),
(104, 0xa27ed07d0601000000b70900),
(104, 0xa27ed17d0601000000b80900),
(104, 0xa67ed07d0601000000660600),
(105, 0xa17ecb7d0601000000b70900),
(105, 0xa27ecb7d0601000000b70900),
(105, 0xa67ecb7d0601000000660600),
(105, 0xa17ecc7d0601000000b80900),
(105, 0xa27ecc7d0601000000b80900),
(106, 0xa17ec67d0601000000b70900),
(106, 0xa17ec77d0601000000b80900),
(106, 0xa27ec67d0601000000b70900),
(106, 0xa27ec77d0601000000b80900),
(106, 0xa67ec67d0601000000660600),
(107, 0xa07ebd7d0701000000b70900),
(107, 0xa07ebe7d0701000000b80900),
(107, 0xa17ebd7d0701000000b70900),
(107, 0xa17ebe7d0701000000b80900),
(107, 0xa57ebd7d0701000000660600),
(108, 0xa07ebd7d0601000000b70900),
(108, 0xa07ebe7d0601000000b80900),
(108, 0xa17ebd7d0601000000b70900),
(108, 0xa17ebe7d0601000000b80900),
(108, 0xa57ebd7d0601000000660600),
(109, 0x557ecd7d0701000000b70900),
(109, 0x557ece7d0701000000b80900),
(109, 0x517ed27d0701000000660600),
(109, 0x527ed07d0701000000680600),
(109, 0x537ed27d0701000000220900),
(110, 0x4d7edf7d0701000000220900),
(110, 0x4f7ede7d0701000000660600),
(110, 0x4b7ee07d0701000000660600),
(111, 0xd07d9f7e0801000000bd0900),
(111, 0xd17d9f7e0801000000be0900),
(111, 0xd77d9f7e0801000000bd0900),
(111, 0xd87d9f7e0801000000be0900),
(111, 0xcc7da97e0801000000680600),
(111, 0xce7daf7e0401000000660600),
(111, 0xcf7dac7e0401000000b70900),
(111, 0xcf7dad7e0401000000b80900),
(111, 0xce7daf7e0501000000680600),
(111, 0xd07da17e0801000000bd0900),
(111, 0xd07da37e0801000000bd0900),
(111, 0xd17da17e0801000000be0900),
(111, 0xd17da37e0801000000be0900),
(111, 0xd77da17e0801000000bd0900),
(111, 0xd77da37e0801000000bd0900),
(111, 0xd87da17e0801000000be0900),
(111, 0xd87da37e0801000000be0900),
(111, 0xd07da57e0801000000bd0900),
(111, 0xd07da77e0801000000bd0900),
(111, 0xd17da57e0801000000be0900),
(111, 0xd17da77e0801000000be0900),
(111, 0xd77da57e0801000000bd0900),
(111, 0xd77da77e0801000000bd0900),
(111, 0xd87da57e0801000000be0900),
(111, 0xd87da77e0801000000be0900),
(111, 0xd07dab7e0501000000680600),
(111, 0xd37da97e0801000000680600),
(111, 0xd37dab7e0801000000680600),
(111, 0xda7da97e0801000000680600),
(111, 0xda7dab7e0801000000680600),
(111, 0xd07dae7e0401000000680600),
(111, 0xd27dae7e0501000000680600),
(111, 0xd07dad7e0701000000680600),
(111, 0xd07dad7e0801000000bd0900),
(111, 0xd07daf7e0801000000bd0900),
(111, 0xd17dad7e0801000000be0900),
(111, 0xd17daf7e0801000000be0900),
(111, 0xd77dad7e0801000000bd0900),
(111, 0xd77daf7e0801000000bd0900),
(111, 0xd87dad7e0801000000be0900),
(111, 0xd87daf7e0801000000be0900),
(111, 0xcc7db27e0501000000b70900),
(111, 0xcc7db37e0501000000b80900),
(111, 0xcd7db07e0701000000660600),
(111, 0xcf7db47e0601000000680600),
(111, 0xd07db07e0401000000680600),
(111, 0xd27db27e0401000000b70900),
(111, 0xd27db37e0401000000b80900),
(111, 0xd37db27e0401000000b70900),
(111, 0xd37db37e0401000000b80900),
(111, 0xd07db27e0501000000b70900),
(111, 0xd07db37e0501000000b80900),
(111, 0xd37db27e0501000000b70900),
(111, 0xd37db37e0501000000b80900),
(111, 0xd17db07e0601000000660600),
(111, 0xd07db27e0701000000680600),
(111, 0xd27db07e0701000000660600),
(111, 0xd07db17e0801000000bd0900),
(111, 0xd07db37e0801000000bd0900),
(111, 0xd17db17e0801000000be0900),
(111, 0xd17db37e0801000000be0900),
(111, 0xd77db17e0801000000bd0900),
(111, 0xd77db37e0801000000bd0900),
(111, 0xd87db17e0801000000be0900),
(111, 0xd87db37e0801000000be0900),
(111, 0xd07db47e0701000000680600),
(111, 0xd07db57e0801000000bd0900),
(111, 0xd17db57e0801000000be0900),
(111, 0xd77db57e0801000000bd0900),
(111, 0xd87db57e0801000000be0900),
(112, 0xaf7d967e0801000000b70900),
(112, 0xaf7d977e0801000000b80900),
(112, 0xb17d967e0801000000b70900),
(112, 0xb17d977e0801000000b80900),
(112, 0xb37d967e0801000000b70900),
(112, 0xb37d977e0801000000b80900),
(112, 0xb57d967e0801000000b70900),
(112, 0xb57d977e0801000000b80900),
(112, 0xb77d967e0801000000b70900),
(112, 0xb77d977e0801000000b80900),
(112, 0xb97d967e0801000000b70900),
(112, 0xb97d977e0801000000b80900),
(112, 0xb27d9a7e0801000000680600),
(112, 0xb77d9a7e0801000000680600),
(112, 0xb67d9f7e08010000001e0900),
(112, 0xba7d9c7e0801000000660600),
(112, 0xbb7d9e7e0801000000bd0900),
(112, 0xbc7d9e7e0801000000be0900),
(112, 0xbe7d9e7e0801000000b70900),
(112, 0xbe7d9f7e0801000000b80900),
(112, 0xae7da47e0601000000b70900),
(112, 0xae7da57e0601000000b80900),
(112, 0xbb7da07e0801000000bd0900),
(112, 0xbb7da27e0801000000bd0900),
(112, 0xbc7da07e0801000000be0900),
(112, 0xbc7da27e0801000000be0900),
(112, 0xb07da47e0601000000b70900),
(112, 0xb07da57e0601000000b80900),
(112, 0xb37da77e0601000000660600),
(112, 0xba7da47e0801000000660600),
(112, 0xbb7da57e0801000000b70900),
(112, 0xbb7da67e0801000000b80900),
(112, 0xbc7da57e0801000000b70900),
(112, 0xbc7da67e0801000000b80900),
(112, 0xbe7da57e0801000000b70900),
(112, 0xbe7da67e0801000000b80900),
(112, 0xb57daa7e0601000000680600),
(112, 0xb47daa7e0701000000680600),
(113, 0xb17dad7e0701000000b70900),
(113, 0xb17dae7e0701000000b80900),
(113, 0xb07db07e0701000000680600),
(114, 0xb67dad7e0701000000b70900),
(114, 0xb67dae7e0701000000b80900),
(114, 0xb87db07e0701000000680600),
(115, 0xc47db77e0701000000680600),
(115, 0xc77dbc7e0601000000b70900),
(115, 0xc77dbd7e0601000000b80900),
(115, 0xc77dbc7e0701000000b70900),
(115, 0xc77dbd7e0701000000b80900),
(115, 0xc87dbc7e0601000000b70900),
(115, 0xc87dbd7e0601000000b80900),
(115, 0xc87dbc7e0701000000b70900),
(115, 0xc87dbd7e0701000000b80900),
(116, 0xaf7db97e0701000000680600),
(116, 0xae7dbd7e0701000000b70900),
(116, 0xae7dbe7e0701000000b80900),
(116, 0xaf7dbd7e0701000000b70900),
(116, 0xaf7dbe7e0701000000b80900),
(117, 0xab7db97e0701000000680600),
(117, 0xa87dbd7e0701000000b70900),
(117, 0xa87dbe7e0701000000b80900),
(117, 0xa97dbd7e0701000000b70900),
(117, 0xa97dbe7e0701000000b80900),
(118, 0x9f7db97e0501000000bd0900),
(118, 0x9f7dba7e0501000000bd0900),
(118, 0x9f7db87e0701000000680600),
(118, 0xa07db97e0501000000be0900),
(118, 0xa07dba7e0501000000be0900),
(119, 0x8e7d857e0701000000b70900),
(119, 0x8e7d867e0701000000b80900),
(119, 0x8e7d887e0701000000b70900),
(119, 0x8e7d897e0701000000b80900),
(119, 0x907d8a7e0701000000680600),
(119, 0x937d8d7e0701000000660600),
(119, 0x977d8e7e0701000000680600),
(120, 0xa87d717e0601000000bd0900),
(120, 0xa87d737e0601000000bd0900),
(120, 0xa97d717e0601000000be0900),
(120, 0xa97d737e0601000000be0900),
(120, 0xa97d717e0801000000bd0900),
(120, 0xa97d737e0801000000bd0900),
(120, 0xaa7d717e0801000000be0900),
(120, 0xaa7d737e0801000000be0900),
(120, 0xad7d737e0601000000660600),
(120, 0xac7d727e0801000000660600),
(120, 0xae7d737e0801000000680600),
(120, 0xab7d747e0601000000680600),
(120, 0xa97d767e0701000000680600),
(120, 0xa97d757e0801000000bd0900),
(120, 0xaa7d757e0801000000be0900),
(120, 0xad7d777e0601000000660600),
(120, 0xaf7d747e0601000000680600),
(120, 0xac7d767e0701000000680600),
(120, 0xae7d757e0701000000660600),
(120, 0xa87d797e0701000000bd0900),
(120, 0xa97d797e0701000000be0900),
(120, 0xab7d797e0701000000bd0900),
(120, 0xaf7d787e0601000000b70900),
(120, 0xaf7d797e0601000000b80900),
(120, 0xac7d797e0701000000be0900),
(120, 0xaf7d797e0701000000bd0900),
(120, 0xb07d737e0701000000680600),
(120, 0xb07d767e0701000000680600),
(120, 0xb17d757e0701000000660600),
(120, 0xb07d787e0601000000b70900),
(120, 0xb07d797e0601000000b80900),
(120, 0xb07d797e0701000000be0900),
(121, 0x837d717e0501000000b70900),
(121, 0x837d727e0501000000b80900),
(121, 0x837d717e0601000000b70900),
(121, 0x837d727e0601000000b80900),
(121, 0x847d737e0601000000680600),
(121, 0x867d717e0601000000b70900),
(121, 0x867d727e0601000000b80900),
(121, 0x877d737e0601000000680600),
(121, 0x857d707e0701000000680600),
(121, 0x877d727e0701000000660600),
(121, 0x887d727e0501000000660600),
(121, 0x897d737e0501000000680600),
(121, 0x837d747e0501000000bd0900),
(121, 0x837d767e0501000000bd0900),
(121, 0x847d747e0501000000be0900),
(121, 0x847d767e0501000000be0900),
(121, 0x857d757e0501000000660600),
(121, 0x847d757e0601000000b70900),
(121, 0x847d767e0601000000b80900),
(121, 0x857d757e0601000000b70900),
(121, 0x857d767e0601000000b80900),
(121, 0x877d767e0701000000660600),
(121, 0x867d747e0801000000680600),
(121, 0x887d757e0601000000660600),
(121, 0x897d747e0701000000680600),
(121, 0x8b7d767e0701000000660600),
(121, 0x897d747e0801000000680600),
(122, 0x067e097d0601000000bd0900),
(122, 0x077e097d0601000000be0900),
(122, 0x0a7e097d0601000000b70900),
(122, 0x0a7e0a7d0601000000b80900),
(122, 0x0b7e0a7d0701000000220900),
(122, 0x097e0a7d0801000000bb0900),
(122, 0x097e0b7d0801000000bc0900),
(122, 0x0b7e0a7d0801000000bb0900),
(122, 0x0b7e0b7d0801000000bc0900),
(122, 0x0c7e0b7d0601000000dc1300),
(122, 0x0d7e0a7d0801000000bb0900),
(122, 0x0d7e0b7d0801000000bc0900),
(122, 0x0f7e0a7d0801000000bb0900),
(122, 0x0f7e0b7d0801000000bc0900),
(122, 0x037e0c7d0601000000bd0900),
(122, 0x037e0e7d0601000000bd0900),
(122, 0x047e0c7d0601000000be0900),
(122, 0x047e0e7d0601000000be0900),
(122, 0x097e0d7d0601000000da1300),
(122, 0x0a7e0f7d0601000000bd0900),
(122, 0x0b7e0f7d0601000000be0900),
(122, 0x097e0f7d0801000000bb0900),
(122, 0x0b7e0f7d0801000000bb0900),
(122, 0x0d7e0e7d0601000000dc1300),
(122, 0x0d7e0f7d0801000000bb0900),
(122, 0x0f7e0f7d0801000000bb0900),
(122, 0x127e0b7d0601000000dc1300),
(122, 0x117e0a7d0801000000bb0900),
(122, 0x117e0b7d0801000000bc0900),
(122, 0x137e0a7d0801000000bb0900),
(122, 0x137e0b7d0801000000bc0900),
(122, 0x167e0b7d0501000000da1300),
(122, 0x147e097d0601000000b70900),
(122, 0x147e0a7d0601000000b80900),
(122, 0x117e0e7d0601000000dc1300),
(122, 0x117e0f7d0801000000bb0900),
(122, 0x137e0f7d0801000000bb0900),
(122, 0x157e0c7d0601000000da1300),
(122, 0x197e0e7d0501000000dc1300),
(122, 0x197e0e7d0601000000dc1300),
(122, 0x067e117d0601000000bd0900),
(122, 0x077e117d0601000000be0900),
(122, 0x0a7e117d0601000000bd0900),
(122, 0x0b7e117d0601000000be0900),
(122, 0x097e107d0801000000bc0900),
(122, 0x0b7e107d0801000000bc0900),
(122, 0x0d7e107d0801000000bc0900),
(122, 0x0f7e107d0801000000bc0900),
(122, 0x137e107d0601000000b70900),
(122, 0x137e117d0601000000b80900),
(122, 0x117e107d0801000000bc0900),
(122, 0x137e107d0801000000bc0900),
(122, 0x147e107d0601000000b70900),
(122, 0x147e117d0601000000b80900),
(123, 0x1f7e3f7d0501000000660600),
(123, 0x1f7e3e7d0601000000b70900),
(123, 0x1f7e3f7d0601000000b80900),
(123, 0x237e3e7d0601000000b70900),
(123, 0x237e3f7d0601000000b80900),
(123, 0x247e3e7d0801000000b70900),
(123, 0x247e3f7d0801000000b80900),
(123, 0x267e3e7d0801000000b70900),
(123, 0x267e3f7d0801000000b80900),
(123, 0x287e3e7d0801000000b70900),
(123, 0x287e3f7d0801000000b80900),
(123, 0x1c7e417d0501000000b70900),
(123, 0x1c7e427d0501000000b80900),
(123, 0x1e7e437d0501000000680600),
(123, 0x1c7e417d0601000000b70900),
(123, 0x1c7e427d0601000000b80900),
(123, 0x1f7e427d0601000000660600),
(123, 0x1c7e407d0701000000680600),
(123, 0x1f7e437d0701000000660600),
(123, 0x1f7e417d0801000000660600),
(123, 0x1c7e447d0601000000b70900),
(123, 0x1c7e457d0601000000b80900),
(123, 0x1f7e457d0601000000660600),
(123, 0x217e407d0601000000680600),
(123, 0x207e407d0701000000680600),
(123, 0x237e407d0701000000680600),
(123, 0x207e427d0801000000680600),
(123, 0x227e407d0801000000660600),
(123, 0x227e437d0801000000b70900),
(123, 0x257e407d0601000000680600),
(123, 0x247e437d0801000000b70900),
(123, 0x267e437d0801000000b70900),
(123, 0x287e437d0801000000b70900),
(123, 0x227e457d0701000000680600),
(123, 0x227e447d0801000000b80900),
(123, 0x247e447d0801000000b80900),
(123, 0x267e447d0801000000b80900),
(123, 0x287e447d0801000000b80900),
(124, 0x167e267d0601000000bd0900),
(124, 0x167e277d0601000000bd0900),
(124, 0x177e267d0601000000be0900),
(124, 0x177e277d0601000000be0900),
(124, 0x167e257d0701000000680600),
(124, 0x1a7e267d0601000000b70900),
(124, 0x1a7e277d0601000000b80900),
(124, 0x1b7e267d0601000000b70900),
(124, 0x1b7e277d0601000000b80900),
(124, 0x187e277d0701000000660600),
(124, 0x157e287d0601000000680600),
(124, 0x167e2a7d0601000000660600),
(124, 0x147e297d0701000000680600),
(124, 0x157e2b7d0701000000660600),
(124, 0x187e2b7d0701000000660600),
(124, 0x147e2c7d0701000000680600),
(125, 0x187e307d0701000000680600),
(125, 0x1b7e327d0701000000660600),
(125, 0x1c7e307d0701000000680600),
(125, 0x1d7e317d0701000000b70900),
(125, 0x1d7e327d0701000000b80900),
(125, 0x177e347d0701000000660600),
(125, 0x1b7e347d0701000000660600),
(126, 0x0b7e3f7d0701000000b70900),
(126, 0x0c7e3f7d0701000000b70900),
(126, 0x117e3e7d0701000000660600),
(126, 0x0b7e407d0701000000b80900),
(126, 0x0c7e407d0701000000b80900),
(126, 0x0e7e407d0701000000bd0900),
(126, 0x0f7e407d0701000000be0900),
(127, 0x087e2b7d0701000000680600),
(127, 0x067e2e7d0701000000bd0900),
(127, 0x077e2e7d0701000000be0900),
(128, 0x037e2b7d0701000000680600),
(128, 0x017e2e7d0701000000bd0900),
(128, 0x027e2e7d0701000000be0900),
(129, 0x047e257d0701000000b70900),
(129, 0x047e267d0701000000b80900),
(129, 0x037e287d0701000000680600),
(130, 0x097e257d0701000000b70900),
(130, 0x097e267d0701000000b80900),
(130, 0x087e287d0701000000680600),
(131, 0x077e277d0601000000680600),
(131, 0x017e2b7d0601000000bd0900),
(131, 0x027e2b7d0601000000be0900),
(131, 0x037e297d0601000000660600),
(131, 0x017e2e7d0601000000bd0900),
(131, 0x027e2e7d0601000000be0900),
(131, 0x037e2d7d0601000000660600),
(132, 0x047e1e7d0701000000b70900),
(132, 0x047e1f7d0701000000b80900),
(132, 0x097e207d0701000000660600),
(133, 0x0b7e437d0701000000b70900),
(133, 0x0d7e437d0701000000b70900),
(133, 0x0f7e437d0701000000b70900),
(133, 0x0e7e437d0801000000bd0900),
(133, 0x0f7e437d0801000000be0900),
(133, 0x0b7e447d0701000000b80900),
(133, 0x0d7e477d0601000000680600),
(133, 0x0d7e447d0701000000b80900),
(133, 0x0d7e467d0701000000680600),
(133, 0x0f7e447d0701000000b80900),
(133, 0x0e7e457d0801000000bd0900),
(133, 0x0e7e467d0801000000bd0900),
(133, 0x0f7e457d0801000000be0900),
(133, 0x0f7e467d0801000000be0900),
(133, 0x0b7e497d0601000000b70900),
(133, 0x0b7e4a7d0601000000b80900),
(133, 0x0f7e497d0601000000b70900),
(133, 0x0f7e4a7d0601000000b80900),
(133, 0x0f7e497d0701000000660600),
(133, 0x0e7e487d0801000000bd0900),
(133, 0x0f7e487d0801000000be0900),
(133, 0x107e477d0601000000680600),
(133, 0x127e457d0601000000660600),
(133, 0x117e467d0701000000680600),
(133, 0x127e447d0801000000660600),
(133, 0x147e477d0601000000680600),
(133, 0x147e467d0701000000680600),
(133, 0x157e457d0701000000660600),
(133, 0x147e457d0801000000680600),
(133, 0x137e4a7d0601000000bd0900),
(133, 0x147e4a7d0601000000be0900),
(134, 0xa47e0f7c0601000000bd0900),
(134, 0xa57e0f7c0601000000be0900),
(134, 0xa47e127c0601000000bd0900),
(134, 0xa57e127c0601000000be0900),
(134, 0xa77e107c0601000000660600),
(134, 0xa77e137c0601000000660600),
(134, 0xa47e117c0801000000b70900),
(134, 0xa47e127c0801000000b80900),
(134, 0xa67e117c0801000000b70900),
(134, 0xa67e127c0801000000b80900),
(134, 0xa77e117c0801000000b70900),
(134, 0xa77e127c0801000000b80900),
(134, 0xa97e117c0701000000660600),
(134, 0xa97e117c0801000000bd0900),
(134, 0xa97e127c0801000000bd0900),
(134, 0xaa7e117c0801000000be0900),
(134, 0xaa7e127c0801000000be0900),
(134, 0xaf7e117c0701000000660600),
(134, 0xaf7e127c0701000000660600),
(134, 0xa77e177c0601000000680600),
(134, 0xa77e157c0701000000680600),
(134, 0xa47e147c0801000000bd0900),
(134, 0xa47e157c0801000000bd0900),
(134, 0xa47e177c0801000000bd0900),
(134, 0xa57e147c0801000000be0900),
(134, 0xa57e157c0801000000be0900),
(134, 0xa57e177c0801000000be0900),
(134, 0xa77e147c0801000000b70900),
(134, 0xa77e157c0801000000b80900),
(134, 0xa97e167c0601000000660600),
(134, 0xa87e147c0801000000b70900),
(134, 0xa87e157c0801000000b80900),
(134, 0xa97e177c0801000000bd0900),
(134, 0xaa7e177c0801000000be0900),
(134, 0xab7e147c0801000000660600),
(134, 0xac7e147c0701000000680600),
(134, 0xac7e167c0801000000b70900),
(134, 0xac7e177c0801000000b80900),
(134, 0xae7e167c0801000000b70900),
(134, 0xae7e177c0801000000b80900),
(134, 0xa47e197c0601000000bd0900),
(134, 0xa57e197c0601000000be0900),
(134, 0xa97e187c0701000000660600),
(134, 0xa87e187c0801000000680600),
(134, 0xab7e1a7c0801000000660600),
(135, 0x137e4f7c0601000000b70900),
(135, 0x147e4f7c0701000000bd0900),
(135, 0x157e4f7c0701000000be0900),
(135, 0x1a7e4f7c0701000000b70900),
(135, 0x1d7e4f7c0601000000b70900),
(135, 0x1d7e4f7c0701000000b70900),
(135, 0x137e507c0601000000b80900),
(135, 0x137e537c0601000000b70900),
(135, 0x117e537c0801000000bd0900),
(135, 0x127e537c0801000000be0900),
(135, 0x167e507c0601000000660600),
(135, 0x167e537c0601000000b70900),
(135, 0x147e507c0701000000bd0900),
(135, 0x157e507c0701000000be0900),
(135, 0x167e527c0701000000660600),
(135, 0x187e527c0501000000660600),
(135, 0x197e527c0601000000680600),
(135, 0x187e507c0701000000680600),
(135, 0x197e527c0701000000660600),
(135, 0x1a7e507c0701000000b80900),
(135, 0x1c7e527c0601000000680600),
(135, 0x1d7e507c0601000000b80900),
(135, 0x1d7e507c0701000000b80900),
(135, 0x137e547c0601000000b80900),
(135, 0x137e557c0701000000bd0900),
(135, 0x117e557c0801000000bd0900),
(135, 0x117e577c0801000000bd0900),
(135, 0x127e557c0801000000be0900),
(135, 0x127e577c0801000000be0900),
(135, 0x157e547c0501000000680600),
(135, 0x157e577c0501000000bd0900),
(135, 0x167e577c0501000000be0900),
(135, 0x167e547c0601000000b80900),
(135, 0x177e567c0601000000660600),
(135, 0x147e557c0701000000be0900),
(135, 0x167e577c0701000000660600),
(135, 0x167e557c0801000000660600),
(135, 0x1b7e547c0501000000680600),
(135, 0x187e547c0701000000680600),
(135, 0x187e567c0801000000680600),
(135, 0x197e557c0801000000660600),
(135, 0x137e587c0601000000bd0900),
(135, 0x117e597c0801000000bd0900),
(135, 0x127e597c0801000000be0900),
(135, 0x157e587c0501000000bd0900),
(135, 0x167e587c0501000000be0900),
(135, 0x147e587c0601000000be0900),
(136, 0x267eaf7b0701000000b70900),
(136, 0x257eaf7b0801000000b70900),
(136, 0x277eaf7b0801000000b70900),
(136, 0x287eaf7b0701000000b70900),
(136, 0x2a7eaf7b0701000000b70900),
(136, 0x2b7eaf7b0701000000b70900),
(136, 0x287eaf7b0801000000b70900),
(136, 0x2d7eaf7b0701000000b70900),
(136, 0x2f7eaf7b0701000000b70900),
(136, 0x2c7eaf7b0801000000b70900),
(136, 0x2d7eaf7b0801000000b70900),
(136, 0x2f7eaf7b0801000000b70900),
(136, 0x217eb17b0601000000bd0900),
(136, 0x227eb17b0601000000be0900),
(136, 0x237eb07b0601000000660600),
(136, 0x257eb17b0501000000660600),
(136, 0x257eb07b0601000000660600),
(136, 0x267eb07b0701000000b80900),
(136, 0x257eb07b0801000000b80900),
(136, 0x257eb37b0801000000bd0900),
(136, 0x267eb37b0801000000be0900),
(136, 0x277eb07b0801000000b80900),
(136, 0x287eb07b0701000000b80900),
(136, 0x297eb27b0701000000680600),
(136, 0x2a7eb07b0701000000b80900),
(136, 0x2b7eb07b0701000000b80900),
(136, 0x287eb07b0801000000b80900),
(136, 0x2b7eb27b0801000000680600),
(136, 0x2c7eb17b0501000000660600),
(136, 0x2e7eb27b0501000000680600),
(136, 0x2c7eb07b0601000000660600),
(136, 0x2d7eb07b0701000000b80900),
(136, 0x2f7eb07b0701000000b80900),
(136, 0x2c7eb07b0801000000b80900),
(136, 0x2d7eb07b0801000000b80900),
(136, 0x2f7eb07b0801000000b80900),
(136, 0x217eb57b0601000000bd0900),
(136, 0x227eb57b0601000000be0900),
(136, 0x237eb47b0601000000660600),
(136, 0x257eb57b0701000000660600),
(136, 0x257eb57b0801000000bd0900),
(136, 0x257eb77b0801000000bd0900),
(136, 0x267eb57b0801000000be0900),
(136, 0x267eb77b0801000000be0900),
(136, 0x297eb47b0801000000660600),
(136, 0x2e7eb57b0501000000bd0900),
(136, 0x2e7eb67b0501000000bd0900),
(136, 0x2f7eb57b0501000000be0900),
(136, 0x2f7eb67b0501000000be0900),
(136, 0x2e7eb77b0601000000680600),
(136, 0x2c7eb57b0701000000660600),
(136, 0x2e7eb77b0701000000680600),
(136, 0x2e7eb47b0801000000680600),
(136, 0x217eb97b0601000000bd0900),
(136, 0x227eb97b0601000000be0900),
(136, 0x237eb87b0601000000660600),
(136, 0x257eb97b0601000000660600),
(136, 0x257eb97b0701000000660600),
(136, 0x257eb97b0801000000bd0900),
(136, 0x267eb97b0801000000be0900),
(136, 0x297eba7b0701000000680600),
(136, 0x297eb87b0801000000660600),
(136, 0x307eb37b0801000000660600),
(137, 0x127eec7b0701000000bb0900),
(137, 0x127eed7b0701000000bc0900),
(137, 0x197eed7b0701000000bb0900),
(137, 0x197eee7b0701000000bc0900),
(137, 0x157ef07b0701000000680600),
(138, 0x0c7e117c0701000000bb0900),
(138, 0x0c7e127c0701000000bc0900),
(138, 0x127e137c0701000000bb0900),
(138, 0x107e167c0701000000680600),
(138, 0x127e147c0701000000bc0900),
(139, 0x197e137c0701000000b90900),
(139, 0x1a7e137c0701000000ba0900),
(139, 0x1b7e167c0701000000660600),
(139, 0x187e187c0701000000b90900),
(139, 0x197e187c0701000000ba0900),
(140, 0x477ee97b0701000000b90900),
(140, 0x487ee97b0701000000ba0900),
(140, 0x457eec7b0701000000660600),
(140, 0x487eef7b0701000000b90900),
(140, 0x497eef7b0701000000ba0900),
(141, 0x5a7e387c0701000000220900),
(142, 0x5a7e3e7c0701000000220900),
(143, 0x5a7e447c0701000000220900),
(144, 0x4b7e127c0701000000b70900),
(144, 0x4b7e137c0701000000b80900),
(144, 0x4c7e127c0701000000b70900),
(144, 0x4c7e137c0701000000b80900),
(144, 0x4f7e167c0701000000680600),
(145, 0x4a7e137c0601000000660600),
(145, 0x4e7e147c0601000000b70900),
(145, 0x4e7e157c0601000000b80900),
(145, 0x4f7e147c0601000000b70900),
(145, 0x4f7e157c0601000000b80900),
(145, 0x507e137c0601000000660600),
(146, 0x437e147c0601000000b70900),
(146, 0x437e157c0601000000b80900),
(146, 0x447e147c0601000000b70900),
(146, 0x447e157c0601000000b80900),
(146, 0x487e147c0601000000660600),
(147, 0x467e127c0701000000b70900),
(147, 0x467e137c0701000000b80900),
(147, 0x477e127c0701000000b70900),
(147, 0x477e137c0701000000b80900),
(147, 0x467e167c0701000000680600),
(148, 0x477e197c0701000000680600),
(148, 0x447e1c7c0701000000b70900),
(148, 0x447e1d7c0701000000b80900),
(148, 0x457e1c7c0701000000b70900),
(148, 0x457e1d7c0701000000b80900),
(148, 0x497e1c7c0701000000660600),
(149, 0x4f7e197c0701000000680600),
(149, 0x4b7e1c7c0701000000660600),
(149, 0x4f7e1c7c0701000000b70900),
(149, 0x4f7e1d7c0701000000b80900),
(149, 0x507e1c7c0701000000b70900),
(149, 0x507e1d7c0701000000b80900),
(150, 0x797e327c0701000000660600),
(150, 0x7b7e347c0701000000bd0900),
(150, 0x7b7e357c0701000000bd0900),
(150, 0x7c7e347c0701000000be0900),
(150, 0x7c7e357c0701000000be0900),
(151, 0x797e327c0601000000660600),
(151, 0x7b7e347c0601000000bd0900),
(151, 0x7b7e357c0601000000bd0900),
(151, 0x7c7e347c0601000000be0900),
(151, 0x7c7e357c0601000000be0900),
(152, 0x787e337c0701000000680600),
(152, 0x777e347c0701000000b70900),
(152, 0x777e357c0701000000b80900),
(153, 0x787e337c0601000000680600),
(153, 0x777e347c0601000000b70900),
(153, 0x777e357c0601000000b80900),
(154, 0x767e327c0701000000660600),
(154, 0x747e347c0701000000bd0900),
(154, 0x747e357c0701000000bd0900),
(154, 0x757e347c0701000000be0900),
(154, 0x757e357c0701000000be0900),
(155, 0x767e327c0601000000660600),
(155, 0x747e347c0601000000bd0900),
(155, 0x747e357c0601000000bd0900),
(155, 0x757e347c0601000000be0900),
(155, 0x757e357c0601000000be0900),
(156, 0x6b7e227c0601000000b70900),
(156, 0x6b7e237c0601000000b80900),
(156, 0x697e257c0601000000680600),
(157, 0x657e227c0601000000b70900),
(157, 0x657e237c0601000000b80900),
(157, 0x677e257c0601000000680600),
(158, 0x677e277c0601000000680600),
(158, 0x657e297c0601000000b70900),
(158, 0x657e2a7c0601000000b80900),
(159, 0x697e277c0601000000680600),
(159, 0x6b7e297c0601000000b70900),
(159, 0x6b7e2a7c0601000000b80900),
(160, 0x5f7e337c0601000000b70900),
(160, 0x5f7e347c0601000000b80900),
(160, 0x607e337c0601000000b70900),
(160, 0x647e337c0601000000660600),
(160, 0x607e347c0601000000b80900),
(161, 0x5f7e307c0501000000bd0900),
(161, 0x5f7e337c0501000000b70900),
(161, 0x5f7e347c0501000000b80900),
(161, 0x607e307c0501000000be0900),
(161, 0x607e337c0501000000b70900),
(161, 0x647e307c0501000000660600),
(161, 0x607e347c0501000000b80900),
(162, 0x5e7e2a7c0701000000660600),
(162, 0x617e297c0701000000b70900);
INSERT INTO `tile_store` (`house_id`, `data`) VALUES
(162, 0x617e2a7c0701000000b80900),
(163, 0x5f7e277c0701000000660600),
(163, 0x617e247c0701000000b70900),
(163, 0x617e257c0701000000b80900),
(164, 0x5e7e237c0701000000680600),
(164, 0x617e217c0701000000b70900),
(164, 0x617e227c0701000000b80900),
(165, 0x587e217c0701000000b70900),
(165, 0x587e227c0701000000b80900),
(165, 0x5c7e237c0701000000680600),
(166, 0x587e247c0701000000b70900),
(166, 0x587e257c0701000000b80900),
(166, 0x5a7e277c0701000000660600),
(167, 0x587e297c0701000000b70900),
(167, 0x587e2a7c0701000000b80900),
(167, 0x5b7e2a7c0701000000660600),
(168, 0x5e7e287c0601000000680600),
(168, 0x617e297c0601000000b70900),
(168, 0x617e2a7c0601000000b80900),
(169, 0x5f7e277c0601000000660600),
(169, 0x617e247c0601000000b70900),
(169, 0x617e257c0601000000b80900),
(170, 0x5e7e237c0601000000680600),
(170, 0x617e217c0601000000b70900),
(170, 0x617e227c0601000000b80900),
(171, 0x587e217c0601000000b70900),
(171, 0x587e227c0601000000b80900),
(171, 0x5c7e237c0601000000680600),
(172, 0x587e247c0601000000b70900),
(172, 0x587e257c0601000000b80900),
(172, 0x5a7e277c0601000000660600),
(173, 0x587e297c0601000000b70900),
(173, 0x587e2a7c0601000000b80900),
(173, 0x5b7e287c0601000000680600),
(174, 0x3a7e307c0701000000680600),
(174, 0x3a7e367c0701000000bd0900),
(174, 0x3a7e377c0701000000bd0900),
(174, 0x3b7e367c0701000000be0900),
(174, 0x3b7e377c0701000000be0900),
(175, 0x327e327c0701000000b70900),
(175, 0x327e337c0701000000b80900),
(175, 0x337e327c0701000000b70900),
(175, 0x337e337c0701000000b80900),
(175, 0x367e307c0701000000680600),
(176, 0x2d7e307c0701000000680600),
(176, 0x267e357c0701000000b70900),
(176, 0x267e367c0701000000b80900),
(176, 0x297e377c0701000000660600),
(176, 0x2e7e387c0701000000680600),
(177, 0x3b7e257c0501000000660600),
(177, 0x3c7e297c0501000000b70900),
(177, 0x3c7e2a7c0501000000b80900),
(177, 0x3d7e297c0501000000b70900),
(177, 0x3d7e2a7c0501000000b80900),
(178, 0x387e277c0501000000b70900),
(178, 0x3a7e267c0501000000680600),
(178, 0x387e287c0501000000b80900),
(179, 0x347e277c0501000000b70900),
(179, 0x367e267c0501000000680600),
(179, 0x347e287c0501000000b80900),
(180, 0x367e367c0701000000b70900),
(180, 0x367e377c0701000000b80900),
(180, 0x377e367c0701000000b70900),
(180, 0x377e377c0701000000b80900),
(180, 0x337e387c0701000000680600),
(181, 0x327e367c0601000000b70900),
(181, 0x327e377c0601000000b80900),
(181, 0x337e367c0601000000b70900),
(181, 0x337e377c0601000000b80900),
(181, 0x367e367c0601000000660600),
(182, 0x327e327c0601000000b70900),
(182, 0x327e337c0601000000b80900),
(182, 0x337e327c0601000000b70900),
(182, 0x337e337c0601000000b80900),
(182, 0x367e337c0601000000660600),
(183, 0x387e337c0601000000660600),
(183, 0x3b7e317c0601000000b70900),
(183, 0x3b7e327c0601000000b80900),
(184, 0x387e367c0601000000660600),
(184, 0x3b7e357c0601000000b70900),
(184, 0x3b7e367c0601000000b80900),
(185, 0x447e387c0701000000b70900),
(185, 0x447e397c0701000000b80900),
(185, 0x447e3b7c0701000000680600),
(186, 0x477e3b7c0701000000680600),
(186, 0x487e387c0701000000b70900),
(186, 0x487e397c0701000000b80900),
(187, 0x437e3a7c0601000000660600),
(187, 0x477e3a7c0601000000b70900),
(187, 0x477e3b7c0601000000b80900),
(187, 0x487e3a7c0601000000b70900),
(187, 0x487e3b7c0601000000b80900),
(188, 0x447e3d7c0701000000680600),
(188, 0x437e407c0701000000bd0900),
(188, 0x447e407c0701000000be0900),
(189, 0x477e3d7c0701000000680600),
(189, 0x477e407c0701000000bd0900),
(189, 0x487e407c0701000000be0900),
(190, 0x437e3f7c0601000000660600),
(190, 0x477e3f7c0601000000b70900),
(190, 0x487e3f7c0601000000b70900),
(190, 0x477e407c0601000000b80900),
(190, 0x487e407c0601000000b80900),
(191, 0x3d7e4d7c0701000000680600),
(191, 0x3c7e507c0601000000b70900),
(191, 0x3c7e517c0601000000b80900),
(191, 0x3d7e507c0601000000b70900),
(191, 0x3d7e517c0601000000b80900),
(191, 0x3c7e507c0701000000b70900),
(191, 0x3c7e517c0701000000b80900),
(191, 0x3d7e507c0701000000b70900),
(191, 0x3d7e517c0701000000b80900),
(192, 0x4b7e4c7c0701000000680600),
(192, 0x487e507c0701000000b70900),
(192, 0x487e517c0701000000b80900),
(192, 0x497e507c0701000000b70900),
(192, 0x497e517c0701000000b80900),
(193, 0x247e4c7c0801000000bd0900),
(193, 0x247e4e7c0801000000bd0900),
(193, 0x257e4c7c0801000000be0900),
(193, 0x257e4e7c0801000000be0900),
(193, 0x287e4c7c0601000000b70900),
(193, 0x287e4d7c0601000000b80900),
(193, 0x2a7e4d7c0601000000660600),
(193, 0x287e4c7c0701000000b70900),
(193, 0x287e4d7c0701000000b80900),
(193, 0x2a7e4e7c0701000000660600),
(193, 0x287e4d7c0801000000660600),
(193, 0x2a7e4e7c0801000000680600),
(193, 0x2d7e4e7c0601000000680600),
(193, 0x2f7e4d7c0601000000660600),
(193, 0x2d7e4f7c0701000000680600),
(193, 0x2f7e4d7c0701000000660600),
(193, 0x337e4b7c0701000000680600),
(193, 0x327e4e7c0701000000680600),
(193, 0x247e507c0801000000bd0900),
(193, 0x247e527c0801000000bd0900),
(193, 0x257e507c0801000000be0900),
(193, 0x257e527c0801000000be0900),
(193, 0x2a7e517c0701000000660600),
(193, 0x2f7e507c0601000000660600),
(193, 0x2f7e537c0601000000660600),
(193, 0x327e507c0601000000bd0900),
(193, 0x327e527c0601000000bd0900),
(193, 0x337e507c0601000000be0900),
(193, 0x337e527c0601000000be0900),
(193, 0x307e527c0701000000b70900),
(193, 0x307e537c0701000000b80900),
(193, 0x317e527c0701000000b70900),
(193, 0x317e537c0701000000b80900),
(194, 0x607e137c0701000000b70900),
(194, 0x617e137c0701000000b70900),
(194, 0x607e147c0701000000b80900),
(194, 0x617e147c0701000000b80900),
(194, 0x637e177c0701000000660600),
(195, 0x607e137c0601000000b70900),
(195, 0x617e137c0601000000b70900),
(195, 0x607e147c0601000000b80900),
(195, 0x617e147c0601000000b80900),
(195, 0x637e177c0601000000660600),
(196, 0x657e167c0601000000680600),
(196, 0x677e147c0601000000b70900),
(196, 0x677e157c0601000000b80900),
(196, 0x687e147c0601000000b70900),
(196, 0x687e157c0601000000b80900),
(197, 0x707e167c0601000000680600),
(197, 0x717e147c0601000000b70900),
(197, 0x717e157c0601000000b80900),
(197, 0x727e147c0601000000b70900),
(197, 0x727e157c0601000000b80900),
(198, 0x737e197c0601000000660600),
(198, 0x767e197c0601000000b70900),
(198, 0x767e1a7c0601000000b80900),
(198, 0x777e197c0601000000b70900),
(198, 0x777e1a7c0601000000b80900),
(199, 0x7c7e1b7c0701000000680600),
(199, 0x7f7e197c0701000000b70900),
(199, 0x7f7e1a7c0701000000b80900),
(199, 0x807e197c0701000000b70900),
(199, 0x807e1a7c0701000000b80900),
(200, 0x877e1b7c0701000000b70900),
(200, 0x887e1b7c0701000000b70900),
(200, 0x857e1d7c0701000000680600),
(200, 0x877e1c7c0701000000b80900),
(200, 0x887e1c7c0701000000b80900),
(201, 0x6c7e337c0601000000680600),
(201, 0x6b7e367c0601000000240900),
(201, 0x6d7e377c0601000000660600),
(202, 0x6a7e507c0701000000680600),
(202, 0x677e567c0701000000bd0900),
(202, 0x687e567c0701000000be0900),
(202, 0x6b7e557c0701000000b70900),
(202, 0x6b7e567c0701000000b80900),
(202, 0x6c7e557c0701000000b70900),
(202, 0x6c7e567c0701000000b80900),
(203, 0x7b7e3b7c0701000000680600),
(203, 0x7b7e3e7c0701000000240900),
(203, 0x7c7e407c0701000000680600),
(204, 0x7f7e3b7c0701000000680600),
(204, 0x7f7e3e7c0701000000240900),
(204, 0x7f7e407c0701000000680600),
(205, 0x797e577c0601000000b70900),
(205, 0x797e587c0601000000b80900),
(205, 0x7a7e5b7c0601000000680600),
(206, 0x777e627c0601000000b70900),
(206, 0x777e637c0601000000b80900),
(206, 0x787e617c0601000000680600),
(207, 0x7d7e577c0601000000b70900),
(207, 0x7d7e587c0601000000b80900),
(207, 0x7e7e5b7c0601000000680600),
(208, 0x7b7e627c0601000000b70900),
(208, 0x7b7e637c0601000000b80900),
(208, 0x7c7e617c0601000000680600),
(209, 0x817e577c0601000000b70900),
(209, 0x817e587c0601000000b80900),
(209, 0x827e5b7c0601000000680600),
(210, 0x7f7e627c0601000000b70900),
(210, 0x7f7e637c0601000000b80900),
(210, 0x807e617c0601000000680600),
(211, 0x847e577c0601000000b70900),
(211, 0x847e587c0601000000b80900),
(211, 0x857e5b7c0601000000680600),
(212, 0x837e627c0601000000b70900),
(212, 0x837e637c0601000000b80900),
(212, 0x847e617c0601000000680600),
(213, 0x797e587c0501000000b70900),
(213, 0x797e597c0501000000b80900),
(213, 0x7a7e587c0501000000b70900),
(213, 0x7a7e597c0501000000b80900),
(213, 0x7d7e5a7c0501000000680600),
(214, 0x817e5a7c0501000000680600),
(214, 0x847e597c0501000000b70900),
(214, 0x847e5a7c0501000000b80900),
(214, 0x857e597c0501000000b70900),
(214, 0x857e5a7c0501000000b80900),
(215, 0x827e637c0501000000660600),
(215, 0x857e627c0501000000b70900),
(215, 0x857e637c0501000000b80900),
(216, 0x897e357c0701000000680600),
(216, 0x847e397c0701000000b70900),
(216, 0x847e3a7c0701000000b80900),
(216, 0x857e397c0701000000b70900),
(216, 0x857e3a7c0701000000b80900),
(217, 0x897e367c0601000000bd0900),
(217, 0x897e377c0601000000bd0900),
(217, 0x8a7e367c0601000000be0900),
(217, 0x8a7e377c0601000000be0900),
(217, 0x8b7e397c0601000000660600),
(218, 0x907e367c0701000000660600),
(218, 0x937e357c0701000000b70900),
(218, 0x937e367c0701000000b80900),
(218, 0x947e357c0701000000b70900),
(218, 0x947e367c0701000000b80900),
(218, 0x967e397c0701000000660600),
(219, 0x4e7e647c0801000000bd0900),
(219, 0x4e7e667c0801000000bd0900),
(219, 0x4f7e647c0801000000be0900),
(219, 0x4f7e667c0801000000be0900),
(219, 0x4e7e687c0801000000bd0900),
(219, 0x4e7e6a7c0801000000bd0900),
(219, 0x4f7e687c0801000000be0900),
(219, 0x4f7e6a7c0801000000be0900),
(219, 0x4e7e6c7c0801000000bd0900),
(219, 0x4e7e6e7c0801000000bd0900),
(219, 0x4f7e6c7c0801000000be0900),
(219, 0x4f7e6e7c0801000000be0900),
(219, 0x527e657c0801000000660600),
(219, 0x537e697c0601000000b70900),
(219, 0x537e6a7c0601000000b80900),
(219, 0x527e697c0801000000660600),
(219, 0x567e697c0401000000b70900),
(219, 0x567e6a7c0401000000b80900),
(219, 0x557e6b7c0501000000680600),
(219, 0x567e697c0501000000b70900),
(219, 0x567e6a7c0501000000b80900),
(219, 0x547e6b7c0601000000680600),
(219, 0x577e6a7c0601000000660600),
(219, 0x557e687c0701000000680600),
(219, 0x567e6a7c0701000000660600),
(219, 0x5a7e6b7c0701000000680600),
(219, 0x527e6d7c0801000000660600),
(219, 0x547e6e7c0501000000660600),
(219, 0x577e6e7c0601000000660600),
(219, 0x557e6c7c0701000000680600),
(219, 0x567e6e7c0701000000660600),
(219, 0x587e6c7c0801000000680600),
(220, 0x387e5d7c0601000000b70900),
(220, 0x387e5e7c0601000000b80900),
(220, 0x3a7e5d7c0601000000b70900),
(220, 0x3a7e5e7c0601000000b80900),
(220, 0x397e5f7c0701000000660600),
(220, 0x3d7e5d7c0601000000660600),
(220, 0x3d7e5f7c0601000000660600),
(220, 0x3f7e5d7c0601000000bd0900),
(220, 0x3f7e5f7c0601000000bd0900),
(220, 0x3a7e607c0601000000680600),
(220, 0x397e637c0701000000660600),
(220, 0x3b7e617c0701000000680600),
(220, 0x3d7e617c0601000000660600),
(220, 0x3d7e637c0601000000660600),
(220, 0x3f7e617c0601000000bd0900),
(220, 0x3f7e637c0601000000bd0900),
(220, 0x3f7e607c0701000000680600),
(220, 0x387e647c0601000000680600),
(220, 0x397e657c0601000000bd0900),
(220, 0x3a7e657c0601000000be0900),
(220, 0x3d7e657c0601000000660600),
(220, 0x3f7e657c0601000000bd0900),
(220, 0x407e5d7c0601000000be0900),
(220, 0x407e5f7c0601000000be0900),
(220, 0x407e617c0601000000be0900),
(220, 0x407e637c0601000000be0900),
(220, 0x407e657c0601000000be0900),
(221, 0xdc7e7c7b0701000000b70900),
(221, 0xdc7e7d7b0701000000b80900),
(221, 0xdd7e7c7b0701000000b70900),
(221, 0xdd7e7d7b0701000000b80900),
(221, 0xe17e7e7b0701000000660600),
(222, 0xdc7e777b0701000000b70900),
(222, 0xdd7e777b0701000000b70900),
(222, 0xdc7e787b0701000000b80900),
(222, 0xdd7e787b0701000000b80900),
(222, 0xe17e797b0701000000660600),
(223, 0xde7e797b0601000000680600),
(223, 0xdb7e7e7b0601000000b70900),
(223, 0xdb7e7f7b0601000000b80900),
(223, 0xdc7e7e7b0601000000b70900),
(223, 0xdc7e7f7b0601000000b80900),
(223, 0xe17e7b7b0601000000660600),
(224, 0xef7e6f7b0701000000b70900),
(224, 0xf17e6f7b0701000000b70900),
(224, 0xeb7e727b0701000000660600),
(224, 0xef7e707b0701000000b80900),
(224, 0xf17e707b0701000000b80900),
(225, 0x0a7f667b0501000000b70900),
(225, 0x0a7f677b0501000000b80900),
(225, 0x0a7f667b0701000000b70900),
(225, 0x0a7f677b0701000000b80900),
(225, 0x0e7f677b0501000000660600),
(225, 0x0d7f667b0701000000b70900),
(225, 0x0d7f677b0701000000b80900),
(225, 0x0d7f647b0801000000bd0900),
(225, 0x0d7f667b0801000000bd0900),
(225, 0x0e7f647b0801000000be0900),
(225, 0x0e7f667b0801000000be0900),
(225, 0x0c7f6a7b0701000000680600),
(225, 0x0d7f687b0801000000bd0900),
(225, 0x0d7f6a7b0801000000bd0900),
(225, 0x0e7f687b0801000000be0900),
(225, 0x0e7f6a7b0801000000be0900),
(225, 0x0f7f6b7b0801000000680600),
(225, 0x0a7f6f7b0501000000bd0900),
(225, 0x0b7f6f7b0501000000be0900),
(225, 0x0e7f6c7b0501000000660600),
(225, 0x0c7f6e7b0701000000680600),
(225, 0x0f7f6e7b0801000000680600),
(225, 0x117f677b0501000000660600),
(225, 0x107f647b0801000000bd0900),
(225, 0x107f667b0801000000bd0900),
(225, 0x117f647b0801000000be0900),
(225, 0x117f667b0801000000be0900),
(225, 0x157f667b0501000000b70900),
(225, 0x157f677b0501000000b80900),
(225, 0x107f687b0801000000bd0900),
(225, 0x107f6a7b0801000000bd0900),
(225, 0x117f687b0801000000be0900),
(225, 0x117f6a7b0801000000be0900),
(225, 0x147f6b7b0801000000680600),
(225, 0x117f6c7b0501000000660600),
(225, 0x127f6f7b0701000000680600),
(225, 0x137f6e7b0801000000680600),
(225, 0x157f6c7b0501000000b70900),
(225, 0x157f6d7b0501000000b80900),
(225, 0x0a7f727b0501000000bd0900),
(225, 0x0b7f727b0501000000be0900),
(225, 0x097f707b0701000000660600),
(225, 0x097f717b0701000000660600),
(225, 0x0e7f717b0501000000660600),
(225, 0x0e7f717b0601000000660600),
(225, 0x0e7f717b0701000000660600),
(225, 0x0f7f717b0801000000bd0900),
(225, 0x117f717b0501000000660600),
(225, 0x107f717b0801000000be0900),
(225, 0x147f717b0501000000b70900),
(225, 0x147f727b0501000000b80900),
(225, 0x157f717b0501000000b70900),
(225, 0x157f727b0501000000b80900),
(225, 0x147f717b0801000000bd0900),
(225, 0x157f717b0801000000be0900),
(226, 0xf87e6f7b0701000000bd0900),
(226, 0xf97e6f7b0701000000be0900),
(226, 0xf87e707b0701000000bd0900),
(226, 0xf97e707b0701000000be0900),
(226, 0xf77e747b0701000000680600),
(227, 0xf67e777b0701000000680600),
(227, 0xf77e7c7b0701000000bd0900),
(227, 0xf77e7d7b0701000000bd0900),
(227, 0xf87e7c7b0701000000be0900),
(227, 0xf87e7d7b0701000000be0900),
(228, 0xcf7e777b0701000000b70900),
(228, 0xcf7e767b0801000000bd0900),
(228, 0xcf7e787b0701000000b80900),
(228, 0xcf7e7a7b0701000000bd0900),
(228, 0xcf7e787b0801000000bd0900),
(228, 0xcf7e7a7b0801000000bd0900),
(228, 0xcf7e7c7b0801000000bd0900),
(228, 0xd07e777b0701000000b70900),
(228, 0xd07e767b0801000000be0900),
(228, 0xd57e767b0601000000b70900),
(228, 0xd57e777b0601000000b80900),
(228, 0xd87e767b0801000000b70900),
(228, 0xd87e777b0801000000b80900),
(228, 0xda7e767b0801000000b70900),
(228, 0xda7e777b0801000000b80900),
(228, 0xd07e787b0701000000b80900),
(228, 0xd07e7a7b0701000000be0900),
(228, 0xd27e787b0701000000660600),
(228, 0xd07e787b0801000000be0900),
(228, 0xd07e7a7b0801000000be0900),
(228, 0xd27e7b7b0801000000660600),
(228, 0xd47e7b7b0601000000660600),
(228, 0xd67e797b0601000000680600),
(228, 0xd47e7a7b0701000000680600),
(228, 0xd47e797b0801000000680600),
(228, 0xd77e7b7b0801000000660600),
(228, 0xd97e797b0801000000680600),
(228, 0xd27e7c7b0701000000660600),
(228, 0xd07e7c7b0801000000be0900),
(228, 0xd47e7d7b0701000000680600),
(229, 0x9e7daa7b0701000000b70900),
(229, 0x9e7dab7b0701000000b80900),
(229, 0xa07dae7b0701000000680600),
(230, 0x997dac7b0601000000b70900),
(230, 0x997dad7b0601000000b80900),
(230, 0x9a7dac7b0601000000b70900),
(230, 0x9a7dad7b0601000000b80900),
(230, 0x9d7dad7b0601000000660600),
(230, 0xa27dac7b0601000000660600),
(231, 0xa17db17b0701000000680600),
(231, 0xa27db47b0701000000b70900),
(231, 0xa27db57b0701000000b80900),
(232, 0x997daa7b0701000000b70900),
(232, 0x997dab7b0701000000b80900),
(232, 0x997dac7b0701000000b70900),
(232, 0x997dad7b0701000000b80900),
(232, 0x9b7dae7b0701000000680600),
(233, 0x9c7db17b0701000000680600),
(233, 0x9a7db47b0701000000b70900),
(233, 0x9a7db57b0701000000b80900),
(234, 0x917da77b0701000000b70900),
(234, 0x947da77b0701000000b70900),
(234, 0x917da87b0701000000b80900),
(234, 0x947da87b0701000000b80900),
(234, 0x957daa7b0701000000660600),
(235, 0x987da77b0701000000660600),
(235, 0x997da57b0701000000bd0900),
(235, 0x9a7da57b0701000000be0900),
(236, 0x997da57b0601000000b70900),
(236, 0x997da67b0601000000b80900),
(236, 0x9d7da67b0601000000660600),
(237, 0x7f7dac7b0601000000b70900),
(237, 0x7f7dad7b0601000000b80900),
(237, 0x837dab7b0601000000660600),
(237, 0x807dac7b0601000000b70900),
(237, 0x807dad7b0601000000b80900),
(238, 0x887db17b0701000000680600),
(238, 0x867db57b0601000000bd0900),
(238, 0x877db57b0601000000be0900),
(238, 0x887db57b0601000000bd0900),
(238, 0x897db57b0601000000be0900),
(239, 0x847db77b0701000000680600),
(239, 0x817dbb7b0801000000b70900),
(239, 0x827dbb7b0801000000b70900),
(239, 0x887dba7b0801000000680600),
(239, 0x817dbc7b0801000000b80900),
(239, 0x827dbc7b0801000000b80900),
(239, 0x857dbc7b0801000000660600),
(240, 0x917dba7b0701000000660600),
(240, 0x947dbb7b0701000000bd0900),
(240, 0x957dbb7b0701000000be0900),
(241, 0x867dbd7b0701000000b70900),
(241, 0x867dbe7b0701000000b80900),
(241, 0x897dbd7b0701000000b70900),
(241, 0x897dbe7b0701000000b80900),
(241, 0x8d7dbc7b0701000000680600),
(241, 0x8a7dc07b0701000000660600),
(242, 0xad7dab7b0601000000660600),
(242, 0xad7daa7b0801000000b70900),
(242, 0xad7dab7b0801000000b80900),
(242, 0xaf7daa7b0801000000b70900),
(242, 0xaf7dab7b0801000000b80900),
(242, 0xab7dae7b0701000000680600),
(242, 0xab7daf7b0801000000680600),
(242, 0xac7dac7b0601000000680600),
(242, 0xac7dac7b0701000000660600),
(242, 0xae7dad7b0701000000680600),
(242, 0xac7dac7b0801000000660600),
(242, 0xaf7daf7b0801000000680600),
(242, 0xb17daa7b0601000000b70900),
(242, 0xb17dab7b0601000000b80900),
(242, 0xb37daa7b0601000000b70900),
(242, 0xb37dab7b0601000000b80900),
(242, 0xb27daa7b0701000000bd0900),
(242, 0xb27dab7b0701000000bd0900),
(242, 0xb37daa7b0701000000be0900),
(242, 0xb37dab7b0701000000be0900),
(242, 0xb17daa7b0801000000b70900),
(242, 0xb17dab7b0801000000b80900),
(242, 0xb37daa7b0801000000b70900),
(242, 0xb37dab7b0801000000b80900),
(242, 0xb07dae7b0601000000660600),
(242, 0xb27dad7b0701000000680600),
(242, 0xb07dae7b0801000000660600),
(242, 0xa97db07b0701000000660600),
(242, 0xac7db07b0701000000660600),
(242, 0xb07db17b0601000000660600),
(242, 0xb37db17b0601000000b70900),
(242, 0xb37db27b0601000000b80900),
(242, 0xb17db17b0801000000660600),
(242, 0xb37db17b0801000000b70900),
(242, 0xb37db27b0801000000b80900),
(243, 0x827f167d0801000000bd0900),
(243, 0x837f167d0801000000be0900),
(243, 0x837f1a7d0701000000680600),
(243, 0x827f187d0801000000bd0900),
(243, 0x827f197d0801000000bd0900),
(243, 0x827f1b7d0801000000bd0900),
(243, 0x837f187d0801000000be0900),
(243, 0x837f197d0801000000be0900),
(243, 0x837f1b7d0801000000be0900),
(243, 0x847f1a7d0701000000680600),
(243, 0x867f1b7d0801000000660600),
(243, 0x887f197d0801000000680600),
(243, 0x827f1d7d0401000000bd0900),
(243, 0x837f1d7d0401000000be0900),
(243, 0x827f1f7d0601000000b70900),
(243, 0x867f1d7d0301000000680600),
(243, 0x867f1c7d0401000000660600),
(243, 0x847f1e7d0501000000680600),
(243, 0x867f1c7d0501000000660600),
(243, 0x847f1f7d0601000000b70900),
(243, 0x857f1f7d0601000000b70900),
(243, 0x877f1d7d0601000000660600),
(243, 0x877f1f7d0601000000b70900),
(243, 0x847f1d7d0701000000680600),
(243, 0x867f1c7d0701000000660600),
(243, 0x867f1f7d0701000000660600),
(243, 0x897f1e7d0501000000680600),
(243, 0x887f1f7d0601000000b70900),
(243, 0x897f1e7d0601000000680600),
(243, 0x8a7f1f7d0601000000b70900),
(243, 0x897f1d7d0701000000680600),
(243, 0x827f227d0401000000b70900),
(243, 0x827f237d0401000000b80900),
(243, 0x827f207d0601000000b80900),
(243, 0x827f227d0601000000b70900),
(243, 0x827f237d0601000000b80900),
(243, 0x827f227d0701000000b70900),
(243, 0x827f237d0701000000b80900),
(243, 0x847f207d0401000000680600),
(243, 0x847f207d0601000000b80900),
(243, 0x847f227d0601000000b70900),
(243, 0x847f237d0601000000b80900),
(243, 0x857f207d0601000000b80900),
(243, 0x857f227d0601000000b70900),
(243, 0x857f237d0601000000b80900),
(243, 0x877f207d0601000000b80900),
(243, 0x877f227d0601000000b70900),
(243, 0x877f237d0601000000b80900),
(243, 0x847f217d0701000000680600),
(243, 0x857f227d0701000000b70900),
(243, 0x857f237d0701000000b80900),
(243, 0x877f227d0701000000b70900),
(243, 0x877f237d0701000000b80900),
(243, 0x887f207d0401000000680600),
(243, 0x8a7f227d0401000000b70900),
(243, 0x8a7f237d0401000000b80900),
(243, 0x887f207d0601000000b80900),
(243, 0x887f227d0601000000b70900),
(243, 0x887f237d0601000000b80900),
(243, 0x8a7f207d0601000000b80900),
(243, 0x8a7f227d0601000000b70900),
(243, 0x8a7f237d0601000000b80900),
(243, 0x897f217d0701000000680600),
(243, 0x8a7f227d0701000000b70900),
(243, 0x8a7f237d0701000000b80900),
(244, 0x407f477c0a01000000bb0900),
(244, 0x427f477c0a01000000bb0900),
(244, 0x437f477c0a01000000bb0900),
(244, 0x457f477c0a01000000bb0900),
(244, 0x467f477c0a01000000bb0900),
(244, 0x487f477c0a01000000bb0900),
(244, 0x497f477c0a01000000bb0900),
(244, 0x4b7f477c0a01000000bb0900),
(244, 0x407f487c0a01000000bc0900),
(244, 0x407f4b7c0a01000000bb0900),
(244, 0x417f4b7c0a01000000bb0900),
(244, 0x427f487c0a01000000bc0900),
(244, 0x437f487c0a01000000bc0900),
(244, 0x457f487c0a01000000bc0900),
(244, 0x467f487c0a01000000bc0900),
(244, 0x487f487c0a01000000bc0900),
(244, 0x497f487c0a01000000bc0900),
(244, 0x4a7f4b7c0a01000000bb0900),
(244, 0x4b7f487c0a01000000bc0900),
(244, 0x4b7f4b7c0a01000000bb0900),
(244, 0x407f4c7c0a01000000bc0900),
(244, 0x417f4c7c0a01000000bc0900),
(244, 0x427f4f7c0a01000000660600),
(244, 0x467f4d7c0a01000000680600),
(244, 0x4a7f4d7c0901000000680600),
(244, 0x4a7f4c7c0a01000000bc0900),
(244, 0x4b7f4c7c0a01000000bc0900),
(244, 0x407f537c0a01000000b90900),
(244, 0x417f537c0a01000000ba0900),
(244, 0x437f507c0a01000000680600),
(244, 0x457f537c0a01000000b90900),
(244, 0x467f507c0a01000000680600),
(244, 0x467f537c0a01000000ba0900),
(244, 0x487f527c0901000000660600),
(244, 0x497f537c0a01000000b90900),
(244, 0x4a7f507c0a01000000680600),
(244, 0x4a7f537c0a01000000ba0900),
(244, 0x507f527c0901000000660600),
(245, 0xf37f837d0801000000660600),
(245, 0xfa7f827d0501000000bd0900),
(245, 0xfb7f827d0501000000be0900),
(245, 0xf87f837d0701000000660600),
(245, 0xf97f817d0701000000680600),
(245, 0xfa7f817d0701000000680600),
(245, 0xfb7f837d0701000000660600),
(245, 0xfc7f827d0401000000b70900),
(245, 0xfc7f837d0401000000b80900),
(245, 0xfe7f827d0401000000b70900),
(245, 0xfe7f837d0401000000b80900),
(245, 0xfd7f827d0501000000bd0900),
(245, 0xfe7f827d0501000000be0900),
(245, 0xf67f867d0401000000680600),
(245, 0xf77f847d0401000000660600),
(245, 0xf77f867d0501000000680600),
(245, 0xf67f857d0601000000680600),
(245, 0xf77f857d0701000000680600),
(245, 0xf77f877d0701000000680600),
(245, 0xf57f847d0801000000680600),
(245, 0xfb7f847d0401000000660600),
(245, 0xfb7f877d0401000000660600),
(245, 0xf97f847d0501000000660600),
(245, 0xfa7f857d0501000000bd0900),
(245, 0xfa7f877d0501000000bd0900),
(245, 0xfb7f857d0501000000be0900),
(245, 0xfb7f877d0501000000be0900),
(245, 0xf87f847d0601000000660600),
(245, 0xfa7f847d0701000000680600),
(245, 0xfa7f877d0701000000680600),
(245, 0xfd7f857d0501000000bd0900),
(245, 0xfd7f877d0501000000bd0900),
(245, 0xfe7f857d0501000000be0900),
(245, 0xfe7f877d0501000000be0900),
(245, 0xfd7f857d0601000000680600),
(245, 0xfd7f857d0701000000680600),
(245, 0xfd7f877d0701000000680600),
(245, 0xf67f887d0401000000680600),
(245, 0xf67f8b7d0401000000bd0900),
(245, 0xf77f8b7d0401000000be0900),
(245, 0xf57f8a7d0701000000b70900),
(245, 0xf57f8b7d0701000000b80900),
(245, 0xf77f8a7d0701000000b70900),
(245, 0xf77f8b7d0701000000b80900),
(245, 0xf97f8b7d0401000000bd0900),
(245, 0xfa7f887d0401000000680600),
(245, 0xfa7f8b7d0401000000be0900),
(245, 0xfa7f897d0501000000bd0900),
(245, 0xfa7f8b7d0501000000bd0900),
(245, 0xfb7f897d0501000000be0900),
(245, 0xfb7f8b7d0501000000be0900),
(245, 0xf97f8a7d0701000000b70900),
(245, 0xf97f8b7d0701000000b80900),
(245, 0xfd7f8a7d0401000000bd0900),
(245, 0xfd7f8b7d0401000000bd0900),
(245, 0xfe7f8a7d0401000000be0900),
(245, 0xfe7f8b7d0401000000be0900),
(245, 0xfd7f897d0501000000bd0900),
(245, 0xfd7f8b7d0501000000bd0900),
(245, 0xfe7f897d0501000000be0900),
(245, 0xfe7f8b7d0501000000be0900),
(246, 0x6a7fb37c0201000000b90900),
(246, 0x6b7fb37c0201000000ba0900),
(246, 0x6a7fb57c0201000000bb0900),
(246, 0x6a7fb67c0201000000bc0900),
(246, 0x6b7fb57c0201000000bb0900),
(246, 0x6b7fb67c0201000000bc0900),
(246, 0x737fb27c0201000000680600),
(246, 0x707fb57c0201000000660600),
(247, 0x827fae7c0201000000660600),
(247, 0x867fac7c0201000000b90900),
(247, 0x867fad7c0201000000b90900),
(247, 0x877fac7c0201000000ba0900),
(247, 0x877fad7c0201000000ba0900),
(248, 0x867fa47c0201000000660600),
(248, 0x8a7fa67c0201000000b90900),
(248, 0x8a7fa77c0201000000b90900),
(248, 0x8b7fa67c0201000000ba0900),
(248, 0x8b7fa77c0201000000ba0900),
(249, 0x897f9b7c0201000000660600),
(249, 0x8d7f9d7c0201000000b90900),
(249, 0x8d7f9e7c0201000000b90900),
(249, 0x8e7f9d7c0201000000ba0900),
(249, 0x8e7f9e7c0201000000ba0900),
(250, 0x8b7f927c0201000000660600),
(250, 0x8f7f947c0201000000b90900),
(250, 0x8f7f957c0201000000b90900),
(250, 0x907f947c0201000000ba0900),
(250, 0x907f957c0201000000ba0900),
(251, 0x767f907c0701000000660600),
(251, 0x7a7f907c0701000000b90900),
(251, 0x7a7f917c0701000000b90900),
(251, 0x7b7f907c0701000000ba0900),
(251, 0x7b7f917c0701000000ba0900),
(252, 0x4c7fb17c0401000000bb0900),
(252, 0x4c7fb27c0401000000bc0900),
(252, 0x4c7fb57c0401000000bb0900),
(252, 0x4c7fb67c0401000000bc0900),
(252, 0x4d7fb57c0401000000bb0900),
(252, 0x4d7fb67c0401000000bc0900),
(252, 0x527fb47c0401000000660600),
(253, 0x537fac7c0401000000bb0900),
(253, 0x537fad7c0401000000bc0900),
(253, 0x597faf7c0401000000660600),
(253, 0x537fb07c0401000000bb0900),
(253, 0x537fb17c0401000000bc0900),
(253, 0x547fb07c0401000000bb0900),
(253, 0x547fb17c0401000000bc0900),
(254, 0x537fa57c0401000000bb0900),
(254, 0x537fa67c0401000000bc0900),
(254, 0x537fa97c0401000000bb0900),
(254, 0x537faa7c0401000000bc0900),
(254, 0x547fa97c0401000000bb0900),
(254, 0x547faa7c0401000000bc0900),
(254, 0x597fa87c0401000000660600),
(255, 0x5f7fb27c0401000000680600),
(255, 0x617fb57c0401000000bb0900),
(255, 0x617fb67c0401000000bc0900),
(256, 0x647fb27c0401000000680600),
(256, 0x667fb57c0401000000bb0900),
(256, 0x667fb67c0401000000bc0900),
(257, 0x657fac7c0401000000b90900),
(257, 0x667fac7c0401000000ba0900),
(257, 0x647fb07c0401000000680600),
(258, 0x5f7fab7c0401000000680600),
(258, 0x617fae7c0401000000bb0900),
(258, 0x617faf7c0401000000bc0900),
(259, 0x5f7fa97c0401000000680600),
(259, 0x607fa57c0401000000b90900),
(259, 0x617fa57c0401000000ba0900),
(260, 0x657fa57c0401000000b90900),
(260, 0x667fa57c0401000000ba0900),
(260, 0x647fa97c0401000000680600),
(261, 0x597fb27c0501000000bb0900),
(261, 0x597fb37c0501000000bc0900),
(261, 0x5c7fb37c0501000000660600),
(262, 0x597faf7c0501000000bb0900),
(262, 0x597fb07c0501000000bc0900),
(262, 0x5c7fb07c0501000000660600),
(263, 0x597fac7c0501000000bb0900),
(263, 0x597fad7c0501000000bc0900),
(263, 0x5c7fad7c0501000000660600),
(264, 0x597fa97c0501000000bb0900),
(264, 0x597faa7c0501000000bc0900),
(264, 0x5c7faa7c0501000000660600),
(265, 0x5e7faa7c0501000000660600),
(265, 0x617fa97c0501000000bb0900),
(265, 0x617faa7c0501000000bc0900),
(266, 0x5e7fad7c0501000000660600),
(266, 0x617fac7c0501000000bb0900),
(266, 0x617fad7c0501000000bc0900),
(267, 0x617faf7c0501000000bb0900),
(267, 0x5e7fb07c0501000000660600),
(267, 0x617fb07c0501000000bc0900),
(268, 0x637fb27c0501000000bb0900),
(268, 0x637fb37c0501000000bc0900),
(268, 0x667fb37c0501000000660600),
(269, 0x637faf7c0501000000bb0900),
(269, 0x637fb07c0501000000bc0900),
(269, 0x667fb07c0501000000660600),
(270, 0x637fac7c0501000000bb0900),
(270, 0x637fad7c0501000000bc0900),
(270, 0x667fad7c0501000000660600),
(271, 0x637fa97c0501000000bb0900),
(271, 0x637faa7c0501000000bc0900),
(271, 0x667faa7c0501000000660600),
(272, 0x687faa7c0501000000660600),
(272, 0x6b7fa97c0501000000bb0900),
(272, 0x6b7faa7c0501000000bc0900),
(273, 0x687fb37c0501000000660600),
(273, 0x6a7fb17c0501000000b90900),
(273, 0x6b7fb17c0501000000ba0900),
(273, 0x6a7fb57c0501000000b90900),
(273, 0x6b7fb57c0501000000ba0900),
(274, 0x777fb37c0801000000680600),
(274, 0x777fb57c0801000000240900),
(275, 0x777fbb7c0801000000240900),
(275, 0x797fba7c0801000000660600),
(276, 0x7c7fb67c0801000000660600),
(276, 0x7f7fb67c0801000000220900),
(277, 0x7c7fbd7c0801000000660600),
(277, 0x7f7fbd7c0801000000220900),
(278, 0x6c7fa27c0901000000bb0900),
(278, 0x6c7fa37c0901000000bc0900),
(278, 0x6f7fa27c0901000000660600),
(279, 0x727fa27c0901000000660600),
(279, 0x757fa27c0901000000bb0900),
(279, 0x757fa37c0901000000bc0900),
(280, 0x6c7fa77c0901000000bb0900),
(280, 0x6f7fa77c0901000000660600),
(280, 0x6c7fa87c0901000000bc0900),
(281, 0x727fa77c0901000000660600),
(281, 0x757fa77c0901000000bb0900),
(281, 0x757fa87c0901000000bc0900),
(282, 0x6c7fac7c0901000000bb0900),
(282, 0x6c7fad7c0901000000bc0900),
(282, 0x6f7fac7c0901000000660600),
(283, 0x727fac7c0901000000660600),
(283, 0x757fac7c0901000000bb0900),
(283, 0x757fad7c0901000000bc0900),
(284, 0x6c7fb17c0901000000bb0900),
(284, 0x6c7fb27c0901000000bc0900),
(284, 0x6f7fb17c0901000000660600),
(285, 0x727fb17c0901000000660600),
(285, 0x757fb17c0901000000bb0900),
(285, 0x757fb27c0901000000bc0900),
(286, 0x6c7fb67c0901000000bb0900),
(286, 0x6c7fb77c0901000000bc0900),
(286, 0x6f7fb67c0901000000660600),
(287, 0x727fb67c0901000000660600),
(287, 0x757fb67c0901000000bb0900),
(287, 0x757fb77c0901000000bc0900),
(288, 0x6c7fbb7c0901000000bb0900),
(288, 0x6f7fbb7c0901000000660600),
(288, 0x6c7fbc7c0901000000bc0900),
(289, 0x727fbb7c0901000000660600),
(289, 0x757fbb7c0901000000bb0900),
(289, 0x757fbc7c0901000000bc0900),
(290, 0x7e7fbb7c0901000000660600),
(290, 0x817fbb7c0901000000bb0900),
(290, 0x817fbc7c0901000000bc0900),
(291, 0x787fbb7c0901000000bb0900),
(291, 0x7b7fbb7c0901000000660600),
(291, 0x787fbc7c0901000000bc0900),
(292, 0x7e7fb67c0901000000660600),
(292, 0x817fb67c0901000000bb0900),
(292, 0x817fb77c0901000000bc0900),
(293, 0x787fb67c0901000000bb0900),
(293, 0x787fb77c0901000000bc0900),
(293, 0x7b7fb67c0901000000660600),
(294, 0x7e7fb17c0901000000660600),
(294, 0x817fb17c0901000000bb0900),
(294, 0x817fb27c0901000000bc0900),
(295, 0x787fb17c0901000000bb0900),
(295, 0x787fb27c0901000000bc0900),
(295, 0x7b7fb17c0901000000660600),
(296, 0x7e7fac7c0901000000660600),
(296, 0x817fac7c0901000000bb0900),
(296, 0x817fad7c0901000000bc0900),
(297, 0x787fac7c0901000000bb0900),
(297, 0x787fad7c0901000000bc0900),
(297, 0x7b7fac7c0901000000660600),
(298, 0x7e7fa77c0901000000660600),
(298, 0x817fa77c0901000000bb0900),
(298, 0x817fa87c0901000000bc0900),
(299, 0x787fa77c0901000000bb0900),
(299, 0x7b7fa77c0901000000660600),
(299, 0x787fa87c0901000000bc0900),
(300, 0x7e7fa27c0901000000660600),
(300, 0x817fa27c0901000000bb0900),
(300, 0x817fa37c0901000000bc0900),
(301, 0x787fa27c0901000000bb0900),
(301, 0x787fa37c0901000000bc0900),
(301, 0x7b7fa27c0901000000660600),
(302, 0x5a7f9e7c0b01000000bb0900),
(302, 0x5a7f9f7c0b01000000bc0900),
(302, 0x5f7f9e7c0b01000000b90900),
(302, 0x5f7f9f7c0b01000000b90900),
(302, 0x607f9e7c0b01000000ba0900),
(302, 0x607f9f7c0b01000000ba0900),
(302, 0x5e7fa37c0b01000000680600),
(303, 0x5e7fa67c0b01000000680600),
(303, 0x5a7faa7c0b01000000bb0900),
(303, 0x5a7fab7c0b01000000bc0900),
(303, 0x5f7faa7c0b01000000b90900),
(303, 0x5f7fab7c0b01000000b90900),
(303, 0x607faa7c0b01000000ba0900),
(303, 0x607fab7c0b01000000ba0900),
(304, 0x5e7f9f7c0c01000000b90900),
(304, 0x5f7f9f7c0c01000000ba0900),
(304, 0x5b7fa37c0b01000000680600),
(304, 0x5e7fa27c0c01000000bb0900),
(304, 0x5e7fa37c0c01000000bc0900),
(304, 0x5f7fa27c0c01000000bb0900),
(304, 0x5f7fa37c0c01000000bc0900),
(305, 0x5a7fa67c0b01000000680600),
(305, 0x5e7fa67c0c01000000b90900),
(305, 0x5f7fa67c0c01000000ba0900),
(305, 0x5e7fa97c0c01000000bb0900),
(305, 0x5e7faa7c0c01000000bc0900),
(305, 0x5f7fa97c0c01000000bb0900),
(305, 0x5f7faa7c0c01000000bc0900),
(306, 0x4c7fa27c0b01000000bb0900),
(306, 0x4c7fa37c0b01000000bc0900),
(306, 0x4d7fa27c0b01000000bb0900),
(306, 0x4d7fa37c0b01000000bc0900),
(306, 0x517fa17c0b01000000660600),
(307, 0x4c7fa77c0b01000000bb0900),
(307, 0x4d7fa77c0b01000000bb0900),
(307, 0x4c7fa87c0b01000000bc0900),
(307, 0x4d7fa87c0b01000000bc0900),
(307, 0x517fa67c0b01000000660600),
(308, 0x4c7fa27c0c01000000bb0900),
(308, 0x4c7fa37c0c01000000bc0900),
(308, 0x4d7fa27c0c01000000bb0900),
(308, 0x4d7fa37c0c01000000bc0900),
(308, 0x517fa37c0c01000000660600),
(309, 0x4c7fa77c0c01000000bb0900),
(309, 0x4d7fa77c0c01000000bb0900),
(309, 0x4c7fa87c0c01000000bc0900),
(309, 0x4d7fa87c0c01000000bc0900),
(309, 0x517fa77c0c01000000660600),
(310, 0x5b7fb77c0b01000000bb0900),
(310, 0x5d7fb57c0b01000000680600),
(310, 0x5b7fb87c0b01000000bc0900),
(310, 0x5e7fb87c0b01000000b90900),
(310, 0x5f7fb87c0b01000000ba0900),
(311, 0x5b7fb07c0b01000000bb0900),
(311, 0x5b7fb17c0b01000000bc0900),
(311, 0x5e7fb07c0b01000000b90900),
(311, 0x5e7fb37c0b01000000680600),
(311, 0x5f7fb07c0b01000000ba0900),
(312, 0x5b7fb17c0c01000000bb0900),
(312, 0x5b7fb27c0c01000000bc0900),
(312, 0x5c7fb17c0c01000000bb0900),
(312, 0x5c7fb27c0c01000000bc0900),
(312, 0x5f7fb37c0c01000000680600),
(313, 0x5b7fb57c0c01000000680600),
(313, 0x5e7fb77c0c01000000bb0900),
(313, 0x5f7fb77c0c01000000bb0900),
(313, 0x5e7fb87c0c01000000bc0900),
(313, 0x5f7fb87c0c01000000bc0900),
(314, 0x6e7fd37c0901000000680600),
(314, 0x667fd77c0801000000b90900),
(314, 0x677fd77c0801000000ba0900),
(314, 0x657fd67c0901000000680600),
(314, 0x667fd47c0901000000bb0900),
(314, 0x667fd57c0901000000bc0900),
(314, 0x647fd47c0a01000000b90900),
(314, 0x647fd57c0a01000000b90900),
(314, 0x657fd47c0a01000000ba0900),
(314, 0x657fd57c0a01000000ba0900),
(314, 0x667fd77c0a01000000660600),
(314, 0x677fd47c0a01000000bb0900),
(314, 0x677fd57c0a01000000bc0900),
(314, 0x687fd47c0801000000660600),
(314, 0x697fd67c0801000000680600),
(314, 0x687fd47c0901000000bb0900),
(314, 0x687fd57c0901000000bc0900),
(314, 0x6a7fd67c0901000000680600),
(314, 0x6b7fd47c0901000000bb0900),
(314, 0x6b7fd57c0901000000bc0900),
(314, 0x697fd67c0a01000000680600),
(314, 0x6a7fd47c0a01000000bb0900),
(314, 0x6a7fd57c0a01000000bc0900),
(314, 0x6c7fd67c0801000000680600),
(314, 0x6d7fd77c0801000000b90900),
(314, 0x6e7fd77c0801000000ba0900),
(314, 0x6f7fd47c0801000000660600),
(314, 0x6d7fd67c0a01000000680600),
(314, 0x6f7fd47c0a01000000bb0900),
(314, 0x6f7fd57c0a01000000bc0900),
(314, 0x637fd87c0901000000660600),
(314, 0x637fdb7c0901000000660600),
(314, 0x667fd97c0801000000b90900),
(314, 0x667fda7c0801000000b90900),
(314, 0x677fd97c0801000000ba0900),
(314, 0x677fda7c0801000000ba0900),
(314, 0x657fd97c0901000000680600),
(314, 0x677fdb7c0901000000660600),
(314, 0x667fda7c0a01000000660600),
(314, 0x697fd87c0a01000000680600),
(314, 0x6d7fd97c0801000000b90900),
(314, 0x6d7fda7c0801000000b90900),
(314, 0x6e7fd97c0801000000ba0900),
(314, 0x6e7fda7c0801000000ba0900),
(314, 0x6e7fd97c0901000000680600),
(314, 0x6d7fdb7c0a01000000bb0900),
(314, 0x6e7fd97c0a01000000680600),
(314, 0x667fdc7c0801000000b90900),
(314, 0x677fdc7c0801000000ba0900),
(314, 0x6d7fdc7c0801000000b90900),
(314, 0x6e7fdc7c0801000000ba0900),
(314, 0x6d7fdc7c0a01000000bc0900),
(315, 0x517f8d7c0b01000000bb0900),
(315, 0x517f8e7c0b01000000bc0900),
(315, 0x537f8d7c0b01000000bb0900),
(315, 0x537f8e7c0b01000000bc0900),
(315, 0x557f8d7c0b01000000bb0900),
(315, 0x557f8e7c0b01000000bc0900),
(315, 0x577f8d7c0b01000000bb0900),
(315, 0x577f8e7c0b01000000bc0900),
(315, 0x4e7f907c0a01000000bb0900),
(315, 0x4e7f917c0a01000000bc0900),
(315, 0x4e7f987c0a01000000bb0900),
(315, 0x4e7f997c0a01000000bc0900),
(315, 0x4f7f987c0a01000000bb0900),
(315, 0x4f7f997c0a01000000bc0900),
(315, 0x527f907c0a01000000bb0900),
(315, 0x527f917c0a01000000bc0900),
(315, 0x527f937c0a01000000680600),
(315, 0x517f907c0b01000000bb0900),
(315, 0x517f917c0b01000000bc0900),
(315, 0x517f937c0b01000000bb0900),
(315, 0x537f907c0b01000000bb0900),
(315, 0x537f917c0b01000000bc0900),
(315, 0x537f937c0b01000000bb0900),
(315, 0x557f917c0901000000660600),
(315, 0x547f907c0a01000000b90900),
(315, 0x557f907c0a01000000ba0900),
(315, 0x557f937c0a01000000680600),
(315, 0x587f937c0901000000680600),
(315, 0x587f907c0a01000000b90900),
(315, 0x597f907c0a01000000ba0900),
(315, 0x597f937c0a01000000680600),
(315, 0x5c7f937c0901000000680600),
(315, 0x5c7f907c0a01000000b90900),
(315, 0x5d7f907c0a01000000ba0900),
(315, 0x5d7f937c0a01000000680600),
(315, 0x517f957c0a01000000660600),
(315, 0x527f967c0a01000000680600),
(315, 0x517f947c0b01000000bc0900),
(315, 0x537f947c0b01000000bc0900),
(315, 0x557f957c0901000000660600),
(315, 0x557f967c0a01000000680600),
(315, 0x587f967c0901000000680600),
(315, 0x597f967c0a01000000680600),
(315, 0x5e7f957c0901000000660600),
(315, 0x5d7f967c0a01000000680600),
(315, 0x547f997c0a01000000b90900),
(315, 0x557f997c0a01000000ba0900),
(315, 0x587f997c0a01000000b90900),
(315, 0x597f997c0a01000000ba0900),
(315, 0x5c7f997c0a01000000b90900),
(315, 0x5d7f997c0a01000000ba0900),
(316, 0x4f7fcf7c0501000000bb0900),
(316, 0x4d7fcf7c0601000000b90900),
(316, 0x4e7fcf7c0601000000ba0900),
(316, 0x517fcf7c0501000000bb0900),
(316, 0x507fcf7c0601000000bb0900),
(316, 0x537fcf7c0601000000bb0900),
(316, 0x577fcd7c0401000000680600),
(316, 0x547fcf7c0501000000bb0900),
(316, 0x577fce7c0501000000680600),
(316, 0x587fcf7c0401000000660600),
(316, 0x587fcf7c0601000000bb0900),
(316, 0x4e7fd27c0401000000b90900),
(316, 0x4f7fd27c0401000000ba0900),
(316, 0x4c7fd37c0501000000660600),
(316, 0x4e7fd17c0501000000680600),
(316, 0x4f7fd07c0501000000bc0900),
(316, 0x4d7fd07c0601000000b90900),
(316, 0x4e7fd07c0601000000ba0900),
(316, 0x4f7fd27c0601000000660600),
(316, 0x4e7fd47c0401000000b90900),
(316, 0x4e7fd57c0401000000b90900),
(316, 0x4e7fd77c0401000000b90900),
(316, 0x4f7fd47c0401000000ba0900),
(316, 0x4f7fd57c0401000000ba0900),
(316, 0x4f7fd77c0401000000ba0900),
(316, 0x4c7fd67c0501000000660600),
(316, 0x4e7fd47c0501000000680600),
(316, 0x4f7fd57c0601000000660600),
(316, 0x517fd17c0401000000680600),
(316, 0x517fd07c0501000000bc0900),
(316, 0x537fd17c0501000000680600),
(316, 0x507fd07c0601000000bc0900),
(316, 0x527fd17c0601000000680600),
(316, 0x527fd37c0601000000680600),
(316, 0x537fd07c0601000000bc0900),
(316, 0x547fd17c0401000000680600),
(316, 0x557fd27c0401000000b90900),
(316, 0x567fd27c0401000000ba0900),
(316, 0x547fd07c0501000000bc0900),
(316, 0x567fd17c0601000000680600),
(316, 0x587fd07c0601000000bc0900),
(316, 0x507fd67c0501000000660600),
(316, 0x557fd47c0401000000b90900),
(316, 0x557fd57c0401000000b90900),
(316, 0x557fd77c0401000000b90900),
(316, 0x567fd47c0401000000ba0900),
(316, 0x567fd57c0401000000ba0900),
(316, 0x567fd77c0401000000ba0900),
(316, 0x577fd47c0501000000680600),
(316, 0x567fd77c0601000000bb0900),
(316, 0x577fd47c0601000000680600),
(316, 0x567fd87c0601000000bc0900),
(317, 0x857fc97d0601000000b90900),
(317, 0x857fca7d0601000000b90900),
(317, 0x867fc97d0601000000ba0900),
(317, 0x867fca7d0601000000ba0900),
(317, 0x847fcc7d0701000000660600),
(318, 0x8a7fd47d0701000000660600),
(318, 0x8c7fd47d0701000000b70900),
(318, 0x8c7fd57d0701000000b80900),
(319, 0x837fd47d0601000000b70900),
(319, 0x837fd57d0601000000b80900),
(319, 0x847fd47d0601000000b70900),
(319, 0x847fd57d0601000000b80900),
(319, 0x887fd47d0601000000660600),
(320, 0x917fd27d0701000000680600),
(320, 0x927fd37d0701000000bb0900),
(320, 0x927fd47d0701000000bc0900),
(321, 0x947fd27d0701000000680600),
(321, 0x957fd37d0701000000bb0900),
(321, 0x957fd47d0701000000bc0900),
(322, 0x977fd27d0701000000680600),
(322, 0x987fd37d0701000000bb0900),
(322, 0x987fd47d0701000000bc0900),
(323, 0x857fd67d0801000000b70900),
(323, 0x857fd77d0801000000b80900),
(323, 0x867fd67d0801000000b70900),
(323, 0x867fd77d0801000000b80900),
(323, 0x877fd47d0801000000660600),
(324, 0x8a7fd47d0801000000660600),
(324, 0x8c7fd47d0801000000b70900),
(324, 0x8c7fd57d0801000000b80900),
(325, 0x917fd27d0801000000680600),
(325, 0x927fd37d0801000000bb0900),
(325, 0x927fd47d0801000000bc0900),
(326, 0x947fd27d0801000000680600),
(326, 0x957fd37d0801000000bb0900),
(326, 0x957fd47d0801000000bc0900),
(327, 0x977fd27d0801000000680600),
(327, 0x987fd37d0801000000bb0900),
(327, 0x987fd47d0801000000bc0900),
(328, 0x957fc97d0801000000240900),
(329, 0x9a7fc97d0801000000240900),
(330, 0x997fc67d0801000000240900),
(331, 0x8f7fea7d0501000000680600),
(331, 0x8e7fe97d0801000000b70900),
(331, 0x8e7fea7d0801000000b80900),
(331, 0x8f7fef7d0601000000bd0900),
(331, 0x907fe97d0801000000b70900),
(331, 0x907fea7d0801000000b80900),
(331, 0x917fe97d0801000000b70900),
(331, 0x917fea7d0801000000b80900),
(331, 0x937fe97d0801000000b70900),
(331, 0x937fea7d0801000000b80900),
(331, 0x947fea7d0501000000680600),
(331, 0x947feb7d0701000000680600),
(331, 0x947fe97d0801000000b70900),
(331, 0x947fea7d0801000000b80900),
(331, 0x967fe97d0801000000b70900),
(331, 0x967fea7d0801000000b80900),
(331, 0x907fef7d0501000000660600),
(331, 0x937fef7d0501000000660600),
(331, 0x907fec7d0601000000680600),
(331, 0x907fef7d0601000000be0900),
(331, 0x937fec7d0601000000680600),
(331, 0x957fec7d0801000000bd0900),
(331, 0x957fed7d0801000000bd0900),
(331, 0x957fee7d0801000000680600),
(331, 0x967fec7d0801000000be0900),
(331, 0x967fed7d0801000000be0900),
(331, 0x937ff27d0801000000660600),
(331, 0x947ff27d0901000000660600),
(331, 0x957ff07d0901000000680600),
(332, 0x88807d7d0701000000b70900),
(332, 0x88807e7d0701000000b80900),
(332, 0x8b807d7d0701000000b70900),
(332, 0x8b807e7d0701000000b80900),
(332, 0x8c807f7d0601000000680600),
(332, 0x8d807d7d0701000000b70900),
(332, 0x8d807e7d0701000000b80900),
(332, 0x90807d7d0701000000b70900),
(332, 0x90807e7d0701000000b80900),
(332, 0x8a80817d0601000000660600),
(332, 0x8880827d0701000000bd0900),
(332, 0x8980827d0701000000be0900),
(332, 0x8b80817d0701000000680600),
(332, 0x8c80827d0601000000680600),
(332, 0x8d80817d0601000000660600),
(332, 0x8d80817d0701000000680600),
(332, 0x8f80827d0701000000bd0900),
(332, 0x8880857d0601000000bd0900),
(332, 0x8980857d0601000000be0900),
(332, 0x8a80847d0701000000660600),
(332, 0x8f80857d0601000000bd0900),
(332, 0x8e80847d0701000000660600),
(332, 0x9080807d0601000000b70900),
(332, 0x9080817d0601000000b80900),
(332, 0x9080827d0701000000be0900),
(332, 0x9080857d0601000000be0900),
(333, 0x9b80757d0501000000b70900),
(333, 0x9b80767d0501000000b80900),
(333, 0x9880757d0701000000bd0900),
(333, 0x9980757d0701000000be0900),
(333, 0x9f80757d0501000000b70900),
(333, 0x9f80767d0501000000b80900),
(333, 0x9f80777d0601000000660600),
(333, 0x9d80757d0701000000bd0900),
(333, 0x9e80757d0701000000be0900),
(333, 0x9f80777d0701000000660600),
(333, 0x9880787d0701000000bd0900),
(333, 0x98807a7d0701000000bd0900),
(333, 0x9980787d0701000000be0900),
(333, 0x99807a7d0701000000be0900),
(333, 0x9c80797d0501000000680600),
(333, 0x9f807b7d0601000000660600),
(333, 0x9d80787d0701000000bd0900),
(333, 0x9d807a7d0701000000bd0900),
(333, 0x9e80787d0701000000be0900),
(333, 0x9e807a7d0701000000be0900),
(333, 0x98807c7d0701000000bd0900),
(333, 0x98807e7d0701000000bd0900),
(333, 0x99807c7d0701000000be0900),
(333, 0x99807e7d0701000000be0900),
(333, 0x9d807e7d0701000000bd0900),
(333, 0x9e807e7d0701000000be0900),
(333, 0x9f807d7d0701000000660600),
(333, 0xa180757d0501000000b70900),
(333, 0xa180767d0501000000b80900),
(333, 0xa280777d0601000000660600),
(333, 0xa580757d0501000000b70900),
(333, 0xa580767d0501000000b80900),
(333, 0xa080797d0501000000680600),
(333, 0xa2807b7d0601000000660600),
(333, 0xa480797d0501000000680600),
(333, 0xa1807c7d0601000000680600),
(334, 0xbc80767d0701000000b70900),
(334, 0xbc80777d0701000000b80900),
(334, 0xbb80787d0701000000680600),
(334, 0xbd80797d0301000000bd0900),
(334, 0xbd807b7d0301000000b70900),
(334, 0xbe80797d0301000000be0900),
(334, 0xbd80797d0401000000bd0900),
(334, 0xbd807b7d0401000000bd0900),
(334, 0xbe80797d0401000000be0900),
(334, 0xbe807b7d0401000000be0900),
(334, 0xbd80797d0501000000bd0900),
(334, 0xbd807b7d0501000000bd0900),
(334, 0xbe80797d0501000000be0900),
(334, 0xbe807b7d0501000000be0900),
(334, 0xbe80787d0601000000680600),
(334, 0xbf80787d0701000000680600),
(334, 0xbd807c7d0301000000b80900),
(334, 0xbd807e7d0301000000bd0900),
(334, 0xbe807e7d0301000000be0900),
(334, 0xbd807d7d0401000000b70900),
(334, 0xbd807e7d0401000000b80900),
(334, 0xbd807d7d0501000000b70900),
(334, 0xbd807e7d0501000000b80900),
(334, 0xc080767d0701000000b70900),
(334, 0xc080777d0701000000b80900),
(334, 0xc380767d0701000000b70900),
(334, 0xc380777d0701000000b80900),
(334, 0xc1807b7d0301000000660600),
(334, 0xc1807b7d0401000000660600),
(334, 0xc1807b7d0501000000660600),
(334, 0xc0807a7d0601000000660600),
(334, 0xc280787d0701000000680600),
(334, 0xc3807c7d0301000000680600),
(334, 0xc1807e7d0401000000660600),
(334, 0xc1807e7d0501000000660600),
(334, 0xc0807d7d0601000000660600),
(335, 0xd3806f7d0601000000b70900),
(335, 0xd3806c7d0701000000bd0900),
(335, 0xd5806f7d0501000000b70900),
(335, 0xd4806c7d0701000000be0900),
(335, 0xd9806f7d0501000000b70900),
(335, 0xdb806e7d0601000000680600),
(335, 0xd8806e7d0701000000660600),
(335, 0xd380707d0601000000b80900),
(335, 0xd380737d0601000000b70900),
(335, 0xd380707d0701000000bd0900),
(335, 0xd380727d0701000000bd0900),
(335, 0xd480717d0501000000680600),
(335, 0xd480737d0501000000680600),
(335, 0xd580707d0501000000b80900),
(335, 0xd780717d0501000000680600),
(335, 0xd780737d0501000000680600),
(335, 0xd680707d0601000000660600),
(335, 0xd480707d0701000000be0900),
(335, 0xd480727d0701000000be0900),
(335, 0xd980707d0501000000b80900),
(335, 0xd980707d0601000000660600),
(335, 0xdb80737d0701000000680600),
(335, 0xd380747d0601000000b80900),
(335, 0xd380757d0701000000bd0900),
(335, 0xd580747d0501000000b70900),
(335, 0xd580757d0501000000b80900),
(335, 0xd680747d0601000000660600),
(335, 0xd480757d0701000000be0900),
(335, 0xd980747d0501000000b70900),
(335, 0xd980757d0501000000b80900),
(335, 0xd980747d0601000000660600),
(335, 0xd880757d0701000000660600),
(336, 0xd5805e7d0501000000b70900),
(336, 0xd5805f7d0501000000b80900),
(336, 0xd7805f7d0701000000660600),
(336, 0xd8805f7d0501000000660600),
(336, 0xdc805f7d0501000000660600),
(336, 0xdf805e7d0501000000b70900),
(336, 0xdf805f7d0501000000b80900),
(336, 0xdc805f7d0701000000660600),
(336, 0xde805e7d0701000000bd0900),
(336, 0xdf805e7d0701000000be0900),
(336, 0xd580617d0501000000b70900),
(336, 0xd580627d0501000000b80900),
(336, 0xd480607d0601000000660600),
(336, 0xd780637d0601000000680600),
(336, 0xd680637d0701000000680600),
(336, 0xd780627d0701000000660600),
(336, 0xd880627d0501000000660600),
(336, 0xda80637d0501000000680600),
(336, 0xda80607d0601000000660600),
(336, 0xdc80627d0501000000660600),
(336, 0xdf80617d0501000000b70900),
(336, 0xdf80627d0501000000b80900),
(336, 0xdd80637d0601000000680600),
(336, 0xde80607d0701000000bd0900),
(336, 0xdf80607d0701000000be0900),
(336, 0xdc80657d0501000000660600),
(336, 0xdf80647d0501000000b70900),
(336, 0xdf80657d0501000000b80900),
(336, 0xdf80677d0501000000b70900),
(336, 0xd580687d0701000000bd0900),
(336, 0xd680687d0701000000be0900),
(336, 0xdc80687d0501000000660600),
(336, 0xdf80687d0501000000b80900),
(337, 0x9880827d0701000000bd0900),
(337, 0x9980827d0701000000be0900),
(337, 0x9a80867d0601000000660600),
(337, 0x9880867d0701000000bd0900),
(337, 0x9980867d0701000000be0900),
(337, 0x9a80847d0701000000660600),
(338, 0xae807f7d0601000000680600),
(338, 0xaf80817d0701000000680600),
(338, 0xad80847d0501000000bd0900),
(338, 0xae80847d0501000000be0900),
(338, 0xaf80847d0501000000bd0900),
(338, 0xad80847d0701000000bd0900),
(338, 0xae80847d0701000000be0900),
(338, 0xaf80847d0701000000bd0900),
(338, 0xb080847d0501000000be0900),
(338, 0xb080847d0701000000be0900),
(339, 0xb4807f7d0601000000680600),
(339, 0xb480817d0701000000680600),
(339, 0xb280847d0501000000bd0900),
(339, 0xb380847d0501000000be0900),
(339, 0xb280847d0701000000bd0900),
(339, 0xb380847d0701000000be0900),
(339, 0xb480847d0501000000bd0900),
(339, 0xb580847d0501000000be0900),
(339, 0xb480847d0701000000bd0900),
(339, 0xb580847d0701000000be0900),
(340, 0x7e80687d0501000000660600),
(340, 0x7c80697d0601000000680600),
(340, 0x7e80697d0601000000680600),
(340, 0x7c80697d0701000000680600),
(340, 0x7e80687d0701000000660600),
(340, 0x7e806a7d0701000000bd0900),
(340, 0x7f806a7d0701000000be0900),
(340, 0x7e806c7d0701000000bd0900),
(340, 0x7f806c7d0701000000be0900),
(340, 0x80806b7d0601000000660600),
(341, 0x8180487d0701000000b70900),
(341, 0x8180497d0701000000b80900),
(341, 0x8380497d0701000000660600),
(341, 0x83804d7d0601000000660600),
(341, 0x81804d7d0701000000b70900),
(341, 0x81804e7d0701000000b80900),
(341, 0x83804d7d0701000000660600),
(341, 0x85804d7d0501000000660600),
(342, 0x7e80467d0501000000bd0900),
(342, 0x7f80467d0501000000be0900),
(342, 0x7e80447d0701000000660600),
(342, 0x8280437d0701000000b70900),
(342, 0x8080457d0601000000660600),
(342, 0x8280447d0701000000b80900),
(343, 0x8180277d0701000000b70900),
(343, 0x8480277d0501000000b70900),
(343, 0x83802a7d0601000000660600),
(343, 0x8180287d0701000000b80900),
(343, 0x81802a7d0701000000b70900),
(343, 0x81802b7d0701000000b80900),
(343, 0x8480287d0501000000b80900),
(343, 0x84802a7d0501000000b70900),
(343, 0x84802b7d0501000000b80900),
(343, 0x8780287d0501000000660600),
(343, 0x87802b7d0501000000660600),
(343, 0x8480287d0701000000660600),
(343, 0x84802b7d0701000000660600),
(344, 0x7c80377d0701000000b70900),
(344, 0x7f803a7d0501000000b70900),
(344, 0x7f803b7d0501000000b80900),
(344, 0x7e80397d0601000000680600),
(344, 0x7c80387d0701000000b80900),
(344, 0x7e80397d0701000000680600),
(345, 0x7e80337d0701000000660600),
(345, 0x7e80367d0601000000680600),
(345, 0x7f80347d0701000000b70900),
(345, 0x7f80357d0701000000b80900),
(345, 0x8280327d0701000000b70900),
(345, 0x8280337d0701000000b80900),
(346, 0x81803a7d0701000000b70900),
(346, 0x81803b7d0701000000b80900),
(346, 0x8680397d0601000000680600),
(346, 0x81803d7d0701000000bd0900),
(346, 0x82803d7d0701000000be0900),
(346, 0x86803d7d0701000000bd0900),
(346, 0x87803d7d0701000000be0900),
(347, 0x8680367d0601000000680600),
(347, 0x8580357d0701000000680600),
(347, 0x8680367d0701000000bd0900),
(347, 0x8780367d0701000000be0900),
(347, 0x8680387d0701000000bd0900),
(347, 0x8780387d0701000000be0900),
(348, 0x9180327d0501000000680600),
(348, 0x9380317d0501000000660600),
(348, 0x9180337d0701000000680600),
(348, 0x9380317d0701000000660600),
(348, 0x9780307d0701000000b70900),
(348, 0x9780317d0701000000b80900),
(348, 0x9080357d0501000000bd0900),
(348, 0x9180357d0501000000be0900),
(348, 0x9380357d0701000000660600),
(348, 0x9580347d0601000000660600),
(349, 0x9380267d0601000000680600),
(349, 0x9180247d0701000000b70900),
(349, 0x9180257d0701000000b80900),
(349, 0x9280277d0701000000680600),
(349, 0x9480277d0701000000680600),
(349, 0x9780247d0701000000b70900),
(349, 0x9780257d0701000000b80900),
(349, 0x9780277d0701000000b70900),
(349, 0x9580297d0701000000660600),
(349, 0x9780287d0701000000b80900),
(350, 0xa780557d0701000000b70900),
(350, 0xa780567d0701000000b80900),
(350, 0xab80567d0701000000660600),
(350, 0xae80577d0701000000680600),
(350, 0xa7805a7d0701000000b70900),
(350, 0xa7805b7d0701000000b80900),
(350, 0xab80587d0501000000660600),
(350, 0xa9805a7d0601000000660600),
(350, 0xab80587d0601000000680600),
(350, 0xae80587d0601000000680600),
(350, 0xac805a7d0701000000b70900),
(350, 0xac805b7d0701000000b80900),
(350, 0xb0805a7d0701000000b70900),
(350, 0xb0805b7d0701000000b80900),
(351, 0x93805b7d0701000000b70900),
(351, 0x93805c7d0701000000b80900),
(351, 0x96805d7d0701000000680600),
(352, 0x92805f7d0701000000680600),
(352, 0x9280627d0701000000bd0900),
(352, 0x9380627d0701000000be0900),
(353, 0x8c80617d0701000000b70900),
(353, 0x8c80627d0701000000b80900),
(353, 0x8f80637d0701000000680600),
(354, 0x8980637d0701000000660600),
(354, 0x8680647d0701000000bd0900),
(354, 0x8780647d0701000000be0900),
(355, 0x86805f7d0701000000b70900),
(355, 0x8680607d0701000000b80900),
(355, 0x8980607d0701000000660600),
(356, 0x86805d7d0701000000bd0900),
(356, 0x87805d7d0701000000be0900),
(356, 0x89805c7d0701000000660600),
(357, 0x8c805f7d0701000000bd0900),
(357, 0x8d805f7d0701000000be0900),
(357, 0x8e805c7d0701000000680600),
(357, 0x8e805f7d0701000000bd0900),
(357, 0x8f805f7d0701000000be0900),
(358, 0x86805b7d0601000000bd0900),
(358, 0x87805b7d0601000000be0900),
(358, 0x87805e7d0601000000680600),
(359, 0x8680627d0601000000b70900),
(359, 0x8680637d0601000000b80900),
(359, 0x8880617d0601000000680600),
(359, 0x8980627d0601000000b70900),
(359, 0x8980637d0601000000b80900),
(360, 0x89805b7d0601000000bd0900),
(360, 0x8a805b7d0601000000be0900),
(360, 0x8b805e7d0601000000680600),
(361, 0x8d80617d0601000000680600),
(361, 0x8c80647d0601000000bd0900),
(361, 0x8d80647d0601000000be0900),
(362, 0x8d805b7d0601000000b70900),
(362, 0x8d805c7d0601000000b80900),
(362, 0x8f805e7d0601000000680600),
(363, 0x9080637d0601000000b70900),
(363, 0x9280617d0601000000680600),
(363, 0x9080647d0601000000b80900),
(364, 0x91805b7d0601000000b70900),
(364, 0x91805c7d0601000000b80900),
(364, 0x93805e7d0601000000680600),
(365, 0x95805b7d0601000000bd0900),
(365, 0x96805b7d0601000000be0900),
(365, 0x96805e7d0601000000680600),
(366, 0x95805b7d0501000000bd0900),
(366, 0x96805b7d0501000000be0900),
(366, 0x96805e7d0501000000680600),
(367, 0x91805b7d0501000000b70900),
(367, 0x91805c7d0501000000b80900),
(367, 0x93805e7d0501000000680600),
(368, 0x9280617d0501000000680600);
INSERT INTO `tile_store` (`house_id`, `data`) VALUES
(368, 0x9280647d0501000000bd0900),
(368, 0x9380647d0501000000be0900),
(369, 0x8d805b7d0501000000b70900),
(369, 0x8d805c7d0501000000b80900),
(369, 0x8f805e7d0501000000680600),
(370, 0x8d80617d0501000000680600),
(370, 0x8d80647d0501000000bd0900),
(370, 0x8e80647d0501000000be0900),
(371, 0x89805b7d0501000000b70900),
(371, 0x89805c7d0501000000b80900),
(371, 0x8b805e7d0501000000680600),
(372, 0x8680627d0501000000b70900),
(372, 0x8680637d0501000000b80900),
(372, 0x8880617d0501000000680600),
(372, 0x8980627d0501000000b70900),
(372, 0x8980637d0501000000b80900),
(373, 0x86805b7d0501000000bd0900),
(373, 0x87805b7d0501000000be0900),
(373, 0x87805e7d0501000000680600),
(374, 0x91805b7d0401000000bd0900),
(374, 0x92805b7d0401000000be0900),
(374, 0x96805e7d0401000000680600),
(375, 0x8c80627d0401000000bd0900),
(375, 0x8d80627d0401000000be0900),
(375, 0x8c80647d0401000000bd0900),
(375, 0x8d80647d0401000000be0900),
(375, 0x8f80647d0401000000660600),
(375, 0x9280617d0401000000680600),
(376, 0x8a805d7d0401000000bd0900),
(376, 0x8b805d7d0401000000be0900),
(376, 0x8c805c7d0401000000660600),
(376, 0x8f805e7d0401000000680600),
(377, 0x89805f7d0401000000660600),
(377, 0x8780617d0401000000680600),
(377, 0x8680647d0401000000bd0900),
(377, 0x8780647d0401000000be0900),
(377, 0x8980647d0401000000bd0900),
(377, 0x8a80647d0401000000be0900),
(378, 0xa0805f7d0701000000b70900),
(378, 0xa3805f7d0701000000b70900),
(378, 0xa080627d0501000000bd0900),
(378, 0xa180627d0501000000be0900),
(378, 0xa180617d0601000000680600),
(378, 0xa080607d0701000000b80900),
(378, 0xa380607d0701000000b80900),
(378, 0xa580627d0501000000b70900),
(378, 0xa580637d0501000000b80900),
(378, 0xa180657d0501000000680600),
(378, 0xa180657d0601000000680600),
(378, 0xa280657d0701000000680600),
(378, 0xa480657d0501000000680600),
(378, 0xa580657d0601000000680600),
(378, 0xa480677d0701000000660600),
(379, 0xc5805f7d0701000000b70900),
(379, 0xc8805f7d0701000000b70900),
(379, 0xc780617d0601000000680600),
(379, 0xc580607d0701000000b80900),
(379, 0xc780627d0701000000680600),
(379, 0xc880607d0701000000b80900),
(380, 0xca805f7d0701000000b70900),
(380, 0xcd805f7d0701000000b70900),
(380, 0xca80607d0701000000b80900),
(380, 0xcc80617d0601000000680600),
(380, 0xcc80627d0701000000680600),
(380, 0xcd80607d0701000000b80900),
(381, 0xce80437d0501000000680600),
(381, 0xce80467d0501000000bd0900),
(381, 0xcf80467d0501000000be0900),
(381, 0xcf80477d0601000000680600),
(381, 0xcf80457d0701000000680600),
(381, 0xce80497d0701000000bd0900),
(381, 0xcf80497d0701000000be0900),
(381, 0xd080437d0601000000680600),
(381, 0xd180497d0701000000bd0900),
(381, 0xd280497d0701000000be0900),
(382, 0xd380477d0601000000680600),
(382, 0xd580457d0701000000680600),
(382, 0xd480487d0701000000b70900),
(382, 0xd480497d0701000000b80900),
(382, 0xd680487d0701000000b70900),
(382, 0xd680497d0701000000b80900),
(383, 0xe7806d7d0601000000660600),
(383, 0xe8806c7d0501000000bd0900),
(383, 0xe9806c7d0501000000be0900),
(383, 0xe9806e7d0501000000680600),
(384, 0xe880577d0501000000bd0900),
(384, 0xe980577d0501000000be0900),
(384, 0xe780587d0601000000660600),
(384, 0xea80587d0701000000660600),
(385, 0xe880537d0501000000bd0900),
(385, 0xe980537d0501000000be0900),
(385, 0xe780547d0601000000660600),
(385, 0xea80547d0701000000660600),
(386, 0xe380497d0701000000660600),
(386, 0xe680487d0701000000b70900),
(386, 0xe680497d0701000000b80900),
(386, 0xe2804d7d0501000000660600),
(386, 0xe3804d7d0701000000660600),
(386, 0xe4804d7d0601000000660600),
(386, 0xe6804c7d0701000000b70900),
(386, 0xe6804d7d0701000000b80900),
(387, 0xd380357d0701000000660600),
(387, 0xd680347d0701000000b70900),
(387, 0xd680357d0701000000b80900),
(387, 0xd680377d0701000000b70900),
(387, 0xd280397d0501000000660600),
(387, 0xd080397d0601000000680600),
(387, 0xd280397d0601000000680600),
(387, 0xd380387d0701000000660600),
(387, 0xd3803b7d0701000000660600),
(387, 0xd4803b7d0601000000660600),
(387, 0xd680387d0701000000b80900),
(387, 0xd6803a7d0701000000b70900),
(387, 0xd6803b7d0701000000b80900),
(388, 0x9c80217d0201000000bd0900),
(388, 0x9d80217d0201000000be0900),
(388, 0x9f80217d0201000000bd0900),
(388, 0x9e80247d0601000000680600),
(388, 0xa080217d0201000000be0900),
(389, 0x9d802f7d0701000000bd0900),
(389, 0x9e802f7d0701000000be0900),
(389, 0x9f802e7d0701000000660600),
(389, 0xa3802f7d0501000000660600),
(389, 0xa1802f7d0701000000660600),
(389, 0xa2802d7d0701000000b70900),
(389, 0xa2802e7d0701000000b80900),
(389, 0xa6802d7d0701000000b70900),
(389, 0xa6802e7d0701000000b80900),
(389, 0xa080307d0701000000680600),
(389, 0xa480327d0601000000680600),
(390, 0xaf80377d0501000000bd0900),
(390, 0xaf80397d0501000000bd0900),
(390, 0xaf803b7d0501000000b70900),
(390, 0xaf803c7d0501000000b80900),
(390, 0xb080377d0501000000be0900),
(390, 0xb080367d0601000000680600),
(390, 0xb080397d0501000000be0900),
(390, 0xb280397d0501000000660600),
(390, 0xb280397d0701000000680600),
(390, 0xb480397d0601000000680600),
(390, 0xb2803c7d0501000000660600),
(391, 0xb5802f7d0701000000660600),
(391, 0xb380307d0701000000bd0900),
(391, 0xb380327d0701000000b70900),
(391, 0xb380337d0701000000b80900),
(391, 0xb680337d0601000000680600),
(391, 0xb480307d0701000000be0900),
(391, 0xb780307d0701000000680600),
(392, 0xbf80327d0501000000bd0900),
(392, 0xc0802f7d0501000000680600),
(392, 0xc1802e7d0501000000660600),
(392, 0xc2802f7d0701000000660600),
(392, 0xc4802d7d0501000000b70900),
(392, 0xc4802e7d0501000000b80900),
(392, 0xc4802f7d0601000000680600),
(392, 0xc080327d0501000000be0900),
(392, 0xc380327d0501000000bd0900),
(392, 0xc080337d0601000000680600),
(392, 0xc280327d0601000000660600),
(392, 0xc480327d0501000000be0900),
(392, 0xc480317d0701000000680600),
(393, 0xc680377d0501000000b70900),
(393, 0xc480367d0601000000680600),
(393, 0xc1803a7d0501000000680600),
(393, 0xc380387d0501000000660600),
(393, 0xc280387d0601000000660600),
(393, 0xc2803b7d0601000000660600),
(393, 0xc5803b7d0501000000bd0900),
(393, 0xc680387d0501000000b80900),
(393, 0xc6803b7d0501000000be0900),
(393, 0xc0803d7d0501000000bd0900),
(393, 0xc1803d7d0501000000be0900),
(393, 0xc5803d7d0501000000bd0900),
(393, 0xc6803d7d0501000000be0900),
(394, 0xe0802f7d0501000000660600),
(394, 0xe0802f7d0701000000660600),
(394, 0xe2802d7d0701000000bd0900),
(394, 0xe3802d7d0701000000be0900),
(394, 0xde80327d0501000000bd0900),
(394, 0xdf80307d0501000000680600),
(394, 0xdf80327d0501000000be0900),
(394, 0xdf80317d0701000000680600),
(394, 0xde80347d0701000000b70900),
(394, 0xde80357d0701000000b80900),
(394, 0xe180337d0601000000680600),
(394, 0xe280307d0701000000bd0900),
(394, 0xe380307d0701000000be0900),
(394, 0xe380347d0701000000b70900),
(394, 0xe380357d0701000000b80900),
(395, 0xec80337d0601000000680600),
(395, 0xed80317d0701000000660600),
(395, 0xef80307d0701000000b70900),
(395, 0xef80317d0701000000b80900),
(395, 0xed80357d0701000000660600),
(395, 0xef80347d0701000000b70900),
(395, 0xef80357d0701000000b80900),
(396, 0xb97f137c0501000000680600),
(396, 0xba7f137c0701000000680600),
(396, 0xbd7f137c0601000000680600),
(396, 0xb67f177c0401000000b70900),
(396, 0xb67f177c0501000000b70900),
(396, 0xb67f177c0601000000b70900),
(396, 0xb77f177c0601000000b70900),
(396, 0xb87f177c0401000000b70900),
(396, 0xba7f177c0401000000b70900),
(396, 0xb87f177c0501000000b70900),
(396, 0xba7f177c0501000000b70900),
(396, 0xb87f177c0601000000b70900),
(396, 0xb97f177c0601000000b70900),
(396, 0xba7f177c0601000000b70900),
(396, 0xbb7f167c0601000000660600),
(396, 0xb87f157c0701000000660600),
(396, 0xbb7f167c0701000000660600),
(396, 0xbf7f167c0601000000660600),
(396, 0xb67f187c0401000000b80900),
(396, 0xb67f187c0501000000b80900),
(396, 0xb67f187c0601000000b80900),
(396, 0xb77f187c0601000000b80900),
(396, 0xb67f187c0701000000bd0900),
(396, 0xb77f187c0701000000be0900),
(396, 0xb87f187c0401000000b80900),
(396, 0xba7f187c0401000000b80900),
(396, 0xb87f187c0501000000b80900),
(396, 0xba7f187c0501000000b80900),
(396, 0xb87f187c0601000000b80900),
(396, 0xb97f187c0601000000b80900),
(396, 0xba7f187c0601000000b80900),
(396, 0xba7f187c0701000000680600),
(396, 0xbd7f1a7c0701000000660600),
(396, 0xbf7f187c0701000000680600),
(396, 0xba7f1c7c0701000000680600),
(396, 0xc17f127c0501000000680600),
(396, 0xc07f137c0601000000b70900),
(396, 0xc47f137c0601000000b70900),
(396, 0xc47f137c0701000000b70900),
(396, 0xc27f147c0301000000660600),
(396, 0xc17f147c0501000000680600),
(396, 0xc37f177c0501000000bd0900),
(396, 0xc07f147c0601000000b80900),
(396, 0xc17f167c0701000000660600),
(396, 0xc47f157c0301000000680600),
(396, 0xc47f177c0501000000be0900),
(396, 0xc47f147c0601000000b80900),
(396, 0xc47f147c0701000000b80900),
(396, 0xc47f177c0701000000b70900),
(396, 0xc37f187c0501000000bd0900),
(396, 0xc47f187c0501000000be0900),
(396, 0xc47f187c0701000000b80900),
(397, 0x1d7fa97b0701000000b70900),
(397, 0x1d7faa7b0701000000b80900),
(397, 0x1f7faf7b0601000000b90900),
(397, 0x1f7fae7b0701000000680600),
(397, 0x217fa37b0501000000b70900),
(397, 0x207fa57b0501000000680600),
(397, 0x217fa47b0501000000b80900),
(397, 0x237fa67b0601000000b90900),
(397, 0x257fa67b0501000000bd0900),
(397, 0x267fa67b0501000000be0900),
(397, 0x247fa67b0601000000ba0900),
(397, 0x257fa67b0601000000b90900),
(397, 0x267fa67b0601000000ba0900),
(397, 0x277fa77b0601000000bb0900),
(397, 0x247fa77b0701000000660600),
(397, 0x257fa67b0701000000b90900),
(397, 0x267fa67b0701000000ba0900),
(397, 0x227faa7b0601000000660600),
(397, 0x217faa7b0801000000680600),
(397, 0x237fa97b0801000000660600),
(397, 0x247fa87b0501000000660600),
(397, 0x277fa97b0501000000b90900),
(397, 0x247fa97b0601000000b90900),
(397, 0x247faa7b0601000000b90900),
(397, 0x257fa97b0601000000ba0900),
(397, 0x257faa7b0601000000ba0900),
(397, 0x277fa87b0601000000bc0900),
(397, 0x247faa7b0701000000660600),
(397, 0x277fa97b0701000000b90900),
(397, 0x277fab7b0701000000b90900),
(397, 0x267faa7b0801000000680600),
(397, 0x287fa97b0501000000ba0900),
(397, 0x287fa97b0601000000bb0900),
(397, 0x287faa7b0601000000bc0900),
(397, 0x287fa97b0701000000ba0900),
(397, 0x287fab7b0701000000ba0900),
(397, 0x207fac7b0601000000680600),
(397, 0x207faf7b0601000000ba0900),
(397, 0x227faf7b0601000000660600),
(397, 0x237fac7b0601000000b90900),
(397, 0x237fad7b0601000000b90900),
(397, 0x247fac7b0601000000ba0900),
(397, 0x247fad7b0601000000ba0900),
(397, 0x277fae7b0601000000bb0900),
(397, 0x277faf7b0601000000bc0900),
(397, 0x247fae7b0701000000660600),
(397, 0x277fad7b0701000000b90900),
(397, 0x287fac7b0601000000bb0900),
(397, 0x287fad7b0601000000bc0900),
(397, 0x287fad7b0701000000ba0900),
(397, 0x227fb17b0701000000680600),
(397, 0x237fb17b0701000000680600),
(397, 0x247fb07b0601000000b90900),
(397, 0x257fb07b0601000000ba0900),
(398, 0x7d7fca7b0701000000bb0900),
(398, 0x7d7fcb7b0701000000bc0900),
(398, 0x7e7fca7b0701000000bb0900),
(398, 0x7e7fcb7b0701000000bc0900),
(398, 0x827fcb7b0701000000660600),
(399, 0x807fbc7b0701000000bb0900),
(399, 0x807fbd7b0701000000bc0900),
(399, 0x817fbc7b0701000000bb0900),
(399, 0x817fbd7b0701000000bc0900),
(399, 0x857fbc7b0701000000660600),
(400, 0x7d7fa97b0701000000bb0900),
(400, 0x7d7faa7b0701000000bc0900),
(400, 0x7e7fac7b0701000000bb0900),
(400, 0x7e7fad7b0701000000bc0900),
(400, 0x7f7fac7b0701000000bb0900),
(400, 0x7f7fad7b0701000000bc0900),
(400, 0x827fa97b0701000000660600),
(401, 0x6f7fa17b0701000000bb0900),
(401, 0x6f7fa27b0701000000bc0900),
(401, 0x6f7fa57b0701000000bb0900),
(401, 0x6f7fa67b0701000000bc0900),
(401, 0x737fa17b0701000000bb0900),
(401, 0x737fa27b0701000000bc0900),
(401, 0x707fa57b0701000000bb0900),
(401, 0x707fa67b0701000000bc0900),
(401, 0x727fa77b0701000000680600),
(402, 0x8e7fae7b0701000000b90900),
(402, 0x8f7fae7b0701000000ba0900),
(402, 0x8c7fb37b0701000000680600),
(402, 0x8e7fb17b0701000000bb0900),
(402, 0x8e7fb27b0701000000bc0900),
(402, 0x8f7fb17b0701000000bb0900),
(402, 0x8f7fb27b0701000000bc0900),
(403, 0x8f7fa27b0701000000b90900),
(403, 0x8c7fa77b0701000000680600),
(403, 0x8f7fa57b0701000000bb0900),
(403, 0x8f7fa67b0701000000bc0900),
(403, 0x907fa27b0701000000ba0900),
(403, 0x907fa57b0701000000bb0900),
(403, 0x907fa67b0701000000bc0900),
(404, 0xa57fb87b0701000000b90900),
(404, 0xa67fb87b0701000000ba0900),
(404, 0xa87fbb7b0701000000bb0900),
(404, 0xa97fbb7b0701000000bb0900),
(404, 0xa57fbd7b0701000000680600),
(404, 0xa87fbc7b0701000000bc0900),
(404, 0xa97fbc7b0701000000bc0900),
(405, 0xb17f9a7b0701000000bb0900),
(405, 0xb17f9b7b0701000000bc0900),
(405, 0xb47f9a7b0701000000bb0900),
(405, 0xb47f9b7b0701000000bc0900),
(405, 0xb27f9e7b0701000000680600),
(406, 0xc87fac7b0701000000bb0900),
(406, 0xc87fad7b0701000000bc0900),
(406, 0xc87fb07b0701000000680600),
(407, 0x727faa7b0701000000680600),
(407, 0x747fab7b0701000000bb0900),
(407, 0x747fac7b0701000000bc0900),
(408, 0xc57f9d7b0601000000bb0900),
(408, 0xc57f9e7b0601000000bc0900),
(408, 0xc57f9d7b0701000000b90900),
(408, 0xc57f9f7b0701000000b90900),
(408, 0xc67f9d7b0701000000ba0900),
(408, 0xc67f9f7b0701000000ba0900),
(408, 0xc87f9e7b0601000000660600),
(408, 0xcb7f9f7b0601000000680600),
(408, 0xc97f9e7b0701000000660600),
(408, 0xca7f9c7b0701000000680600),
(408, 0xc57fa07b0601000000b90900),
(408, 0xc57fa27b0601000000b90900),
(408, 0xc67fa07b0601000000ba0900),
(408, 0xc67fa27b0601000000ba0900),
(408, 0xc57fa37b0701000000b90900),
(408, 0xc67fa37b0701000000ba0900),
(408, 0xc87fa17b0601000000660600),
(408, 0xcb7fa07b0701000000680600),
(408, 0xc57fa47b0601000000bb0900),
(408, 0xc57fa57b0601000000bc0900),
(408, 0xc57fa57b0701000000b90900),
(408, 0xc67fa57b0701000000ba0900),
(408, 0xc87fa57b0601000000660600),
(408, 0xcb7fa77b0801000000660600),
(408, 0xce7fa77b0801000000660600),
(408, 0xc67faa7b0801000000bb0900),
(408, 0xc67fab7b0801000000bc0900),
(408, 0xc77faa7b0801000000bb0900),
(408, 0xc77fab7b0801000000bc0900),
(408, 0xca7fa87b0801000000680600),
(408, 0xcd7fa87b0801000000680600),
(409, 0x867f557b0801000000bd0900),
(409, 0x877f557b0801000000be0900),
(409, 0x8a7f567b0401000000bd0900),
(409, 0x8b7f567b0401000000be0900),
(409, 0x8a7f577b0601000000b70900),
(409, 0x897f577b0801000000660600),
(409, 0x8d7f557b0501000000660600),
(409, 0x8e7f567b0601000000680600),
(409, 0x867f587b0801000000bd0900),
(409, 0x877f587b0801000000be0900),
(409, 0x8a7f587b0601000000b80900),
(409, 0x8b7f597b0801000000660600),
(409, 0x8c7f587b0601000000660600),
(409, 0x8e7f5a7b0601000000680600),
(409, 0x8c7f5b7b0701000000680600),
(409, 0x867f5c7b0801000000b70900),
(409, 0x867f5d7b0801000000b80900),
(409, 0x877f5c7b0801000000b70900),
(409, 0x877f5d7b0801000000b80900),
(409, 0x897f5c7b0801000000660600),
(409, 0x8d7f5c7b0501000000660600),
(409, 0x8f7f5c7b0601000000660600),
(409, 0x8e7f5d7b0701000000660600),
(409, 0x8f7f5d7b0801000000660600),
(409, 0x917f557b0601000000660600),
(409, 0x907f557b0801000000bd0900),
(409, 0x907f577b0801000000bd0900),
(409, 0x917f557b0801000000be0900),
(409, 0x917f577b0801000000be0900),
(409, 0x937f557b0801000000bd0900),
(409, 0x937f577b0801000000bd0900),
(409, 0x947f557b0501000000660600),
(409, 0x947f557b0801000000be0900),
(409, 0x947f577b0801000000be0900),
(409, 0x917f587b0601000000660600),
(409, 0x917f5a7b0701000000680600),
(409, 0x907f597b0801000000bd0900),
(409, 0x907f5b7b0801000000bd0900),
(409, 0x917f597b0801000000be0900),
(409, 0x917f5b7b0801000000be0900),
(409, 0x937f597b0801000000bd0900),
(409, 0x937f5b7b0801000000bd0900),
(409, 0x977f5b7b0401000000b70900),
(409, 0x967f5b7b0601000000bd0900),
(409, 0x977f5b7b0601000000be0900),
(409, 0x967f5a7b0701000000680600),
(409, 0x947f597b0801000000be0900),
(409, 0x947f5b7b0801000000be0900),
(409, 0x917f5e7b0701000000680600),
(409, 0x927f5e7b0701000000680600),
(409, 0x977f5c7b0401000000b80900),
(409, 0x947f5c7b0501000000660600),
(409, 0x947f5c7b0601000000660600),
(409, 0x967f5d7b0601000000bd0900),
(409, 0x977f5d7b0601000000be0900),
(409, 0x957f5d7b0701000000bd0900),
(409, 0x967f5d7b0701000000be0900),
(410, 0x907f997b0701000000bb0900),
(410, 0x907f9a7b0701000000bc0900),
(410, 0x937f997b0701000000660600),
(411, 0x9a7f977b0701000000b90900),
(411, 0x9b7f977b0701000000ba0900),
(411, 0x987f997b0701000000660600),
(412, 0x9a7f937b0701000000b90900),
(412, 0x9b7f937b0701000000ba0900),
(412, 0x977f947b0701000000660600),
(413, 0x8f7f9a7b0601000000b90900),
(413, 0x907f9a7b0601000000ba0900),
(413, 0x927f997b0601000000660600),
(414, 0x977f9a7b0601000000660600),
(414, 0x9b7f997b0601000000bb0900),
(414, 0x9b7f9a7b0601000000bc0900),
(415, 0x977f967b0601000000660600),
(415, 0x9b7f957b0601000000bb0900),
(415, 0x9b7f967b0601000000bc0900),
(416, 0x977f937b0601000000660600),
(416, 0x9b7f927b0601000000bb0900),
(416, 0x9b7f937b0601000000bc0900),
(417, 0x8f7f9a7b0501000000b90900),
(417, 0x907f9a7b0501000000ba0900),
(417, 0x927f997b0501000000660600),
(418, 0x977f9a7b0501000000660600),
(418, 0x9b7f997b0501000000bb0900),
(418, 0x9b7f9a7b0501000000bc0900),
(419, 0x977f967b0501000000660600),
(419, 0x9b7f957b0501000000bb0900),
(419, 0x9b7f967b0501000000bc0900),
(420, 0x977f937b0501000000660600),
(420, 0x9b7f927b0501000000bb0900),
(420, 0x9b7f937b0501000000bc0900),
(421, 0x8f7f997b0401000000bb0900),
(421, 0x8f7f9a7b0401000000bc0900),
(421, 0x907f997b0401000000bb0900),
(421, 0x907f9a7b0401000000bc0900),
(421, 0x937f997b0401000000660600),
(422, 0x937f947b0401000000bb0900),
(422, 0x937f957b0401000000bc0900),
(422, 0x947f947b0401000000bb0900),
(422, 0x947f957b0401000000bc0900),
(422, 0x967f967b0401000000680600),
(423, 0x987f967b0401000000680600),
(423, 0x9a7f947b0401000000bb0900),
(423, 0x9a7f957b0401000000bc0900),
(423, 0x9b7f947b0401000000bb0900),
(423, 0x9b7f957b0401000000bc0900),
(424, 0x9a7f977b0401000000b90900),
(424, 0x9b7f977b0401000000ba0900),
(424, 0x987f987b0401000000680600),
(425, 0x857f6e7b0701000000b90900),
(425, 0x867f6e7b0701000000ba0900),
(425, 0x827f727b0701000000bb0900),
(425, 0x827f737b0701000000bc0900),
(425, 0x837f727b0701000000bb0900),
(425, 0x837f737b0701000000bc0900),
(425, 0x877f727b0701000000660600),
(426, 0xa47f637b0701000000bb0900),
(426, 0xa47f647b0701000000bc0900),
(426, 0xa47f677b0701000000bb0900),
(426, 0xa47f687b0701000000bc0900),
(426, 0xa87f687b0701000000660600),
(427, 0xb67f707b0701000000b90900),
(427, 0xb67f717b0701000000b90900),
(427, 0xb77f707b0701000000ba0900),
(427, 0xb77f717b0701000000ba0900),
(427, 0xb57f747b0701000000680600),
(428, 0xcf7f807b0701000000b90900),
(428, 0xcf7f817b0701000000b90900),
(428, 0xcd7f847b0701000000680600),
(428, 0xd07f807b0701000000ba0900),
(428, 0xd07f817b0701000000ba0900),
(429, 0x7c7fca7b0601000000680600),
(429, 0x7d7fcd7b0601000000bb0900),
(429, 0x7d7fce7b0601000000bc0900),
(430, 0x807fca7b0601000000680600),
(430, 0x817fcd7b0601000000bb0900),
(430, 0x817fce7b0601000000bc0900),
(431, 0x827fbb7b0501000000bb0900),
(431, 0x827fbc7b0501000000bc0900),
(431, 0x817fbd7b0601000000220900),
(431, 0x837fbc7b0601000000660600),
(432, 0x827fb77b0501000000bb0900),
(432, 0x827fb87b0501000000bc0900),
(432, 0x817fb97b0601000000220900),
(432, 0x837fb87b0601000000660600),
(433, 0x8a7fa17b0601000000b90900),
(433, 0x8b7fa17b0601000000ba0900),
(433, 0x8c7fa27b0601000000660600),
(433, 0x8b7fa57b0601000000680600),
(433, 0x907fa57b0601000000680600),
(434, 0x7d7fac7b0601000000bb0900),
(434, 0x7d7fad7b0601000000bc0900),
(434, 0x817fad7b0601000000660600),
(435, 0x7c7fa87b0601000000bb0900),
(435, 0x7c7fa97b0601000000bc0900),
(435, 0x817fa97b0601000000660600),
(436, 0x757fa07b0601000000bb0900),
(436, 0x757fa17b0601000000bc0900),
(436, 0x747fa57b0601000000680600),
(437, 0x6e7fa07b0601000000bb0900),
(437, 0x6e7fa17b0601000000bc0900),
(437, 0x717fa07b0601000000bb0900),
(437, 0x717fa17b0601000000bc0900),
(437, 0x707fa57b0601000000680600),
(438, 0x727fa97b0601000000680600),
(438, 0x707fac7b0601000000bb0900),
(438, 0x707fad7b0601000000bc0900),
(438, 0x717fac7b0601000000bb0900),
(438, 0x717fad7b0601000000bc0900),
(439, 0xb17f9a7b0601000000660600),
(439, 0xb37f9c7b0601000000bb0900),
(439, 0xb37f9d7b0601000000bc0900),
(439, 0xb47f9c7b0601000000bb0900),
(439, 0xb47f9d7b0601000000bc0900),
(440, 0xa77fb77b0601000000bb0900),
(440, 0xa47fb97b0601000000680600),
(440, 0xa67fb97b0601000000680600),
(440, 0xa77fb87b0601000000bc0900),
(440, 0xa87fbb7b0601000000660600),
(441, 0xca7fab7b0601000000b90900),
(441, 0xcb7fab7b0601000000ba0900),
(441, 0xca7fac7b0601000000b90900),
(441, 0xcb7fac7b0601000000ba0900),
(441, 0xc97fb07b0601000000680600),
(442, 0x817f727b0601000000bb0900),
(442, 0x817f737b0601000000bc0900),
(442, 0x827f727b0601000000bb0900),
(442, 0x827f737b0601000000bc0900),
(442, 0x867f737b0601000000660600),
(443, 0x817f6e7b0601000000bb0900),
(443, 0x817f6f7b0601000000bc0900),
(443, 0x827f6e7b0601000000bb0900),
(443, 0x827f6f7b0601000000bc0900),
(443, 0x867f6f7b0601000000660600),
(444, 0x9b7f757b0601000000b90900),
(444, 0x9b7f767b0601000000b90900),
(444, 0x9c7f757b0601000000ba0900),
(444, 0x9c7f767b0601000000ba0900),
(444, 0x9c7f7b7b0601000000680600),
(445, 0x9e7f757b0601000000b90900),
(445, 0x9f7f757b0601000000ba0900),
(445, 0x9f7f7b7b0601000000680600),
(445, 0xa17f787b0601000000bb0900),
(445, 0xa17f797b0601000000bc0900),
(446, 0xa67f627b0601000000b90900),
(446, 0xa67f637b0601000000b90900),
(446, 0xa77f627b0601000000ba0900),
(446, 0xa77f637b0601000000ba0900),
(446, 0xa47f677b0601000000680600),
(447, 0xae7f647b0601000000bb0900),
(447, 0xae7f657b0601000000bc0900),
(447, 0xb17f637b0601000000660600),
(447, 0xb07f677b0601000000680600),
(447, 0xb37f677b0601000000680600),
(448, 0xb67f637b0601000000b90900),
(448, 0xb77f637b0601000000ba0900),
(448, 0xb77f677b0601000000680600),
(449, 0xb37f707b0601000000660600),
(449, 0xb67f727b0601000000bb0900),
(449, 0xb67f737b0601000000bc0900),
(449, 0xb77f727b0601000000bb0900),
(449, 0xb77f737b0601000000bc0900),
(450, 0xad7f797b0601000000bb0900),
(450, 0xad7f7a7b0601000000bc0900),
(450, 0xb07f7d7b0601000000680600),
(451, 0xcf7f7f7b0601000000b90900),
(451, 0xd07f7f7b0601000000ba0900),
(451, 0xcf7f827b0601000000bb0900),
(451, 0xcf7f837b0601000000bc0900),
(451, 0xcd7f847b0601000000680600),
(451, 0xd07f827b0601000000bb0900),
(451, 0xd07f837b0601000000bc0900),
(452, 0x8a7fb77b0801000000bb0900),
(452, 0x8a7fb87b0801000000bc0900),
(452, 0x8d7fb87b0801000000660600),
(453, 0x947fb77b0801000000bb0900),
(453, 0x917fb87b0801000000660600),
(453, 0x947fb87b0801000000bc0900),
(454, 0x8a7fbb7b0801000000bb0900),
(454, 0x8a7fbc7b0801000000bc0900),
(454, 0x8d7fbc7b0801000000660600),
(455, 0x947fbb7b0801000000bb0900),
(455, 0x917fbc7b0801000000660600),
(455, 0x947fbc7b0801000000bc0900),
(456, 0x8a7faf7b0901000000bb0900),
(456, 0x8a7fb07b0901000000bc0900),
(456, 0x8d7fb07b0901000000660600),
(457, 0x947faf7b0901000000bb0900),
(457, 0x917fb07b0901000000660600),
(457, 0x947fb07b0901000000bc0900),
(458, 0x8a7fb37b0901000000bb0900),
(458, 0x8a7fb47b0901000000bc0900),
(458, 0x8d7fb47b0901000000660600),
(459, 0x947fb37b0901000000bb0900),
(459, 0x917fb47b0901000000660600),
(459, 0x947fb47b0901000000bc0900),
(460, 0x8a7fb77b0901000000bb0900),
(460, 0x8a7fb87b0901000000bc0900),
(460, 0x8d7fb87b0901000000660600),
(461, 0x947fb77b0901000000bb0900),
(461, 0x917fb87b0901000000660600),
(461, 0x947fb87b0901000000bc0900),
(462, 0x8a7fbb7b0901000000bb0900),
(462, 0x8a7fbc7b0901000000bc0900),
(462, 0x8d7fbc7b0901000000660600),
(463, 0x947fbb7b0901000000bb0900),
(463, 0x917fbc7b0901000000660600),
(463, 0x947fbc7b0901000000bc0900),
(464, 0x8a7faf7b0a01000000bb0900),
(464, 0x8a7fb07b0a01000000bc0900),
(464, 0x8d7fb07b0a01000000660600),
(465, 0x947faf7b0a01000000bb0900),
(465, 0x917fb07b0a01000000660600),
(465, 0x947fb07b0a01000000bc0900),
(466, 0x8a7fb37b0a01000000bb0900),
(466, 0x8a7fb47b0a01000000bc0900),
(466, 0x8d7fb47b0a01000000660600),
(467, 0x947fb37b0a01000000bb0900),
(467, 0x917fb47b0a01000000660600),
(467, 0x947fb47b0a01000000bc0900),
(468, 0x8a7fb77b0a01000000bb0900),
(468, 0x8a7fb87b0a01000000bc0900),
(468, 0x8d7fb87b0a01000000660600),
(469, 0x947fb77b0a01000000bb0900),
(469, 0x917fb87b0a01000000660600),
(469, 0x947fb87b0a01000000bc0900),
(470, 0x8a7fbb7b0a01000000bb0900),
(470, 0x8a7fbc7b0a01000000bc0900),
(470, 0x8d7fbc7b0a01000000660600),
(471, 0x947fbb7b0a01000000bb0900),
(471, 0x917fbc7b0a01000000660600),
(471, 0x947fbc7b0a01000000bc0900),
(472, 0x4b7ff67f0701000000c70900),
(472, 0x4b7ff77f0701000000c80900),
(472, 0x4d7ff47f0701000000c90900),
(472, 0x4e7ff47f0701000000ca0900),
(472, 0x507ff77f07010000009e0600),
(473, 0x597ff37f0701000000c90900),
(473, 0x5a7ff37f0701000000ca0900),
(473, 0x597ff87f0701000000950600),
(474, 0x617fe07f0501000000bd0900),
(474, 0x627fe07f0501000000be0900),
(474, 0x627fe07f0601000000bb0900),
(474, 0x627fe17f0601000000bc0900),
(474, 0x637fe37f07010000009e0600),
(474, 0x617fe57f0501000000bd0900),
(474, 0x627fe57f0501000000be0900),
(474, 0x627fe47f0601000000bb0900),
(474, 0x627fe57f0601000000bc0900),
(475, 0x617ff07f0701000000c70900),
(475, 0x617ff17f0701000000c80900),
(475, 0x657ff07f0701000000220900),
(475, 0x677ff07f07010000009e0600),
(476, 0x617ff67f0701000000c70900),
(476, 0x617ff77f0701000000c80900),
(476, 0x657ff67f0701000000220900),
(476, 0x677ff67f07010000009e0600),
(477, 0x777ff57f07010000009e0600),
(477, 0x797ff57f0701000000220900),
(477, 0x7c7ff87f0701000000c70900),
(477, 0x7c7ff97f0701000000c80900),
(478, 0x7f7fee7f07010000009e0600),
(478, 0x807fe57f0601000000c70900),
(478, 0x807fe67f0601000000c80900),
(478, 0x857fe57f0601000000c70900),
(478, 0x857fe67f0601000000c80900),
(478, 0x807fe87f0601000000c70900),
(478, 0x807fe97f0601000000c80900),
(478, 0x837fea7f0601000000950600),
(478, 0x837fea7f0701000000950600),
(478, 0x857fe87f0601000000c70900),
(478, 0x857fe97f0601000000c80900),
(479, 0x287f1b800601000000c90900),
(479, 0x297f1b800601000000ca0900),
(479, 0x297f1e800601000000950600),
(480, 0x217f21800601000000c70900),
(480, 0x217f22800601000000c80900),
(480, 0x257f238006010000009e0600),
(481, 0x2d7f26800601000000c90900),
(481, 0x2e7f26800601000000ca0900),
(481, 0x307f258006010000009e0600),
(482, 0x287f2f800601000000b90900),
(482, 0x297f2f800601000000ba0900),
(482, 0x2b7f2e8006010000009e0600),
(483, 0x367f18800601000000c90900),
(483, 0x377f18800601000000ca0900),
(483, 0x3a7f1a8006010000009e0600),
(483, 0x367f1c800601000000c90900),
(483, 0x377f1c800601000000ca0900),
(484, 0x367f11800601000000c90900),
(484, 0x377f11800601000000ca0900),
(484, 0x3a7f138006010000009e0600),
(484, 0x367f14800601000000c90900),
(484, 0x377f14800601000000ca0900),
(485, 0x407f0e800601000000c70900),
(485, 0x407f0f800601000000c80900),
(485, 0x447f0e800601000000c70900),
(485, 0x447f0f800601000000c80900),
(485, 0x437f13800601000000950600),
(486, 0x4d7f0e800601000000b70900),
(486, 0x4d7f0f800601000000b80900),
(486, 0x527f0e800601000000b70900),
(486, 0x527f0f800601000000b80900),
(486, 0x4d7f16800501000000bd0900),
(486, 0x4e7f16800501000000be0900),
(486, 0x507f13800501000000950600),
(486, 0x507f10800601000000950600),
(486, 0x517f16800501000000bd0900),
(486, 0x527f16800501000000be0900),
(486, 0x507f17800601000000950600),
(487, 0x5f7f13800501000000b70900),
(487, 0x5f7f14800501000000b80900),
(487, 0x5d7f18800601000000950600),
(487, 0x617f13800501000000b70900),
(487, 0x607f15800501000000950600),
(487, 0x617f14800501000000b80900),
(488, 0x687f0e800601000000c70900),
(488, 0x687f0f800601000000c80900),
(488, 0x6a7f12800601000000950600),
(489, 0x717f0e800601000000c70900),
(489, 0x717f0f800601000000c80900),
(489, 0x747f108006010000009e0600),
(490, 0x7a7f0c800601000000c90900),
(490, 0x7b7f0c800601000000ca0900),
(490, 0x7c7f0c800601000000c90900),
(490, 0x7d7f0c800601000000ca0900),
(490, 0x7e7f0e8006010000009e0600),
(490, 0x827f0f800601000000950600),
(491, 0x8b7f0b800601000000c70900),
(491, 0x8b7f0c800601000000c80900),
(491, 0x8d7f0d800601000000950600),
(492, 0x947f03800601000000c90900),
(492, 0x957f03800601000000ca0900),
(492, 0x947f06800601000000c90900),
(492, 0x957f06800601000000ca0900),
(492, 0x977f058006010000009e0600),
(493, 0x9e7f01800601000000c70900),
(493, 0x9e7f02800601000000c80900),
(493, 0xa27f01800601000000c70900),
(493, 0xa27f02800601000000c80900),
(493, 0xa07f05800601000000950600),
(494, 0xa77ffe7f0601000000c70900),
(494, 0xa77fff7f0601000000c80900),
(494, 0xaa7ffe7f0601000000c70900),
(494, 0xaa7fff7f0601000000c80900),
(494, 0xa97f01800601000000950600),
(495, 0xa07f0a800601000000c90900),
(495, 0xa17f0a800601000000ca0900),
(495, 0xa27f0a800601000000c90900),
(495, 0xa37f0a800601000000ca0900),
(495, 0xa27f0e800601000000950600),
(496, 0x9a7f0d800501000000c70900),
(496, 0x9a7f0e800501000000c80900),
(496, 0x987f11800601000000950600),
(497, 0x3f7f1b8007010000009e0600),
(497, 0x447f19800701000000c70900),
(497, 0x447f1a800701000000c80900),
(497, 0x467f19800701000000c70900),
(497, 0x467f1a800701000000c80900),
(497, 0x437f1c8007010000009e0600),
(497, 0x457f1d800701000000c90900),
(497, 0x467f1d800701000000ca0900),
(498, 0x697f19800701000000c70900),
(498, 0x697f1a800701000000c80900),
(498, 0x697f1c800701000000c70900),
(498, 0x697f1d800701000000c80900),
(498, 0x6d7f1c8007010000009e0600),
(499, 0x867f158007010000009e0600),
(499, 0x8a7f17800701000000950600),
(499, 0x877f18800701000000c70900),
(499, 0x877f19800701000000c80900),
(499, 0x8b7f18800701000000c70900),
(499, 0x8b7f19800701000000c80900),
(500, 0x327f04800601000000c90900),
(500, 0x337f04800601000000ca0900),
(500, 0x377f078006010000009e0600),
(500, 0x327f09800601000000c90900),
(500, 0x337f09800601000000ca0900),
(501, 0x3b7ffb7f0601000000c90900),
(501, 0x3c7ffb7f0601000000ca0900),
(501, 0x3b7ffe7f0601000000c90900),
(501, 0x3c7ffe7f0601000000ca0900),
(501, 0x407ffe7f06010000009e0600),
(502, 0x467fff7f0601000000c70900),
(502, 0x4d7fff7f0601000000c70900),
(502, 0x467f00800601000000c80900),
(502, 0x467f02800601000000c70900),
(502, 0x467f03800601000000c80900),
(502, 0x4d7f00800601000000c80900),
(502, 0x4d7f02800601000000c70900),
(502, 0x4d7f03800601000000c80900),
(502, 0x4a7f04800601000000950600),
(503, 0x537ffe7f0601000000c70900),
(503, 0x537fff7f0601000000c80900),
(503, 0x597ffe7f0601000000bb0900),
(503, 0x597fff7f0601000000bc0900),
(503, 0x537f02800601000000c70900),
(503, 0x537f03800601000000c80900),
(503, 0x567f04800601000000950600),
(504, 0x687f00800501000000c70900),
(504, 0x687f01800501000000c80900),
(504, 0x637f05800501000000c90900),
(504, 0x647f05800501000000ca0900),
(504, 0x687f04800501000000c70900),
(504, 0x687f05800501000000c80900),
(504, 0x697f058006010000009e0600),
(505, 0x717fff7f0601000000bb0900),
(505, 0x757fff7f0601000000bb0900),
(505, 0x717f00800601000000bc0900),
(505, 0x757f00800601000000bc0900),
(505, 0x737f04800601000000950600),
(506, 0x777fff7f0601000000c70900),
(506, 0x797fff7f0601000000bd0900),
(506, 0x7a7fff7f0601000000be0900),
(506, 0x7c7fff7f0601000000c70900),
(506, 0x777f00800601000000c80900),
(506, 0x7c7f00800601000000c80900),
(506, 0x7a7f04800601000000950600),
(507, 0x847ff77f0501000000c70900),
(507, 0x867ff77f0501000000c90900),
(507, 0x877ff77f0501000000ca0900),
(507, 0x847ff77f0601000000c70900),
(507, 0x897ff77f0501000000c70900),
(507, 0x897ff77f0601000000c70900),
(507, 0x847ff87f0501000000c80900),
(507, 0x847ff97f0501000000c70900),
(507, 0x847ffa7f0501000000c80900),
(507, 0x877ffb7f0501000000950600),
(507, 0x847ff87f0601000000c80900),
(507, 0x877ffb7f0601000000950600),
(507, 0x897ff87f0501000000c80900),
(507, 0x897ff97f0501000000c70900),
(507, 0x897ffa7f0501000000c80900),
(507, 0x897ff87f0601000000c80900),
(507, 0x877f00800601000000950600),
(508, 0x947fef7f0501000000c70900),
(508, 0x907ff27f0501000000c70900),
(508, 0x907ff37f0501000000c80900),
(508, 0x947ff07f0501000000c80900),
(508, 0x947ff27f0501000000c70900),
(508, 0x947ff37f0501000000c80900),
(508, 0x957ff07f06010000009e0600),
(509, 0x9e7fe67f0501000000c90900),
(509, 0x9f7fe67f0501000000ca0900),
(509, 0x9b7fe87f0501000000950600),
(509, 0x9d7feb7f05010000009e0600),
(509, 0x9e7fe87f0501000000c90900),
(509, 0x9f7fe87f0501000000ca0900),
(509, 0x9f7fea7f0501000000c70900),
(509, 0x9f7feb7f0501000000c80900),
(509, 0xa07fea7f06010000009e0600),
(510, 0xa67fe47f0601000000c70900),
(510, 0xa67fe57f0601000000c80900),
(510, 0xa97fe47f0601000000c70900),
(510, 0xa97fe57f0601000000c80900),
(510, 0xa87fe87f0601000000950600),
(511, 0x9d7ff37f0601000000c90900),
(511, 0x9e7ff37f0601000000ca0900),
(511, 0x9d7ff67f0601000000c90900),
(511, 0x9e7ff67f0601000000ca0900),
(511, 0xa17ff57f06010000009e0600),
(512, 0xa67fef7f0601000000c70900),
(512, 0xa97fef7f0601000000c70900),
(512, 0xa67ff07f0601000000c80900),
(512, 0xa87ff37f0601000000950600),
(512, 0xa97ff07f0601000000c80900),
(513, 0xb37ff17f0601000000c70900),
(513, 0xb37ff27f0601000000c80900),
(513, 0xb27ff47f0601000000950600),
(514, 0x207ffb7f0601000000b70900),
(514, 0x277ffb7f0501000000c90900),
(514, 0x267ffb7f0601000000b70900),
(514, 0x287ffb7f0501000000ca0900),
(514, 0x297ffb7f0501000000c90900),
(514, 0x2a7ffb7f0501000000ca0900),
(514, 0x2a7ffb7f0601000000b70900),
(514, 0x207ffc7f0601000000b80900),
(514, 0x227ffd7f0601000000950600),
(514, 0x267ffe7f05010000009e0600),
(514, 0x257ffd7f0601000000950600),
(514, 0x267ffc7f0601000000b80900),
(514, 0x287ffd7f0501000000c70900),
(514, 0x287ffe7f0501000000c80900),
(514, 0x297ffd7f0501000000c70900),
(514, 0x297ffe7f0501000000c80900),
(514, 0x297ffd7f0601000000950600),
(514, 0x2a7ffc7f0601000000b80900),
(514, 0x2b7fff7f06010000009e0600),
(514, 0x207f02800601000000bb0900),
(514, 0x207f03800601000000bc0900),
(514, 0x227f00800601000000950600),
(514, 0x227f02800601000000bb0900),
(514, 0x227f03800601000000bc0900),
(514, 0x267f038005010000009e0600),
(514, 0x277f00800501000000c90900),
(514, 0x247f02800601000000bb0900),
(514, 0x247f03800601000000bc0900),
(514, 0x267f02800601000000bb0900),
(514, 0x267f03800601000000bc0900),
(514, 0x287f00800501000000ca0900),
(514, 0x297f00800501000000c90900),
(514, 0x2a7f00800501000000ca0900),
(514, 0x287f00800601000000950600),
(514, 0x287f02800601000000bb0900),
(514, 0x287f03800601000000bc0900),
(514, 0x2a7f02800601000000bb0900),
(514, 0x2a7f03800601000000bc0900),
(515, 0x927f1b800601000000c70900),
(515, 0x937f19800601000000c90900),
(515, 0x927f19800701000000c90900),
(515, 0x927f1b800701000000c90900),
(515, 0x937f19800701000000ca0900),
(515, 0x937f1b800701000000ca0900),
(515, 0x947f1b800501000000b70900),
(515, 0x967f1a800501000000950600),
(515, 0x947f19800601000000ca0900),
(515, 0x957f1b800601000000c70900),
(515, 0x977f19800601000000c70900),
(515, 0x977f1a800601000000c80900),
(515, 0x977f1b800601000000c70900),
(515, 0x967f1a8007010000009e0600),
(515, 0x997f1b800501000000b70900),
(515, 0x9b7f1a800501000000950600),
(515, 0x997f19800601000000c70900),
(515, 0x997f1a800601000000c80900),
(515, 0x9b7f19800601000000c70900),
(515, 0x9b7f1a800601000000c80900),
(515, 0x9b7f1b800601000000c70900),
(515, 0x987f18800701000000950600),
(515, 0x997f18800701000000950600),
(515, 0x9b7f1a8007010000009e0600),
(515, 0x927f1c800601000000c80900),
(515, 0x947f1c800501000000b80900),
(515, 0x947f1e800501000000b70900),
(515, 0x947f1f800501000000b80900),
(515, 0x977f1e800501000000b70900),
(515, 0x977f1f800501000000b80900),
(515, 0x947f1d800601000000950600),
(515, 0x957f1c800601000000c80900),
(515, 0x977f1c800601000000c80900),
(515, 0x997f1c800501000000b80900),
(515, 0x997f1e800501000000b70900),
(515, 0x997f1f800501000000b80900),
(515, 0x9a7f1d800601000000950600),
(515, 0x9b7f1c800601000000c80900),
(515, 0x997f1c800701000000950600),
(515, 0x9c7f1e800501000000b70900),
(515, 0x9c7f1f800501000000b80900),
(515, 0x927f21800601000000c70900),
(515, 0x927f22800601000000c80900),
(515, 0x937f20800601000000950600),
(515, 0x967f20800501000000950600),
(515, 0x967f20800601000000950600),
(515, 0x977f21800601000000c70900),
(515, 0x977f22800601000000c80900),
(515, 0x9b7f20800501000000950600),
(515, 0x997f21800601000000c70900),
(515, 0x997f22800601000000c80900),
(515, 0x9b7f20800601000000950600),
(515, 0x9c7f21800601000000c70900),
(515, 0x9c7f22800601000000c80900),
(516, 0xd67fad7f0501000000c90900),
(516, 0xd67faf7f0501000000c90900),
(516, 0xd77fad7f0501000000ca0900),
(516, 0xd77faf7f0501000000ca0900),
(516, 0xd77faf7f0601000000c90900),
(516, 0xda7fad7f0501000000c90900),
(516, 0xdb7fad7f0501000000ca0900),
(516, 0xdb7faf7f0501000000950600),
(516, 0xd87faf7f0601000000ca0900),
(516, 0xda7faf7f0601000000c90900),
(516, 0xdb7faf7f0601000000ca0900),
(516, 0xe07fac7f0501000000c70900),
(516, 0xe07fad7f0501000000c80900),
(516, 0xe27fac7f0501000000c70900),
(516, 0xe27fad7f0501000000c80900),
(516, 0xe37faf7f0601000000c70900),
(516, 0xe47fac7f0501000000c70900),
(516, 0xe47fad7f0501000000c80900),
(516, 0xe67fac7f0501000000c70900),
(516, 0xe67fad7f0501000000c80900),
(516, 0xe57faf7f0601000000c70900),
(516, 0xd77fb17f0601000000c90900),
(516, 0xd77fb37f0601000000c90900),
(516, 0xd87fb17f0601000000ca0900),
(516, 0xd87fb37f0601000000ca0900),
(516, 0xd67fb57f0501000000c90900),
(516, 0xd67fb77f0501000000c90900),
(516, 0xd77fb57f0501000000ca0900),
(516, 0xd77fb77f0501000000ca0900),
(516, 0xd97fb77f05010000009e0600),
(516, 0xd67fb87f0501000000c90900),
(516, 0xd67fba7f0501000000c90900),
(516, 0xd77fb87f0501000000ca0900),
(516, 0xd77fba7f0501000000ca0900),
(516, 0xd87fb87f0601000000c90900),
(516, 0xd87fbb7f0601000000c90900),
(516, 0xd97fb87f0601000000ca0900),
(516, 0xd97fbb7f0601000000ca0900),
(516, 0xdd7fb87f0601000000c70900),
(516, 0xdd7fb97f0601000000c80900),
(516, 0xe37fb07f0601000000c80900),
(516, 0xe67fb07f0501000000950600),
(516, 0xe57fb07f0601000000c80900),
(516, 0xe07fbb7f0501000000c70900),
(516, 0xe37fb97f0501000000950600),
(516, 0xe47fbb7f0501000000c70900),
(516, 0xea7fb97f07010000009e0600),
(516, 0xe07fbc7f0501000000c80900),
(516, 0xe17fbc7f0501000000c90900),
(516, 0xe27fbc7f0501000000ca0900),
(516, 0xe47fbc7f0501000000c80900),
(517, 0xbe812f7c0701000000b70900),
(517, 0xb681327c0701000000660600),
(517, 0xb981327c0701000000220900),
(517, 0xbc81337c0701000000660600),
(517, 0xbe81307c0701000000b80900),
(517, 0xbf81337c0701000000660600),
(518, 0xbe81367c0701000000b70900),
(518, 0xbe81377c0701000000b80900),
(518, 0xb681397c0701000000660600),
(518, 0xb981397c0701000000220900),
(518, 0xbc813a7c0701000000660600),
(518, 0xbf813a7c0701000000660600),
(519, 0xbe813d7c0701000000b70900),
(519, 0xbe813e7c0701000000b80900),
(519, 0xb681407c0701000000660600),
(519, 0xb981407c0701000000220900),
(519, 0xbc81417c0701000000660600),
(519, 0xbf81417c0701000000660600),
(520, 0x9381497c0501000000660600),
(520, 0x96814a7c0501000000bd0900),
(520, 0x97814a7c0501000000be0900),
(521, 0x9381447c0501000000660600),
(521, 0x9681467c0501000000bd0900),
(521, 0x9781467c0501000000be0900),
(522, 0x8d81467c0501000000bd0900),
(522, 0x8e81467c0501000000be0900),
(522, 0x9081447c0501000000660600),
(523, 0x90813f7c0501000000660600),
(523, 0x8d81417c0501000000bd0900),
(523, 0x8e81417c0501000000be0900),
(524, 0x93813f7c0501000000660600),
(524, 0x9681417c0501000000bd0900),
(524, 0x9781417c0501000000be0900),
(525, 0x93813a7c0501000000660600),
(525, 0x9681387c0501000000bd0900),
(525, 0x9781387c0501000000be0900),
(525, 0x96813c7c0501000000bd0900),
(525, 0x97813c7c0501000000be0900),
(526, 0x8d813c7c0501000000bd0900),
(526, 0x8e813c7c0501000000be0900),
(526, 0x90813a7c0501000000660600),
(527, 0x9381497c0401000000660600),
(527, 0x96814a7c0401000000bd0900),
(527, 0x97814a7c0401000000be0900),
(528, 0x9381447c0401000000660600),
(528, 0x9681467c0401000000bd0900),
(528, 0x9781467c0401000000be0900),
(529, 0x8d81467c0401000000bd0900),
(529, 0x8e81467c0401000000be0900),
(529, 0x9081447c0401000000660600),
(530, 0x90813f7c0401000000660600),
(530, 0x8d81417c0401000000bd0900),
(530, 0x8e81417c0401000000be0900),
(531, 0x93813f7c0401000000660600),
(531, 0x9681417c0401000000bd0900),
(531, 0x9781417c0401000000be0900),
(532, 0x93813a7c0401000000660600),
(532, 0x96813c7c0401000000bd0900),
(532, 0x97813c7c0401000000be0900),
(533, 0x8d813c7c0401000000bd0900),
(533, 0x8e813c7c0401000000be0900),
(533, 0x90813a7c0401000000660600),
(534, 0x8f81327c0401000000660600),
(534, 0x9381337c0401000000bd0900),
(534, 0x9481337c0401000000be0900),
(535, 0x8f812d7c0401000000660600),
(535, 0x93812c7c0401000000bd0900),
(535, 0x94812c7c0401000000be0900),
(536, 0xb381297c0801000000b70900),
(536, 0xb3812a7c0801000000b80900),
(536, 0xb4812d7c0801000000680600),
(537, 0xb381337c0801000000b70900),
(537, 0xb481307c0801000000680600),
(537, 0xb381347c0801000000b80900),
(538, 0xb781337c0801000000b70900),
(538, 0xb881307c0801000000680600),
(538, 0xb781347c0801000000b80900),
(539, 0xbb81337c0801000000b70900),
(539, 0xbc81307c0801000000680600),
(539, 0xbb81347c0801000000b80900),
(540, 0xbb81297c0801000000b70900),
(540, 0xbb812a7c0801000000b80900),
(540, 0xbc812d7c0801000000680600),
(541, 0xbf81297c0801000000b70900),
(541, 0xbf812a7c0801000000b80900),
(541, 0xc0812d7c0801000000680600),
(542, 0xbf81337c0801000000b70900),
(542, 0xbf81347c0801000000b80900),
(542, 0xc081307c0801000000680600),
(543, 0xc381337c0801000000b70900),
(543, 0xc481307c0801000000680600),
(543, 0xc381347c0801000000b80900),
(544, 0xc381297c0801000000b70900),
(544, 0xc3812a7c0801000000b80900),
(544, 0xc4812d7c0801000000680600),
(545, 0x8c815a7c0601000000bd0900),
(545, 0x8d815a7c0601000000be0900),
(545, 0x8e815b7c0701000000660600),
(545, 0x8c815d7c0601000000b70900),
(545, 0x8c815e7c0601000000b80900),
(545, 0x8d815d7c0601000000b70900),
(545, 0x8d815e7c0601000000b80900),
(546, 0x8381367c0701000000660600),
(546, 0x8781347c0701000000bd0900),
(546, 0x8781357c0701000000bd0900),
(546, 0x8881347c0701000000be0900),
(546, 0x8881357c0701000000be0900),
(547, 0x7781367c0701000000b70900),
(547, 0x7781377c0701000000b80900),
(547, 0x7881367c0701000000b70900),
(547, 0x7881377c0701000000b80900),
(547, 0x7d81357c0701000000660600),
(548, 0x8481287c0701000000bd0900),
(548, 0x8481297c0701000000bd0900),
(548, 0x8581287c0701000000be0900),
(548, 0x8581297c0701000000be0900),
(548, 0x83812e7c0701000000680600),
(549, 0x7f81217c0701000000bd0900),
(549, 0x7f81227c0701000000bd0900),
(549, 0x7c81277c0701000000680600),
(549, 0x8081217c0701000000be0900),
(549, 0x8081227c0701000000be0900),
(550, 0xa481607c0701000000b70900),
(550, 0xa481617c0701000000b80900),
(550, 0xa581637c0701000000680600),
(551, 0xa581667c0701000000680600),
(551, 0xa181687c0701000000b70900),
(551, 0xa181697c0701000000b80900),
(551, 0xa281687c0701000000b70900),
(551, 0xa281697c0701000000b80900),
(552, 0x9f81667c0701000000680600),
(552, 0x9d81687c0701000000b70900),
(552, 0x9d81697c0701000000b80900),
(553, 0x9d81607c0701000000b70900),
(553, 0x9d81617c0701000000b80900),
(553, 0x9f81637c0701000000680600),
(554, 0x9981607c0701000000b70900),
(554, 0x9981617c0701000000b80900),
(554, 0x9b81637c0701000000680600),
(555, 0x9b81667c0701000000680600),
(555, 0x9981687c0701000000b70900),
(555, 0x9981697c0701000000b80900),
(556, 0x9781667c0701000000680600),
(556, 0x9581687c0701000000b70900),
(556, 0x9581697c0701000000b80900),
(557, 0x9581607c0701000000b70900),
(557, 0x9581617c0701000000b80900),
(557, 0x9781637c0701000000680600),
(558, 0xa481607c0601000000b70900),
(558, 0xa481617c0601000000b80900),
(558, 0xa581637c0601000000680600),
(559, 0xa581667c0601000000680600),
(559, 0xa481687c0601000000b70900),
(559, 0xa481697c0601000000b80900),
(560, 0x9f81667c0601000000680600),
(560, 0x9d81687c0601000000b70900),
(560, 0x9d81697c0601000000b80900),
(561, 0x9d81607c0601000000b70900),
(561, 0x9d81617c0601000000b80900),
(561, 0x9f81637c0601000000680600),
(562, 0x9981607c0601000000b70900),
(562, 0x9981617c0601000000b80900),
(562, 0x9b81637c0601000000680600),
(563, 0x9b81667c0601000000680600),
(563, 0x9981687c0601000000b70900),
(563, 0x9981697c0601000000b80900),
(564, 0x9781667c0601000000680600),
(564, 0x9581687c0601000000b70900),
(564, 0x9581697c0601000000b80900),
(565, 0x9581607c0601000000b70900),
(565, 0x9581617c0601000000b80900),
(565, 0x9781637c0601000000680600),
(566, 0xa181607c0501000000b70900),
(566, 0xa181617c0501000000b80900),
(566, 0xa581637c0501000000680600),
(566, 0xa681607c0501000000b70900),
(566, 0xa681617c0501000000b80900),
(567, 0xa581667c0501000000680600),
(567, 0xa481687c0501000000b70900),
(567, 0xa481697c0501000000b80900),
(568, 0x9f81667c0501000000680600),
(568, 0x9d81687c0501000000b70900),
(568, 0x9d81697c0501000000b80900),
(569, 0x9d81607c0501000000b70900),
(569, 0x9d81617c0501000000b80900),
(569, 0x9f81637c0501000000680600),
(570, 0x9981607c0501000000b70900),
(570, 0x9981617c0501000000b80900),
(570, 0x9b81637c0501000000680600),
(571, 0x9b81667c0501000000680600),
(571, 0x9981687c0501000000b70900),
(571, 0x9981697c0501000000b80900),
(572, 0x9781667c0501000000680600),
(572, 0x9581687c0501000000b70900),
(572, 0x9581697c0501000000b80900),
(573, 0x9581607c0501000000b70900),
(573, 0x9581617c0501000000b80900),
(573, 0x9781637c0501000000680600),
(574, 0xa381627c0801000000680600),
(574, 0xa281687c0801000000b70900),
(574, 0xa281697c0801000000b80900),
(574, 0xa381687c0801000000b70900),
(574, 0xa381697c0801000000b80900),
(575, 0x9f81627c0801000000680600),
(575, 0x9f81687c0801000000b70900),
(575, 0x9f81697c0801000000b80900),
(575, 0xa081687c0801000000b70900),
(575, 0xa081697c0801000000b80900),
(576, 0xb4815b7c0701000000660600),
(576, 0xb6815a7c0701000000b70900),
(576, 0xb6815b7c0701000000b80900),
(576, 0xb4815e7c0701000000660600),
(576, 0xb6815d7c0701000000b70900),
(576, 0xb6815e7c0701000000b80900),
(576, 0xb381607c0701000000680600),
(577, 0xbb815b7c0701000000660600),
(577, 0xbd815a7c0701000000b70900),
(577, 0xbd815b7c0701000000b80900),
(577, 0xbb815e7c0701000000660600),
(577, 0xbd815d7c0701000000b70900),
(577, 0xbd815e7c0701000000b80900),
(577, 0xba81607c0701000000680600),
(578, 0xae816b7c0601000000660600),
(578, 0xad816b7c0801000000660600),
(578, 0xad816c7c0601000000680600),
(578, 0xad816e7c0801000000660600),
(578, 0xb1816a7c0601000000b70900),
(578, 0xb1816b7c0601000000b80900),
(578, 0xb181697c0701000000680600),
(578, 0xb0816b7c0801000000b70900),
(578, 0xb1816b7c0801000000b70900),
(578, 0xb0816e7c0601000000b70900),
(578, 0xb0816f7c0601000000b80900),
(578, 0xb1816e7c0601000000b70900),
(578, 0xb1816f7c0601000000b80900),
(578, 0xb0816c7c0801000000b80900),
(578, 0xb1816c7c0801000000b80900),
(579, 0xb5816b7c0601000000660600),
(579, 0xb4816b7c0801000000660600),
(579, 0xb7816b7c0801000000b70900),
(579, 0xb8816a7c0601000000b70900),
(579, 0xb8816b7c0601000000b80900),
(579, 0xb881697c0701000000680600),
(579, 0xb8816b7c0801000000b70900),
(579, 0xb4816c7c0601000000680600),
(579, 0xb7816e7c0601000000b70900),
(579, 0xb7816f7c0601000000b80900),
(579, 0xb4816e7c0801000000660600),
(579, 0xb7816c7c0801000000b80900),
(579, 0xb8816e7c0601000000b70900),
(579, 0xb8816f7c0601000000b80900),
(579, 0xb8816c7c0801000000b80900),
(580, 0xbb816b7c0801000000660600),
(580, 0xbc816b7c0601000000660600),
(580, 0xbf816a7c0601000000b70900),
(580, 0xbf816b7c0601000000b80900),
(580, 0xbf81697c0701000000680600),
(580, 0xbe816b7c0801000000b70900),
(580, 0xbf816b7c0801000000b70900),
(580, 0xbb816c7c0601000000680600),
(580, 0xbb816e7c0801000000660600),
(580, 0xbe816e7c0601000000b70900),
(580, 0xbe816f7c0601000000b80900),
(580, 0xbf816e7c0601000000b70900),
(580, 0xbf816f7c0601000000b80900),
(580, 0xbe816c7c0801000000b80900),
(580, 0xbf816c7c0801000000b80900),
(581, 0xbb81737c0701000000680600),
(581, 0xbc81737c0601000000680600),
(581, 0xbf81737c0601000000680600),
(581, 0xbc81727c0701000000660600),
(581, 0xba81747c0601000000bd0900),
(581, 0xba81767c0601000000bd0900),
(581, 0xbb81747c0601000000be0900),
(581, 0xbb81767c0601000000be0900),
(581, 0xbc81767c0701000000660600),
(581, 0xbe81777c0701000000680600),
(582, 0xb581737c0601000000680600),
(582, 0xb481737c0701000000680600),
(582, 0xb581727c0701000000660600),
(582, 0xb881737c0601000000680600),
(582, 0xb381747c0601000000bd0900),
(582, 0xb381767c0601000000bd0900),
(582, 0xb481747c0601000000be0900),
(582, 0xb481767c0601000000be0900),
(582, 0xb581767c0701000000660600),
(582, 0xb781777c0701000000680600),
(583, 0xae81737c0601000000680600),
(583, 0xad81737c0701000000680600),
(583, 0xae81727c0701000000660600),
(583, 0xac81747c0601000000bd0900),
(583, 0xac81767c0601000000bd0900),
(583, 0xad81747c0601000000be0900),
(583, 0xad81767c0601000000be0900),
(583, 0xae81767c0701000000660600),
(583, 0xb181737c0601000000680600),
(583, 0xb081777c0701000000680600),
(584, 0xa4817a7c0701000000bd0900),
(584, 0xa4817b7c0701000000bd0900),
(584, 0xa5817a7c0701000000be0900),
(584, 0xa5817b7c0701000000be0900),
(584, 0xa681787c0701000000660600),
(585, 0xa4817a7c0601000000bd0900),
(585, 0xa4817b7c0601000000bd0900),
(585, 0xa5817a7c0601000000be0900),
(585, 0xa5817b7c0601000000be0900),
(585, 0xa681787c0601000000660600),
(586, 0xcf81327c0701000000bd0900),
(586, 0xcf81337c0701000000bd0900),
(586, 0xce81387c0701000000680600),
(586, 0xd081327c0701000000be0900),
(586, 0xd081337c0701000000be0900),
(587, 0xcd81427c0701000000660600),
(587, 0xd281437c0701000000bd0900),
(587, 0xd381437c0701000000be0900),
(587, 0xd281447c0701000000bd0900),
(587, 0xd381447c0701000000be0900),
(588, 0xca81497c0701000000660600),
(588, 0xcf814a7c0701000000b70900),
(588, 0xcf814b7c0701000000b80900),
(588, 0xd0814a7c0701000000b70900),
(588, 0xd0814b7c0701000000b80900),
(589, 0xd2814a7c0701000000b70900),
(589, 0xd2814b7c0701000000b80900),
(589, 0xd3814a7c0701000000b70900),
(589, 0xd3814b7c0701000000b80900),
(589, 0xd5814c7c0701000000680600),
(590, 0xd781577c0701000000660600),
(590, 0xdc81587c0701000000bd0900),
(590, 0xdc81597c0701000000bd0900),
(590, 0xdd81587c0701000000be0900),
(590, 0xdd81597c0701000000be0900),
(591, 0xc581637c0701000000b70900),
(591, 0xc981627c0701000000680600),
(591, 0xc581647c0701000000b80900),
(591, 0xc581667c0701000000b70900),
(591, 0xc581677c0701000000b80900),
(591, 0xc781677c0701000000660600),
(591, 0xc881647c0701000000660600),
(592, 0xc581637c0601000000b70900),
(592, 0xcb81637c0601000000660600),
(592, 0xc581647c0601000000b80900),
(592, 0xc581667c0601000000b70900),
(592, 0xc581677c0601000000b80900),
(592, 0xc781677c0601000000660600),
(592, 0xc881647c0601000000660600),
(593, 0xd381677c0601000000680600),
(593, 0xd081677c0701000000660600),
(593, 0xd481667c0601000000660600),
(593, 0xd681657c0601000000b70900),
(593, 0xd681667c0601000000b80900),
(593, 0xd781677c0701000000660600),
(593, 0xd581677c0801000000680600),
(593, 0xd581697c0601000000bd0900),
(593, 0xd5816a7c0601000000bd0900),
(593, 0xd681697c0601000000be0900),
(593, 0xd6816a7c0601000000be0900),
(594, 0xd3816e7c0601000000680600),
(594, 0xd0816e7c0701000000660600),
(594, 0xd4816d7c0601000000660600),
(594, 0xd6816c7c0601000000b70900),
(594, 0xd6816d7c0601000000b80900),
(594, 0xd7816e7c0701000000660600),
(594, 0xd5816e7c0801000000680600),
(594, 0xd581707c0601000000bd0900),
(594, 0xd581717c0601000000bd0900),
(594, 0xd681707c0601000000be0900),
(594, 0xd681717c0601000000be0900),
(595, 0xc8816a7c0701000000b70900),
(595, 0xc8816b7c0701000000b80900),
(595, 0xca816a7c0701000000b70900),
(595, 0xca816b7c0701000000b80900),
(595, 0xc9816c7c0701000000680600),
(595, 0xcb816e7c0701000000660600),
(596, 0xcb816a7c0601000000660600),
(596, 0xc8816e7c0601000000b70900),
(596, 0xc8816f7c0601000000b80900),
(596, 0xc9816c7c0601000000680600),
(596, 0xca816e7c0601000000b70900),
(596, 0xca816f7c0601000000b80900),
(597, 0xcb81737c0701000000660600),
(597, 0xc881757c0701000000b70900),
(597, 0xc881767c0701000000b80900),
(597, 0xc981747c0701000000680600),
(597, 0xca81757c0701000000b70900),
(597, 0xca81767c0701000000b80900),
(598, 0xc881727c0601000000660600),
(598, 0xcb81717c0601000000660600),
(598, 0xc681757c0601000000b70900),
(598, 0xc681767c0601000000b80900),
(598, 0xc781757c0601000000b70900),
(598, 0xc781767c0601000000b80900),
(598, 0xc981767c0601000000bd0900),
(598, 0xca81747c0601000000680600),
(598, 0xca81767c0601000000be0900),
(599, 0xd081757c0701000000660600),
(599, 0xd581767c0601000000660600),
(599, 0xd581777c0701000000660600),
(599, 0xd1817b7c0601000000b70900),
(599, 0xd381787c0601000000680600),
(599, 0xd3817b7c0601000000b70900),
(599, 0xd181797c0701000000bd0900),
(599, 0xd281797c0701000000be0900),
(599, 0xd4817b7c0701000000660600),
(599, 0xd881787c0601000000680600),
(599, 0xd8817b7c0601000000bd0900),
(599, 0xd9817b7c0601000000be0900),
(599, 0xd881787c0701000000680600),
(599, 0xd1817c7c0601000000b80900),
(599, 0xd3817c7c0601000000b80900),
(599, 0xd1817c7c0701000000bd0900),
(599, 0xd2817c7c0701000000be0900),
(599, 0xd8817c7c0601000000bd0900),
(599, 0xd9817c7c0601000000be0900),
(600, 0xcb814a7c0601000000b70900),
(600, 0xcb814b7c0601000000b80900),
(600, 0xcc814a7c0601000000b70900),
(600, 0xcc814b7c0601000000b80900),
(600, 0xd081497c0601000000660600),
(601, 0xd281497c0601000000660600),
(601, 0xd6814a7c0601000000b70900),
(601, 0xd6814b7c0601000000b80900),
(601, 0xd7814a7c0601000000b70900),
(601, 0xd7814b7c0601000000b80900),
(602, 0xce813f7c0601000000bd0900),
(602, 0xcf813f7c0601000000be0900),
(602, 0xce81417c0601000000bd0900),
(602, 0xcf81417c0601000000be0900),
(602, 0xd181457c0601000000680600),
(603, 0xba817c7c0501000000b70900),
(603, 0xba817d7c0501000000b80900),
(603, 0xba817c7c0701000000b70900),
(603, 0xba817d7c0701000000b80900),
(603, 0xba817f7c0701000000b70900),
(603, 0xbb817c7c0801000000b70900),
(603, 0xbb817d7c0801000000b80900),
(603, 0xbb817e7c0801000000b70900),
(603, 0xbb817f7c0801000000b80900),
(603, 0xbc817f7c0501000000680600),
(603, 0xbe817c7c0501000000b70900),
(603, 0xbe817d7c0501000000b80900),
(603, 0xbf817f7c0501000000680600),
(603, 0xbe817d7c0701000000660600),
(603, 0xbe817d7c0801000000660600),
(603, 0xc0817d7c0701000000660600),
(603, 0xba81837c0501000000bd0900),
(603, 0xbb81817c0501000000660600),
(603, 0xbb81837c0501000000be0900),
(603, 0xba81807c0701000000b80900),
(603, 0xba81827c0701000000bd0900),
(603, 0xbb81827c0701000000be0900);
INSERT INTO `tile_store` (`house_id`, `data`) VALUES
(603, 0xbb81807c0801000000b70900),
(603, 0xbb81817c0801000000b80900),
(603, 0xbb81837c0801000000b70900),
(603, 0xbd81827c0501000000680600),
(603, 0xbe81807c0701000000660600),
(603, 0xbc81807c0801000000b70900),
(603, 0xbc81817c0801000000b80900),
(603, 0xbc81837c0801000000b70900),
(603, 0xbe81807c0801000000b70900),
(603, 0xbe81817c0801000000b80900),
(603, 0xbe81837c0801000000b70900),
(603, 0xbf81807c0801000000b70900),
(603, 0xbf81817c0801000000b80900),
(603, 0xbf81837c0801000000b70900),
(603, 0xba81857c0501000000bd0900),
(603, 0xbb81857c0501000000be0900),
(603, 0xba81857c0701000000bd0900),
(603, 0xbb81857c0701000000be0900),
(603, 0xbb81847c0801000000b80900),
(603, 0xbe81847c0701000000660600),
(603, 0xbc81847c0801000000b80900),
(603, 0xbe81847c0801000000b80900),
(603, 0xbf81847c0801000000b80900),
(603, 0xc281827c0501000000680600),
(603, 0xc181807c0801000000b70900),
(603, 0xc181817c0801000000b80900),
(603, 0xc181837c0801000000b70900),
(603, 0xc281807c0801000000b70900),
(603, 0xc281817c0801000000b80900),
(603, 0xc281837c0801000000b70900),
(603, 0xc481827c0701000000660600),
(603, 0xc381847c0501000000b70900),
(603, 0xc381857c0501000000b80900),
(603, 0xc181847c0801000000b80900),
(603, 0xc281847c0801000000b80900),
(604, 0xcb81847c0701000000660600),
(604, 0xcd81867c0501000000680600),
(604, 0xcf81857c0601000000660600),
(604, 0xce81877c0801000000680600),
(604, 0xcf81857c0801000000660600),
(604, 0xcc818b7c0501000000bd0900),
(604, 0xcd818b7c0501000000be0900),
(604, 0xcf818a7c0601000000660600),
(604, 0xcc818b7c0701000000bd0900),
(604, 0xcd818b7c0701000000be0900),
(604, 0xcf818a7c0701000000660600),
(604, 0xcd81897c0801000000b70900),
(604, 0xcd818a7c0801000000b80900),
(604, 0xce81897c0801000000b70900),
(604, 0xce818a7c0801000000b80900),
(604, 0xd581827c0701000000b70900),
(604, 0xd581837c0701000000b80900),
(604, 0xd281847c0501000000680600),
(604, 0xd281867c0501000000680600),
(604, 0xd181847c0701000000680600),
(604, 0xd281877c0701000000660600),
(604, 0xd381857c0701000000bd0900),
(604, 0xd581847c0501000000b70900),
(604, 0xd581857c0501000000b80900),
(604, 0xd481857c0701000000be0900),
(604, 0xd2818a7c0701000000660600),
(604, 0xd3818b7c0701000000bd0900),
(604, 0xd081897c0801000000b70900),
(604, 0xd0818a7c0801000000b80900),
(604, 0xd181897c0801000000b70900),
(604, 0xd1818a7c0801000000b80900),
(604, 0xd381897c0801000000b70900),
(604, 0xd3818a7c0801000000b80900),
(604, 0xd4818a7c0501000000b70900),
(604, 0xd4818b7c0501000000b80900),
(604, 0xd5818a7c0501000000b70900),
(604, 0xd5818b7c0501000000b80900),
(604, 0xd4818b7c0701000000be0900),
(604, 0xd481897c0801000000b70900),
(604, 0xd4818a7c0801000000b80900),
(605, 0xc981937c0601000000b70900),
(605, 0xcb81937c0601000000b70900),
(605, 0xcd81937c0601000000b70900),
(605, 0xcf81937c0601000000b70900),
(605, 0xce81927c0701000000680600),
(605, 0xc981957c0501000000b70900),
(605, 0xc981967c0501000000b80900),
(605, 0xca81957c0501000000b70900),
(605, 0xca81967c0501000000b80900),
(605, 0xcb81957c0501000000b70900),
(605, 0xcb81967c0501000000b80900),
(605, 0xc981947c0601000000b80900),
(605, 0xca81977c0601000000680600),
(605, 0xcb81947c0601000000b80900),
(605, 0xc981957c0701000000bd0900),
(605, 0xc981977c0701000000bd0900),
(605, 0xca81957c0701000000be0900),
(605, 0xca81977c0701000000be0900),
(605, 0xcc81957c0501000000b70900),
(605, 0xcc81967c0501000000b80900),
(605, 0xcd81957c0501000000b70900),
(605, 0xcd81967c0501000000b80900),
(605, 0xce81957c0501000000b70900),
(605, 0xce81967c0501000000b80900),
(605, 0xcf81957c0501000000b70900),
(605, 0xcf81967c0501000000b80900),
(605, 0xcd81947c0601000000b80900),
(605, 0xce81977c0601000000680600),
(605, 0xcf81947c0601000000b80900),
(605, 0xcc81957c0701000000660600),
(605, 0xca81997c0601000000680600),
(605, 0xc981997c0701000000bd0900),
(605, 0xc9819a7c0701000000bd0900),
(605, 0xca81997c0701000000be0900),
(605, 0xca819a7c0701000000be0900),
(605, 0xce81997c0601000000680600),
(605, 0xcc81987c0701000000660600),
(605, 0xce81997c0701000000680600),
(605, 0xc9819c7c0601000000bd0900),
(605, 0xca819c7c0601000000be0900),
(605, 0xc9819c7c0701000000bd0900),
(605, 0xca819c7c0701000000be0900),
(605, 0xcd819c7c0601000000bd0900),
(605, 0xce819c7c0601000000be0900),
(605, 0xd081947c0501000000660600),
(605, 0xd281997c0601000000680600),
(606, 0xdb818f7c0401000000b70900),
(606, 0xdb818f7c0501000000b70900),
(606, 0xdc818f7c0401000000b70900),
(606, 0xdc818c7c0501000000660600),
(606, 0xdc818f7c0501000000b70900),
(606, 0xdd818e7c0601000000680600),
(606, 0xde818f7c0601000000bd0900),
(606, 0xdf818f7c0601000000be0900),
(606, 0xdb81907c0401000000b80900),
(606, 0xdb81907c0501000000b80900),
(606, 0xdc81907c0401000000b80900),
(606, 0xdc81907c0501000000b80900),
(606, 0xde81907c0601000000bd0900),
(606, 0xdf81907c0601000000be0900),
(606, 0xdd81917c0701000000680600),
(607, 0xf9814f7c0301000000bd0900),
(607, 0xfa814f7c0301000000be0900),
(607, 0xfb814f7c0401000000680600),
(607, 0xfb814f7c0501000000680600),
(607, 0xfb814f7c0801000000680600),
(607, 0xfd814d7c0301000000b70900),
(607, 0xfd814e7c0301000000b80900),
(607, 0xfe814f7c0301000000bd0900),
(607, 0xff814f7c0301000000be0900),
(607, 0xfd814f7c0401000000680600),
(607, 0xfd814f7c0501000000680600),
(607, 0xfd814f7c0801000000680600),
(607, 0xf981507c0301000000b70900),
(607, 0xf981517c0301000000b80900),
(607, 0xfa81517c0301000000b70900),
(607, 0xfa81527c0301000000b80900),
(607, 0xfb81527c0301000000b70900),
(607, 0xfb81537c0301000000b80900),
(607, 0xfb81527c0401000000b70900),
(607, 0xfb81537c0401000000b80900),
(607, 0xfb81527c0501000000b70900),
(607, 0xfb81537c0501000000b80900),
(607, 0xf881517c0601000000660600),
(607, 0xfc81527c0301000000b70900),
(607, 0xfc81537c0301000000b80900),
(607, 0xfd81527c0301000000b70900),
(607, 0xfd81537c0301000000b80900),
(607, 0xfe81517c0301000000b70900),
(607, 0xfe81527c0301000000b80900),
(607, 0xff81507c0301000000b70900),
(607, 0xff81517c0301000000b80900),
(607, 0xfd81527c0401000000b70900),
(607, 0xfd81537c0401000000b80900),
(607, 0xfd81527c0501000000b70900),
(607, 0xfd81537c0501000000b80900),
(608, 0xeb815f7c0801000000b70900),
(608, 0xe781607c0801000000220900),
(608, 0xeb81607c0801000000b80900),
(609, 0xff81597c0801000000bd0900),
(609, 0x0082597c0801000000be0900),
(609, 0x01825b7c0801000000660600),
(609, 0x0282597c0801000000680600),
(609, 0x02825c7c0801000000b70900),
(609, 0x02825d7c0801000000b80900),
(609, 0x03825c7c0801000000b70900),
(609, 0x03825d7c0801000000b80900),
(610, 0xff81597c0701000000b70900),
(610, 0xff815a7c0701000000b80900),
(610, 0x0282597c0701000000680600),
(610, 0x02825d7c0701000000bd0900),
(610, 0x03825d7c0701000000be0900),
(611, 0x0282597c0501000000680600),
(611, 0x02825d7c0501000000bd0900),
(611, 0x03825d7c0501000000be0900),
(612, 0xff81597c0401000000b70900),
(612, 0xff815a7c0401000000b80900),
(612, 0x0282597c0401000000680600),
(612, 0x02825d7c0401000000bd0900),
(612, 0x03825d7c0401000000be0900),
(613, 0x0282597c0301000000680600),
(613, 0x02825d7c0301000000bd0900),
(613, 0x03825d7c0301000000be0900),
(614, 0x0882157c0701000000660600),
(614, 0x0c82177c0701000000bd0900),
(614, 0x0d82177c0701000000be0900),
(614, 0x0e82157c0701000000660600),
(614, 0x0c82187c0701000000bd0900),
(614, 0x0d82187c0701000000be0900),
(615, 0x1f821d7c0601000000680600),
(615, 0x22821a7c0601000000b70900),
(615, 0x22821b7c0601000000b80900),
(616, 0x1882177c0601000000660600),
(616, 0x1482197c0601000000bd0900),
(616, 0x1582197c0601000000be0900),
(617, 0x11820f7c0601000000b70900),
(617, 0x12820f7c0601000000b70900),
(617, 0x15820f7c0601000000660600),
(617, 0x1182107c0601000000b80900),
(617, 0x1282107c0601000000b80900),
(618, 0x2e821c7c0601000000680600),
(618, 0x2b82207c0601000000b70900),
(618, 0x2b82217c0601000000b80900),
(618, 0x2c82207c0601000000b70900),
(618, 0x2c82217c0601000000b80900),
(619, 0x2e820f7c0601000000bd0900),
(619, 0x2f820f7c0601000000be0900),
(619, 0x2e82107c0601000000bd0900),
(619, 0x2f82107c0601000000be0900),
(619, 0x2e82157c0601000000680600),
(620, 0x1b82087c0701000000b70900),
(620, 0x1b82097c0701000000b80900),
(620, 0x1c82087c0701000000b70900),
(620, 0x1c82097c0701000000b80900),
(620, 0x2082097c0701000000660600),
(621, 0x2482047c0701000000bd0900),
(621, 0x2582047c0701000000be0900),
(621, 0x2682087c0701000000680600),
(622, 0x2e82067c0701000000b70900),
(622, 0x2e82077c0701000000b80900),
(622, 0x2c820a7c0701000000680600),
(623, 0x1282217c0701000000b70900),
(623, 0x1282227c0701000000b80900),
(623, 0x1382247c0701000000680600),
(624, 0x1382277c0701000000680600),
(624, 0x1082297c0701000000b70900),
(624, 0x10822a7c0701000000b80900),
(624, 0x1182297c0701000000b70900),
(624, 0x11822a7c0701000000b80900),
(625, 0x0e82277c0701000000680600),
(625, 0x0c82297c0701000000b70900),
(625, 0x0c822a7c0701000000b80900),
(626, 0x0c82217c0701000000b70900),
(626, 0x0c82227c0701000000b80900),
(626, 0x0e82247c0701000000680600),
(627, 0x0882217c0701000000b70900),
(627, 0x0882227c0701000000b80900),
(627, 0x0a82247c0701000000680600),
(628, 0x0a82277c0701000000680600),
(628, 0x0882297c0701000000b70900),
(628, 0x08822a7c0701000000b80900),
(629, 0x1082217c0601000000b70900),
(629, 0x1082227c0601000000b80900),
(629, 0x1482217c0601000000b70900),
(629, 0x1482227c0601000000b80900),
(629, 0x1182247c0601000000680600),
(630, 0x1182277c0601000000680600),
(630, 0x1382297c0601000000b70900),
(630, 0x13822a7c0601000000b80900),
(630, 0x1482297c0601000000b70900),
(630, 0x14822a7c0601000000b80900),
(631, 0x0e82277c0601000000680600),
(631, 0x0c82297c0601000000b70900),
(631, 0x0c822a7c0601000000b80900),
(632, 0x0c82217c0601000000b70900),
(632, 0x0c82227c0601000000b80900),
(632, 0x0e82247c0601000000680600),
(633, 0x0882217c0601000000b70900),
(633, 0x0882227c0601000000b80900),
(633, 0x0a82247c0601000000680600),
(634, 0x0a82277c0601000000680600),
(634, 0x0882297c0601000000b70900),
(634, 0x08822a7c0601000000b80900),
(635, 0x3382127c0601000000b70900),
(635, 0x3382137c0601000000b80900),
(635, 0x3682137c0601000000660600),
(635, 0x3582117c0701000000680600),
(635, 0x3682137c0701000000660600),
(635, 0x3982137c0701000000660600),
(635, 0x3982127c0801000000bd0900),
(635, 0x3a82127c0801000000be0900),
(635, 0x3c82127c0601000000b70900),
(635, 0x3c82137c0601000000b80900),
(635, 0x3c82127c0701000000b70900),
(635, 0x3c82137c0701000000b80900),
(635, 0x3582177c0601000000680600),
(635, 0x3682167c0601000000660600),
(635, 0x3682167c0701000000660600),
(635, 0x3482177c0801000000680600),
(635, 0x3682147c0801000000660600),
(635, 0x3682167c0801000000660600),
(635, 0x3982147c0601000000660600),
(635, 0x3982177c0601000000660600),
(635, 0x3882147c0701000000680600),
(635, 0x3382197c0601000000b70900),
(635, 0x33821a7c0601000000b80900),
(635, 0x3382187c0701000000bd0900),
(635, 0x3582197c0601000000b70900),
(635, 0x35821a7c0601000000b80900),
(635, 0x3482187c0701000000be0900),
(635, 0x3682197c0701000000660600),
(635, 0x3882187c0601000000680600),
(635, 0x3a821a7c0601000000bd0900),
(635, 0x3b821a7c0601000000be0900),
(635, 0x3982187c0801000000b70900),
(635, 0x3982197c0801000000b80900),
(635, 0x3a82187c0801000000b70900),
(635, 0x3a82197c0801000000b80900),
(636, 0x1d82d97c0701000000b70900),
(636, 0x1d82da7c0701000000b80900),
(636, 0x1f82dc7c0701000000680600),
(637, 0x2182d97c0701000000b70900),
(637, 0x2182da7c0701000000b80900),
(637, 0x2382dc7c0701000000680600),
(638, 0x2582d97c0701000000bd0900),
(638, 0x2582db7c0701000000bd0900),
(638, 0x2682d97c0701000000be0900),
(638, 0x2682db7c0701000000be0900),
(638, 0x2882dc7c0701000000680600),
(639, 0x2882df7c0701000000680600),
(639, 0x2582e17c0701000000b70900),
(639, 0x2582e27c0701000000b80900),
(639, 0x2682e17c0701000000b70900),
(639, 0x2682e27c0701000000b80900),
(640, 0x2382df7c0701000000680600),
(640, 0x2182e17c0701000000b70900),
(640, 0x2182e27c0701000000b80900),
(641, 0x1f82df7c0701000000680600),
(641, 0x1d82e17c0701000000b70900),
(641, 0x1d82e27c0701000000b80900),
(642, 0x1d82d97c0601000000b70900),
(642, 0x1d82da7c0601000000b80900),
(642, 0x1f82dc7c0601000000680600),
(643, 0x2182d97c0601000000b70900),
(643, 0x2182da7c0601000000b80900),
(643, 0x2382dc7c0601000000680600),
(644, 0x2582d97c0601000000b70900),
(644, 0x2582da7c0601000000b80900),
(644, 0x2982d97c0601000000b70900),
(644, 0x2982da7c0601000000b80900),
(644, 0x2682dc7c0601000000680600),
(645, 0x2682df7c0601000000680600),
(645, 0x2882e17c0601000000b70900),
(645, 0x2882e27c0601000000b80900),
(645, 0x2982e17c0601000000b70900),
(645, 0x2982e27c0601000000b80900),
(646, 0x2382df7c0601000000680600),
(646, 0x2182e17c0601000000b70900),
(646, 0x2182e27c0601000000b80900),
(647, 0x1f82df7c0601000000680600),
(647, 0x1d82e17c0601000000b70900),
(647, 0x1d82e27c0601000000b80900),
(648, 0x1782d57c0701000000bd0900),
(648, 0x1782d67c0701000000bd0900),
(648, 0x1882d57c0701000000be0900),
(648, 0x1882d67c0701000000be0900),
(648, 0x1682da7c0701000000680600),
(649, 0x0c82de7c0601000000660600),
(649, 0x0e82df7c0601000000680600),
(649, 0x0982e17c0601000000b70900),
(649, 0x0982e27c0601000000b80900),
(649, 0x0b82e17c0601000000b70900),
(649, 0x0b82e27c0601000000b80900),
(649, 0x0f82e17c0601000000b70900),
(649, 0x0f82e27c0601000000b80900),
(649, 0x1082e07c0701000000660600),
(650, 0x1a82e77c0701000000bd0900),
(650, 0x1b82e77c0701000000be0900),
(650, 0x1e82e77c0701000000bd0900),
(650, 0x1f82e77c0701000000be0900),
(650, 0x1982ea7c0701000000660600),
(651, 0x0c82e67c0701000000bd0900),
(651, 0x0c82e77c0701000000bd0900),
(651, 0x0d82e67c0701000000be0900),
(651, 0x0d82e77c0701000000be0900),
(651, 0x0c82ed7c0701000000680600),
(652, 0xf781ea7c0701000000660600),
(652, 0xf881ed7c0601000000b70900),
(652, 0xf881ee7c0601000000b80900),
(652, 0xf981ed7c0601000000b70900),
(652, 0xf981ee7c0601000000b80900),
(652, 0xfc81ed7c0701000000b70900),
(652, 0xfc81ee7c0701000000b80900),
(652, 0xfd81ec7c0701000000660600),
(653, 0x0182f67c0601000000b70900),
(653, 0x0182f77c0601000000b80900),
(653, 0x0282f67c0601000000b70900),
(653, 0x0282f77c0601000000b80900),
(653, 0x0682f47c0701000000660600),
(654, 0x0682fa7c0701000000660600),
(654, 0x0182fc7c0601000000b70900),
(654, 0x0182fd7c0601000000b80900),
(654, 0x0282fc7c0601000000b70900),
(654, 0x0282fd7c0601000000b80900),
(655, 0x0182ff7c0601000000b70900),
(655, 0x0082037d0601000000660600),
(655, 0x0182007d0601000000b80900),
(655, 0x0482037d0601000000bd0900),
(655, 0x0582037d0601000000be0900),
(655, 0x0682007d0701000000660600),
(656, 0x08820e7d0701000000680600),
(656, 0x0882137d0701000000b70900),
(656, 0x0982137d0701000000b70900),
(656, 0x0882147d0701000000b80900),
(656, 0x0982147d0701000000b80900),
(657, 0xff81137d0701000000b70900),
(657, 0xff81147d0701000000b80900),
(657, 0x01820f7d0701000000680600),
(657, 0x05820c7d0701000000660600),
(657, 0x0082137d0701000000b70900),
(657, 0x0082147d0701000000b80900),
(658, 0x08820e7d0601000000680600),
(658, 0x0882137d0601000000b70900),
(658, 0x0982137d0601000000b70900),
(658, 0x0882147d0601000000b80900),
(658, 0x0982147d0601000000b80900),
(659, 0xff81137d0601000000b70900),
(659, 0xff81147d0601000000b80900),
(659, 0x01820f7d0601000000680600),
(659, 0x05820c7d0601000000660600),
(659, 0x0082137d0601000000b70900),
(659, 0x0082147d0601000000b80900),
(660, 0x0e82067d0701000000680600),
(660, 0x0c820a7d0601000000b70900),
(660, 0x0c820b7d0601000000b80900),
(660, 0x0d820a7d0601000000b70900),
(660, 0x0d820b7d0601000000b80900),
(660, 0x0c820a7d0701000000b70900),
(660, 0x0c820b7d0701000000b80900),
(660, 0x0e820c7d0701000000680600),
(661, 0x1982067d0701000000680600),
(661, 0x1b820b7d0701000000bd0900),
(661, 0x1c820b7d0701000000be0900),
(661, 0x1b820c7d0701000000bd0900),
(661, 0x1c820c7d0701000000be0900),
(662, 0x0b82f47c0401000000b70900),
(662, 0x0b82f57c0401000000b80900),
(662, 0x0e82f87c0501000000680600),
(662, 0x0d82f87c0601000000680600),
(662, 0x0d82f87c0701000000680600),
(662, 0x0e82f97c0801000000b70900),
(662, 0x0e82fa7c0801000000b80900),
(662, 0x0e82ff7c0401000000b70900),
(662, 0x0f82fe7c0501000000660600),
(662, 0x0e82fc7c0801000000b70900),
(662, 0x0e82fd7c0801000000b80900),
(662, 0x0e82ff7c0801000000b70900),
(662, 0x1182f37c0701000000680600),
(662, 0x1382f67c0701000000660600),
(662, 0x1782f47c0401000000b70900),
(662, 0x1782f57c0401000000b80900),
(662, 0x1582f57c0501000000660600),
(662, 0x1382fa7c0601000000660600),
(662, 0x1182f87c0701000000680600),
(662, 0x1082f97c0801000000b70900),
(662, 0x1082fa7c0801000000b80900),
(662, 0x1182f97c0801000000b70900),
(662, 0x1182fa7c0801000000b80900),
(662, 0x1582f87c0501000000680600),
(662, 0x1582f87c0601000000680600),
(662, 0x1782fa7c0601000000660600),
(662, 0x1582f87c0701000000680600),
(662, 0x1482fa7c0801000000660600),
(662, 0x1782f97c0801000000b70900),
(662, 0x1782fa7c0801000000b80900),
(662, 0x1382fe7c0501000000660600),
(662, 0x1382ff7c0601000000660600),
(662, 0x1082fc7c0801000000b70900),
(662, 0x1082fd7c0801000000b80900),
(662, 0x1082ff7c0801000000b70900),
(662, 0x1182fc7c0801000000b70900),
(662, 0x1182fd7c0801000000b80900),
(662, 0x1182ff7c0801000000b70900),
(662, 0x1482ff7c0401000000b70900),
(662, 0x1482fc7c0801000000b70900),
(662, 0x1482fd7c0801000000b80900),
(662, 0x1482ff7c0801000000b70900),
(662, 0x1582fc7c0801000000b70900),
(662, 0x1582fd7c0801000000b80900),
(662, 0x1582ff7c0801000000b70900),
(662, 0x1782ff7c0801000000b70900),
(662, 0x0e82007d0401000000b80900),
(662, 0x0e82007d0801000000b80900),
(662, 0x1082007d0801000000b80900),
(662, 0x1182007d0801000000b80900),
(662, 0x1482007d0401000000b80900),
(662, 0x1482007d0801000000b80900),
(662, 0x1582007d0801000000b80900),
(662, 0x1782007d0801000000b80900),
(663, 0x468159800701000000bb0900),
(663, 0x46815a800701000000bc0900),
(663, 0x4a8159800701000000780600),
(664, 0x5c815b800701000000b90900),
(664, 0x5d815b800701000000ba0900),
(664, 0x60815d800701000000780600),
(665, 0x558131800501000000b90900),
(665, 0x568131800501000000ba0900),
(665, 0x5581358005010000007a0600),
(666, 0x52812f800601000000b90900),
(666, 0x53812f800601000000ba0900),
(666, 0x5281328006010000007a0600),
(666, 0x5681328006010000007a0600),
(666, 0x578130800601000000bb0900),
(666, 0x578131800601000000bc0900),
(666, 0x588130800601000000bb0900),
(666, 0x588131800601000000bc0900),
(666, 0x598135800601000000780600),
(667, 0x55812c8007010000007a0600),
(667, 0x56812e800701000000780600),
(667, 0x4f8131800701000000bb0900),
(667, 0x4f8132800701000000bc0900),
(667, 0x5181308007010000007a0600),
(667, 0x528131800701000000bb0900),
(667, 0x528132800701000000bc0900),
(667, 0x548132800701000000b90900),
(667, 0x5581308007010000007a0600),
(667, 0x558132800701000000ba0900),
(668, 0x538137800701000000780600),
(668, 0x548134800701000000b90900),
(668, 0x558134800701000000ba0900),
(668, 0x5581368007010000007a0600),
(668, 0x568137800701000000780600),
(668, 0x598134800701000000b90900),
(668, 0x598135800701000000b90900),
(668, 0x5a8134800701000000ba0900),
(668, 0x5a8135800701000000ba0900),
(668, 0x5a8137800701000000bb0900),
(668, 0x5581398007010000007a0600),
(668, 0x5a8138800701000000bc0900),
(669, 0x4e8146800501000000bb0900),
(669, 0x4e8147800501000000bc0900),
(669, 0x528148800501000000660600),
(670, 0x4c8147800601000000b90900),
(670, 0x4d8147800601000000ba0900),
(670, 0x4e8145800601000000660600),
(671, 0x518145800601000000660600),
(671, 0x528147800601000000b90900),
(671, 0x538147800601000000ba0900),
(672, 0x4c8149800601000000b90900),
(672, 0x4d8149800601000000ba0900),
(672, 0x4e814b800601000000660600),
(673, 0x51814b800601000000660600),
(673, 0x528149800601000000b90900),
(673, 0x538149800601000000ba0900),
(674, 0x4f8144800701000000780600),
(674, 0x548142800701000000b90900),
(674, 0x558142800701000000ba0900),
(674, 0x5181478007010000007a0600),
(674, 0x528144800701000000780600),
(674, 0x548145800701000000bb0900),
(674, 0x548146800701000000bc0900),
(674, 0x558145800701000000bb0900),
(674, 0x558146800701000000bc0900),
(675, 0x4a8148800701000000b90900),
(675, 0x4b8148800701000000ba0900),
(675, 0x4f8149800701000000780600),
(675, 0x4a814c800701000000bb0900),
(675, 0x4a814d800701000000bc0900),
(676, 0x528149800701000000780600),
(676, 0x52814b800701000000780600),
(676, 0x50814c800701000000bb0900),
(676, 0x50814d800701000000bc0900),
(676, 0x51814c800701000000bb0900),
(676, 0x51814d800701000000bc0900),
(677, 0x658127800701000000bb0900),
(677, 0x658128800701000000bc0900),
(677, 0x67812b800701000000220900),
(678, 0x6f8127800701000000bb0900),
(678, 0x6d812b800701000000220900),
(678, 0x6f8128800701000000bc0900),
(679, 0x678133800701000000220900),
(679, 0x658136800701000000bb0900),
(679, 0x658137800701000000bc0900),
(680, 0x6d8133800701000000220900),
(680, 0x6f8136800701000000bb0900),
(680, 0x6f8137800701000000bc0900),
(681, 0xa9813d800501000000b90900),
(681, 0xaa813d800501000000ba0900),
(681, 0xae813f800501000000780600),
(682, 0xa8813b800601000000b90900),
(682, 0xa9813b800601000000ba0900),
(682, 0xab813b800601000000bb0900),
(682, 0xae813b800601000000bb0900),
(682, 0xa8813e8006010000007a0600),
(682, 0xab813c800601000000bc0900),
(682, 0xac813e8006010000007a0600),
(682, 0xae813c800601000000bc0900),
(682, 0xab81438006010000007a0600),
(683, 0xa5813a800701000000bb0900),
(683, 0xa5813b800701000000bc0900),
(683, 0xa6813a800701000000bb0900),
(683, 0xa6813b800701000000bc0900),
(683, 0xa78139800701000000780600),
(683, 0xa4813e800701000000780600),
(684, 0xac8139800701000000bb0900),
(684, 0xac813a800701000000bc0900),
(684, 0xaf8139800701000000b90900),
(684, 0xae813d8007010000007a0600),
(684, 0xaf813c800701000000b90900),
(684, 0xb08139800701000000ba0900),
(684, 0xb0813c800701000000ba0900),
(684, 0xaf81458007010000007a0600),
(685, 0xa58140800701000000b90900),
(685, 0xa58142800701000000bb0900),
(685, 0xa58143800701000000bc0900),
(685, 0xa68140800701000000ba0900),
(685, 0xa881458007010000007a0600),
(686, 0xbe8155800501000000780600),
(686, 0xc28153800501000000bb0900),
(686, 0xc28154800501000000bc0900),
(687, 0xbd8151800601000000b90900),
(687, 0xbd8153800601000000bb0900),
(687, 0xbe8151800601000000ba0900),
(687, 0xbd8154800601000000bc0900),
(687, 0xc08152800601000000780600),
(687, 0xc58153800601000000780600),
(688, 0xc28157800601000000780600),
(688, 0xc38156800601000000b90900),
(688, 0xc48156800601000000ba0900),
(688, 0xc181598006010000007a0600),
(688, 0xc38158800601000000b90900),
(688, 0xc48158800601000000ba0900),
(689, 0xba8151800701000000780600),
(689, 0xbf8153800701000000b90900),
(689, 0xbf8154800701000000b90900),
(689, 0xc08153800701000000ba0900),
(689, 0xc08154800701000000ba0900),
(690, 0xc4814e8007010000007a0600),
(690, 0xc28153800701000000bb0900),
(690, 0xc68153800701000000bb0900),
(690, 0xc28154800701000000bc0900),
(690, 0xc68154800701000000bc0900),
(691, 0xbf8156800701000000b90900),
(691, 0xbf8157800701000000b90900),
(691, 0xbd815b8007010000007a0600),
(691, 0xc08156800701000000ba0900),
(691, 0xc08157800701000000ba0900),
(692, 0xc28156800701000000b90900),
(692, 0xc38156800701000000ba0900),
(692, 0xc68156800701000000bb0900),
(692, 0xc68157800701000000bc0900),
(692, 0xc4815b8007010000007a0600),
(693, 0xaa8167800501000000780600),
(693, 0xae8165800501000000b90900),
(693, 0xae8166800501000000b90900),
(693, 0xaf8165800501000000ba0900),
(693, 0xaf8166800501000000ba0900),
(694, 0xab81628006010000007a0600),
(694, 0xa98165800601000000bb0900),
(694, 0xa98166800601000000bc0900),
(694, 0xac8165800601000000bb0900),
(694, 0xac8166800601000000bc0900),
(695, 0xae8163800601000000b90900),
(695, 0xaf8163800601000000ba0900),
(695, 0xb28165800601000000780600),
(696, 0xa98168800601000000b90900),
(696, 0xaa8168800601000000ba0900),
(696, 0xab816c8006010000007a0600),
(697, 0xae8168800601000000bb0900),
(697, 0xae8169800601000000bc0900),
(697, 0xb0816c8006010000007a0600),
(698, 0xa68163800701000000780600),
(698, 0xa98166800701000000b90900),
(698, 0xaa8166800701000000ba0900),
(698, 0xac8165800701000000bb0900),
(698, 0xac8166800701000000bc0900),
(698, 0xad8165800701000000bb0900),
(698, 0xad8166800701000000bc0900),
(699, 0xaf8165800701000000bb0900),
(699, 0xaf8166800701000000bc0900),
(699, 0xb181608007010000007a0600),
(699, 0xb28166800701000000b90900),
(699, 0xb38166800701000000ba0900),
(700, 0xa6816b800701000000780600),
(700, 0xaf8169800701000000780600),
(700, 0xaf816c800701000000780600),
(700, 0xb28168800701000000b90900),
(700, 0xb2816b800701000000b90900),
(700, 0xb38168800701000000ba0900),
(700, 0xb3816b800701000000ba0900),
(700, 0xb2816d800701000000b90900),
(700, 0xb3816d800701000000ba0900),
(701, 0x9781568005010000007a0600),
(701, 0x95815a800501000000bb0900),
(701, 0x95815b800501000000bc0900),
(701, 0x99815a800501000000bb0900),
(701, 0x99815b800501000000bc0900),
(702, 0x928157800601000000780600),
(702, 0x958158800601000000b90900),
(702, 0x968158800601000000ba0900),
(703, 0x988155800601000000bb0900),
(703, 0x988156800601000000bc0900),
(703, 0x9c8157800601000000780600),
(704, 0x95815a800601000000b90900),
(704, 0x96815a800601000000ba0900),
(704, 0x95815e8006010000007a0600),
(705, 0x98815a800601000000bb0900),
(705, 0x98815b800601000000bc0900),
(705, 0x9c815c800601000000780600),
(706, 0x9481528007010000007a0600),
(706, 0x918157800701000000bb0900),
(706, 0x9481568007010000007a0600),
(706, 0x968157800701000000bb0900),
(706, 0x918158800701000000bc0900),
(706, 0x968158800701000000bc0900),
(707, 0x9b81528007010000007a0600),
(707, 0x9981568007010000007a0600),
(707, 0x9a8157800701000000bb0900),
(707, 0x9c81568007010000007a0600),
(707, 0x9d8157800701000000bb0900),
(707, 0x9a8158800701000000bc0900),
(707, 0x9d8158800701000000bc0900),
(708, 0x91815a800701000000b90900),
(708, 0x92815a800701000000ba0900),
(708, 0x90815d800701000000780600),
(709, 0x98815a800701000000b90900),
(709, 0x99815a800701000000ba0900),
(709, 0x98815e800701000000bb0900),
(709, 0x98815f800701000000bc0900),
(709, 0x99815e800701000000bb0900),
(709, 0x99815f800701000000bc0900),
(709, 0x9a815d800701000000780600),
(709, 0x9c81608007010000007a0600),
(710, 0x938142800601000000b70900),
(710, 0x938143800601000000b80900),
(710, 0x918140800701000000b90900),
(710, 0x918142800701000000b90900),
(710, 0x928140800701000000ba0900),
(710, 0x928142800701000000ba0900),
(710, 0x9681438007010000007a0600),
(710, 0x988142800601000000b70900),
(710, 0x988143800601000000b80900),
(710, 0x998140800701000000b90900),
(710, 0x998142800701000000b90900),
(710, 0x9a8140800701000000ba0900),
(710, 0x9a8142800701000000ba0900),
(710, 0x938146800601000000b70900),
(710, 0x938147800601000000b80900),
(710, 0x918144800701000000b90900),
(710, 0x918145800701000000b90900),
(710, 0x918147800701000000b90900),
(710, 0x928144800701000000ba0900),
(710, 0x928145800701000000ba0900),
(710, 0x928147800701000000ba0900),
(710, 0x948146800701000000780600),
(710, 0x978146800701000000780600),
(710, 0x988145800501000000780600),
(710, 0x988146800601000000b70900),
(710, 0x988147800601000000b80900),
(710, 0x998144800701000000b90900),
(710, 0x998145800701000000b90900),
(710, 0x998147800701000000b90900),
(710, 0x9a8144800701000000ba0900),
(710, 0x9a8145800701000000ba0900),
(710, 0x9a8147800701000000ba0900),
(710, 0x918149800701000000b90900),
(710, 0x928149800701000000ba0900),
(710, 0x96814a8007010000007a0600),
(710, 0x998149800701000000b90900),
(710, 0x9a8149800701000000ba0900),
(711, 0x30812f800601000000bb0900),
(711, 0x308130800601000000bc0900),
(711, 0x338130800601000000780600),
(712, 0x32812f800701000000b90900),
(712, 0x33812f800701000000ba0900),
(712, 0x3181338007010000007a0600),
(712, 0x328130800701000000b90900),
(712, 0x338130800701000000ba0900),
(713, 0x2a813c800701000000bb0900),
(713, 0x2a813d800701000000bc0900),
(713, 0x2a813f800701000000bb0900),
(713, 0x2f813e800701000000780600),
(713, 0x2a8140800701000000bc0900),
(714, 0x2b8149800701000000b70900),
(714, 0x2b814a800701000000b80900),
(714, 0x2f814b800701000000780600),
(715, 0x408121800501000000b90900),
(715, 0x418121800501000000ba0900),
(715, 0x4181248005010000007a0600),
(716, 0x3e8123800601000000bb0900),
(716, 0x3e8124800601000000bc0900),
(716, 0x40811e8006010000007a0600),
(716, 0x4081228006010000007a0600),
(716, 0x428123800601000000b90900),
(716, 0x438123800601000000ba0900),
(717, 0x3c811d800701000000b90900),
(717, 0x3c811f800701000000bb0900),
(717, 0x3d811d800701000000ba0900),
(717, 0x3d811f800701000000bb0900),
(717, 0x3c8120800701000000bc0900),
(717, 0x3d8120800701000000bc0900),
(717, 0x40811f800701000000780600),
(717, 0x46811f800701000000780600),
(718, 0x3f8122800701000000b90900),
(718, 0x3f8123800701000000b90900),
(718, 0x3f8125800701000000780600),
(718, 0x408122800701000000ba0900),
(718, 0x408123800701000000ba0900),
(718, 0x428122800701000000bb0900),
(718, 0x428123800701000000bc0900),
(718, 0x458122800701000000bb0900),
(718, 0x458123800701000000bc0900),
(718, 0x4181278007010000007a0600),
(718, 0x428125800701000000780600),
(719, 0x53811d800501000000bb0900),
(719, 0x53811e800501000000bc0900),
(719, 0x56811d800501000000780600),
(720, 0x53811a800601000000bb0900),
(720, 0x53811b800601000000bc0900),
(720, 0x56811a800601000000b90900),
(720, 0x56811b800601000000b90900),
(720, 0x57811a800601000000ba0900),
(720, 0x57811b800601000000ba0900),
(720, 0x52811c8006010000007a0600),
(720, 0x55811c8006010000007a0600),
(720, 0x5481218006010000007a0600),
(721, 0x4e811a800701000000780600),
(721, 0x52811b800701000000b90900),
(721, 0x53811b800701000000ba0900),
(722, 0x558118800701000000bb0900),
(722, 0x558119800701000000bc0900),
(722, 0x5a811a800701000000780600),
(723, 0x52811d800701000000b90900),
(723, 0x52811e800701000000b90900),
(723, 0x53811d800701000000ba0900),
(723, 0x53811e800701000000ba0900),
(723, 0x5181238007010000007a0600),
(724, 0x58811f800701000000b90900),
(724, 0x59811f800701000000ba0900),
(724, 0x5781238007010000007a0600),
(724, 0x588120800701000000b90900),
(724, 0x598120800701000000ba0900),
(725, 0x678118800501000000bb0900),
(725, 0x678119800501000000bc0900),
(725, 0x6a8119800501000000780600),
(726, 0x678116800601000000bb0900),
(726, 0x678117800601000000bc0900),
(726, 0x698116800601000000bb0900),
(726, 0x698117800601000000bc0900),
(726, 0x64811a800601000000780600),
(726, 0x6681188006010000007a0600),
(726, 0x6a81188006010000007a0600),
(727, 0x628116800701000000780600),
(727, 0x658114800701000000b90900),
(727, 0x668114800701000000ba0900),
(727, 0x668117800701000000bb0900),
(727, 0x668118800701000000bc0900),
(728, 0x6b81138007010000007a0600),
(728, 0x688115800701000000bb0900),
(728, 0x688116800701000000bc0900),
(729, 0x66811a800701000000b90900),
(729, 0x67811a800701000000ba0900),
(729, 0x66811e8007010000007a0600),
(730, 0x6c811a800701000000bb0900),
(730, 0x6c811b800701000000bc0900),
(730, 0x6b811e8007010000007a0600),
(731, 0x3e8132800601000000b70900),
(731, 0x3e8133800601000000b80900),
(731, 0x3f81348006010000007a0600),
(731, 0x3f81368007010000007a0600),
(731, 0x418132800601000000b70900),
(731, 0x418133800601000000b80900),
(731, 0x438132800601000000b70900),
(731, 0x438133800601000000b80900),
(731, 0x428130800701000000bb0900),
(731, 0x428131800701000000bc0900),
(731, 0x428132800701000000bb0900),
(731, 0x428133800701000000bc0900),
(731, 0x448130800701000000b90900),
(731, 0x448132800701000000b90900),
(731, 0x458130800701000000ba0900),
(731, 0x458132800701000000ba0900),
(731, 0x4281348006010000007a0600),
(731, 0x418134800701000000780600),
(731, 0x418137800701000000780600),
(731, 0x448134800701000000b90900),
(731, 0x448136800701000000b90900),
(731, 0x458134800701000000ba0900),
(731, 0x458136800701000000ba0900),
(731, 0x40813a8007010000007a0600),
(731, 0x448139800701000000b90900),
(731, 0x458139800701000000ba0900),
(732, 0x388145800701000000bb0900),
(732, 0x388146800701000000bc0900),
(732, 0x3c81478007010000007a0600),
(733, 0x3e8145800701000000b90900),
(733, 0x3f8145800701000000ba0900),
(733, 0x3d8149800701000000780600),
(734, 0x3c814a8007010000007a0600),
(734, 0x3f814b800701000000bb0900),
(734, 0x3f814c800701000000bc0900),
(735, 0x3a8149800701000000780600),
(735, 0x38814c800701000000b90900),
(735, 0x39814c800701000000ba0900),
(736, 0x36815a800501000000b90900),
(736, 0x36815b800501000000b90900),
(736, 0x37815a800501000000ba0900),
(736, 0x37815b800501000000ba0900),
(736, 0x3581608005010000007a0600),
(737, 0x2f815a800601000000780600),
(737, 0x338158800601000000b90900),
(737, 0x348158800601000000ba0900),
(738, 0x36815a800601000000bb0900),
(738, 0x36815b800601000000bc0900),
(738, 0x3a815a800601000000780600),
(739, 0x2f815f800601000000780600),
(739, 0x33815e800601000000b90900),
(739, 0x34815e800601000000ba0900),
(739, 0x338160800601000000b90900),
(739, 0x348160800601000000ba0900),
(740, 0x3a815f800601000000780600),
(740, 0x368160800601000000bb0900),
(740, 0x368161800601000000bc0900),
(741, 0x2e8160800701000000bb0900),
(741, 0x2e8161800701000000bc0900),
(741, 0x338161800701000000780600),
(742, 0x2e815a800701000000b90900),
(742, 0x2f815a800701000000ba0900),
(742, 0x2e815d800701000000bb0900),
(742, 0x2e815e800701000000bc0900),
(742, 0x33815c800701000000780600),
(743, 0x338157800701000000780600),
(743, 0x378157800701000000780600),
(743, 0x3a8156800701000000b90900),
(743, 0x3b8156800701000000ba0900),
(743, 0x3581598007010000007a0600),
(743, 0x388158800701000000b90900),
(743, 0x398158800701000000ba0900),
(743, 0x3a8158800701000000b90900),
(743, 0x3b8158800701000000ba0900),
(744, 0x3a815a800701000000b90900),
(744, 0x3b815a800701000000ba0900),
(744, 0x37815c800701000000780600),
(745, 0x378161800701000000780600),
(745, 0x3b8160800701000000bb0900),
(745, 0x3b8161800701000000bc0900),
(746, 0x56810e800701000000bb0900),
(746, 0x56810f800701000000bc0900),
(746, 0x57810e800701000000bb0900),
(746, 0x57810f800701000000bc0900),
(746, 0x5b810d800701000000780600),
(747, 0x6a8107800701000000b90900),
(747, 0x6b8107800701000000ba0900),
(747, 0x6a810a800701000000bb0900),
(747, 0x6a810b800701000000bc0900),
(747, 0x6b810a800701000000bb0900),
(747, 0x6b810b800701000000bc0900),
(747, 0x708109800701000000780600),
(748, 0x788107800701000000bb0900),
(748, 0x788108800701000000bc0900),
(748, 0x7a81098007010000007a0600),
(749, 0x858104800701000000b90900),
(749, 0x868104800701000000ba0900),
(749, 0x888104800701000000b90900),
(749, 0x898104800701000000ba0900),
(749, 0x8781098007010000007a0600),
(750, 0x92810b800701000000bb0900),
(750, 0x93810b800701000000bb0900),
(750, 0x98810a800701000000780600),
(750, 0x92810c800701000000bc0900),
(750, 0x93810c800701000000bc0900),
(751, 0x7b8115800501000000b90900),
(751, 0x7c8115800501000000ba0900),
(751, 0x7e8115800501000000b90900),
(751, 0x7f8115800501000000ba0900),
(751, 0x808118800501000000780600),
(752, 0x798113800601000000b90900),
(752, 0x7a8113800601000000ba0900),
(752, 0x7e81128006010000007a0600),
(752, 0x798116800601000000b90900),
(752, 0x7a8116800601000000ba0900),
(752, 0x7b8115800601000000780600),
(753, 0x78811a800601000000780600),
(753, 0x7e8119800601000000780600),
(753, 0x7f811a800601000000bb0900),
(753, 0x7f811b800601000000bc0900),
(753, 0x81811a800601000000bb0900),
(753, 0x81811b800601000000bc0900),
(754, 0x768113800701000000780600),
(754, 0x778116800701000000b90900),
(754, 0x788116800701000000ba0900),
(754, 0x7b8115800701000000bb0900),
(754, 0x7b8116800701000000bc0900),
(754, 0x7c8115800701000000bb0900),
(754, 0x7c8116800701000000bc0900),
(755, 0x7e8111800701000000bb0900),
(755, 0x7e8112800701000000bc0900),
(755, 0x838111800701000000bb0900),
(755, 0x838112800701000000bc0900),
(755, 0x848114800701000000780600),
(756, 0x7b8118800701000000b90900),
(756, 0x7c8118800701000000ba0900),
(756, 0x7c811a800701000000bb0900),
(756, 0x7c811b800701000000bc0900),
(756, 0x7a811e8007010000007a0600),
(757, 0x7e8118800701000000b90900),
(757, 0x7f8118800701000000ba0900),
(757, 0x81811e8007010000007a0600),
(758, 0x9281168006010000007a0600),
(758, 0x91811b800601000000b90900),
(758, 0x92811b800601000000ba0900),
(759, 0x8d8117800701000000780600),
(759, 0x908115800701000000b90900),
(759, 0x918115800701000000ba0900),
(760, 0x938117800701000000bb0900),
(760, 0x978117800701000000780600),
(760, 0x938118800701000000bc0900),
(761, 0x8e811a800701000000bb0900),
(761, 0x8e811b800701000000bc0900),
(761, 0x8e811c800701000000bb0900),
(761, 0x8e811d800701000000bc0900),
(761, 0x92811e8007010000007a0600),
(762, 0xa381128006010000007a0600),
(762, 0xa48116800601000000bb0900),
(762, 0xa48117800601000000bc0900),
(762, 0xa58116800601000000bb0900),
(762, 0xa58117800601000000bc0900),
(763, 0x9e8113800701000000780600),
(763, 0xa28111800701000000bb0900),
(763, 0xa28112800701000000bc0900),
(764, 0xa48111800701000000bb0900),
(764, 0xa48112800701000000bc0900),
(764, 0xa88113800701000000780600),
(765, 0x9f8116800701000000bb0900),
(765, 0x9f8117800701000000bc0900),
(765, 0xa28116800701000000bb0900),
(765, 0xa28117800701000000bc0900),
(765, 0xa1811a8007010000007a0600),
(766, 0xa48116800701000000b90900),
(766, 0xa58116800701000000ba0900),
(766, 0xa78116800701000000bb0900),
(766, 0xa78117800701000000bc0900),
(766, 0xa6811a8007010000007a0600),
(767, 0xb48119800601000000bb0900),
(767, 0xb4811a800601000000bc0900),
(767, 0xb98119800601000000780600),
(768, 0xb18116800701000000780600),
(768, 0xb58114800701000000bb0900),
(768, 0xb58115800701000000bc0900),
(769, 0xb78117800701000000b90900),
(769, 0xb88117800701000000ba0900),
(769, 0xbb8116800701000000780600),
(770, 0xb28119800701000000b90900),
(770, 0xb38119800701000000ba0900),
(770, 0xb4811b800701000000780600),
(770, 0xb2811c800701000000b90900),
(770, 0xb3811c800701000000ba0900),
(770, 0xb7811d8007010000007a0600),
(771, 0xa38128800501000000b90900),
(771, 0xa48128800501000000ba0900),
(771, 0xa4812b8005010000007a0600),
(772, 0xa38126800601000000bb0900),
(772, 0xa38127800601000000bc0900),
(772, 0xa0812b800601000000780600),
(772, 0xa281288006010000007a0600),
(773, 0xa58126800601000000bb0900),
(773, 0xa58127800601000000bc0900),
(773, 0xa78126800601000000bb0900),
(773, 0xa78127800601000000bc0900),
(773, 0xa681288006010000007a0600),
(773, 0xa8812b800601000000780600),
(774, 0x9e8126800701000000780600),
(774, 0xa38126800701000000bb0900),
(774, 0xa38127800701000000bc0900),
(775, 0xa58124800701000000b90900),
(775, 0xa58126800701000000bb0900),
(775, 0xa58127800701000000bc0900),
(775, 0xa68124800701000000ba0900),
(775, 0xaa8126800701000000780600),
(776, 0xa3812a800701000000780600),
(776, 0xa88129800701000000b90900),
(776, 0xa8812a800701000000b90900),
(776, 0xa98129800701000000ba0900),
(776, 0xa9812a800701000000ba0900),
(776, 0xa3812d800701000000780600),
(776, 0xa5812f8007010000007a0600),
(776, 0xa6812d800701000000780600),
(776, 0xa9812d800701000000bb0900),
(776, 0xa9812e800701000000bc0900),
(777, 0xb6812b800601000000bb0900),
(777, 0xb7812b800601000000bb0900),
(777, 0xb98128800601000000b90900),
(777, 0xb9812b800601000000bb0900),
(777, 0xba8128800601000000ba0900),
(777, 0xba812b800601000000bb0900),
(777, 0xb6812c800601000000bc0900),
(777, 0xb7812c800601000000bc0900),
(777, 0xb4812d800701000000bb0900),
(777, 0xb4812e800701000000bc0900),
(777, 0xb6812d800701000000780600),
(777, 0xb9812c800601000000bc0900),
(777, 0xba812c800601000000bc0900),
(777, 0xb8812f8007010000007a0600),
(777, 0xb9812d800701000000780600),
(777, 0xbb812c800701000000b90900),
(777, 0xbb812e800701000000b90900),
(777, 0xbc812c800701000000ba0900),
(777, 0xbc812e800701000000ba0900),
(778, 0xc8811e800701000000bb0900),
(778, 0xc8811f800701000000bc0900),
(778, 0xc48120800701000000780600),
(779, 0xc7812c800601000000bb0900),
(779, 0xc7812d800601000000bc0900),
(779, 0xca812d800601000000780600),
(780, 0xc9812a800701000000b90900),
(780, 0xc9812b800701000000b90900),
(780, 0xca812a800701000000ba0900),
(780, 0xca812b800701000000ba0900),
(780, 0xc8812c8007010000007a0600),
(780, 0xc781308007010000007a0600),
(781, 0xd58133800601000000bb0900),
(781, 0xd58134800601000000bc0900),
(781, 0xd88134800601000000780600),
(782, 0xd28133800701000000780600),
(782, 0xd38135800701000000bb0900),
(782, 0xd38136800701000000bc0900),
(782, 0xd481348007010000007a0600),
(782, 0xd58135800701000000bb0900),
(782, 0xd58136800701000000bc0900),
(782, 0xd781348007010000007a0600),
(783, 0xd18143800601000000b90900),
(783, 0xd281408006010000007a0600),
(783, 0xd28143800601000000ba0900),
(784, 0xd1813f800701000000bb0900),
(784, 0xce8140800701000000780600),
(784, 0xd18140800701000000bc0900),
(785, 0xd3813f800701000000bb0900),
(785, 0xd38140800701000000bc0900),
(785, 0xd68140800701000000780600),
(786, 0xcf8143800701000000bb0900),
(786, 0xcf8144800701000000bc0900),
(786, 0xd28144800701000000780600),
(786, 0xd481468007010000007a0600),
(787, 0xbb8139800701000000b70900),
(787, 0xbb813a800701000000b80900),
(787, 0xbe813b8007010000007a0600),
(787, 0xbb813d800701000000bb0900),
(787, 0xbb813e800701000000bc0900),
(787, 0xbe813f8006010000007a0600),
(787, 0xbc813d800701000000bb0900),
(787, 0xbc813e800701000000bc0900),
(787, 0xc08139800701000000b70900),
(787, 0xc0813a800701000000b80900),
(787, 0xc4813b8007010000007a0600),
(787, 0xc3813f8006010000007a0600),
(787, 0xc5813d800701000000bb0900),
(787, 0xc5813e800701000000bc0900),
(787, 0xc6813d800701000000bb0900),
(787, 0xc6813e800701000000bc0900),
(787, 0xbb8140800701000000bb0900),
(787, 0xbb8141800701000000bc0900),
(787, 0xbb8143800701000000bb0900),
(787, 0xbc8140800701000000bb0900),
(787, 0xbc8141800701000000bc0900),
(787, 0xbc8143800701000000bb0900),
(787, 0xbb8144800701000000bc0900),
(787, 0xbc8144800701000000bc0900),
(787, 0xc181438006010000007a0600),
(787, 0xc58140800701000000bb0900),
(787, 0xc58141800701000000bc0900),
(787, 0xc58143800701000000bb0900),
(787, 0xc68140800701000000bb0900),
(787, 0xc68141800701000000bc0900),
(787, 0xc68143800701000000bb0900),
(787, 0xc58144800701000000bc0900),
(787, 0xc68144800701000000bc0900),
(788, 0xb881967e0701000000bd0900),
(788, 0xb981967e0701000000be0900),
(788, 0xba81967e0701000000bd0900),
(788, 0xbb81967e0701000000be0900),
(788, 0xba819c7e0701000000680600),
(789, 0xb681967e0701000000b70900),
(789, 0xb681977e0701000000b80900),
(789, 0xb2819a7e0701000000680600),
(790, 0xac81967e0701000000b70900),
(790, 0xac81977e0701000000b80900),
(790, 0xaf81967e0701000000b70900),
(790, 0xaf81977e0701000000b80900),
(790, 0xae819a7e0701000000680600),
(790, 0xb0819e7e0701000000660600),
(790, 0xae81a17e0701000000680600),
(790, 0xae81a47e0701000000bd0900),
(790, 0xae81a57e0701000000bd0900),
(790, 0xaf81a47e0701000000be0900),
(790, 0xaf81a57e0701000000be0900),
(791, 0xb281a17e0701000000680600),
(791, 0xb681a47e0701000000b70900),
(791, 0xb681a57e0701000000b80900),
(792, 0xba819f7e0701000000680600),
(792, 0xb881a47e0701000000b70900),
(792, 0xb881a57e0701000000b80900),
(792, 0xbb81a47e0701000000b70900),
(792, 0xbb81a57e0701000000b80900),
(793, 0xb2819a7e0601000000680600),
(793, 0xb581987e0601000000bd0900),
(793, 0xb581997e0601000000bd0900),
(793, 0xb681987e0601000000be0900),
(793, 0xb681997e0601000000be0900),
(794, 0xac81967e0601000000b70900),
(794, 0xac81977e0601000000b80900),
(794, 0xaf81967e0601000000b70900),
(794, 0xaf81977e0601000000b80900),
(794, 0xae819a7e0601000000680600),
(794, 0xb0819c7e0601000000660600),
(795, 0xac81a27e0601000000bd0900),
(795, 0xad81a27e0601000000be0900),
(795, 0xac81a57e0601000000bd0900),
(795, 0xad81a57e0601000000be0900),
(795, 0xb681a17e0601000000680600),
(795, 0xb081a47e0601000000660600),
(796, 0xba81967e0601000000bd0900),
(796, 0xbb81967e0601000000be0900),
(796, 0xba819a7e0601000000680600),
(796, 0xb781a07e0601000000660600),
(796, 0xba81a17e0601000000680600),
(796, 0xb881a47e0601000000b70900),
(796, 0xb881a57e0601000000b80900),
(796, 0xb981a47e0601000000b70900),
(796, 0xb981a57e0601000000b80900),
(796, 0xba81a47e0601000000b70900),
(796, 0xba81a57e0601000000b80900),
(796, 0xbb81a47e0601000000b70900),
(796, 0xbb81a57e0601000000b80900),
(797, 0xbb81ad7e0701000000b70900),
(797, 0xbb81ae7e0701000000b80900),
(797, 0xbc81b37e0701000000680600),
(798, 0xb481ad7e0701000000b70900),
(798, 0xb481ae7e0701000000b80900),
(798, 0xb781b17e0701000000680600),
(799, 0xaf81ad7e0701000000b70900),
(799, 0xaf81ae7e0701000000b80900),
(799, 0xb381b37e0701000000660600),
(800, 0xaf81b67e0701000000b70900),
(800, 0xaf81b77e0701000000b80900),
(800, 0xb381b67e0701000000660600),
(801, 0xaf81bb7e0701000000b70900),
(801, 0xaf81bc7e0701000000b80900),
(801, 0xb081bb7e0701000000b70900),
(801, 0xb581b87e0701000000680600),
(801, 0xb081bc7e0701000000b80900),
(802, 0xb781bb7e0701000000b70900),
(802, 0xb881b87e0701000000680600),
(802, 0xb781bc7e0701000000b80900),
(803, 0xbc81b67e0701000000680600),
(803, 0xbb81bb7e0701000000b70900),
(803, 0xbb81bc7e0701000000b80900),
(804, 0xbe81ad7e0601000000b70900),
(804, 0xbe81ae7e0601000000b80900),
(804, 0xba81b27e0601000000660600),
(805, 0xb781ad7e0601000000b70900),
(805, 0xb781ae7e0601000000b80900),
(805, 0xb881b17e0601000000680600),
(806, 0xaf81ad7e0601000000b70900),
(806, 0xaf81ae7e0601000000b80900),
(806, 0xb581b17e0601000000680600),
(807, 0xaf81b37e0601000000b70900),
(807, 0xaf81b47e0601000000b80900),
(807, 0xb381b37e0601000000660600),
(808, 0xaf81bb7e0601000000b70900),
(808, 0xaf81bc7e0601000000b80900),
(808, 0xb381b77e0601000000660600),
(808, 0xb281bb7e0601000000b70900),
(808, 0xb281bc7e0601000000b80900),
(809, 0xb581b87e0601000000680600),
(809, 0xb781bb7e0601000000b70900),
(809, 0xb781bc7e0601000000b80900),
(810, 0xb981b87e0601000000680600),
(810, 0xbe81bb7e0601000000b70900),
(810, 0xbe81bc7e0601000000b80900),
(811, 0xba81b77e0601000000660600),
(811, 0xbe81b47e0601000000b70900),
(811, 0xbe81b57e0601000000b80900),
(812, 0xc681ba7e0701000000b70900),
(812, 0xc681bb7e0701000000b80900),
(812, 0xc781ba7e0701000000b70900),
(812, 0xc781bb7e0701000000b80900),
(812, 0xcc81ba7e0701000000660600),
(813, 0xca81bf7e0701000000660600),
(813, 0xc881c27e0701000000680600),
(813, 0xc681c57e0701000000b70900),
(813, 0xc681c67e0701000000b80900),
(813, 0xc981c57e0701000000b70900),
(813, 0xc981c67e0701000000b80900),
(814, 0xcb81c37e0701000000b70900),
(814, 0xce81c27e0701000000680600),
(814, 0xcb81c47e0701000000b80900),
(814, 0xcb81c57e0701000000b70900),
(814, 0xcb81c67e0701000000b80900),
(815, 0xd181bf7e0701000000660600),
(815, 0xd481c27e0701000000680600),
(815, 0xd481c57e0701000000bd0900),
(815, 0xd481c67e0701000000bd0900),
(815, 0xd581c57e0701000000be0900),
(815, 0xd581c67e0701000000be0900),
(816, 0xcf81ba7e0701000000660600),
(816, 0xd581b87e0701000000b70900),
(816, 0xd581b97e0701000000b80900),
(817, 0xcc81bc7e0601000000680600),
(817, 0xd081b87e0601000000b70900),
(817, 0xd081b97e0601000000b80900),
(818, 0xc681b87e0601000000b70900),
(818, 0xc681b97e0601000000b80900),
(818, 0xc981b87e0601000000b70900),
(818, 0xc981b97e0601000000b80900),
(818, 0xc881bc7e0601000000680600),
(818, 0xca81be7e0601000000660600),
(818, 0xc681c37e0601000000bd0900),
(818, 0xc781c37e0601000000be0900),
(818, 0xc881c27e0601000000680600),
(818, 0xc681c57e0601000000b70900),
(818, 0xc681c67e0601000000b80900),
(818, 0xc781c57e0601000000b70900),
(818, 0xc781c67e0601000000b80900),
(819, 0xcb81c37e0601000000bd0900),
(819, 0xcc81c37e0601000000be0900),
(819, 0xcb81c67e0601000000bd0900),
(819, 0xcc81c67e0601000000be0900),
(819, 0xd081c27e0601000000680600),
(820, 0xd281b87e0601000000b70900),
(820, 0xd281b97e0601000000b80900),
(820, 0xd581b87e0601000000b70900),
(820, 0xd581b97e0601000000b80900),
(820, 0xd481bc7e0601000000680600),
(820, 0xd181c17e0601000000660600),
(820, 0xd481c27e0601000000680600),
(820, 0xd281c57e0601000000b70900),
(820, 0xd281c67e0601000000b80900),
(821, 0xe081a17e0701000000bd0900),
(821, 0xe181a17e0701000000be0900),
(821, 0xe281a77e0701000000680600),
(822, 0xd481a37e0701000000b70900),
(822, 0xd581a37e0701000000b70900),
(822, 0xd881a37e0701000000660600),
(822, 0xd481a47e0701000000b80900),
(822, 0xd581a47e0701000000b80900),
(822, 0xdc81a57e0701000000680600),
(823, 0xd481a67e0701000000bd0900),
(823, 0xd581a67e0701000000be0900),
(823, 0xd881a97e0701000000660600),
(824, 0xd481ad7e0701000000bd0900),
(824, 0xd581ad7e0701000000be0900),
(824, 0xd881af7e0701000000660600),
(824, 0xdc81ac7e0701000000680600),
(824, 0xd481b07e0701000000bd0900),
(824, 0xd581b07e0701000000be0900),
(825, 0xe281aa7e0701000000680600),
(825, 0xe081af7e0701000000b70900),
(825, 0xe181af7e0701000000b70900),
(825, 0xe081b07e0701000000b80900),
(825, 0xe181b07e0701000000b80900),
(826, 0xde81a37e0601000000b70900),
(826, 0xda81a57e0601000000680600),
(826, 0xde81a47e0601000000b80900),
(827, 0xd481a17e0601000000bd0900),
(827, 0xd581a17e0601000000be0900),
(827, 0xd681a57e0601000000680600),
(827, 0xd881a77e0601000000660600),
(827, 0xd481af7e0601000000b70900),
(827, 0xd681ac7e0601000000680600),
(827, 0xd781af7e0601000000b70900),
(827, 0xd481b07e0601000000b80900),
(827, 0xd781b07e0601000000b80900),
(828, 0xde81ac7e0601000000680600),
(828, 0xdf81af7e0601000000660600),
(828, 0xe281af7e0601000000b70900),
(828, 0xe381af7e0601000000b70900),
(828, 0xe281b07e0601000000b80900),
(828, 0xe381b07e0601000000b80900),
(829, 0xdf81ab7e0601000000660600),
(829, 0xe081a17e0601000000b70900),
(829, 0xe081a27e0601000000b80900),
(829, 0xe381a17e0601000000b70900),
(829, 0xe381a27e0601000000b80900),
(829, 0xe281a57e0601000000680600),
(830, 0xe181977e0701000000b70900),
(830, 0xe181987e0701000000b80900),
(830, 0xe781997e0701000000660600),
(831, 0xe3818c7e0701000000bd0900),
(831, 0xe3818d7e0701000000bd0900),
(831, 0xe4818c7e0701000000be0900),
(831, 0xe4818d7e0701000000be0900),
(831, 0xe381907e0701000000680600),
(831, 0xe581937e0701000000660600),
(832, 0xe6818c7e0701000000b70900),
(832, 0xe6818d7e0701000000b80900),
(832, 0xe881907e0701000000680600),
(833, 0xef818c7e0701000000bd0900),
(833, 0xef818d7e0701000000bd0900),
(833, 0xf0818c7e0701000000be0900),
(833, 0xf0818d7e0701000000be0900),
(833, 0xec81937e0701000000660600),
(833, 0xee81907e0701000000680600),
(834, 0xea81997e0701000000660600),
(834, 0xf081977e0701000000b70900),
(834, 0xf081987e0701000000b80900),
(835, 0xe1818c7e0601000000bd0900),
(835, 0xe1818f7e0601000000bd0900),
(835, 0xe2818c7e0601000000be0900),
(835, 0xe2818f7e0601000000be0900),
(835, 0xe5818e7e0601000000660600),
(835, 0xe781907e0601000000680600),
(836, 0xe581927e0601000000660600),
(836, 0xe381967e0601000000680600),
(836, 0xe181997e0601000000b70900),
(836, 0xe1819a7e0601000000b80900),
(836, 0xe481997e0601000000b70900),
(836, 0xe4819a7e0601000000b80900),
(837, 0xeb81967e0601000000680600),
(837, 0xef81977e0601000000bd0900),
(837, 0xec81997e0601000000660600),
(837, 0xef81987e0601000000bd0900),
(837, 0xf081977e0601000000be0900),
(837, 0xf081987e0601000000be0900),
(838, 0xef818c7e0601000000bd0900),
(838, 0xef818d7e0601000000bd0900),
(838, 0xf0818c7e0601000000be0900),
(838, 0xf0818d7e0601000000be0900),
(838, 0xef81907e0601000000680600),
(838, 0xec81957e0601000000660600),
(839, 0xf881917e0601000000b70900),
(839, 0xf881927e0601000000b80900),
(839, 0xfa81917e0601000000b70900),
(839, 0xfa81927e0601000000b80900),
(839, 0xfb81937e0601000000660600),
(839, 0xf981947e0701000000680600),
(839, 0xfd81957e0701000000660600),
(840, 0xf881967e0601000000b70900),
(840, 0xf881977e0601000000b80900),
(840, 0xfa81967e0601000000b70900),
(840, 0xfa81977e0601000000b80900),
(840, 0xf981977e0701000000680600),
(840, 0xfb81987e0601000000660600),
(841, 0xec81a17e0701000000b70900),
(841, 0xec81a27e0701000000b80900),
(841, 0xeb81a77e0701000000680600),
(842, 0xf281a17e0701000000bd0900),
(842, 0xf381a17e0701000000be0900),
(842, 0xf181a57e0701000000680600),
(843, 0xf781a17e0701000000bd0900),
(843, 0xf781a27e0701000000bd0900),
(843, 0xf881a17e0701000000be0900),
(843, 0xf881a27e0701000000be0900),
(843, 0xf781a57e0701000000680600),
(843, 0xf481a97e0701000000660600),
(843, 0xf581af7e0701000000b70900),
(843, 0xf781ac7e0701000000680600),
(843, 0xf881af7e0701000000b70900),
(843, 0xf581b07e0701000000b80900),
(843, 0xf881b07e0701000000b80900),
(844, 0xf181ac7e0701000000680600),
(844, 0xf381af7e0701000000b70900),
(844, 0xf381b07e0701000000b80900),
(845, 0xeb81aa7e0701000000680600),
(845, 0xeb81af7e0701000000b70900),
(845, 0xec81af7e0701000000b70900),
(845, 0xeb81b07e0701000000b80900),
(845, 0xec81b07e0701000000b80900),
(846, 0xee81a17e0601000000b70900),
(846, 0xee81a27e0601000000b80900),
(846, 0xef81a57e0601000000680600),
(847, 0xeb81a17e0601000000bd0900),
(847, 0xeb81a27e0601000000bd0900),
(847, 0xec81a17e0601000000be0900),
(847, 0xec81a27e0601000000be0900),
(847, 0xeb81a57e0601000000680600),
(847, 0xed81a77e0601000000660600),
(847, 0xe981af7e0601000000b70900),
(847, 0xea81af7e0601000000b70900),
(847, 0xeb81ac7e0601000000680600),
(847, 0xe981b07e0601000000b80900),
(847, 0xea81b07e0601000000b80900),
(848, 0xf381ac7e0601000000680600),
(848, 0xf381af7e0601000000b70900),
(848, 0xf381b07e0601000000b80900),
(849, 0xf781a17e0601000000bd0900),
(849, 0xf781a27e0601000000bd0900),
(849, 0xf881a17e0601000000be0900),
(849, 0xf881a27e0601000000be0900),
(849, 0xf781a57e0601000000680600),
(849, 0xf481ab7e0601000000660600),
(849, 0xf781ac7e0601000000680600),
(849, 0xf781af7e0601000000bd0900),
(849, 0xf881af7e0601000000be0900),
(849, 0xf781b07e0601000000bd0900),
(849, 0xf881b07e0601000000be0900),
(850, 0xdc81b87e0701000000bd0900),
(850, 0xdc81bb7e0701000000bd0900),
(850, 0xdd81b87e0701000000be0900),
(850, 0xdd81bb7e0701000000be0900),
(850, 0xe281ba7e0701000000660600),
(851, 0xe081bf7e0701000000660600),
(851, 0xde81c27e0701000000680600),
(851, 0xdc81c57e0701000000b70900),
(851, 0xdc81c67e0701000000b80900),
(851, 0xdd81c57e0701000000b70900),
(851, 0xdd81c67e0701000000b80900),
(852, 0xe481c27e0701000000680600),
(852, 0xe881c37e0701000000b70900),
(852, 0xea81c37e0701000000bd0900),
(852, 0xeb81c37e0701000000be0900),
(852, 0xe781c57e0701000000660600),
(852, 0xe581c47e0801000000660600),
(852, 0xe681c57e0801000000680600),
(852, 0xe781c47e0801000000660600),
(852, 0xe881c47e0701000000b80900),
(852, 0xea81c67e0701000000bd0900),
(852, 0xeb81c67e0701000000be0900),
(853, 0xe781bf7e0701000000660600);
INSERT INTO `tile_store` (`house_id`, `data`) VALUES
(853, 0xea81c07e0701000000b70900),
(853, 0xea81c17e0701000000b80900),
(853, 0xeb81c07e0701000000b70900),
(853, 0xeb81c17e0701000000b80900),
(854, 0xe581ba7e0701000000660600),
(854, 0xea81b87e0701000000bd0900),
(854, 0xea81bb7e0701000000bd0900),
(854, 0xeb81b87e0701000000be0900),
(854, 0xeb81bb7e0701000000be0900),
(855, 0xf681c17e0601000000bd0900),
(855, 0xf681c27e0601000000bd0900),
(855, 0xf781c17e0601000000be0900),
(855, 0xf781c27e0601000000be0900),
(855, 0xf981c17e0601000000b70900),
(855, 0xf981c27e0601000000b80900),
(855, 0xfb81c17e0601000000bd0900),
(855, 0xfa81c27e0701000000660600),
(855, 0xfc81c17e0601000000be0900),
(855, 0xf381c57e0701000000660600),
(855, 0xf581c67e0601000000680600),
(855, 0xf581c47e0701000000680600),
(855, 0xf581c67e0701000000680600),
(855, 0xf681c57e0701000000660600),
(855, 0xfa81c57e0701000000660600),
(855, 0xfc81c67e0601000000680600),
(855, 0xf681c87e0601000000660600),
(855, 0xf681c97e0701000000660600),
(855, 0xfa81c97e0701000000660600),
(856, 0xbf81d07e0601000000b70900),
(856, 0xbf81d17e0601000000b80900),
(856, 0xbf81d47e0601000000b70900),
(856, 0xbf81d57e0601000000b80900),
(856, 0xbf81d97e0701000000bd0900),
(856, 0xbf81db7e0701000000bd0900),
(856, 0xc281d17e0601000000660600),
(856, 0xc381d07e0601000000bd0900),
(856, 0xc381d27e0601000000bd0900),
(856, 0xc481d07e0601000000be0900),
(856, 0xc481d27e0601000000be0900),
(856, 0xc581d07e0601000000bd0900),
(856, 0xc581d27e0601000000bd0900),
(856, 0xc681d07e0601000000be0900),
(856, 0xc681d27e0601000000be0900),
(856, 0xc781d17e0601000000660600),
(856, 0xc581d07e0701000000bd0900),
(856, 0xc581d37e0701000000680600),
(856, 0xc681d07e0701000000be0900),
(856, 0xc981d07e0701000000bd0900),
(856, 0xc981d17e0701000000bd0900),
(856, 0xc981d27e0701000000bd0900),
(856, 0xca81d07e0701000000be0900),
(856, 0xca81d17e0701000000be0900),
(856, 0xca81d27e0701000000be0900),
(856, 0xc181d47e0601000000b70900),
(856, 0xc181d57e0601000000b80900),
(856, 0xc081d57e0701000000680600),
(856, 0xc181d67e0701000000b70900),
(856, 0xc181d77e0701000000b80900),
(856, 0xc281d47e0701000000660600),
(856, 0xc781d67e0701000000660600),
(856, 0xc981d47e0601000000680600),
(856, 0xc981d47e0701000000680600),
(856, 0xc981d77e0701000000680600),
(856, 0xcb81d67e0701000000660600),
(856, 0xc081d87e0601000000680600),
(856, 0xc281da7e0601000000660600),
(856, 0xc081d97e0701000000be0900),
(856, 0xc081db7e0701000000be0900),
(856, 0xc281da7e0701000000660600),
(856, 0xc581d87e0701000000680600),
(856, 0xc781da7e0701000000660600),
(856, 0xc981d87e0601000000680600),
(857, 0xd581d17e0601000000660600),
(857, 0xd781d07e0601000000bd0900),
(857, 0xd781d27e0601000000bd0900),
(857, 0xd581d17e0701000000660600),
(857, 0xd681d27e0701000000bd0900),
(857, 0xd781d27e0701000000be0900),
(857, 0xd881d07e0601000000be0900),
(857, 0xd881d27e0601000000be0900),
(857, 0xda81d07e0601000000b70900),
(857, 0xda81d17e0601000000b80900),
(857, 0xd981d17e0701000000b70900),
(857, 0xd981d27e0701000000b80900),
(857, 0xda81d17e0701000000b70900),
(857, 0xda81d27e0701000000b80900),
(857, 0xdc81d37e0601000000680600),
(857, 0xdd81d07e0601000000b70900),
(857, 0xdd81d17e0601000000b80900),
(857, 0xd381d47e0601000000680600),
(857, 0xd381d77e0601000000680600),
(857, 0xd181d67e0701000000660600),
(857, 0xd381d47e0701000000680600),
(857, 0xd381d77e0701000000680600),
(857, 0xd381d77e0801000000680600),
(857, 0xd581d67e0701000000660600),
(857, 0xd481d67e0801000000660600),
(857, 0xda81d67e0701000000660600),
(857, 0xd881d57e0801000000bd0900),
(857, 0xd881d67e0801000000bd0900),
(857, 0xd881d77e0801000000bd0900),
(857, 0xd981d57e0801000000be0900),
(857, 0xd981d67e0801000000be0900),
(857, 0xd981d77e0801000000be0900),
(857, 0xdc81d57e0701000000680600),
(857, 0xd581d97e0801000000b70900),
(857, 0xd581da7e0801000000b80900),
(857, 0xd681d97e0801000000b70900),
(857, 0xd681da7e0801000000b80900),
(857, 0xd781d97e0801000000b70900),
(857, 0xd781da7e0801000000b80900),
(857, 0xd881d97e0701000000bd0900),
(857, 0xd981d97e0701000000be0900),
(857, 0xda81da7e0701000000660600),
(857, 0xd881d97e0801000000b70900),
(857, 0xd881da7e0801000000b80900),
(857, 0xd981d97e0801000000b70900),
(857, 0xd981da7e0801000000b80900),
(857, 0xdc81d87e0601000000680600),
(858, 0xdc81ba7e0601000000b70900),
(858, 0xdc81bb7e0601000000b80900),
(858, 0xdd81ba7e0601000000b70900),
(858, 0xdd81bb7e0601000000b80900),
(858, 0xe081ba7e0601000000660600),
(858, 0xe281bc7e0601000000680600),
(859, 0xe081be7e0601000000660600),
(859, 0xde81c27e0601000000680600),
(859, 0xdc81c57e0601000000b70900),
(859, 0xdc81c67e0601000000b80900),
(859, 0xdd81c57e0601000000b70900),
(859, 0xdd81c67e0601000000b80900),
(860, 0xe681c27e0601000000680600),
(860, 0xe781c57e0601000000660600),
(860, 0xea81c57e0601000000b70900),
(860, 0xea81c67e0601000000b80900),
(860, 0xeb81c57e0601000000b70900),
(860, 0xeb81c67e0601000000b80900),
(861, 0xea81b87e0601000000bd0900),
(861, 0xea81b97e0601000000bd0900),
(861, 0xeb81b87e0601000000be0900),
(861, 0xeb81b97e0601000000be0900),
(861, 0xea81bc7e0601000000680600),
(861, 0xe781c17e0601000000660600);

--
-- Indexes for dumped tables
--

--
-- Indexes for table `accounts`
--
ALTER TABLE `accounts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `account_bans`
--
ALTER TABLE `account_bans`
  ADD PRIMARY KEY (`account_id`),
  ADD KEY `banned_by` (`banned_by`);

--
-- Indexes for table `account_ban_history`
--
ALTER TABLE `account_ban_history`
  ADD PRIMARY KEY (`id`),
  ADD KEY `account_id` (`account_id`),
  ADD KEY `banned_by` (`banned_by`);

--
-- Indexes for table `account_viplist`
--
ALTER TABLE `account_viplist`
  ADD UNIQUE KEY `account_player_index` (`account_id`,`player_id`),
  ADD KEY `player_id` (`player_id`);

--
-- Indexes for table `guilds`
--
ALTER TABLE `guilds`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`),
  ADD UNIQUE KEY `ownerid` (`ownerid`);

--
-- Indexes for table `guildwar_kills`
--
ALTER TABLE `guildwar_kills`
  ADD PRIMARY KEY (`id`),
  ADD KEY `warid` (`warid`);

--
-- Indexes for table `guild_invites`
--
ALTER TABLE `guild_invites`
  ADD PRIMARY KEY (`player_id`,`guild_id`),
  ADD KEY `guild_id` (`guild_id`);

--
-- Indexes for table `guild_membership`
--
ALTER TABLE `guild_membership`
  ADD PRIMARY KEY (`player_id`),
  ADD KEY `guild_id` (`guild_id`),
  ADD KEY `rank_id` (`rank_id`);

--
-- Indexes for table `guild_ranks`
--
ALTER TABLE `guild_ranks`
  ADD PRIMARY KEY (`id`),
  ADD KEY `guild_id` (`guild_id`);

--
-- Indexes for table `guild_wars`
--
ALTER TABLE `guild_wars`
  ADD PRIMARY KEY (`id`),
  ADD KEY `guild1` (`guild1`),
  ADD KEY `guild2` (`guild2`);

--
-- Indexes for table `houses`
--
ALTER TABLE `houses`
  ADD PRIMARY KEY (`id`),
  ADD KEY `owner` (`owner`),
  ADD KEY `town_id` (`town_id`);

--
-- Indexes for table `house_lists`
--
ALTER TABLE `house_lists`
  ADD KEY `house_id` (`house_id`);

--
-- Indexes for table `ip_bans`
--
ALTER TABLE `ip_bans`
  ADD PRIMARY KEY (`ip`),
  ADD KEY `banned_by` (`banned_by`);

--
-- Indexes for table `players`
--
ALTER TABLE `players`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`),
  ADD KEY `account_id` (`account_id`),
  ADD KEY `vocation` (`vocation`);

--
-- Indexes for table `players_online`
--
ALTER TABLE `players_online`
  ADD PRIMARY KEY (`player_id`);

--
-- Indexes for table `player_deaths`
--
ALTER TABLE `player_deaths`
  ADD KEY `player_id` (`player_id`),
  ADD KEY `killed_by` (`killed_by`),
  ADD KEY `mostdamage_by` (`mostdamage_by`);

--
-- Indexes for table `player_depotitems`
--
ALTER TABLE `player_depotitems`
  ADD UNIQUE KEY `player_id_2` (`player_id`,`sid`);

--
-- Indexes for table `player_items`
--
ALTER TABLE `player_items`
  ADD KEY `player_id` (`player_id`),
  ADD KEY `sid` (`sid`);

--
-- Indexes for table `player_murders`
--
ALTER TABLE `player_murders`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `player_namelocks`
--
ALTER TABLE `player_namelocks`
  ADD PRIMARY KEY (`player_id`),
  ADD KEY `namelocked_by` (`namelocked_by`);

--
-- Indexes for table `player_spells`
--
ALTER TABLE `player_spells`
  ADD KEY `player_id` (`player_id`);

--
-- Indexes for table `player_storage`
--
ALTER TABLE `player_storage`
  ADD PRIMARY KEY (`player_id`,`key`);

--
-- Indexes for table `server_config`
--
ALTER TABLE `server_config`
  ADD PRIMARY KEY (`config`);

--
-- Indexes for table `tile_store`
--
ALTER TABLE `tile_store`
  ADD KEY `house_id` (`house_id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `account_ban_history`
--
ALTER TABLE `account_ban_history`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `guilds`
--
ALTER TABLE `guilds`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `guildwar_kills`
--
ALTER TABLE `guildwar_kills`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `guild_ranks`
--
ALTER TABLE `guild_ranks`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `guild_wars`
--
ALTER TABLE `guild_wars`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `houses`
--
ALTER TABLE `houses`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=862;

--
-- AUTO_INCREMENT for table `players`
--
ALTER TABLE `players`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;

--
-- AUTO_INCREMENT for table `player_murders`
--
ALTER TABLE `player_murders`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=30;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `account_bans`
--
ALTER TABLE `account_bans`
  ADD CONSTRAINT `account_bans_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `account_bans_ibfk_2` FOREIGN KEY (`banned_by`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `account_ban_history`
--
ALTER TABLE `account_ban_history`
  ADD CONSTRAINT `account_ban_history_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `account_ban_history_ibfk_2` FOREIGN KEY (`banned_by`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `account_viplist`
--
ALTER TABLE `account_viplist`
  ADD CONSTRAINT `account_viplist_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `account_viplist_ibfk_2` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `guilds`
--
ALTER TABLE `guilds`
  ADD CONSTRAINT `guilds_ibfk_1` FOREIGN KEY (`ownerid`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `guildwar_kills`
--
ALTER TABLE `guildwar_kills`
  ADD CONSTRAINT `guildwar_kills_ibfk_1` FOREIGN KEY (`warid`) REFERENCES `guild_wars` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `guild_invites`
--
ALTER TABLE `guild_invites`
  ADD CONSTRAINT `guild_invites_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `guild_invites_ibfk_2` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `guild_membership`
--
ALTER TABLE `guild_membership`
  ADD CONSTRAINT `guild_membership_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `guild_membership_ibfk_2` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `guild_membership_ibfk_3` FOREIGN KEY (`rank_id`) REFERENCES `guild_ranks` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `guild_ranks`
--
ALTER TABLE `guild_ranks`
  ADD CONSTRAINT `guild_ranks_ibfk_1` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `house_lists`
--
ALTER TABLE `house_lists`
  ADD CONSTRAINT `house_lists_ibfk_1` FOREIGN KEY (`house_id`) REFERENCES `houses` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `ip_bans`
--
ALTER TABLE `ip_bans`
  ADD CONSTRAINT `ip_bans_ibfk_1` FOREIGN KEY (`banned_by`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `players`
--
ALTER TABLE `players`
  ADD CONSTRAINT `players_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `player_deaths`
--
ALTER TABLE `player_deaths`
  ADD CONSTRAINT `player_deaths_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `player_depotitems`
--
ALTER TABLE `player_depotitems`
  ADD CONSTRAINT `player_depotitems_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `player_items`
--
ALTER TABLE `player_items`
  ADD CONSTRAINT `player_items_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `player_namelocks`
--
ALTER TABLE `player_namelocks`
  ADD CONSTRAINT `player_namelocks_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `player_namelocks_ibfk_2` FOREIGN KEY (`namelocked_by`) REFERENCES `players` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `player_spells`
--
ALTER TABLE `player_spells`
  ADD CONSTRAINT `player_spells_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `player_storage`
--
ALTER TABLE `player_storage`
  ADD CONSTRAINT `player_storage_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `tile_store`
--
ALTER TABLE `tile_store`
  ADD CONSTRAINT `tile_store_ibfk_1` FOREIGN KEY (`house_id`) REFERENCES `houses` (`id`) ON DELETE CASCADE;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
